/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/































#include "../P2ToP1ElementwiseDivergenceIcosahedralShellMap_0_2.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ToP1ElementwiseDivergenceIcosahedralShellMap_0_2::apply_P2ToP1ElementwiseDivergenceIcosahedralShellMap_0_2_macro_3D( real_t * RESTRICT  _data_dst, real_t * RESTRICT  _data_srcEdge, real_t * RESTRICT  _data_srcVertex, real_t forVertex_0, real_t forVertex_1, real_t forVertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t rayVertex_2, real_t refVertex_0, real_t refVertex_1, real_t refVertex_2, real_t thrVertex_0, real_t thrVertex_1, real_t thrVertex_2 ) const
{
    {
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       const real_t tmp_kernel_op_17 = rayVertex_1 - refVertex_1;
       const real_t tmp_kernel_op_18 = -rayVertex_0;
       const real_t tmp_kernel_op_19 = -forVertex_0 - tmp_kernel_op_18;
       const real_t tmp_kernel_op_20 = rayVertex_2 - thrVertex_2;
       const real_t tmp_kernel_op_21 = tmp_kernel_op_19*tmp_kernel_op_20;
       const real_t tmp_kernel_op_22 = rayVertex_2 - refVertex_2;
       const real_t tmp_kernel_op_23 = rayVertex_1 - thrVertex_1;
       const real_t tmp_kernel_op_24 = tmp_kernel_op_19*tmp_kernel_op_23;
       const real_t tmp_kernel_op_25 = -rayVertex_1;
       const real_t tmp_kernel_op_26 = -forVertex_1 - tmp_kernel_op_25;
       const real_t tmp_kernel_op_27 = rayVertex_0 - thrVertex_0;
       const real_t tmp_kernel_op_28 = rayVertex_0 - refVertex_0;
       const real_t tmp_kernel_op_29 = -rayVertex_2;
       const real_t tmp_kernel_op_30 = -forVertex_2 - tmp_kernel_op_29;
       const real_t tmp_kernel_op_31 = tmp_kernel_op_20*tmp_kernel_op_26;
       const real_t tmp_kernel_op_32 = tmp_kernel_op_27*tmp_kernel_op_30;
       const real_t tmp_kernel_op_33 = tmp_kernel_op_17*tmp_kernel_op_21 - tmp_kernel_op_17*tmp_kernel_op_32 - tmp_kernel_op_22*tmp_kernel_op_24 + tmp_kernel_op_22*tmp_kernel_op_26*tmp_kernel_op_27 + tmp_kernel_op_23*tmp_kernel_op_28*tmp_kernel_op_30 - tmp_kernel_op_28*tmp_kernel_op_31;
       const real_t tmp_kernel_op_34 = 1.0 / (tmp_kernel_op_33*tmp_kernel_op_33*tmp_kernel_op_33);
       const real_t tmp_kernel_op_35 = radRayVertex - radRefVertex;
       const real_t tmp_kernel_op_36 = tmp_kernel_op_35*(-tmp_kernel_op_24 + tmp_kernel_op_26*tmp_kernel_op_27);
       const real_t tmp_kernel_op_37 = radRayVertex*tmp_kernel_op_33;
       const real_t tmp_kernel_op_44 = tmp_kernel_op_35*(tmp_kernel_op_23*tmp_kernel_op_30 - tmp_kernel_op_31);
       const real_t tmp_kernel_op_46 = -tmp_kernel_op_21 + tmp_kernel_op_27*tmp_kernel_op_30;
       const real_t tmp_kernel_op_47 = tmp_kernel_op_35*tmp_kernel_op_46;
       const real_t tmp_kernel_op_49 = -tmp_kernel_op_35*tmp_kernel_op_46;
       const real_t tmp_kernel_op_52 = tmp_kernel_op_34*1.0;
       const real_t tmp_kernel_op_64 = 1.0 / (tmp_kernel_op_33*tmp_kernel_op_33);
       const real_t tmp_kernel_op_65 = tmp_kernel_op_64*1.0;
       const real_t tmp_kernel_op_72 = 0.55278640450004202;
       const real_t tmp_kernel_op_109 = 0.55278640450004202;
       const real_t tmp_kernel_op_146 = 2.3416407864998736;
       const real_t tmp_kernel_op_183 = 0.55278640450004202;
       const real_t tmp_kernel_op_186 = 0.55278640450004202;
       const real_t tmp_kernel_op_189 = 2.3416407864998736;
       const real_t tmp_kernel_op_192 = 0.55278640450004202;
       const real_t tmp_kernel_op_195 = 0.55278640450004202;
       const real_t tmp_kernel_op_198 = 2.3416407864998736;
       const real_t tmp_kernel_op_201 = 0.55278640450004202;
       const real_t tmp_kernel_op_204 = 0.55278640450004202;
       const real_t tmp_kernel_op_207 = 0.55278640450004202;
       const real_t tmp_kernel_op_245 = tmp_kernel_op_186 + tmp_kernel_op_72;
       const real_t tmp_kernel_op_247 = tmp_kernel_op_109 + tmp_kernel_op_189;
       const real_t tmp_kernel_op_249 = tmp_kernel_op_146 + tmp_kernel_op_192;
       const real_t tmp_kernel_op_251 = tmp_kernel_op_183 + tmp_kernel_op_195;
       const real_t tmp_kernel_op_253 = tmp_kernel_op_198 - 4.0;
       const real_t tmp_kernel_op_255 = tmp_kernel_op_201 - 4.0;
       const real_t tmp_kernel_op_257 = tmp_kernel_op_204 - 4.0;
       const real_t tmp_kernel_op_259 = tmp_kernel_op_207 - 4.0;
       const real_t tmp_kernel_op_265 = tmp_kernel_op_198 + tmp_kernel_op_245 - 3.0;
       const real_t tmp_kernel_op_267 = tmp_kernel_op_201 + tmp_kernel_op_247 - 3.0;
       const real_t tmp_kernel_op_269 = tmp_kernel_op_204 + tmp_kernel_op_249 - 3.0;
       const real_t tmp_kernel_op_271 = tmp_kernel_op_207 + tmp_kernel_op_251 - 3.0;
       {
          /* CellType.WHITE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_0 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0);
                const __m256d tmp_kernel_op_1 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0);
                const __m256d tmp_kernel_op_2 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0);
                const __m256d tmp_kernel_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_kernel_op_4 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1);
                const __m256d tmp_kernel_op_5 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1);
                const __m256d tmp_kernel_op_6 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1);
                const __m256d tmp_kernel_op_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_kernel_op_8 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2);
                const __m256d tmp_kernel_op_9 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2);
                const __m256d tmp_kernel_op_10 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2);
                const __m256d tmp_kernel_op_11 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_kernel_op_12 = _mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_3);
                const __m256d tmp_kernel_op_13 = _mm256_mul_pd(tmp_kernel_op_7,tmp_kernel_op_7);
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_11);
                const __m256d tmp_kernel_op_15 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_12,tmp_kernel_op_13),tmp_kernel_op_14);
                const __m256d tmp_kernel_op_16 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_15),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_15,tmp_kernel_op_15),tmp_kernel_op_15),tmp_kernel_op_15),tmp_kernel_op_15));
                const __m256d tmp_kernel_op_38 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_11,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_39 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_40 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_41 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_39,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_39,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_42 = _mm256_mul_pd(tmp_kernel_op_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_45 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_48 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_7),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_7,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_41)),_mm256_mul_pd(tmp_kernel_op_13,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_51 = _mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_53 = _mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_54 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_43),tmp_kernel_op_53);
                const __m256d tmp_kernel_op_55 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_11,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_41)),_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_56 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_51),tmp_kernel_op_7);
                const __m256d tmp_kernel_op_57 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_41)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_41),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_58 = _mm256_mul_pd(tmp_kernel_op_57,tmp_kernel_op_7);
                const __m256d tmp_kernel_op_59 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_54),tmp_kernel_op_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_51),tmp_kernel_op_54),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_53,tmp_kernel_op_55),tmp_kernel_op_56),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_16,tmp_kernel_op_50),tmp_kernel_op_55),tmp_kernel_op_57),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_16),tmp_kernel_op_3),tmp_kernel_op_43),tmp_kernel_op_45),tmp_kernel_op_48),tmp_kernel_op_7),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_60 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_59))));
                const __m256d tmp_kernel_op_61 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.13819660112501053,0.13819660112501053,0.13819660112501053,0.13819660112501053));
                const __m256d tmp_kernel_op_62 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_59);
                const __m256d tmp_kernel_op_63 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_15),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_15)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_15));
                const __m256d tmp_kernel_op_66 = _mm256_mul_pd(tmp_kernel_op_63,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_67 = _mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_66);
                const __m256d tmp_kernel_op_68 = _mm256_mul_pd(tmp_kernel_op_62,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_58,tmp_kernel_op_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_43),tmp_kernel_op_45),tmp_kernel_op_63),tmp_kernel_op_7),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_69 = _mm256_mul_pd(tmp_kernel_op_62,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_50),tmp_kernel_op_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_43),tmp_kernel_op_48),tmp_kernel_op_63),tmp_kernel_op_7),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_70 = _mm256_mul_pd(tmp_kernel_op_62,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_56,tmp_kernel_op_66),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_57),tmp_kernel_op_66)));
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)));
                const __m256d tmp_kernel_op_73 = _mm256_mul_pd(tmp_kernel_op_71,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72)));
                const __m256d tmp_kernel_op_74 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_kernel_op_75 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_kernel_op_76 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_kernel_op_77 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_74);
                const __m256d tmp_kernel_op_78 = _mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_75);
                const __m256d tmp_kernel_op_79 = _mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_76);
                const __m256d tmp_kernel_op_80 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_77,tmp_kernel_op_78),tmp_kernel_op_79);
                const __m256d tmp_kernel_op_81 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_80),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_80,tmp_kernel_op_80),tmp_kernel_op_80),tmp_kernel_op_80),tmp_kernel_op_80));
                const __m256d tmp_kernel_op_82 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_76,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_83 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_74,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_75,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_85 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_82,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_82,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_86 = _mm256_mul_pd(tmp_kernel_op_85,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_87 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_88 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_89 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_90 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_75,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_91 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_88);
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_81,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_93 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_87),tmp_kernel_op_92);
                const __m256d tmp_kernel_op_94 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_76,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_79,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_95 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_89),tmp_kernel_op_91);
                const __m256d tmp_kernel_op_96 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_74,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_85)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_77,tmp_kernel_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_97 = _mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_98 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_89,tmp_kernel_op_93),tmp_kernel_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_90,tmp_kernel_op_91),tmp_kernel_op_93),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_94),tmp_kernel_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_81,tmp_kernel_op_90),tmp_kernel_op_94),tmp_kernel_op_96),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_75),tmp_kernel_op_76),tmp_kernel_op_81),tmp_kernel_op_87),tmp_kernel_op_88),tmp_kernel_op_89),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_99 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_98))));
                const __m256d tmp_kernel_op_100 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_101 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_98);
                const __m256d tmp_kernel_op_102 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_80),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_80)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_80));
                const __m256d tmp_kernel_op_103 = _mm256_mul_pd(tmp_kernel_op_102,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_104 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_105 = _mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_74),tmp_kernel_op_75),tmp_kernel_op_87),tmp_kernel_op_88),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_106 = _mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_74),tmp_kernel_op_90),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_74),tmp_kernel_op_75),tmp_kernel_op_87),tmp_kernel_op_89),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_107 = _mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_90),tmp_kernel_op_96)));
                const __m256d tmp_kernel_op_108 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_mul_pd(tmp_kernel_op_105,_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)));
                const __m256d tmp_kernel_op_110 = _mm256_mul_pd(tmp_kernel_op_108,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)));
                const __m256d tmp_kernel_op_111 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_kernel_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_kernel_op_113 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_kernel_op_114 = _mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_111);
                const __m256d tmp_kernel_op_115 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_112);
                const __m256d tmp_kernel_op_116 = _mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_113);
                const __m256d tmp_kernel_op_117 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_114,tmp_kernel_op_115),tmp_kernel_op_116);
                const __m256d tmp_kernel_op_118 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_117),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_117,tmp_kernel_op_117),tmp_kernel_op_117),tmp_kernel_op_117),tmp_kernel_op_117));
                const __m256d tmp_kernel_op_119 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_120 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_111,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_121 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_112,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_122 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_119,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_121,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_121,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_119,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_123 = _mm256_mul_pd(tmp_kernel_op_122,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_124 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_125 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_126 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_122),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_127 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_112,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_122)),_mm256_mul_pd(tmp_kernel_op_115,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_128 = _mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_125);
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(tmp_kernel_op_118,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_130 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_124),tmp_kernel_op_129);
                const __m256d tmp_kernel_op_131 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_122)),_mm256_mul_pd(tmp_kernel_op_116,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_132 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_126),tmp_kernel_op_128);
                const __m256d tmp_kernel_op_133 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_111,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_122)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_114,tmp_kernel_op_122),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_134 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_133);
                const __m256d tmp_kernel_op_135 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_130),tmp_kernel_op_134),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_128),tmp_kernel_op_130),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_129,tmp_kernel_op_131),tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_127),tmp_kernel_op_131),tmp_kernel_op_133),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_112),tmp_kernel_op_113),tmp_kernel_op_118),tmp_kernel_op_124),tmp_kernel_op_125),tmp_kernel_op_126),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_135))));
                const __m256d tmp_kernel_op_137 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_138 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_135);
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_117),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_117)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_117));
                const __m256d tmp_kernel_op_140 = _mm256_mul_pd(tmp_kernel_op_139,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_141 = _mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_140);
                const __m256d tmp_kernel_op_142 = _mm256_mul_pd(tmp_kernel_op_138,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_141),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_112),tmp_kernel_op_124),tmp_kernel_op_125),tmp_kernel_op_139),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_143 = _mm256_mul_pd(tmp_kernel_op_138,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_127),tmp_kernel_op_141),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_112),tmp_kernel_op_124),tmp_kernel_op_126),tmp_kernel_op_139),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_144 = _mm256_mul_pd(tmp_kernel_op_138,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_140),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_133),tmp_kernel_op_140)));
                const __m256d tmp_kernel_op_145 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP))),_mm256_mul_pd(tmp_kernel_op_144,_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)));
                const __m256d tmp_kernel_op_147 = _mm256_mul_pd(tmp_kernel_op_145,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146)));
                const __m256d tmp_kernel_op_148 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_0);
                const __m256d tmp_kernel_op_149 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_1);
                const __m256d tmp_kernel_op_150 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_2);
                const __m256d tmp_kernel_op_151 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_148);
                const __m256d tmp_kernel_op_152 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_149);
                const __m256d tmp_kernel_op_153 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_150);
                const __m256d tmp_kernel_op_154 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_151,tmp_kernel_op_152),tmp_kernel_op_153);
                const __m256d tmp_kernel_op_155 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_154),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_154),tmp_kernel_op_154),tmp_kernel_op_154),tmp_kernel_op_154));
                const __m256d tmp_kernel_op_156 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_150,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_157 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_158 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_149,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_159 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_156,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_156,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_160 = _mm256_mul_pd(tmp_kernel_op_159,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_161 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_162 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_163 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_164 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_149,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_159)),_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_165 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_162);
                const __m256d tmp_kernel_op_166 = _mm256_mul_pd(tmp_kernel_op_155,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_167 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_161),tmp_kernel_op_166);
                const __m256d tmp_kernel_op_168 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_150,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_159)),_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_169 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_163),tmp_kernel_op_165);
                const __m256d tmp_kernel_op_170 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_159)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_171 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_170);
                const __m256d tmp_kernel_op_172 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_167),tmp_kernel_op_171),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_164,tmp_kernel_op_165),tmp_kernel_op_167),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_166,tmp_kernel_op_168),tmp_kernel_op_169),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_164),tmp_kernel_op_168),tmp_kernel_op_170),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_149),tmp_kernel_op_150),tmp_kernel_op_155),tmp_kernel_op_161),tmp_kernel_op_162),tmp_kernel_op_163),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_173 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_172))));
                const __m256d tmp_kernel_op_174 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_175 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_172);
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_154),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_154)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_154));
                const __m256d tmp_kernel_op_177 = _mm256_mul_pd(tmp_kernel_op_176,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_178 = _mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_177);
                const __m256d tmp_kernel_op_179 = _mm256_mul_pd(tmp_kernel_op_175,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_178),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_149),tmp_kernel_op_161),tmp_kernel_op_162),tmp_kernel_op_176),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_180 = _mm256_mul_pd(tmp_kernel_op_175,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_164),tmp_kernel_op_178),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_149),tmp_kernel_op_161),tmp_kernel_op_163),tmp_kernel_op_176),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_181 = _mm256_mul_pd(tmp_kernel_op_175,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_177),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_164,tmp_kernel_op_170),tmp_kernel_op_177)));
                const __m256d tmp_kernel_op_182 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP)),_mm256_mul_pd(tmp_kernel_op_179,_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP))),_mm256_mul_pd(tmp_kernel_op_181,_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP)));
                const __m256d tmp_kernel_op_184 = _mm256_mul_pd(tmp_kernel_op_182,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183)));
                const __m256d tmp_kernel_op_185 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)));
                const __m256d tmp_kernel_op_187 = _mm256_mul_pd(tmp_kernel_op_185,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186)));
                const __m256d tmp_kernel_op_188 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_mul_pd(tmp_kernel_op_105,_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)));
                const __m256d tmp_kernel_op_190 = _mm256_mul_pd(tmp_kernel_op_188,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189)));
                const __m256d tmp_kernel_op_191 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP))),_mm256_mul_pd(tmp_kernel_op_144,_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)));
                const __m256d tmp_kernel_op_193 = _mm256_mul_pd(tmp_kernel_op_191,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192)));
                const __m256d tmp_kernel_op_194 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_mul_pd(tmp_kernel_op_179,_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP))),_mm256_mul_pd(tmp_kernel_op_181,_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)));
                const __m256d tmp_kernel_op_196 = _mm256_mul_pd(tmp_kernel_op_194,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195)));
                const __m256d tmp_kernel_op_197 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)));
                const __m256d tmp_kernel_op_199 = _mm256_mul_pd(tmp_kernel_op_197,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198)));
                const __m256d tmp_kernel_op_200 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_mul_pd(tmp_kernel_op_105,_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)));
                const __m256d tmp_kernel_op_202 = _mm256_mul_pd(tmp_kernel_op_200,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201)));
                const __m256d tmp_kernel_op_203 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_mul_pd(tmp_kernel_op_144,_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)));
                const __m256d tmp_kernel_op_205 = _mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204)));
                const __m256d tmp_kernel_op_206 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_mul_pd(tmp_kernel_op_179,_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_mul_pd(tmp_kernel_op_181,_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)));
                const __m256d tmp_kernel_op_208 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207)));
                const __m256d tmp_kernel_op_209 = _mm256_mul_pd(tmp_kernel_op_197,_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186));
                const __m256d tmp_kernel_op_210 = _mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198));
                const __m256d tmp_kernel_op_211 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_209,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_212 = _mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189));
                const __m256d tmp_kernel_op_213 = _mm256_mul_pd(tmp_kernel_op_188,_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201));
                const __m256d tmp_kernel_op_214 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_212,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_213,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_215 = _mm256_mul_pd(tmp_kernel_op_203,_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192));
                const __m256d tmp_kernel_op_216 = _mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204));
                const __m256d tmp_kernel_op_217 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_215,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_216,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_218 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195));
                const __m256d tmp_kernel_op_219 = _mm256_mul_pd(tmp_kernel_op_194,_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207));
                const __m256d tmp_kernel_op_220 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_218,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_219,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_221 = _mm256_mul_pd(tmp_kernel_op_197,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72));
                const __m256d tmp_kernel_op_222 = _mm256_mul_pd(tmp_kernel_op_71,_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198));
                const __m256d tmp_kernel_op_223 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_222,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_224 = _mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_225 = _mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201));
                const __m256d tmp_kernel_op_226 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_224,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_225,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_227 = _mm256_mul_pd(tmp_kernel_op_203,_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146));
                const __m256d tmp_kernel_op_228 = _mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204));
                const __m256d tmp_kernel_op_229 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_227,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_228,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_230 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183));
                const __m256d tmp_kernel_op_231 = _mm256_mul_pd(tmp_kernel_op_182,_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207));
                const __m256d tmp_kernel_op_232 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_230,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_231,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_233 = _mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72));
                const __m256d tmp_kernel_op_234 = _mm256_mul_pd(tmp_kernel_op_71,_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186));
                const __m256d tmp_kernel_op_235 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_233,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_234,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_236 = _mm256_mul_pd(tmp_kernel_op_188,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_237 = _mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189));
                const __m256d tmp_kernel_op_238 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_236,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_237,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_239 = _mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146));
                const __m256d tmp_kernel_op_240 = _mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192));
                const __m256d tmp_kernel_op_241 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_239,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_240,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_242 = _mm256_mul_pd(tmp_kernel_op_194,_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183));
                const __m256d tmp_kernel_op_243 = _mm256_mul_pd(tmp_kernel_op_182,_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195));
                const __m256d tmp_kernel_op_244 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_243,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_246 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245)),_mm256_set_pd(-0.68328157299974723,-0.68328157299974723,-0.68328157299974723,-0.68328157299974723))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_210),tmp_kernel_op_222);
                const __m256d tmp_kernel_op_248 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_200,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247)),_mm256_set_pd(2.8944271909999157,2.8944271909999157,2.8944271909999157,2.8944271909999157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_213),tmp_kernel_op_225);
                const __m256d tmp_kernel_op_250 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249)),_mm256_set_pd(2.8944271909999157,2.8944271909999157,2.8944271909999157,2.8944271909999157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_216),tmp_kernel_op_228);
                const __m256d tmp_kernel_op_252 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_206,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251)),_mm256_set_pd(2.8944271909999157,2.8944271909999157,2.8944271909999157,2.8944271909999157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_219),tmp_kernel_op_231);
                const __m256d tmp_kernel_op_254 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_209),tmp_kernel_op_234);
                const __m256d tmp_kernel_op_256 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_188,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))),_mm256_set_pd(-4.6832815729997472,-4.6832815729997472,-4.6832815729997472,-4.6832815729997472))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_212),tmp_kernel_op_237);
                const __m256d tmp_kernel_op_258 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_191,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_215),tmp_kernel_op_240);
                const __m256d tmp_kernel_op_260 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_218),tmp_kernel_op_243);
                const __m256d tmp_kernel_op_261 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_221),tmp_kernel_op_233);
                const __m256d tmp_kernel_op_262 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_108,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_224),tmp_kernel_op_236);
                const __m256d tmp_kernel_op_263 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_145,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257))),_mm256_set_pd(-4.6832815729997472,-4.6832815729997472,-4.6832815729997472,-4.6832815729997472))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_227),tmp_kernel_op_239);
                const __m256d tmp_kernel_op_264 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_182,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_230),tmp_kernel_op_242);
                const __m256d tmp_kernel_op_266 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265)));
                const __m256d tmp_kernel_op_268 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_188,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267)));
                const __m256d tmp_kernel_op_270 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_203,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269)));
                const __m256d tmp_kernel_op_272 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_182,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271)));
                const __m256d tmp_kernel_op_273 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_274 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_275 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_276 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_277 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_278 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_279 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_280 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_281 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_282 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_283 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_284 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_214),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_217)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_220)),_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_61))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_226),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_229)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_232)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_238),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_241)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_244)),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_248),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_250)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_252)),_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_256),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_258)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_260)),_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_262),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_263)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_264)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_268),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_270)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_272)),_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_110),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_184),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_190),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_193),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_196),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_202),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_205),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_208),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_276))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_232,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_241,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_258,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_262,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_268,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_270,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_272,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_110,tmp_kernel_op_274),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_275),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_276),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_273,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_273),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_190,tmp_kernel_op_274),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_275),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_276),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_273),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_274),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_275),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_276),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_280))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_232,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_241,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_258,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_262,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_268,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_270,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_272,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_110,tmp_kernel_op_278),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_279),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_280),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_277),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_190,tmp_kernel_op_278),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_279),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_280),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_277),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_278),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_279),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_280),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_284))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_232,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_241,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_258,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_262,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_268,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_270,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_272,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_110,tmp_kernel_op_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_283),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_284),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_281,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_281),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_190,tmp_kernel_op_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_283),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_284),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_281),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_283),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_284),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_0 = -p_affine_0_0 + p_affine_1_0;
                const real_t tmp_kernel_op_1 = -p_affine_0_0 + p_affine_2_0;
                const real_t tmp_kernel_op_2 = -p_affine_0_0 + p_affine_3_0;
                const real_t tmp_kernel_op_3 = p_affine_0_0 + tmp_kernel_op_0*0.1381966011250105 + tmp_kernel_op_1*0.1381966011250105 + tmp_kernel_op_2*0.5854101966249684;
                const real_t tmp_kernel_op_4 = -p_affine_0_1 + p_affine_1_1;
                const real_t tmp_kernel_op_5 = -p_affine_0_1 + p_affine_2_1;
                const real_t tmp_kernel_op_6 = -p_affine_0_1 + p_affine_3_1;
                const real_t tmp_kernel_op_7 = p_affine_0_1 + tmp_kernel_op_4*0.1381966011250105 + tmp_kernel_op_5*0.1381966011250105 + tmp_kernel_op_6*0.5854101966249684;
                const real_t tmp_kernel_op_8 = -p_affine_0_2 + p_affine_1_2;
                const real_t tmp_kernel_op_9 = -p_affine_0_2 + p_affine_2_2;
                const real_t tmp_kernel_op_10 = -p_affine_0_2 + p_affine_3_2;
                const real_t tmp_kernel_op_11 = p_affine_0_2 + tmp_kernel_op_10*0.5854101966249684 + tmp_kernel_op_8*0.1381966011250105 + tmp_kernel_op_9*0.1381966011250105;
                const real_t tmp_kernel_op_12 = (tmp_kernel_op_3*tmp_kernel_op_3);
                const real_t tmp_kernel_op_13 = (tmp_kernel_op_7*tmp_kernel_op_7);
                const real_t tmp_kernel_op_14 = (tmp_kernel_op_11*tmp_kernel_op_11);
                const real_t tmp_kernel_op_15 = tmp_kernel_op_12 + tmp_kernel_op_13 + tmp_kernel_op_14;
                const real_t tmp_kernel_op_16 = pow(tmp_kernel_op_15, -4.5000000000000000);
                const real_t tmp_kernel_op_38 = -tmp_kernel_op_11 - tmp_kernel_op_29;
                const real_t tmp_kernel_op_39 = -tmp_kernel_op_18 - tmp_kernel_op_3;
                const real_t tmp_kernel_op_40 = -tmp_kernel_op_25 - tmp_kernel_op_7;
                const real_t tmp_kernel_op_41 = -tmp_kernel_op_35*(tmp_kernel_op_19*tmp_kernel_op_20*tmp_kernel_op_40 + tmp_kernel_op_23*tmp_kernel_op_30*tmp_kernel_op_39 - tmp_kernel_op_24*tmp_kernel_op_38 + tmp_kernel_op_26*tmp_kernel_op_27*tmp_kernel_op_38 - tmp_kernel_op_31*tmp_kernel_op_39 - tmp_kernel_op_32*tmp_kernel_op_40) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_42 = -tmp_kernel_op_41;
                const real_t tmp_kernel_op_43 = tmp_kernel_op_11*tmp_kernel_op_42 + tmp_kernel_op_15*tmp_kernel_op_36;
                const real_t tmp_kernel_op_45 = tmp_kernel_op_15*tmp_kernel_op_44 + tmp_kernel_op_3*tmp_kernel_op_42;
                const real_t tmp_kernel_op_48 = -tmp_kernel_op_15*tmp_kernel_op_47 - tmp_kernel_op_41*tmp_kernel_op_7;
                const real_t tmp_kernel_op_50 = tmp_kernel_op_13*tmp_kernel_op_42 + tmp_kernel_op_15*(tmp_kernel_op_41 + tmp_kernel_op_49*tmp_kernel_op_7);
                const real_t tmp_kernel_op_51 = tmp_kernel_op_3*tmp_kernel_op_45;
                const real_t tmp_kernel_op_53 = tmp_kernel_op_16*tmp_kernel_op_52;
                const real_t tmp_kernel_op_54 = tmp_kernel_op_11*tmp_kernel_op_43*tmp_kernel_op_53;
                const real_t tmp_kernel_op_55 = tmp_kernel_op_14*tmp_kernel_op_42 + tmp_kernel_op_15*(tmp_kernel_op_11*tmp_kernel_op_36 + tmp_kernel_op_41);
                const real_t tmp_kernel_op_56 = tmp_kernel_op_48*tmp_kernel_op_51*tmp_kernel_op_7;
                const real_t tmp_kernel_op_57 = -tmp_kernel_op_12*tmp_kernel_op_41 + tmp_kernel_op_15*(tmp_kernel_op_3*tmp_kernel_op_44 + tmp_kernel_op_41);
                const real_t tmp_kernel_op_58 = tmp_kernel_op_57*tmp_kernel_op_7;
                const real_t tmp_kernel_op_59 = tmp_kernel_op_11*tmp_kernel_op_16*tmp_kernel_op_3*tmp_kernel_op_34*tmp_kernel_op_43*tmp_kernel_op_45*tmp_kernel_op_48*tmp_kernel_op_7*2.0 + tmp_kernel_op_16*tmp_kernel_op_34*tmp_kernel_op_50*tmp_kernel_op_55*tmp_kernel_op_57*1.0 - tmp_kernel_op_48*tmp_kernel_op_54*tmp_kernel_op_58 - tmp_kernel_op_50*tmp_kernel_op_51*tmp_kernel_op_54 - tmp_kernel_op_53*tmp_kernel_op_55*tmp_kernel_op_56;
                const real_t tmp_kernel_op_60 = abs_det_jac_affine_WHITE_UP*0.041666666666666657*abs(tmp_kernel_op_59);
                const real_t tmp_kernel_op_61 = tmp_kernel_op_60*0.13819660112501053;
                const real_t tmp_kernel_op_62 = 1.0 / (tmp_kernel_op_59);
                const real_t tmp_kernel_op_63 = 1.0 / (tmp_kernel_op_15*tmp_kernel_op_15*tmp_kernel_op_15);
                const real_t tmp_kernel_op_66 = tmp_kernel_op_63*tmp_kernel_op_65;
                const real_t tmp_kernel_op_67 = tmp_kernel_op_43*tmp_kernel_op_66;
                const real_t tmp_kernel_op_68 = tmp_kernel_op_62*(tmp_kernel_op_3*tmp_kernel_op_43*tmp_kernel_op_45*tmp_kernel_op_63*tmp_kernel_op_64*tmp_kernel_op_7*1.0 - tmp_kernel_op_58*tmp_kernel_op_67);
                const real_t tmp_kernel_op_69 = tmp_kernel_op_62*(tmp_kernel_op_3*tmp_kernel_op_43*tmp_kernel_op_48*tmp_kernel_op_63*tmp_kernel_op_64*tmp_kernel_op_7*1.0 - tmp_kernel_op_3*tmp_kernel_op_50*tmp_kernel_op_67);
                const real_t tmp_kernel_op_70 = tmp_kernel_op_62*(tmp_kernel_op_50*tmp_kernel_op_57*tmp_kernel_op_66 - tmp_kernel_op_56*tmp_kernel_op_66);
                const real_t tmp_kernel_op_71 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_69 + jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_68 + jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_70;
                const real_t tmp_kernel_op_73 = tmp_kernel_op_71*(tmp_kernel_op_72 - 1.0);
                const real_t tmp_kernel_op_74 = p_affine_0_0 + tmp_kernel_op_0*0.1381966011250105 + tmp_kernel_op_1*0.5854101966249684 + tmp_kernel_op_2*0.1381966011250105;
                const real_t tmp_kernel_op_75 = p_affine_0_1 + tmp_kernel_op_4*0.1381966011250105 + tmp_kernel_op_5*0.5854101966249684 + tmp_kernel_op_6*0.1381966011250105;
                const real_t tmp_kernel_op_76 = p_affine_0_2 + tmp_kernel_op_10*0.1381966011250105 + tmp_kernel_op_8*0.1381966011250105 + tmp_kernel_op_9*0.5854101966249684;
                const real_t tmp_kernel_op_77 = (tmp_kernel_op_74*tmp_kernel_op_74);
                const real_t tmp_kernel_op_78 = (tmp_kernel_op_75*tmp_kernel_op_75);
                const real_t tmp_kernel_op_79 = (tmp_kernel_op_76*tmp_kernel_op_76);
                const real_t tmp_kernel_op_80 = tmp_kernel_op_77 + tmp_kernel_op_78 + tmp_kernel_op_79;
                const real_t tmp_kernel_op_81 = pow(tmp_kernel_op_80, -4.5000000000000000);
                const real_t tmp_kernel_op_82 = -tmp_kernel_op_29 - tmp_kernel_op_76;
                const real_t tmp_kernel_op_83 = -tmp_kernel_op_18 - tmp_kernel_op_74;
                const real_t tmp_kernel_op_84 = -tmp_kernel_op_25 - tmp_kernel_op_75;
                const real_t tmp_kernel_op_85 = -tmp_kernel_op_35*(tmp_kernel_op_19*tmp_kernel_op_20*tmp_kernel_op_84 + tmp_kernel_op_23*tmp_kernel_op_30*tmp_kernel_op_83 - tmp_kernel_op_24*tmp_kernel_op_82 + tmp_kernel_op_26*tmp_kernel_op_27*tmp_kernel_op_82 - tmp_kernel_op_31*tmp_kernel_op_83 - tmp_kernel_op_32*tmp_kernel_op_84) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_86 = -tmp_kernel_op_85;
                const real_t tmp_kernel_op_87 = tmp_kernel_op_36*tmp_kernel_op_80 + tmp_kernel_op_76*tmp_kernel_op_86;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_44*tmp_kernel_op_80 + tmp_kernel_op_74*tmp_kernel_op_86;
                const real_t tmp_kernel_op_89 = -tmp_kernel_op_47*tmp_kernel_op_80 - tmp_kernel_op_75*tmp_kernel_op_85;
                const real_t tmp_kernel_op_90 = tmp_kernel_op_78*tmp_kernel_op_86 + tmp_kernel_op_80*(tmp_kernel_op_49*tmp_kernel_op_75 + tmp_kernel_op_85);
                const real_t tmp_kernel_op_91 = tmp_kernel_op_74*tmp_kernel_op_88;
                const real_t tmp_kernel_op_92 = tmp_kernel_op_52*tmp_kernel_op_81;
                const real_t tmp_kernel_op_93 = tmp_kernel_op_76*tmp_kernel_op_87*tmp_kernel_op_92;
                const real_t tmp_kernel_op_94 = tmp_kernel_op_79*tmp_kernel_op_86 + tmp_kernel_op_80*(tmp_kernel_op_36*tmp_kernel_op_76 + tmp_kernel_op_85);
                const real_t tmp_kernel_op_95 = tmp_kernel_op_75*tmp_kernel_op_89*tmp_kernel_op_91;
                const real_t tmp_kernel_op_96 = -tmp_kernel_op_77*tmp_kernel_op_85 + tmp_kernel_op_80*(tmp_kernel_op_44*tmp_kernel_op_74 + tmp_kernel_op_85);
                const real_t tmp_kernel_op_97 = tmp_kernel_op_75*tmp_kernel_op_96;
                const real_t tmp_kernel_op_98 = tmp_kernel_op_34*tmp_kernel_op_74*tmp_kernel_op_75*tmp_kernel_op_76*tmp_kernel_op_81*tmp_kernel_op_87*tmp_kernel_op_88*tmp_kernel_op_89*2.0 + tmp_kernel_op_34*tmp_kernel_op_81*tmp_kernel_op_90*tmp_kernel_op_94*tmp_kernel_op_96*1.0 - tmp_kernel_op_89*tmp_kernel_op_93*tmp_kernel_op_97 - tmp_kernel_op_90*tmp_kernel_op_91*tmp_kernel_op_93 - tmp_kernel_op_92*tmp_kernel_op_94*tmp_kernel_op_95;
                const real_t tmp_kernel_op_99 = abs_det_jac_affine_WHITE_UP*0.041666666666666657*abs(tmp_kernel_op_98);
                const real_t tmp_kernel_op_100 = tmp_kernel_op_99*0.13819660112501056;
                const real_t tmp_kernel_op_101 = 1.0 / (tmp_kernel_op_98);
                const real_t tmp_kernel_op_102 = 1.0 / (tmp_kernel_op_80*tmp_kernel_op_80*tmp_kernel_op_80);
                const real_t tmp_kernel_op_103 = tmp_kernel_op_102*tmp_kernel_op_65;
                const real_t tmp_kernel_op_104 = tmp_kernel_op_103*tmp_kernel_op_87;
                const real_t tmp_kernel_op_105 = tmp_kernel_op_101*(tmp_kernel_op_102*tmp_kernel_op_64*tmp_kernel_op_74*tmp_kernel_op_75*tmp_kernel_op_87*tmp_kernel_op_88*1.0 - tmp_kernel_op_104*tmp_kernel_op_97);
                const real_t tmp_kernel_op_106 = tmp_kernel_op_101*(tmp_kernel_op_102*tmp_kernel_op_64*tmp_kernel_op_74*tmp_kernel_op_75*tmp_kernel_op_87*tmp_kernel_op_89*1.0 - tmp_kernel_op_104*tmp_kernel_op_74*tmp_kernel_op_90);
                const real_t tmp_kernel_op_107 = tmp_kernel_op_101*(tmp_kernel_op_103*tmp_kernel_op_90*tmp_kernel_op_96 - tmp_kernel_op_103*tmp_kernel_op_95);
                const real_t tmp_kernel_op_108 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_106 + jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_105 + jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_107;
                const real_t tmp_kernel_op_110 = tmp_kernel_op_108*(tmp_kernel_op_109 - 1.0);
                const real_t tmp_kernel_op_111 = p_affine_0_0 + tmp_kernel_op_0*0.5854101966249684 + tmp_kernel_op_1*0.1381966011250105 + tmp_kernel_op_2*0.1381966011250105;
                const real_t tmp_kernel_op_112 = p_affine_0_1 + tmp_kernel_op_4*0.5854101966249684 + tmp_kernel_op_5*0.1381966011250105 + tmp_kernel_op_6*0.1381966011250105;
                const real_t tmp_kernel_op_113 = p_affine_0_2 + tmp_kernel_op_10*0.1381966011250105 + tmp_kernel_op_8*0.5854101966249684 + tmp_kernel_op_9*0.1381966011250105;
                const real_t tmp_kernel_op_114 = (tmp_kernel_op_111*tmp_kernel_op_111);
                const real_t tmp_kernel_op_115 = (tmp_kernel_op_112*tmp_kernel_op_112);
                const real_t tmp_kernel_op_116 = (tmp_kernel_op_113*tmp_kernel_op_113);
                const real_t tmp_kernel_op_117 = tmp_kernel_op_114 + tmp_kernel_op_115 + tmp_kernel_op_116;
                const real_t tmp_kernel_op_118 = pow(tmp_kernel_op_117, -4.5000000000000000);
                const real_t tmp_kernel_op_119 = -tmp_kernel_op_113 - tmp_kernel_op_29;
                const real_t tmp_kernel_op_120 = -tmp_kernel_op_111 - tmp_kernel_op_18;
                const real_t tmp_kernel_op_121 = -tmp_kernel_op_112 - tmp_kernel_op_25;
                const real_t tmp_kernel_op_122 = -tmp_kernel_op_35*(-tmp_kernel_op_119*tmp_kernel_op_24 + tmp_kernel_op_119*tmp_kernel_op_26*tmp_kernel_op_27 + tmp_kernel_op_120*tmp_kernel_op_23*tmp_kernel_op_30 - tmp_kernel_op_120*tmp_kernel_op_31 + tmp_kernel_op_121*tmp_kernel_op_19*tmp_kernel_op_20 - tmp_kernel_op_121*tmp_kernel_op_32) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_123 = -tmp_kernel_op_122;
                const real_t tmp_kernel_op_124 = tmp_kernel_op_113*tmp_kernel_op_123 + tmp_kernel_op_117*tmp_kernel_op_36;
                const real_t tmp_kernel_op_125 = tmp_kernel_op_111*tmp_kernel_op_123 + tmp_kernel_op_117*tmp_kernel_op_44;
                const real_t tmp_kernel_op_126 = -tmp_kernel_op_112*tmp_kernel_op_122 - tmp_kernel_op_117*tmp_kernel_op_47;
                const real_t tmp_kernel_op_127 = tmp_kernel_op_115*tmp_kernel_op_123 + tmp_kernel_op_117*(tmp_kernel_op_112*tmp_kernel_op_49 + tmp_kernel_op_122);
                const real_t tmp_kernel_op_128 = tmp_kernel_op_111*tmp_kernel_op_125;
                const real_t tmp_kernel_op_129 = tmp_kernel_op_118*tmp_kernel_op_52;
                const real_t tmp_kernel_op_130 = tmp_kernel_op_113*tmp_kernel_op_124*tmp_kernel_op_129;
                const real_t tmp_kernel_op_131 = tmp_kernel_op_116*tmp_kernel_op_123 + tmp_kernel_op_117*(tmp_kernel_op_113*tmp_kernel_op_36 + tmp_kernel_op_122);
                const real_t tmp_kernel_op_132 = tmp_kernel_op_112*tmp_kernel_op_126*tmp_kernel_op_128;
                const real_t tmp_kernel_op_133 = -tmp_kernel_op_114*tmp_kernel_op_122 + tmp_kernel_op_117*(tmp_kernel_op_111*tmp_kernel_op_44 + tmp_kernel_op_122);
                const real_t tmp_kernel_op_134 = tmp_kernel_op_112*tmp_kernel_op_133;
                const real_t tmp_kernel_op_135 = tmp_kernel_op_111*tmp_kernel_op_112*tmp_kernel_op_113*tmp_kernel_op_118*tmp_kernel_op_124*tmp_kernel_op_125*tmp_kernel_op_126*tmp_kernel_op_34*2.0 + tmp_kernel_op_118*tmp_kernel_op_127*tmp_kernel_op_131*tmp_kernel_op_133*tmp_kernel_op_34*1.0 - tmp_kernel_op_126*tmp_kernel_op_130*tmp_kernel_op_134 - tmp_kernel_op_127*tmp_kernel_op_128*tmp_kernel_op_130 - tmp_kernel_op_129*tmp_kernel_op_131*tmp_kernel_op_132;
                const real_t tmp_kernel_op_136 = abs_det_jac_affine_WHITE_UP*0.041666666666666657*abs(tmp_kernel_op_135);
                const real_t tmp_kernel_op_137 = tmp_kernel_op_136*0.13819660112501056;
                const real_t tmp_kernel_op_138 = 1.0 / (tmp_kernel_op_135);
                const real_t tmp_kernel_op_139 = 1.0 / (tmp_kernel_op_117*tmp_kernel_op_117*tmp_kernel_op_117);
                const real_t tmp_kernel_op_140 = tmp_kernel_op_139*tmp_kernel_op_65;
                const real_t tmp_kernel_op_141 = tmp_kernel_op_124*tmp_kernel_op_140;
                const real_t tmp_kernel_op_142 = tmp_kernel_op_138*(tmp_kernel_op_111*tmp_kernel_op_112*tmp_kernel_op_124*tmp_kernel_op_125*tmp_kernel_op_139*tmp_kernel_op_64*1.0 - tmp_kernel_op_134*tmp_kernel_op_141);
                const real_t tmp_kernel_op_143 = tmp_kernel_op_138*(tmp_kernel_op_111*tmp_kernel_op_112*tmp_kernel_op_124*tmp_kernel_op_126*tmp_kernel_op_139*tmp_kernel_op_64*1.0 - tmp_kernel_op_111*tmp_kernel_op_127*tmp_kernel_op_141);
                const real_t tmp_kernel_op_144 = tmp_kernel_op_138*(tmp_kernel_op_127*tmp_kernel_op_133*tmp_kernel_op_140 - tmp_kernel_op_132*tmp_kernel_op_140);
                const real_t tmp_kernel_op_145 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_143 + jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_142 + jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_144;
                const real_t tmp_kernel_op_147 = tmp_kernel_op_145*(tmp_kernel_op_146 - 1.0);
                const real_t tmp_kernel_op_148 = p_affine_0_0 + tmp_kernel_op_0*0.1381966011250105 + tmp_kernel_op_1*0.1381966011250105 + tmp_kernel_op_2*0.1381966011250105;
                const real_t tmp_kernel_op_149 = p_affine_0_1 + tmp_kernel_op_4*0.1381966011250105 + tmp_kernel_op_5*0.1381966011250105 + tmp_kernel_op_6*0.1381966011250105;
                const real_t tmp_kernel_op_150 = p_affine_0_2 + tmp_kernel_op_10*0.1381966011250105 + tmp_kernel_op_8*0.1381966011250105 + tmp_kernel_op_9*0.1381966011250105;
                const real_t tmp_kernel_op_151 = (tmp_kernel_op_148*tmp_kernel_op_148);
                const real_t tmp_kernel_op_152 = (tmp_kernel_op_149*tmp_kernel_op_149);
                const real_t tmp_kernel_op_153 = (tmp_kernel_op_150*tmp_kernel_op_150);
                const real_t tmp_kernel_op_154 = tmp_kernel_op_151 + tmp_kernel_op_152 + tmp_kernel_op_153;
                const real_t tmp_kernel_op_155 = pow(tmp_kernel_op_154, -4.5000000000000000);
                const real_t tmp_kernel_op_156 = -tmp_kernel_op_150 - tmp_kernel_op_29;
                const real_t tmp_kernel_op_157 = -tmp_kernel_op_148 - tmp_kernel_op_18;
                const real_t tmp_kernel_op_158 = -tmp_kernel_op_149 - tmp_kernel_op_25;
                const real_t tmp_kernel_op_159 = -tmp_kernel_op_35*(-tmp_kernel_op_156*tmp_kernel_op_24 + tmp_kernel_op_156*tmp_kernel_op_26*tmp_kernel_op_27 + tmp_kernel_op_157*tmp_kernel_op_23*tmp_kernel_op_30 - tmp_kernel_op_157*tmp_kernel_op_31 + tmp_kernel_op_158*tmp_kernel_op_19*tmp_kernel_op_20 - tmp_kernel_op_158*tmp_kernel_op_32) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_160 = -tmp_kernel_op_159;
                const real_t tmp_kernel_op_161 = tmp_kernel_op_150*tmp_kernel_op_160 + tmp_kernel_op_154*tmp_kernel_op_36;
                const real_t tmp_kernel_op_162 = tmp_kernel_op_148*tmp_kernel_op_160 + tmp_kernel_op_154*tmp_kernel_op_44;
                const real_t tmp_kernel_op_163 = -tmp_kernel_op_149*tmp_kernel_op_159 - tmp_kernel_op_154*tmp_kernel_op_47;
                const real_t tmp_kernel_op_164 = tmp_kernel_op_152*tmp_kernel_op_160 + tmp_kernel_op_154*(tmp_kernel_op_149*tmp_kernel_op_49 + tmp_kernel_op_159);
                const real_t tmp_kernel_op_165 = tmp_kernel_op_148*tmp_kernel_op_162;
                const real_t tmp_kernel_op_166 = tmp_kernel_op_155*tmp_kernel_op_52;
                const real_t tmp_kernel_op_167 = tmp_kernel_op_150*tmp_kernel_op_161*tmp_kernel_op_166;
                const real_t tmp_kernel_op_168 = tmp_kernel_op_153*tmp_kernel_op_160 + tmp_kernel_op_154*(tmp_kernel_op_150*tmp_kernel_op_36 + tmp_kernel_op_159);
                const real_t tmp_kernel_op_169 = tmp_kernel_op_149*tmp_kernel_op_163*tmp_kernel_op_165;
                const real_t tmp_kernel_op_170 = -tmp_kernel_op_151*tmp_kernel_op_159 + tmp_kernel_op_154*(tmp_kernel_op_148*tmp_kernel_op_44 + tmp_kernel_op_159);
                const real_t tmp_kernel_op_171 = tmp_kernel_op_149*tmp_kernel_op_170;
                const real_t tmp_kernel_op_172 = tmp_kernel_op_148*tmp_kernel_op_149*tmp_kernel_op_150*tmp_kernel_op_155*tmp_kernel_op_161*tmp_kernel_op_162*tmp_kernel_op_163*tmp_kernel_op_34*2.0 + tmp_kernel_op_155*tmp_kernel_op_164*tmp_kernel_op_168*tmp_kernel_op_170*tmp_kernel_op_34*1.0 - tmp_kernel_op_163*tmp_kernel_op_167*tmp_kernel_op_171 - tmp_kernel_op_164*tmp_kernel_op_165*tmp_kernel_op_167 - tmp_kernel_op_166*tmp_kernel_op_168*tmp_kernel_op_169;
                const real_t tmp_kernel_op_173 = abs_det_jac_affine_WHITE_UP*0.041666666666666657*abs(tmp_kernel_op_172);
                const real_t tmp_kernel_op_174 = tmp_kernel_op_173*0.5854101966249684;
                const real_t tmp_kernel_op_175 = 1.0 / (tmp_kernel_op_172);
                const real_t tmp_kernel_op_176 = 1.0 / (tmp_kernel_op_154*tmp_kernel_op_154*tmp_kernel_op_154);
                const real_t tmp_kernel_op_177 = tmp_kernel_op_176*tmp_kernel_op_65;
                const real_t tmp_kernel_op_178 = tmp_kernel_op_161*tmp_kernel_op_177;
                const real_t tmp_kernel_op_179 = tmp_kernel_op_175*(tmp_kernel_op_148*tmp_kernel_op_149*tmp_kernel_op_161*tmp_kernel_op_162*tmp_kernel_op_176*tmp_kernel_op_64*1.0 - tmp_kernel_op_171*tmp_kernel_op_178);
                const real_t tmp_kernel_op_180 = tmp_kernel_op_175*(tmp_kernel_op_148*tmp_kernel_op_149*tmp_kernel_op_161*tmp_kernel_op_163*tmp_kernel_op_176*tmp_kernel_op_64*1.0 - tmp_kernel_op_148*tmp_kernel_op_164*tmp_kernel_op_178);
                const real_t tmp_kernel_op_181 = tmp_kernel_op_175*(tmp_kernel_op_164*tmp_kernel_op_170*tmp_kernel_op_177 - tmp_kernel_op_169*tmp_kernel_op_177);
                const real_t tmp_kernel_op_182 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_180 + jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_179 + jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_181;
                const real_t tmp_kernel_op_184 = tmp_kernel_op_182*(tmp_kernel_op_183 - 1.0);
                const real_t tmp_kernel_op_185 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_69 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_68 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_70;
                const real_t tmp_kernel_op_187 = tmp_kernel_op_185*(tmp_kernel_op_186 - 1.0);
                const real_t tmp_kernel_op_188 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_106 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_105 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_107;
                const real_t tmp_kernel_op_190 = tmp_kernel_op_188*(tmp_kernel_op_189 - 1.0);
                const real_t tmp_kernel_op_191 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_143 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_142 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_144;
                const real_t tmp_kernel_op_193 = tmp_kernel_op_191*(tmp_kernel_op_192 - 1.0);
                const real_t tmp_kernel_op_194 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_180 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_179 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_181;
                const real_t tmp_kernel_op_196 = tmp_kernel_op_194*(tmp_kernel_op_195 - 1.0);
                const real_t tmp_kernel_op_197 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_69 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_68 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_70;
                const real_t tmp_kernel_op_199 = tmp_kernel_op_197*(tmp_kernel_op_198 - 1.0);
                const real_t tmp_kernel_op_200 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_106 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_105 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_107;
                const real_t tmp_kernel_op_202 = tmp_kernel_op_200*(tmp_kernel_op_201 - 1.0);
                const real_t tmp_kernel_op_203 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_143 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_142 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_144;
                const real_t tmp_kernel_op_205 = tmp_kernel_op_203*(tmp_kernel_op_204 - 1.0);
                const real_t tmp_kernel_op_206 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_180 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_179 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_181;
                const real_t tmp_kernel_op_208 = tmp_kernel_op_206*(tmp_kernel_op_207 - 1.0);
                const real_t tmp_kernel_op_209 = tmp_kernel_op_186*tmp_kernel_op_197;
                const real_t tmp_kernel_op_210 = tmp_kernel_op_185*tmp_kernel_op_198;
                const real_t tmp_kernel_op_211 = -tmp_kernel_op_209 - tmp_kernel_op_210;
                const real_t tmp_kernel_op_212 = tmp_kernel_op_189*tmp_kernel_op_200;
                const real_t tmp_kernel_op_213 = tmp_kernel_op_188*tmp_kernel_op_201;
                const real_t tmp_kernel_op_214 = -tmp_kernel_op_212 - tmp_kernel_op_213;
                const real_t tmp_kernel_op_215 = tmp_kernel_op_192*tmp_kernel_op_203;
                const real_t tmp_kernel_op_216 = tmp_kernel_op_191*tmp_kernel_op_204;
                const real_t tmp_kernel_op_217 = -tmp_kernel_op_215 - tmp_kernel_op_216;
                const real_t tmp_kernel_op_218 = tmp_kernel_op_195*tmp_kernel_op_206;
                const real_t tmp_kernel_op_219 = tmp_kernel_op_194*tmp_kernel_op_207;
                const real_t tmp_kernel_op_220 = -tmp_kernel_op_218 - tmp_kernel_op_219;
                const real_t tmp_kernel_op_221 = tmp_kernel_op_197*tmp_kernel_op_72;
                const real_t tmp_kernel_op_222 = tmp_kernel_op_198*tmp_kernel_op_71;
                const real_t tmp_kernel_op_223 = -tmp_kernel_op_221 - tmp_kernel_op_222;
                const real_t tmp_kernel_op_224 = tmp_kernel_op_109*tmp_kernel_op_200;
                const real_t tmp_kernel_op_225 = tmp_kernel_op_108*tmp_kernel_op_201;
                const real_t tmp_kernel_op_226 = -tmp_kernel_op_224 - tmp_kernel_op_225;
                const real_t tmp_kernel_op_227 = tmp_kernel_op_146*tmp_kernel_op_203;
                const real_t tmp_kernel_op_228 = tmp_kernel_op_145*tmp_kernel_op_204;
                const real_t tmp_kernel_op_229 = -tmp_kernel_op_227 - tmp_kernel_op_228;
                const real_t tmp_kernel_op_230 = tmp_kernel_op_183*tmp_kernel_op_206;
                const real_t tmp_kernel_op_231 = tmp_kernel_op_182*tmp_kernel_op_207;
                const real_t tmp_kernel_op_232 = -tmp_kernel_op_230 - tmp_kernel_op_231;
                const real_t tmp_kernel_op_233 = tmp_kernel_op_185*tmp_kernel_op_72;
                const real_t tmp_kernel_op_234 = tmp_kernel_op_186*tmp_kernel_op_71;
                const real_t tmp_kernel_op_235 = -tmp_kernel_op_233 - tmp_kernel_op_234;
                const real_t tmp_kernel_op_236 = tmp_kernel_op_109*tmp_kernel_op_188;
                const real_t tmp_kernel_op_237 = tmp_kernel_op_108*tmp_kernel_op_189;
                const real_t tmp_kernel_op_238 = -tmp_kernel_op_236 - tmp_kernel_op_237;
                const real_t tmp_kernel_op_239 = tmp_kernel_op_146*tmp_kernel_op_191;
                const real_t tmp_kernel_op_240 = tmp_kernel_op_145*tmp_kernel_op_192;
                const real_t tmp_kernel_op_241 = -tmp_kernel_op_239 - tmp_kernel_op_240;
                const real_t tmp_kernel_op_242 = tmp_kernel_op_183*tmp_kernel_op_194;
                const real_t tmp_kernel_op_243 = tmp_kernel_op_182*tmp_kernel_op_195;
                const real_t tmp_kernel_op_244 = -tmp_kernel_op_242 - tmp_kernel_op_243;
                const real_t tmp_kernel_op_246 = -tmp_kernel_op_197*(-tmp_kernel_op_245 - 0.68328157299974723) + tmp_kernel_op_210 + tmp_kernel_op_222;
                const real_t tmp_kernel_op_248 = -tmp_kernel_op_200*(-tmp_kernel_op_247 + 2.8944271909999157) + tmp_kernel_op_213 + tmp_kernel_op_225;
                const real_t tmp_kernel_op_250 = -tmp_kernel_op_203*(-tmp_kernel_op_249 + 2.8944271909999157) + tmp_kernel_op_216 + tmp_kernel_op_228;
                const real_t tmp_kernel_op_252 = -tmp_kernel_op_206*(-tmp_kernel_op_251 + 2.8944271909999157) + tmp_kernel_op_219 + tmp_kernel_op_231;
                const real_t tmp_kernel_op_254 = -tmp_kernel_op_185*(-tmp_kernel_op_253 - tmp_kernel_op_72 - 1.105572809000084) + tmp_kernel_op_209 + tmp_kernel_op_234;
                const real_t tmp_kernel_op_256 = -tmp_kernel_op_188*(-tmp_kernel_op_109 - tmp_kernel_op_255 - 4.6832815729997472) + tmp_kernel_op_212 + tmp_kernel_op_237;
                const real_t tmp_kernel_op_258 = -tmp_kernel_op_191*(-tmp_kernel_op_146 - tmp_kernel_op_257 - 1.105572809000084) + tmp_kernel_op_215 + tmp_kernel_op_240;
                const real_t tmp_kernel_op_260 = -tmp_kernel_op_194*(-tmp_kernel_op_183 - tmp_kernel_op_259 - 1.105572809000084) + tmp_kernel_op_218 + tmp_kernel_op_243;
                const real_t tmp_kernel_op_261 = tmp_kernel_op_221 + tmp_kernel_op_233 - tmp_kernel_op_71*(-tmp_kernel_op_186 - tmp_kernel_op_253 - 1.105572809000084);
                const real_t tmp_kernel_op_262 = -tmp_kernel_op_108*(-tmp_kernel_op_189 - tmp_kernel_op_255 - 1.105572809000084) + tmp_kernel_op_224 + tmp_kernel_op_236;
                const real_t tmp_kernel_op_263 = -tmp_kernel_op_145*(-tmp_kernel_op_192 - tmp_kernel_op_257 - 4.6832815729997472) + tmp_kernel_op_227 + tmp_kernel_op_239;
                const real_t tmp_kernel_op_264 = -tmp_kernel_op_182*(-tmp_kernel_op_195 - tmp_kernel_op_259 - 1.105572809000084) + tmp_kernel_op_230 + tmp_kernel_op_242;
                const real_t tmp_kernel_op_266 = -tmp_kernel_op_185*tmp_kernel_op_265 - tmp_kernel_op_197*tmp_kernel_op_265 - tmp_kernel_op_265*tmp_kernel_op_71;
                const real_t tmp_kernel_op_268 = -tmp_kernel_op_108*tmp_kernel_op_267 - tmp_kernel_op_188*tmp_kernel_op_267 - tmp_kernel_op_200*tmp_kernel_op_267;
                const real_t tmp_kernel_op_270 = -tmp_kernel_op_145*tmp_kernel_op_269 - tmp_kernel_op_191*tmp_kernel_op_269 - tmp_kernel_op_203*tmp_kernel_op_269;
                const real_t tmp_kernel_op_272 = -tmp_kernel_op_182*tmp_kernel_op_271 - tmp_kernel_op_194*tmp_kernel_op_271 - tmp_kernel_op_206*tmp_kernel_op_271;
                const real_t tmp_kernel_op_273 = tmp_kernel_op_60*0.1381966011250105;
                const real_t tmp_kernel_op_274 = tmp_kernel_op_99*0.1381966011250105;
                const real_t tmp_kernel_op_275 = tmp_kernel_op_136*0.5854101966249684;
                const real_t tmp_kernel_op_276 = tmp_kernel_op_173*0.1381966011250105;
                const real_t tmp_kernel_op_277 = tmp_kernel_op_60*0.1381966011250105;
                const real_t tmp_kernel_op_278 = tmp_kernel_op_99*0.5854101966249684;
                const real_t tmp_kernel_op_279 = tmp_kernel_op_136*0.1381966011250105;
                const real_t tmp_kernel_op_280 = tmp_kernel_op_173*0.1381966011250105;
                const real_t tmp_kernel_op_281 = tmp_kernel_op_60*0.5854101966249684;
                const real_t tmp_kernel_op_282 = tmp_kernel_op_99*0.1381966011250105;
                const real_t tmp_kernel_op_283 = tmp_kernel_op_136*0.1381966011250105;
                const real_t tmp_kernel_op_284 = tmp_kernel_op_173*0.1381966011250105;
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_100*tmp_kernel_op_268 + tmp_kernel_op_137*tmp_kernel_op_270 + tmp_kernel_op_174*tmp_kernel_op_272 + tmp_kernel_op_266*tmp_kernel_op_61) + src_dof_1*(-tmp_kernel_op_100*tmp_kernel_op_110 - tmp_kernel_op_137*tmp_kernel_op_147 - tmp_kernel_op_174*tmp_kernel_op_184 - tmp_kernel_op_61*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_100*tmp_kernel_op_190 - tmp_kernel_op_137*tmp_kernel_op_193 - tmp_kernel_op_174*tmp_kernel_op_196 - tmp_kernel_op_187*tmp_kernel_op_61) + src_dof_3*(-tmp_kernel_op_100*tmp_kernel_op_202 - tmp_kernel_op_137*tmp_kernel_op_205 - tmp_kernel_op_174*tmp_kernel_op_208 - tmp_kernel_op_199*tmp_kernel_op_61) + src_dof_4*(tmp_kernel_op_100*tmp_kernel_op_214 + tmp_kernel_op_137*tmp_kernel_op_217 + tmp_kernel_op_174*tmp_kernel_op_220 + tmp_kernel_op_211*tmp_kernel_op_61) + src_dof_5*(tmp_kernel_op_100*tmp_kernel_op_226 + tmp_kernel_op_137*tmp_kernel_op_229 + tmp_kernel_op_174*tmp_kernel_op_232 + tmp_kernel_op_223*tmp_kernel_op_61) + src_dof_6*(tmp_kernel_op_100*tmp_kernel_op_238 + tmp_kernel_op_137*tmp_kernel_op_241 + tmp_kernel_op_174*tmp_kernel_op_244 + tmp_kernel_op_235*tmp_kernel_op_61) + src_dof_7*(tmp_kernel_op_100*tmp_kernel_op_248 + tmp_kernel_op_137*tmp_kernel_op_250 + tmp_kernel_op_174*tmp_kernel_op_252 + tmp_kernel_op_246*tmp_kernel_op_61) + src_dof_8*(tmp_kernel_op_100*tmp_kernel_op_256 + tmp_kernel_op_137*tmp_kernel_op_258 + tmp_kernel_op_174*tmp_kernel_op_260 + tmp_kernel_op_254*tmp_kernel_op_61) + src_dof_9*(tmp_kernel_op_100*tmp_kernel_op_262 + tmp_kernel_op_137*tmp_kernel_op_263 + tmp_kernel_op_174*tmp_kernel_op_264 + tmp_kernel_op_261*tmp_kernel_op_61);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_266*tmp_kernel_op_273 + tmp_kernel_op_268*tmp_kernel_op_274 + tmp_kernel_op_270*tmp_kernel_op_275 + tmp_kernel_op_272*tmp_kernel_op_276) + src_dof_1*(-tmp_kernel_op_110*tmp_kernel_op_274 - tmp_kernel_op_147*tmp_kernel_op_275 - tmp_kernel_op_184*tmp_kernel_op_276 - tmp_kernel_op_273*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_187*tmp_kernel_op_273 - tmp_kernel_op_190*tmp_kernel_op_274 - tmp_kernel_op_193*tmp_kernel_op_275 - tmp_kernel_op_196*tmp_kernel_op_276) + src_dof_3*(-tmp_kernel_op_199*tmp_kernel_op_273 - tmp_kernel_op_202*tmp_kernel_op_274 - tmp_kernel_op_205*tmp_kernel_op_275 - tmp_kernel_op_208*tmp_kernel_op_276) + src_dof_4*(tmp_kernel_op_211*tmp_kernel_op_273 + tmp_kernel_op_214*tmp_kernel_op_274 + tmp_kernel_op_217*tmp_kernel_op_275 + tmp_kernel_op_220*tmp_kernel_op_276) + src_dof_5*(tmp_kernel_op_223*tmp_kernel_op_273 + tmp_kernel_op_226*tmp_kernel_op_274 + tmp_kernel_op_229*tmp_kernel_op_275 + tmp_kernel_op_232*tmp_kernel_op_276) + src_dof_6*(tmp_kernel_op_235*tmp_kernel_op_273 + tmp_kernel_op_238*tmp_kernel_op_274 + tmp_kernel_op_241*tmp_kernel_op_275 + tmp_kernel_op_244*tmp_kernel_op_276) + src_dof_7*(tmp_kernel_op_246*tmp_kernel_op_273 + tmp_kernel_op_248*tmp_kernel_op_274 + tmp_kernel_op_250*tmp_kernel_op_275 + tmp_kernel_op_252*tmp_kernel_op_276) + src_dof_8*(tmp_kernel_op_254*tmp_kernel_op_273 + tmp_kernel_op_256*tmp_kernel_op_274 + tmp_kernel_op_258*tmp_kernel_op_275 + tmp_kernel_op_260*tmp_kernel_op_276) + src_dof_9*(tmp_kernel_op_261*tmp_kernel_op_273 + tmp_kernel_op_262*tmp_kernel_op_274 + tmp_kernel_op_263*tmp_kernel_op_275 + tmp_kernel_op_264*tmp_kernel_op_276);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_266*tmp_kernel_op_277 + tmp_kernel_op_268*tmp_kernel_op_278 + tmp_kernel_op_270*tmp_kernel_op_279 + tmp_kernel_op_272*tmp_kernel_op_280) + src_dof_1*(-tmp_kernel_op_110*tmp_kernel_op_278 - tmp_kernel_op_147*tmp_kernel_op_279 - tmp_kernel_op_184*tmp_kernel_op_280 - tmp_kernel_op_277*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_187*tmp_kernel_op_277 - tmp_kernel_op_190*tmp_kernel_op_278 - tmp_kernel_op_193*tmp_kernel_op_279 - tmp_kernel_op_196*tmp_kernel_op_280) + src_dof_3*(-tmp_kernel_op_199*tmp_kernel_op_277 - tmp_kernel_op_202*tmp_kernel_op_278 - tmp_kernel_op_205*tmp_kernel_op_279 - tmp_kernel_op_208*tmp_kernel_op_280) + src_dof_4*(tmp_kernel_op_211*tmp_kernel_op_277 + tmp_kernel_op_214*tmp_kernel_op_278 + tmp_kernel_op_217*tmp_kernel_op_279 + tmp_kernel_op_220*tmp_kernel_op_280) + src_dof_5*(tmp_kernel_op_223*tmp_kernel_op_277 + tmp_kernel_op_226*tmp_kernel_op_278 + tmp_kernel_op_229*tmp_kernel_op_279 + tmp_kernel_op_232*tmp_kernel_op_280) + src_dof_6*(tmp_kernel_op_235*tmp_kernel_op_277 + tmp_kernel_op_238*tmp_kernel_op_278 + tmp_kernel_op_241*tmp_kernel_op_279 + tmp_kernel_op_244*tmp_kernel_op_280) + src_dof_7*(tmp_kernel_op_246*tmp_kernel_op_277 + tmp_kernel_op_248*tmp_kernel_op_278 + tmp_kernel_op_250*tmp_kernel_op_279 + tmp_kernel_op_252*tmp_kernel_op_280) + src_dof_8*(tmp_kernel_op_254*tmp_kernel_op_277 + tmp_kernel_op_256*tmp_kernel_op_278 + tmp_kernel_op_258*tmp_kernel_op_279 + tmp_kernel_op_260*tmp_kernel_op_280) + src_dof_9*(tmp_kernel_op_261*tmp_kernel_op_277 + tmp_kernel_op_262*tmp_kernel_op_278 + tmp_kernel_op_263*tmp_kernel_op_279 + tmp_kernel_op_264*tmp_kernel_op_280);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_266*tmp_kernel_op_281 + tmp_kernel_op_268*tmp_kernel_op_282 + tmp_kernel_op_270*tmp_kernel_op_283 + tmp_kernel_op_272*tmp_kernel_op_284) + src_dof_1*(-tmp_kernel_op_110*tmp_kernel_op_282 - tmp_kernel_op_147*tmp_kernel_op_283 - tmp_kernel_op_184*tmp_kernel_op_284 - tmp_kernel_op_281*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_187*tmp_kernel_op_281 - tmp_kernel_op_190*tmp_kernel_op_282 - tmp_kernel_op_193*tmp_kernel_op_283 - tmp_kernel_op_196*tmp_kernel_op_284) + src_dof_3*(-tmp_kernel_op_199*tmp_kernel_op_281 - tmp_kernel_op_202*tmp_kernel_op_282 - tmp_kernel_op_205*tmp_kernel_op_283 - tmp_kernel_op_208*tmp_kernel_op_284) + src_dof_4*(tmp_kernel_op_211*tmp_kernel_op_281 + tmp_kernel_op_214*tmp_kernel_op_282 + tmp_kernel_op_217*tmp_kernel_op_283 + tmp_kernel_op_220*tmp_kernel_op_284) + src_dof_5*(tmp_kernel_op_223*tmp_kernel_op_281 + tmp_kernel_op_226*tmp_kernel_op_282 + tmp_kernel_op_229*tmp_kernel_op_283 + tmp_kernel_op_232*tmp_kernel_op_284) + src_dof_6*(tmp_kernel_op_235*tmp_kernel_op_281 + tmp_kernel_op_238*tmp_kernel_op_282 + tmp_kernel_op_241*tmp_kernel_op_283 + tmp_kernel_op_244*tmp_kernel_op_284) + src_dof_7*(tmp_kernel_op_246*tmp_kernel_op_281 + tmp_kernel_op_248*tmp_kernel_op_282 + tmp_kernel_op_250*tmp_kernel_op_283 + tmp_kernel_op_252*tmp_kernel_op_284) + src_dof_8*(tmp_kernel_op_254*tmp_kernel_op_281 + tmp_kernel_op_256*tmp_kernel_op_282 + tmp_kernel_op_258*tmp_kernel_op_283 + tmp_kernel_op_260*tmp_kernel_op_284) + src_dof_9*(tmp_kernel_op_261*tmp_kernel_op_281 + tmp_kernel_op_262*tmp_kernel_op_282 + tmp_kernel_op_263*tmp_kernel_op_283 + tmp_kernel_op_264*tmp_kernel_op_284);
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       {
          /* CellType.WHITE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_kernel_op_0 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0);
                const __m256d tmp_kernel_op_1 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0);
                const __m256d tmp_kernel_op_2 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0);
                const __m256d tmp_kernel_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_kernel_op_4 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1);
                const __m256d tmp_kernel_op_5 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1);
                const __m256d tmp_kernel_op_6 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1);
                const __m256d tmp_kernel_op_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_kernel_op_8 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2);
                const __m256d tmp_kernel_op_9 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2);
                const __m256d tmp_kernel_op_10 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2);
                const __m256d tmp_kernel_op_11 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_kernel_op_12 = _mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_3);
                const __m256d tmp_kernel_op_13 = _mm256_mul_pd(tmp_kernel_op_7,tmp_kernel_op_7);
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_11);
                const __m256d tmp_kernel_op_15 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_12,tmp_kernel_op_13),tmp_kernel_op_14);
                const __m256d tmp_kernel_op_16 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_15),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_15,tmp_kernel_op_15),tmp_kernel_op_15),tmp_kernel_op_15),tmp_kernel_op_15));
                const __m256d tmp_kernel_op_38 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_11,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_39 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_40 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_41 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_39,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_39,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_42 = _mm256_mul_pd(tmp_kernel_op_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_45 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_48 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_7),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_7,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_41)),_mm256_mul_pd(tmp_kernel_op_13,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_51 = _mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_53 = _mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_54 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_43),tmp_kernel_op_53);
                const __m256d tmp_kernel_op_55 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_11,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_41)),_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_56 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_51),tmp_kernel_op_7);
                const __m256d tmp_kernel_op_57 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_41)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_41),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_58 = _mm256_mul_pd(tmp_kernel_op_57,tmp_kernel_op_7);
                const __m256d tmp_kernel_op_59 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_54),tmp_kernel_op_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_51),tmp_kernel_op_54),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_53,tmp_kernel_op_55),tmp_kernel_op_56),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_16,tmp_kernel_op_50),tmp_kernel_op_55),tmp_kernel_op_57),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_16),tmp_kernel_op_3),tmp_kernel_op_43),tmp_kernel_op_45),tmp_kernel_op_48),tmp_kernel_op_7),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_60 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_59))));
                const __m256d tmp_kernel_op_61 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.13819660112501053,0.13819660112501053,0.13819660112501053,0.13819660112501053));
                const __m256d tmp_kernel_op_62 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_59);
                const __m256d tmp_kernel_op_63 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_15),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_15)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_15));
                const __m256d tmp_kernel_op_66 = _mm256_mul_pd(tmp_kernel_op_63,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_67 = _mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_66);
                const __m256d tmp_kernel_op_68 = _mm256_mul_pd(tmp_kernel_op_62,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_58,tmp_kernel_op_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_43),tmp_kernel_op_45),tmp_kernel_op_63),tmp_kernel_op_7),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_69 = _mm256_mul_pd(tmp_kernel_op_62,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_50),tmp_kernel_op_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_43),tmp_kernel_op_48),tmp_kernel_op_63),tmp_kernel_op_7),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_70 = _mm256_mul_pd(tmp_kernel_op_62,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_56,tmp_kernel_op_66),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_57),tmp_kernel_op_66)));
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)));
                const __m256d tmp_kernel_op_73 = _mm256_mul_pd(tmp_kernel_op_71,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72)));
                const __m256d tmp_kernel_op_74 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_kernel_op_75 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_kernel_op_76 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_kernel_op_77 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_74);
                const __m256d tmp_kernel_op_78 = _mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_75);
                const __m256d tmp_kernel_op_79 = _mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_76);
                const __m256d tmp_kernel_op_80 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_77,tmp_kernel_op_78),tmp_kernel_op_79);
                const __m256d tmp_kernel_op_81 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_80),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_80,tmp_kernel_op_80),tmp_kernel_op_80),tmp_kernel_op_80),tmp_kernel_op_80));
                const __m256d tmp_kernel_op_82 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_76,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_83 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_74,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_75,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_85 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_82,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_82,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_86 = _mm256_mul_pd(tmp_kernel_op_85,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_87 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_88 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_89 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_90 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_75,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_91 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_88);
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_81,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_93 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_87),tmp_kernel_op_92);
                const __m256d tmp_kernel_op_94 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_76,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_79,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_95 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_89),tmp_kernel_op_91);
                const __m256d tmp_kernel_op_96 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_74,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_85)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_77,tmp_kernel_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_97 = _mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_98 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_89,tmp_kernel_op_93),tmp_kernel_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_90,tmp_kernel_op_91),tmp_kernel_op_93),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_94),tmp_kernel_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_81,tmp_kernel_op_90),tmp_kernel_op_94),tmp_kernel_op_96),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_75),tmp_kernel_op_76),tmp_kernel_op_81),tmp_kernel_op_87),tmp_kernel_op_88),tmp_kernel_op_89),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_99 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_98))));
                const __m256d tmp_kernel_op_100 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_101 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_98);
                const __m256d tmp_kernel_op_102 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_80),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_80)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_80));
                const __m256d tmp_kernel_op_103 = _mm256_mul_pd(tmp_kernel_op_102,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_104 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_105 = _mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_74),tmp_kernel_op_75),tmp_kernel_op_87),tmp_kernel_op_88),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_106 = _mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_74),tmp_kernel_op_90),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_74),tmp_kernel_op_75),tmp_kernel_op_87),tmp_kernel_op_89),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_107 = _mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_90),tmp_kernel_op_96)));
                const __m256d tmp_kernel_op_108 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_mul_pd(tmp_kernel_op_105,_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)));
                const __m256d tmp_kernel_op_110 = _mm256_mul_pd(tmp_kernel_op_108,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)));
                const __m256d tmp_kernel_op_111 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_kernel_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_kernel_op_113 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_kernel_op_114 = _mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_111);
                const __m256d tmp_kernel_op_115 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_112);
                const __m256d tmp_kernel_op_116 = _mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_113);
                const __m256d tmp_kernel_op_117 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_114,tmp_kernel_op_115),tmp_kernel_op_116);
                const __m256d tmp_kernel_op_118 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_117),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_117,tmp_kernel_op_117),tmp_kernel_op_117),tmp_kernel_op_117),tmp_kernel_op_117));
                const __m256d tmp_kernel_op_119 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_120 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_111,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_121 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_112,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_122 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_119,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_121,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_121,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_119,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_123 = _mm256_mul_pd(tmp_kernel_op_122,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_124 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_125 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_126 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_122),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_127 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_112,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_122)),_mm256_mul_pd(tmp_kernel_op_115,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_128 = _mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_125);
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(tmp_kernel_op_118,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_130 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_124),tmp_kernel_op_129);
                const __m256d tmp_kernel_op_131 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_122)),_mm256_mul_pd(tmp_kernel_op_116,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_132 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_126),tmp_kernel_op_128);
                const __m256d tmp_kernel_op_133 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_111,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_122)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_114,tmp_kernel_op_122),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_134 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_133);
                const __m256d tmp_kernel_op_135 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_130),tmp_kernel_op_134),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_128),tmp_kernel_op_130),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_129,tmp_kernel_op_131),tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_127),tmp_kernel_op_131),tmp_kernel_op_133),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_112),tmp_kernel_op_113),tmp_kernel_op_118),tmp_kernel_op_124),tmp_kernel_op_125),tmp_kernel_op_126),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_135))));
                const __m256d tmp_kernel_op_137 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_138 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_135);
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_117),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_117)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_117));
                const __m256d tmp_kernel_op_140 = _mm256_mul_pd(tmp_kernel_op_139,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_141 = _mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_140);
                const __m256d tmp_kernel_op_142 = _mm256_mul_pd(tmp_kernel_op_138,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_141),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_112),tmp_kernel_op_124),tmp_kernel_op_125),tmp_kernel_op_139),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_143 = _mm256_mul_pd(tmp_kernel_op_138,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_127),tmp_kernel_op_141),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_112),tmp_kernel_op_124),tmp_kernel_op_126),tmp_kernel_op_139),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_144 = _mm256_mul_pd(tmp_kernel_op_138,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_140),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_133),tmp_kernel_op_140)));
                const __m256d tmp_kernel_op_145 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN))),_mm256_mul_pd(tmp_kernel_op_144,_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)));
                const __m256d tmp_kernel_op_147 = _mm256_mul_pd(tmp_kernel_op_145,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146)));
                const __m256d tmp_kernel_op_148 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_0);
                const __m256d tmp_kernel_op_149 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_1);
                const __m256d tmp_kernel_op_150 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_2);
                const __m256d tmp_kernel_op_151 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_148);
                const __m256d tmp_kernel_op_152 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_149);
                const __m256d tmp_kernel_op_153 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_150);
                const __m256d tmp_kernel_op_154 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_151,tmp_kernel_op_152),tmp_kernel_op_153);
                const __m256d tmp_kernel_op_155 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_154),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_154),tmp_kernel_op_154),tmp_kernel_op_154),tmp_kernel_op_154));
                const __m256d tmp_kernel_op_156 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_150,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_157 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_158 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_149,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_159 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_156,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_156,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_160 = _mm256_mul_pd(tmp_kernel_op_159,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_161 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_162 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_163 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_164 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_149,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_159)),_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_165 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_162);
                const __m256d tmp_kernel_op_166 = _mm256_mul_pd(tmp_kernel_op_155,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_167 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_161),tmp_kernel_op_166);
                const __m256d tmp_kernel_op_168 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_150,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_159)),_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_169 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_163),tmp_kernel_op_165);
                const __m256d tmp_kernel_op_170 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_159)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_171 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_170);
                const __m256d tmp_kernel_op_172 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_167),tmp_kernel_op_171),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_164,tmp_kernel_op_165),tmp_kernel_op_167),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_166,tmp_kernel_op_168),tmp_kernel_op_169),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_164),tmp_kernel_op_168),tmp_kernel_op_170),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_149),tmp_kernel_op_150),tmp_kernel_op_155),tmp_kernel_op_161),tmp_kernel_op_162),tmp_kernel_op_163),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_173 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_172))));
                const __m256d tmp_kernel_op_174 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_175 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_172);
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_154),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_154)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_154));
                const __m256d tmp_kernel_op_177 = _mm256_mul_pd(tmp_kernel_op_176,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_178 = _mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_177);
                const __m256d tmp_kernel_op_179 = _mm256_mul_pd(tmp_kernel_op_175,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_178),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_149),tmp_kernel_op_161),tmp_kernel_op_162),tmp_kernel_op_176),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_180 = _mm256_mul_pd(tmp_kernel_op_175,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_164),tmp_kernel_op_178),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_149),tmp_kernel_op_161),tmp_kernel_op_163),tmp_kernel_op_176),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_181 = _mm256_mul_pd(tmp_kernel_op_175,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_177),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_164,tmp_kernel_op_170),tmp_kernel_op_177)));
                const __m256d tmp_kernel_op_182 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN)),_mm256_mul_pd(tmp_kernel_op_179,_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN))),_mm256_mul_pd(tmp_kernel_op_181,_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN)));
                const __m256d tmp_kernel_op_184 = _mm256_mul_pd(tmp_kernel_op_182,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183)));
                const __m256d tmp_kernel_op_185 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)));
                const __m256d tmp_kernel_op_187 = _mm256_mul_pd(tmp_kernel_op_185,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186)));
                const __m256d tmp_kernel_op_188 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_mul_pd(tmp_kernel_op_105,_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)));
                const __m256d tmp_kernel_op_190 = _mm256_mul_pd(tmp_kernel_op_188,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189)));
                const __m256d tmp_kernel_op_191 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN))),_mm256_mul_pd(tmp_kernel_op_144,_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)));
                const __m256d tmp_kernel_op_193 = _mm256_mul_pd(tmp_kernel_op_191,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192)));
                const __m256d tmp_kernel_op_194 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_mul_pd(tmp_kernel_op_179,_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN))),_mm256_mul_pd(tmp_kernel_op_181,_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)));
                const __m256d tmp_kernel_op_196 = _mm256_mul_pd(tmp_kernel_op_194,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195)));
                const __m256d tmp_kernel_op_197 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)));
                const __m256d tmp_kernel_op_199 = _mm256_mul_pd(tmp_kernel_op_197,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198)));
                const __m256d tmp_kernel_op_200 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_mul_pd(tmp_kernel_op_105,_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)));
                const __m256d tmp_kernel_op_202 = _mm256_mul_pd(tmp_kernel_op_200,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201)));
                const __m256d tmp_kernel_op_203 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_mul_pd(tmp_kernel_op_144,_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)));
                const __m256d tmp_kernel_op_205 = _mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204)));
                const __m256d tmp_kernel_op_206 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_mul_pd(tmp_kernel_op_179,_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_mul_pd(tmp_kernel_op_181,_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)));
                const __m256d tmp_kernel_op_208 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207)));
                const __m256d tmp_kernel_op_209 = _mm256_mul_pd(tmp_kernel_op_197,_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186));
                const __m256d tmp_kernel_op_210 = _mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198));
                const __m256d tmp_kernel_op_211 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_209,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_212 = _mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189));
                const __m256d tmp_kernel_op_213 = _mm256_mul_pd(tmp_kernel_op_188,_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201));
                const __m256d tmp_kernel_op_214 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_212,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_213,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_215 = _mm256_mul_pd(tmp_kernel_op_203,_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192));
                const __m256d tmp_kernel_op_216 = _mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204));
                const __m256d tmp_kernel_op_217 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_215,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_216,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_218 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195));
                const __m256d tmp_kernel_op_219 = _mm256_mul_pd(tmp_kernel_op_194,_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207));
                const __m256d tmp_kernel_op_220 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_218,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_219,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_221 = _mm256_mul_pd(tmp_kernel_op_197,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72));
                const __m256d tmp_kernel_op_222 = _mm256_mul_pd(tmp_kernel_op_71,_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198));
                const __m256d tmp_kernel_op_223 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_222,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_224 = _mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_225 = _mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201));
                const __m256d tmp_kernel_op_226 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_224,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_225,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_227 = _mm256_mul_pd(tmp_kernel_op_203,_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146));
                const __m256d tmp_kernel_op_228 = _mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204));
                const __m256d tmp_kernel_op_229 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_227,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_228,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_230 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183));
                const __m256d tmp_kernel_op_231 = _mm256_mul_pd(tmp_kernel_op_182,_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207));
                const __m256d tmp_kernel_op_232 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_230,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_231,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_233 = _mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72));
                const __m256d tmp_kernel_op_234 = _mm256_mul_pd(tmp_kernel_op_71,_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186));
                const __m256d tmp_kernel_op_235 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_233,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_234,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_236 = _mm256_mul_pd(tmp_kernel_op_188,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_237 = _mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189));
                const __m256d tmp_kernel_op_238 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_236,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_237,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_239 = _mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146));
                const __m256d tmp_kernel_op_240 = _mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192));
                const __m256d tmp_kernel_op_241 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_239,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_240,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_242 = _mm256_mul_pd(tmp_kernel_op_194,_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183));
                const __m256d tmp_kernel_op_243 = _mm256_mul_pd(tmp_kernel_op_182,_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195));
                const __m256d tmp_kernel_op_244 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_243,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_246 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245)),_mm256_set_pd(-0.68328157299974723,-0.68328157299974723,-0.68328157299974723,-0.68328157299974723))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_210),tmp_kernel_op_222);
                const __m256d tmp_kernel_op_248 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_200,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247)),_mm256_set_pd(2.8944271909999157,2.8944271909999157,2.8944271909999157,2.8944271909999157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_213),tmp_kernel_op_225);
                const __m256d tmp_kernel_op_250 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249)),_mm256_set_pd(2.8944271909999157,2.8944271909999157,2.8944271909999157,2.8944271909999157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_216),tmp_kernel_op_228);
                const __m256d tmp_kernel_op_252 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_206,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251)),_mm256_set_pd(2.8944271909999157,2.8944271909999157,2.8944271909999157,2.8944271909999157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_219),tmp_kernel_op_231);
                const __m256d tmp_kernel_op_254 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_209),tmp_kernel_op_234);
                const __m256d tmp_kernel_op_256 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_188,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))),_mm256_set_pd(-4.6832815729997472,-4.6832815729997472,-4.6832815729997472,-4.6832815729997472))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_212),tmp_kernel_op_237);
                const __m256d tmp_kernel_op_258 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_191,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_215),tmp_kernel_op_240);
                const __m256d tmp_kernel_op_260 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_218),tmp_kernel_op_243);
                const __m256d tmp_kernel_op_261 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_221),tmp_kernel_op_233);
                const __m256d tmp_kernel_op_262 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_108,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_224),tmp_kernel_op_236);
                const __m256d tmp_kernel_op_263 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_145,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257))),_mm256_set_pd(-4.6832815729997472,-4.6832815729997472,-4.6832815729997472,-4.6832815729997472))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_227),tmp_kernel_op_239);
                const __m256d tmp_kernel_op_264 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_182,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_230),tmp_kernel_op_242);
                const __m256d tmp_kernel_op_266 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265)));
                const __m256d tmp_kernel_op_268 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_188,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267)));
                const __m256d tmp_kernel_op_270 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_203,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269)));
                const __m256d tmp_kernel_op_272 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_182,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271)));
                const __m256d tmp_kernel_op_273 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_274 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_275 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_276 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_277 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_278 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_279 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_280 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_281 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_282 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_283 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_284 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_214),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_217)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_220)),_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_61))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_226),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_229)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_232)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_238),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_241)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_244)),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_248),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_250)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_252)),_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_256),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_258)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_260)),_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_262),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_263)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_264)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_268),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_270)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_272)),_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_110),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_184),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_190),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_193),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_196),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_202),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_205),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_208),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_276))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_232,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_241,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_258,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_262,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_268,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_270,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_272,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_110,tmp_kernel_op_274),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_275),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_276),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_273,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_273),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_190,tmp_kernel_op_274),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_275),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_276),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_273),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_274),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_275),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_276),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_280))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_232,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_241,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_258,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_262,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_268,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_270,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_272,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_110,tmp_kernel_op_278),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_279),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_280),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_277),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_190,tmp_kernel_op_278),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_279),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_280),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_277),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_278),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_279),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_280),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_284))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_232,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_241,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_258,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_262,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_268,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_270,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_272,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_110,tmp_kernel_op_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_283),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_284),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_281,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_281),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_190,tmp_kernel_op_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_283),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_284),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_281),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_283),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_284),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_kernel_op_0 = -p_affine_0_0 + p_affine_1_0;
                const real_t tmp_kernel_op_1 = -p_affine_0_0 + p_affine_2_0;
                const real_t tmp_kernel_op_2 = -p_affine_0_0 + p_affine_3_0;
                const real_t tmp_kernel_op_3 = p_affine_0_0 + tmp_kernel_op_0*0.1381966011250105 + tmp_kernel_op_1*0.1381966011250105 + tmp_kernel_op_2*0.5854101966249684;
                const real_t tmp_kernel_op_4 = -p_affine_0_1 + p_affine_1_1;
                const real_t tmp_kernel_op_5 = -p_affine_0_1 + p_affine_2_1;
                const real_t tmp_kernel_op_6 = -p_affine_0_1 + p_affine_3_1;
                const real_t tmp_kernel_op_7 = p_affine_0_1 + tmp_kernel_op_4*0.1381966011250105 + tmp_kernel_op_5*0.1381966011250105 + tmp_kernel_op_6*0.5854101966249684;
                const real_t tmp_kernel_op_8 = -p_affine_0_2 + p_affine_1_2;
                const real_t tmp_kernel_op_9 = -p_affine_0_2 + p_affine_2_2;
                const real_t tmp_kernel_op_10 = -p_affine_0_2 + p_affine_3_2;
                const real_t tmp_kernel_op_11 = p_affine_0_2 + tmp_kernel_op_10*0.5854101966249684 + tmp_kernel_op_8*0.1381966011250105 + tmp_kernel_op_9*0.1381966011250105;
                const real_t tmp_kernel_op_12 = (tmp_kernel_op_3*tmp_kernel_op_3);
                const real_t tmp_kernel_op_13 = (tmp_kernel_op_7*tmp_kernel_op_7);
                const real_t tmp_kernel_op_14 = (tmp_kernel_op_11*tmp_kernel_op_11);
                const real_t tmp_kernel_op_15 = tmp_kernel_op_12 + tmp_kernel_op_13 + tmp_kernel_op_14;
                const real_t tmp_kernel_op_16 = pow(tmp_kernel_op_15, -4.5000000000000000);
                const real_t tmp_kernel_op_38 = -tmp_kernel_op_11 - tmp_kernel_op_29;
                const real_t tmp_kernel_op_39 = -tmp_kernel_op_18 - tmp_kernel_op_3;
                const real_t tmp_kernel_op_40 = -tmp_kernel_op_25 - tmp_kernel_op_7;
                const real_t tmp_kernel_op_41 = -tmp_kernel_op_35*(tmp_kernel_op_19*tmp_kernel_op_20*tmp_kernel_op_40 + tmp_kernel_op_23*tmp_kernel_op_30*tmp_kernel_op_39 - tmp_kernel_op_24*tmp_kernel_op_38 + tmp_kernel_op_26*tmp_kernel_op_27*tmp_kernel_op_38 - tmp_kernel_op_31*tmp_kernel_op_39 - tmp_kernel_op_32*tmp_kernel_op_40) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_42 = -tmp_kernel_op_41;
                const real_t tmp_kernel_op_43 = tmp_kernel_op_11*tmp_kernel_op_42 + tmp_kernel_op_15*tmp_kernel_op_36;
                const real_t tmp_kernel_op_45 = tmp_kernel_op_15*tmp_kernel_op_44 + tmp_kernel_op_3*tmp_kernel_op_42;
                const real_t tmp_kernel_op_48 = -tmp_kernel_op_15*tmp_kernel_op_47 - tmp_kernel_op_41*tmp_kernel_op_7;
                const real_t tmp_kernel_op_50 = tmp_kernel_op_13*tmp_kernel_op_42 + tmp_kernel_op_15*(tmp_kernel_op_41 + tmp_kernel_op_49*tmp_kernel_op_7);
                const real_t tmp_kernel_op_51 = tmp_kernel_op_3*tmp_kernel_op_45;
                const real_t tmp_kernel_op_53 = tmp_kernel_op_16*tmp_kernel_op_52;
                const real_t tmp_kernel_op_54 = tmp_kernel_op_11*tmp_kernel_op_43*tmp_kernel_op_53;
                const real_t tmp_kernel_op_55 = tmp_kernel_op_14*tmp_kernel_op_42 + tmp_kernel_op_15*(tmp_kernel_op_11*tmp_kernel_op_36 + tmp_kernel_op_41);
                const real_t tmp_kernel_op_56 = tmp_kernel_op_48*tmp_kernel_op_51*tmp_kernel_op_7;
                const real_t tmp_kernel_op_57 = -tmp_kernel_op_12*tmp_kernel_op_41 + tmp_kernel_op_15*(tmp_kernel_op_3*tmp_kernel_op_44 + tmp_kernel_op_41);
                const real_t tmp_kernel_op_58 = tmp_kernel_op_57*tmp_kernel_op_7;
                const real_t tmp_kernel_op_59 = tmp_kernel_op_11*tmp_kernel_op_16*tmp_kernel_op_3*tmp_kernel_op_34*tmp_kernel_op_43*tmp_kernel_op_45*tmp_kernel_op_48*tmp_kernel_op_7*2.0 + tmp_kernel_op_16*tmp_kernel_op_34*tmp_kernel_op_50*tmp_kernel_op_55*tmp_kernel_op_57*1.0 - tmp_kernel_op_48*tmp_kernel_op_54*tmp_kernel_op_58 - tmp_kernel_op_50*tmp_kernel_op_51*tmp_kernel_op_54 - tmp_kernel_op_53*tmp_kernel_op_55*tmp_kernel_op_56;
                const real_t tmp_kernel_op_60 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657*abs(tmp_kernel_op_59);
                const real_t tmp_kernel_op_61 = tmp_kernel_op_60*0.13819660112501053;
                const real_t tmp_kernel_op_62 = 1.0 / (tmp_kernel_op_59);
                const real_t tmp_kernel_op_63 = 1.0 / (tmp_kernel_op_15*tmp_kernel_op_15*tmp_kernel_op_15);
                const real_t tmp_kernel_op_66 = tmp_kernel_op_63*tmp_kernel_op_65;
                const real_t tmp_kernel_op_67 = tmp_kernel_op_43*tmp_kernel_op_66;
                const real_t tmp_kernel_op_68 = tmp_kernel_op_62*(tmp_kernel_op_3*tmp_kernel_op_43*tmp_kernel_op_45*tmp_kernel_op_63*tmp_kernel_op_64*tmp_kernel_op_7*1.0 - tmp_kernel_op_58*tmp_kernel_op_67);
                const real_t tmp_kernel_op_69 = tmp_kernel_op_62*(tmp_kernel_op_3*tmp_kernel_op_43*tmp_kernel_op_48*tmp_kernel_op_63*tmp_kernel_op_64*tmp_kernel_op_7*1.0 - tmp_kernel_op_3*tmp_kernel_op_50*tmp_kernel_op_67);
                const real_t tmp_kernel_op_70 = tmp_kernel_op_62*(tmp_kernel_op_50*tmp_kernel_op_57*tmp_kernel_op_66 - tmp_kernel_op_56*tmp_kernel_op_66);
                const real_t tmp_kernel_op_71 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_69 + jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_68 + jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_70;
                const real_t tmp_kernel_op_73 = tmp_kernel_op_71*(tmp_kernel_op_72 - 1.0);
                const real_t tmp_kernel_op_74 = p_affine_0_0 + tmp_kernel_op_0*0.1381966011250105 + tmp_kernel_op_1*0.5854101966249684 + tmp_kernel_op_2*0.1381966011250105;
                const real_t tmp_kernel_op_75 = p_affine_0_1 + tmp_kernel_op_4*0.1381966011250105 + tmp_kernel_op_5*0.5854101966249684 + tmp_kernel_op_6*0.1381966011250105;
                const real_t tmp_kernel_op_76 = p_affine_0_2 + tmp_kernel_op_10*0.1381966011250105 + tmp_kernel_op_8*0.1381966011250105 + tmp_kernel_op_9*0.5854101966249684;
                const real_t tmp_kernel_op_77 = (tmp_kernel_op_74*tmp_kernel_op_74);
                const real_t tmp_kernel_op_78 = (tmp_kernel_op_75*tmp_kernel_op_75);
                const real_t tmp_kernel_op_79 = (tmp_kernel_op_76*tmp_kernel_op_76);
                const real_t tmp_kernel_op_80 = tmp_kernel_op_77 + tmp_kernel_op_78 + tmp_kernel_op_79;
                const real_t tmp_kernel_op_81 = pow(tmp_kernel_op_80, -4.5000000000000000);
                const real_t tmp_kernel_op_82 = -tmp_kernel_op_29 - tmp_kernel_op_76;
                const real_t tmp_kernel_op_83 = -tmp_kernel_op_18 - tmp_kernel_op_74;
                const real_t tmp_kernel_op_84 = -tmp_kernel_op_25 - tmp_kernel_op_75;
                const real_t tmp_kernel_op_85 = -tmp_kernel_op_35*(tmp_kernel_op_19*tmp_kernel_op_20*tmp_kernel_op_84 + tmp_kernel_op_23*tmp_kernel_op_30*tmp_kernel_op_83 - tmp_kernel_op_24*tmp_kernel_op_82 + tmp_kernel_op_26*tmp_kernel_op_27*tmp_kernel_op_82 - tmp_kernel_op_31*tmp_kernel_op_83 - tmp_kernel_op_32*tmp_kernel_op_84) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_86 = -tmp_kernel_op_85;
                const real_t tmp_kernel_op_87 = tmp_kernel_op_36*tmp_kernel_op_80 + tmp_kernel_op_76*tmp_kernel_op_86;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_44*tmp_kernel_op_80 + tmp_kernel_op_74*tmp_kernel_op_86;
                const real_t tmp_kernel_op_89 = -tmp_kernel_op_47*tmp_kernel_op_80 - tmp_kernel_op_75*tmp_kernel_op_85;
                const real_t tmp_kernel_op_90 = tmp_kernel_op_78*tmp_kernel_op_86 + tmp_kernel_op_80*(tmp_kernel_op_49*tmp_kernel_op_75 + tmp_kernel_op_85);
                const real_t tmp_kernel_op_91 = tmp_kernel_op_74*tmp_kernel_op_88;
                const real_t tmp_kernel_op_92 = tmp_kernel_op_52*tmp_kernel_op_81;
                const real_t tmp_kernel_op_93 = tmp_kernel_op_76*tmp_kernel_op_87*tmp_kernel_op_92;
                const real_t tmp_kernel_op_94 = tmp_kernel_op_79*tmp_kernel_op_86 + tmp_kernel_op_80*(tmp_kernel_op_36*tmp_kernel_op_76 + tmp_kernel_op_85);
                const real_t tmp_kernel_op_95 = tmp_kernel_op_75*tmp_kernel_op_89*tmp_kernel_op_91;
                const real_t tmp_kernel_op_96 = -tmp_kernel_op_77*tmp_kernel_op_85 + tmp_kernel_op_80*(tmp_kernel_op_44*tmp_kernel_op_74 + tmp_kernel_op_85);
                const real_t tmp_kernel_op_97 = tmp_kernel_op_75*tmp_kernel_op_96;
                const real_t tmp_kernel_op_98 = tmp_kernel_op_34*tmp_kernel_op_74*tmp_kernel_op_75*tmp_kernel_op_76*tmp_kernel_op_81*tmp_kernel_op_87*tmp_kernel_op_88*tmp_kernel_op_89*2.0 + tmp_kernel_op_34*tmp_kernel_op_81*tmp_kernel_op_90*tmp_kernel_op_94*tmp_kernel_op_96*1.0 - tmp_kernel_op_89*tmp_kernel_op_93*tmp_kernel_op_97 - tmp_kernel_op_90*tmp_kernel_op_91*tmp_kernel_op_93 - tmp_kernel_op_92*tmp_kernel_op_94*tmp_kernel_op_95;
                const real_t tmp_kernel_op_99 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657*abs(tmp_kernel_op_98);
                const real_t tmp_kernel_op_100 = tmp_kernel_op_99*0.13819660112501056;
                const real_t tmp_kernel_op_101 = 1.0 / (tmp_kernel_op_98);
                const real_t tmp_kernel_op_102 = 1.0 / (tmp_kernel_op_80*tmp_kernel_op_80*tmp_kernel_op_80);
                const real_t tmp_kernel_op_103 = tmp_kernel_op_102*tmp_kernel_op_65;
                const real_t tmp_kernel_op_104 = tmp_kernel_op_103*tmp_kernel_op_87;
                const real_t tmp_kernel_op_105 = tmp_kernel_op_101*(tmp_kernel_op_102*tmp_kernel_op_64*tmp_kernel_op_74*tmp_kernel_op_75*tmp_kernel_op_87*tmp_kernel_op_88*1.0 - tmp_kernel_op_104*tmp_kernel_op_97);
                const real_t tmp_kernel_op_106 = tmp_kernel_op_101*(tmp_kernel_op_102*tmp_kernel_op_64*tmp_kernel_op_74*tmp_kernel_op_75*tmp_kernel_op_87*tmp_kernel_op_89*1.0 - tmp_kernel_op_104*tmp_kernel_op_74*tmp_kernel_op_90);
                const real_t tmp_kernel_op_107 = tmp_kernel_op_101*(tmp_kernel_op_103*tmp_kernel_op_90*tmp_kernel_op_96 - tmp_kernel_op_103*tmp_kernel_op_95);
                const real_t tmp_kernel_op_108 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_106 + jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_105 + jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_107;
                const real_t tmp_kernel_op_110 = tmp_kernel_op_108*(tmp_kernel_op_109 - 1.0);
                const real_t tmp_kernel_op_111 = p_affine_0_0 + tmp_kernel_op_0*0.5854101966249684 + tmp_kernel_op_1*0.1381966011250105 + tmp_kernel_op_2*0.1381966011250105;
                const real_t tmp_kernel_op_112 = p_affine_0_1 + tmp_kernel_op_4*0.5854101966249684 + tmp_kernel_op_5*0.1381966011250105 + tmp_kernel_op_6*0.1381966011250105;
                const real_t tmp_kernel_op_113 = p_affine_0_2 + tmp_kernel_op_10*0.1381966011250105 + tmp_kernel_op_8*0.5854101966249684 + tmp_kernel_op_9*0.1381966011250105;
                const real_t tmp_kernel_op_114 = (tmp_kernel_op_111*tmp_kernel_op_111);
                const real_t tmp_kernel_op_115 = (tmp_kernel_op_112*tmp_kernel_op_112);
                const real_t tmp_kernel_op_116 = (tmp_kernel_op_113*tmp_kernel_op_113);
                const real_t tmp_kernel_op_117 = tmp_kernel_op_114 + tmp_kernel_op_115 + tmp_kernel_op_116;
                const real_t tmp_kernel_op_118 = pow(tmp_kernel_op_117, -4.5000000000000000);
                const real_t tmp_kernel_op_119 = -tmp_kernel_op_113 - tmp_kernel_op_29;
                const real_t tmp_kernel_op_120 = -tmp_kernel_op_111 - tmp_kernel_op_18;
                const real_t tmp_kernel_op_121 = -tmp_kernel_op_112 - tmp_kernel_op_25;
                const real_t tmp_kernel_op_122 = -tmp_kernel_op_35*(-tmp_kernel_op_119*tmp_kernel_op_24 + tmp_kernel_op_119*tmp_kernel_op_26*tmp_kernel_op_27 + tmp_kernel_op_120*tmp_kernel_op_23*tmp_kernel_op_30 - tmp_kernel_op_120*tmp_kernel_op_31 + tmp_kernel_op_121*tmp_kernel_op_19*tmp_kernel_op_20 - tmp_kernel_op_121*tmp_kernel_op_32) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_123 = -tmp_kernel_op_122;
                const real_t tmp_kernel_op_124 = tmp_kernel_op_113*tmp_kernel_op_123 + tmp_kernel_op_117*tmp_kernel_op_36;
                const real_t tmp_kernel_op_125 = tmp_kernel_op_111*tmp_kernel_op_123 + tmp_kernel_op_117*tmp_kernel_op_44;
                const real_t tmp_kernel_op_126 = -tmp_kernel_op_112*tmp_kernel_op_122 - tmp_kernel_op_117*tmp_kernel_op_47;
                const real_t tmp_kernel_op_127 = tmp_kernel_op_115*tmp_kernel_op_123 + tmp_kernel_op_117*(tmp_kernel_op_112*tmp_kernel_op_49 + tmp_kernel_op_122);
                const real_t tmp_kernel_op_128 = tmp_kernel_op_111*tmp_kernel_op_125;
                const real_t tmp_kernel_op_129 = tmp_kernel_op_118*tmp_kernel_op_52;
                const real_t tmp_kernel_op_130 = tmp_kernel_op_113*tmp_kernel_op_124*tmp_kernel_op_129;
                const real_t tmp_kernel_op_131 = tmp_kernel_op_116*tmp_kernel_op_123 + tmp_kernel_op_117*(tmp_kernel_op_113*tmp_kernel_op_36 + tmp_kernel_op_122);
                const real_t tmp_kernel_op_132 = tmp_kernel_op_112*tmp_kernel_op_126*tmp_kernel_op_128;
                const real_t tmp_kernel_op_133 = -tmp_kernel_op_114*tmp_kernel_op_122 + tmp_kernel_op_117*(tmp_kernel_op_111*tmp_kernel_op_44 + tmp_kernel_op_122);
                const real_t tmp_kernel_op_134 = tmp_kernel_op_112*tmp_kernel_op_133;
                const real_t tmp_kernel_op_135 = tmp_kernel_op_111*tmp_kernel_op_112*tmp_kernel_op_113*tmp_kernel_op_118*tmp_kernel_op_124*tmp_kernel_op_125*tmp_kernel_op_126*tmp_kernel_op_34*2.0 + tmp_kernel_op_118*tmp_kernel_op_127*tmp_kernel_op_131*tmp_kernel_op_133*tmp_kernel_op_34*1.0 - tmp_kernel_op_126*tmp_kernel_op_130*tmp_kernel_op_134 - tmp_kernel_op_127*tmp_kernel_op_128*tmp_kernel_op_130 - tmp_kernel_op_129*tmp_kernel_op_131*tmp_kernel_op_132;
                const real_t tmp_kernel_op_136 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657*abs(tmp_kernel_op_135);
                const real_t tmp_kernel_op_137 = tmp_kernel_op_136*0.13819660112501056;
                const real_t tmp_kernel_op_138 = 1.0 / (tmp_kernel_op_135);
                const real_t tmp_kernel_op_139 = 1.0 / (tmp_kernel_op_117*tmp_kernel_op_117*tmp_kernel_op_117);
                const real_t tmp_kernel_op_140 = tmp_kernel_op_139*tmp_kernel_op_65;
                const real_t tmp_kernel_op_141 = tmp_kernel_op_124*tmp_kernel_op_140;
                const real_t tmp_kernel_op_142 = tmp_kernel_op_138*(tmp_kernel_op_111*tmp_kernel_op_112*tmp_kernel_op_124*tmp_kernel_op_125*tmp_kernel_op_139*tmp_kernel_op_64*1.0 - tmp_kernel_op_134*tmp_kernel_op_141);
                const real_t tmp_kernel_op_143 = tmp_kernel_op_138*(tmp_kernel_op_111*tmp_kernel_op_112*tmp_kernel_op_124*tmp_kernel_op_126*tmp_kernel_op_139*tmp_kernel_op_64*1.0 - tmp_kernel_op_111*tmp_kernel_op_127*tmp_kernel_op_141);
                const real_t tmp_kernel_op_144 = tmp_kernel_op_138*(tmp_kernel_op_127*tmp_kernel_op_133*tmp_kernel_op_140 - tmp_kernel_op_132*tmp_kernel_op_140);
                const real_t tmp_kernel_op_145 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_143 + jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_142 + jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_144;
                const real_t tmp_kernel_op_147 = tmp_kernel_op_145*(tmp_kernel_op_146 - 1.0);
                const real_t tmp_kernel_op_148 = p_affine_0_0 + tmp_kernel_op_0*0.1381966011250105 + tmp_kernel_op_1*0.1381966011250105 + tmp_kernel_op_2*0.1381966011250105;
                const real_t tmp_kernel_op_149 = p_affine_0_1 + tmp_kernel_op_4*0.1381966011250105 + tmp_kernel_op_5*0.1381966011250105 + tmp_kernel_op_6*0.1381966011250105;
                const real_t tmp_kernel_op_150 = p_affine_0_2 + tmp_kernel_op_10*0.1381966011250105 + tmp_kernel_op_8*0.1381966011250105 + tmp_kernel_op_9*0.1381966011250105;
                const real_t tmp_kernel_op_151 = (tmp_kernel_op_148*tmp_kernel_op_148);
                const real_t tmp_kernel_op_152 = (tmp_kernel_op_149*tmp_kernel_op_149);
                const real_t tmp_kernel_op_153 = (tmp_kernel_op_150*tmp_kernel_op_150);
                const real_t tmp_kernel_op_154 = tmp_kernel_op_151 + tmp_kernel_op_152 + tmp_kernel_op_153;
                const real_t tmp_kernel_op_155 = pow(tmp_kernel_op_154, -4.5000000000000000);
                const real_t tmp_kernel_op_156 = -tmp_kernel_op_150 - tmp_kernel_op_29;
                const real_t tmp_kernel_op_157 = -tmp_kernel_op_148 - tmp_kernel_op_18;
                const real_t tmp_kernel_op_158 = -tmp_kernel_op_149 - tmp_kernel_op_25;
                const real_t tmp_kernel_op_159 = -tmp_kernel_op_35*(-tmp_kernel_op_156*tmp_kernel_op_24 + tmp_kernel_op_156*tmp_kernel_op_26*tmp_kernel_op_27 + tmp_kernel_op_157*tmp_kernel_op_23*tmp_kernel_op_30 - tmp_kernel_op_157*tmp_kernel_op_31 + tmp_kernel_op_158*tmp_kernel_op_19*tmp_kernel_op_20 - tmp_kernel_op_158*tmp_kernel_op_32) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_160 = -tmp_kernel_op_159;
                const real_t tmp_kernel_op_161 = tmp_kernel_op_150*tmp_kernel_op_160 + tmp_kernel_op_154*tmp_kernel_op_36;
                const real_t tmp_kernel_op_162 = tmp_kernel_op_148*tmp_kernel_op_160 + tmp_kernel_op_154*tmp_kernel_op_44;
                const real_t tmp_kernel_op_163 = -tmp_kernel_op_149*tmp_kernel_op_159 - tmp_kernel_op_154*tmp_kernel_op_47;
                const real_t tmp_kernel_op_164 = tmp_kernel_op_152*tmp_kernel_op_160 + tmp_kernel_op_154*(tmp_kernel_op_149*tmp_kernel_op_49 + tmp_kernel_op_159);
                const real_t tmp_kernel_op_165 = tmp_kernel_op_148*tmp_kernel_op_162;
                const real_t tmp_kernel_op_166 = tmp_kernel_op_155*tmp_kernel_op_52;
                const real_t tmp_kernel_op_167 = tmp_kernel_op_150*tmp_kernel_op_161*tmp_kernel_op_166;
                const real_t tmp_kernel_op_168 = tmp_kernel_op_153*tmp_kernel_op_160 + tmp_kernel_op_154*(tmp_kernel_op_150*tmp_kernel_op_36 + tmp_kernel_op_159);
                const real_t tmp_kernel_op_169 = tmp_kernel_op_149*tmp_kernel_op_163*tmp_kernel_op_165;
                const real_t tmp_kernel_op_170 = -tmp_kernel_op_151*tmp_kernel_op_159 + tmp_kernel_op_154*(tmp_kernel_op_148*tmp_kernel_op_44 + tmp_kernel_op_159);
                const real_t tmp_kernel_op_171 = tmp_kernel_op_149*tmp_kernel_op_170;
                const real_t tmp_kernel_op_172 = tmp_kernel_op_148*tmp_kernel_op_149*tmp_kernel_op_150*tmp_kernel_op_155*tmp_kernel_op_161*tmp_kernel_op_162*tmp_kernel_op_163*tmp_kernel_op_34*2.0 + tmp_kernel_op_155*tmp_kernel_op_164*tmp_kernel_op_168*tmp_kernel_op_170*tmp_kernel_op_34*1.0 - tmp_kernel_op_163*tmp_kernel_op_167*tmp_kernel_op_171 - tmp_kernel_op_164*tmp_kernel_op_165*tmp_kernel_op_167 - tmp_kernel_op_166*tmp_kernel_op_168*tmp_kernel_op_169;
                const real_t tmp_kernel_op_173 = abs_det_jac_affine_WHITE_DOWN*0.041666666666666657*abs(tmp_kernel_op_172);
                const real_t tmp_kernel_op_174 = tmp_kernel_op_173*0.5854101966249684;
                const real_t tmp_kernel_op_175 = 1.0 / (tmp_kernel_op_172);
                const real_t tmp_kernel_op_176 = 1.0 / (tmp_kernel_op_154*tmp_kernel_op_154*tmp_kernel_op_154);
                const real_t tmp_kernel_op_177 = tmp_kernel_op_176*tmp_kernel_op_65;
                const real_t tmp_kernel_op_178 = tmp_kernel_op_161*tmp_kernel_op_177;
                const real_t tmp_kernel_op_179 = tmp_kernel_op_175*(tmp_kernel_op_148*tmp_kernel_op_149*tmp_kernel_op_161*tmp_kernel_op_162*tmp_kernel_op_176*tmp_kernel_op_64*1.0 - tmp_kernel_op_171*tmp_kernel_op_178);
                const real_t tmp_kernel_op_180 = tmp_kernel_op_175*(tmp_kernel_op_148*tmp_kernel_op_149*tmp_kernel_op_161*tmp_kernel_op_163*tmp_kernel_op_176*tmp_kernel_op_64*1.0 - tmp_kernel_op_148*tmp_kernel_op_164*tmp_kernel_op_178);
                const real_t tmp_kernel_op_181 = tmp_kernel_op_175*(tmp_kernel_op_164*tmp_kernel_op_170*tmp_kernel_op_177 - tmp_kernel_op_169*tmp_kernel_op_177);
                const real_t tmp_kernel_op_182 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_180 + jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_179 + jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_181;
                const real_t tmp_kernel_op_184 = tmp_kernel_op_182*(tmp_kernel_op_183 - 1.0);
                const real_t tmp_kernel_op_185 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_69 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_68 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_70;
                const real_t tmp_kernel_op_187 = tmp_kernel_op_185*(tmp_kernel_op_186 - 1.0);
                const real_t tmp_kernel_op_188 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_106 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_105 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_107;
                const real_t tmp_kernel_op_190 = tmp_kernel_op_188*(tmp_kernel_op_189 - 1.0);
                const real_t tmp_kernel_op_191 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_143 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_142 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_144;
                const real_t tmp_kernel_op_193 = tmp_kernel_op_191*(tmp_kernel_op_192 - 1.0);
                const real_t tmp_kernel_op_194 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_180 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_179 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_181;
                const real_t tmp_kernel_op_196 = tmp_kernel_op_194*(tmp_kernel_op_195 - 1.0);
                const real_t tmp_kernel_op_197 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_69 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_68 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_70;
                const real_t tmp_kernel_op_199 = tmp_kernel_op_197*(tmp_kernel_op_198 - 1.0);
                const real_t tmp_kernel_op_200 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_106 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_105 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_107;
                const real_t tmp_kernel_op_202 = tmp_kernel_op_200*(tmp_kernel_op_201 - 1.0);
                const real_t tmp_kernel_op_203 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_143 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_142 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_144;
                const real_t tmp_kernel_op_205 = tmp_kernel_op_203*(tmp_kernel_op_204 - 1.0);
                const real_t tmp_kernel_op_206 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_180 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_179 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_181;
                const real_t tmp_kernel_op_208 = tmp_kernel_op_206*(tmp_kernel_op_207 - 1.0);
                const real_t tmp_kernel_op_209 = tmp_kernel_op_186*tmp_kernel_op_197;
                const real_t tmp_kernel_op_210 = tmp_kernel_op_185*tmp_kernel_op_198;
                const real_t tmp_kernel_op_211 = -tmp_kernel_op_209 - tmp_kernel_op_210;
                const real_t tmp_kernel_op_212 = tmp_kernel_op_189*tmp_kernel_op_200;
                const real_t tmp_kernel_op_213 = tmp_kernel_op_188*tmp_kernel_op_201;
                const real_t tmp_kernel_op_214 = -tmp_kernel_op_212 - tmp_kernel_op_213;
                const real_t tmp_kernel_op_215 = tmp_kernel_op_192*tmp_kernel_op_203;
                const real_t tmp_kernel_op_216 = tmp_kernel_op_191*tmp_kernel_op_204;
                const real_t tmp_kernel_op_217 = -tmp_kernel_op_215 - tmp_kernel_op_216;
                const real_t tmp_kernel_op_218 = tmp_kernel_op_195*tmp_kernel_op_206;
                const real_t tmp_kernel_op_219 = tmp_kernel_op_194*tmp_kernel_op_207;
                const real_t tmp_kernel_op_220 = -tmp_kernel_op_218 - tmp_kernel_op_219;
                const real_t tmp_kernel_op_221 = tmp_kernel_op_197*tmp_kernel_op_72;
                const real_t tmp_kernel_op_222 = tmp_kernel_op_198*tmp_kernel_op_71;
                const real_t tmp_kernel_op_223 = -tmp_kernel_op_221 - tmp_kernel_op_222;
                const real_t tmp_kernel_op_224 = tmp_kernel_op_109*tmp_kernel_op_200;
                const real_t tmp_kernel_op_225 = tmp_kernel_op_108*tmp_kernel_op_201;
                const real_t tmp_kernel_op_226 = -tmp_kernel_op_224 - tmp_kernel_op_225;
                const real_t tmp_kernel_op_227 = tmp_kernel_op_146*tmp_kernel_op_203;
                const real_t tmp_kernel_op_228 = tmp_kernel_op_145*tmp_kernel_op_204;
                const real_t tmp_kernel_op_229 = -tmp_kernel_op_227 - tmp_kernel_op_228;
                const real_t tmp_kernel_op_230 = tmp_kernel_op_183*tmp_kernel_op_206;
                const real_t tmp_kernel_op_231 = tmp_kernel_op_182*tmp_kernel_op_207;
                const real_t tmp_kernel_op_232 = -tmp_kernel_op_230 - tmp_kernel_op_231;
                const real_t tmp_kernel_op_233 = tmp_kernel_op_185*tmp_kernel_op_72;
                const real_t tmp_kernel_op_234 = tmp_kernel_op_186*tmp_kernel_op_71;
                const real_t tmp_kernel_op_235 = -tmp_kernel_op_233 - tmp_kernel_op_234;
                const real_t tmp_kernel_op_236 = tmp_kernel_op_109*tmp_kernel_op_188;
                const real_t tmp_kernel_op_237 = tmp_kernel_op_108*tmp_kernel_op_189;
                const real_t tmp_kernel_op_238 = -tmp_kernel_op_236 - tmp_kernel_op_237;
                const real_t tmp_kernel_op_239 = tmp_kernel_op_146*tmp_kernel_op_191;
                const real_t tmp_kernel_op_240 = tmp_kernel_op_145*tmp_kernel_op_192;
                const real_t tmp_kernel_op_241 = -tmp_kernel_op_239 - tmp_kernel_op_240;
                const real_t tmp_kernel_op_242 = tmp_kernel_op_183*tmp_kernel_op_194;
                const real_t tmp_kernel_op_243 = tmp_kernel_op_182*tmp_kernel_op_195;
                const real_t tmp_kernel_op_244 = -tmp_kernel_op_242 - tmp_kernel_op_243;
                const real_t tmp_kernel_op_246 = -tmp_kernel_op_197*(-tmp_kernel_op_245 - 0.68328157299974723) + tmp_kernel_op_210 + tmp_kernel_op_222;
                const real_t tmp_kernel_op_248 = -tmp_kernel_op_200*(-tmp_kernel_op_247 + 2.8944271909999157) + tmp_kernel_op_213 + tmp_kernel_op_225;
                const real_t tmp_kernel_op_250 = -tmp_kernel_op_203*(-tmp_kernel_op_249 + 2.8944271909999157) + tmp_kernel_op_216 + tmp_kernel_op_228;
                const real_t tmp_kernel_op_252 = -tmp_kernel_op_206*(-tmp_kernel_op_251 + 2.8944271909999157) + tmp_kernel_op_219 + tmp_kernel_op_231;
                const real_t tmp_kernel_op_254 = -tmp_kernel_op_185*(-tmp_kernel_op_253 - tmp_kernel_op_72 - 1.105572809000084) + tmp_kernel_op_209 + tmp_kernel_op_234;
                const real_t tmp_kernel_op_256 = -tmp_kernel_op_188*(-tmp_kernel_op_109 - tmp_kernel_op_255 - 4.6832815729997472) + tmp_kernel_op_212 + tmp_kernel_op_237;
                const real_t tmp_kernel_op_258 = -tmp_kernel_op_191*(-tmp_kernel_op_146 - tmp_kernel_op_257 - 1.105572809000084) + tmp_kernel_op_215 + tmp_kernel_op_240;
                const real_t tmp_kernel_op_260 = -tmp_kernel_op_194*(-tmp_kernel_op_183 - tmp_kernel_op_259 - 1.105572809000084) + tmp_kernel_op_218 + tmp_kernel_op_243;
                const real_t tmp_kernel_op_261 = tmp_kernel_op_221 + tmp_kernel_op_233 - tmp_kernel_op_71*(-tmp_kernel_op_186 - tmp_kernel_op_253 - 1.105572809000084);
                const real_t tmp_kernel_op_262 = -tmp_kernel_op_108*(-tmp_kernel_op_189 - tmp_kernel_op_255 - 1.105572809000084) + tmp_kernel_op_224 + tmp_kernel_op_236;
                const real_t tmp_kernel_op_263 = -tmp_kernel_op_145*(-tmp_kernel_op_192 - tmp_kernel_op_257 - 4.6832815729997472) + tmp_kernel_op_227 + tmp_kernel_op_239;
                const real_t tmp_kernel_op_264 = -tmp_kernel_op_182*(-tmp_kernel_op_195 - tmp_kernel_op_259 - 1.105572809000084) + tmp_kernel_op_230 + tmp_kernel_op_242;
                const real_t tmp_kernel_op_266 = -tmp_kernel_op_185*tmp_kernel_op_265 - tmp_kernel_op_197*tmp_kernel_op_265 - tmp_kernel_op_265*tmp_kernel_op_71;
                const real_t tmp_kernel_op_268 = -tmp_kernel_op_108*tmp_kernel_op_267 - tmp_kernel_op_188*tmp_kernel_op_267 - tmp_kernel_op_200*tmp_kernel_op_267;
                const real_t tmp_kernel_op_270 = -tmp_kernel_op_145*tmp_kernel_op_269 - tmp_kernel_op_191*tmp_kernel_op_269 - tmp_kernel_op_203*tmp_kernel_op_269;
                const real_t tmp_kernel_op_272 = -tmp_kernel_op_182*tmp_kernel_op_271 - tmp_kernel_op_194*tmp_kernel_op_271 - tmp_kernel_op_206*tmp_kernel_op_271;
                const real_t tmp_kernel_op_273 = tmp_kernel_op_60*0.1381966011250105;
                const real_t tmp_kernel_op_274 = tmp_kernel_op_99*0.1381966011250105;
                const real_t tmp_kernel_op_275 = tmp_kernel_op_136*0.5854101966249684;
                const real_t tmp_kernel_op_276 = tmp_kernel_op_173*0.1381966011250105;
                const real_t tmp_kernel_op_277 = tmp_kernel_op_60*0.1381966011250105;
                const real_t tmp_kernel_op_278 = tmp_kernel_op_99*0.5854101966249684;
                const real_t tmp_kernel_op_279 = tmp_kernel_op_136*0.1381966011250105;
                const real_t tmp_kernel_op_280 = tmp_kernel_op_173*0.1381966011250105;
                const real_t tmp_kernel_op_281 = tmp_kernel_op_60*0.5854101966249684;
                const real_t tmp_kernel_op_282 = tmp_kernel_op_99*0.1381966011250105;
                const real_t tmp_kernel_op_283 = tmp_kernel_op_136*0.1381966011250105;
                const real_t tmp_kernel_op_284 = tmp_kernel_op_173*0.1381966011250105;
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_100*tmp_kernel_op_268 + tmp_kernel_op_137*tmp_kernel_op_270 + tmp_kernel_op_174*tmp_kernel_op_272 + tmp_kernel_op_266*tmp_kernel_op_61) + src_dof_1*(-tmp_kernel_op_100*tmp_kernel_op_110 - tmp_kernel_op_137*tmp_kernel_op_147 - tmp_kernel_op_174*tmp_kernel_op_184 - tmp_kernel_op_61*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_100*tmp_kernel_op_190 - tmp_kernel_op_137*tmp_kernel_op_193 - tmp_kernel_op_174*tmp_kernel_op_196 - tmp_kernel_op_187*tmp_kernel_op_61) + src_dof_3*(-tmp_kernel_op_100*tmp_kernel_op_202 - tmp_kernel_op_137*tmp_kernel_op_205 - tmp_kernel_op_174*tmp_kernel_op_208 - tmp_kernel_op_199*tmp_kernel_op_61) + src_dof_4*(tmp_kernel_op_100*tmp_kernel_op_214 + tmp_kernel_op_137*tmp_kernel_op_217 + tmp_kernel_op_174*tmp_kernel_op_220 + tmp_kernel_op_211*tmp_kernel_op_61) + src_dof_5*(tmp_kernel_op_100*tmp_kernel_op_226 + tmp_kernel_op_137*tmp_kernel_op_229 + tmp_kernel_op_174*tmp_kernel_op_232 + tmp_kernel_op_223*tmp_kernel_op_61) + src_dof_6*(tmp_kernel_op_100*tmp_kernel_op_238 + tmp_kernel_op_137*tmp_kernel_op_241 + tmp_kernel_op_174*tmp_kernel_op_244 + tmp_kernel_op_235*tmp_kernel_op_61) + src_dof_7*(tmp_kernel_op_100*tmp_kernel_op_248 + tmp_kernel_op_137*tmp_kernel_op_250 + tmp_kernel_op_174*tmp_kernel_op_252 + tmp_kernel_op_246*tmp_kernel_op_61) + src_dof_8*(tmp_kernel_op_100*tmp_kernel_op_256 + tmp_kernel_op_137*tmp_kernel_op_258 + tmp_kernel_op_174*tmp_kernel_op_260 + tmp_kernel_op_254*tmp_kernel_op_61) + src_dof_9*(tmp_kernel_op_100*tmp_kernel_op_262 + tmp_kernel_op_137*tmp_kernel_op_263 + tmp_kernel_op_174*tmp_kernel_op_264 + tmp_kernel_op_261*tmp_kernel_op_61);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_266*tmp_kernel_op_273 + tmp_kernel_op_268*tmp_kernel_op_274 + tmp_kernel_op_270*tmp_kernel_op_275 + tmp_kernel_op_272*tmp_kernel_op_276) + src_dof_1*(-tmp_kernel_op_110*tmp_kernel_op_274 - tmp_kernel_op_147*tmp_kernel_op_275 - tmp_kernel_op_184*tmp_kernel_op_276 - tmp_kernel_op_273*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_187*tmp_kernel_op_273 - tmp_kernel_op_190*tmp_kernel_op_274 - tmp_kernel_op_193*tmp_kernel_op_275 - tmp_kernel_op_196*tmp_kernel_op_276) + src_dof_3*(-tmp_kernel_op_199*tmp_kernel_op_273 - tmp_kernel_op_202*tmp_kernel_op_274 - tmp_kernel_op_205*tmp_kernel_op_275 - tmp_kernel_op_208*tmp_kernel_op_276) + src_dof_4*(tmp_kernel_op_211*tmp_kernel_op_273 + tmp_kernel_op_214*tmp_kernel_op_274 + tmp_kernel_op_217*tmp_kernel_op_275 + tmp_kernel_op_220*tmp_kernel_op_276) + src_dof_5*(tmp_kernel_op_223*tmp_kernel_op_273 + tmp_kernel_op_226*tmp_kernel_op_274 + tmp_kernel_op_229*tmp_kernel_op_275 + tmp_kernel_op_232*tmp_kernel_op_276) + src_dof_6*(tmp_kernel_op_235*tmp_kernel_op_273 + tmp_kernel_op_238*tmp_kernel_op_274 + tmp_kernel_op_241*tmp_kernel_op_275 + tmp_kernel_op_244*tmp_kernel_op_276) + src_dof_7*(tmp_kernel_op_246*tmp_kernel_op_273 + tmp_kernel_op_248*tmp_kernel_op_274 + tmp_kernel_op_250*tmp_kernel_op_275 + tmp_kernel_op_252*tmp_kernel_op_276) + src_dof_8*(tmp_kernel_op_254*tmp_kernel_op_273 + tmp_kernel_op_256*tmp_kernel_op_274 + tmp_kernel_op_258*tmp_kernel_op_275 + tmp_kernel_op_260*tmp_kernel_op_276) + src_dof_9*(tmp_kernel_op_261*tmp_kernel_op_273 + tmp_kernel_op_262*tmp_kernel_op_274 + tmp_kernel_op_263*tmp_kernel_op_275 + tmp_kernel_op_264*tmp_kernel_op_276);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_266*tmp_kernel_op_277 + tmp_kernel_op_268*tmp_kernel_op_278 + tmp_kernel_op_270*tmp_kernel_op_279 + tmp_kernel_op_272*tmp_kernel_op_280) + src_dof_1*(-tmp_kernel_op_110*tmp_kernel_op_278 - tmp_kernel_op_147*tmp_kernel_op_279 - tmp_kernel_op_184*tmp_kernel_op_280 - tmp_kernel_op_277*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_187*tmp_kernel_op_277 - tmp_kernel_op_190*tmp_kernel_op_278 - tmp_kernel_op_193*tmp_kernel_op_279 - tmp_kernel_op_196*tmp_kernel_op_280) + src_dof_3*(-tmp_kernel_op_199*tmp_kernel_op_277 - tmp_kernel_op_202*tmp_kernel_op_278 - tmp_kernel_op_205*tmp_kernel_op_279 - tmp_kernel_op_208*tmp_kernel_op_280) + src_dof_4*(tmp_kernel_op_211*tmp_kernel_op_277 + tmp_kernel_op_214*tmp_kernel_op_278 + tmp_kernel_op_217*tmp_kernel_op_279 + tmp_kernel_op_220*tmp_kernel_op_280) + src_dof_5*(tmp_kernel_op_223*tmp_kernel_op_277 + tmp_kernel_op_226*tmp_kernel_op_278 + tmp_kernel_op_229*tmp_kernel_op_279 + tmp_kernel_op_232*tmp_kernel_op_280) + src_dof_6*(tmp_kernel_op_235*tmp_kernel_op_277 + tmp_kernel_op_238*tmp_kernel_op_278 + tmp_kernel_op_241*tmp_kernel_op_279 + tmp_kernel_op_244*tmp_kernel_op_280) + src_dof_7*(tmp_kernel_op_246*tmp_kernel_op_277 + tmp_kernel_op_248*tmp_kernel_op_278 + tmp_kernel_op_250*tmp_kernel_op_279 + tmp_kernel_op_252*tmp_kernel_op_280) + src_dof_8*(tmp_kernel_op_254*tmp_kernel_op_277 + tmp_kernel_op_256*tmp_kernel_op_278 + tmp_kernel_op_258*tmp_kernel_op_279 + tmp_kernel_op_260*tmp_kernel_op_280) + src_dof_9*(tmp_kernel_op_261*tmp_kernel_op_277 + tmp_kernel_op_262*tmp_kernel_op_278 + tmp_kernel_op_263*tmp_kernel_op_279 + tmp_kernel_op_264*tmp_kernel_op_280);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_266*tmp_kernel_op_281 + tmp_kernel_op_268*tmp_kernel_op_282 + tmp_kernel_op_270*tmp_kernel_op_283 + tmp_kernel_op_272*tmp_kernel_op_284) + src_dof_1*(-tmp_kernel_op_110*tmp_kernel_op_282 - tmp_kernel_op_147*tmp_kernel_op_283 - tmp_kernel_op_184*tmp_kernel_op_284 - tmp_kernel_op_281*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_187*tmp_kernel_op_281 - tmp_kernel_op_190*tmp_kernel_op_282 - tmp_kernel_op_193*tmp_kernel_op_283 - tmp_kernel_op_196*tmp_kernel_op_284) + src_dof_3*(-tmp_kernel_op_199*tmp_kernel_op_281 - tmp_kernel_op_202*tmp_kernel_op_282 - tmp_kernel_op_205*tmp_kernel_op_283 - tmp_kernel_op_208*tmp_kernel_op_284) + src_dof_4*(tmp_kernel_op_211*tmp_kernel_op_281 + tmp_kernel_op_214*tmp_kernel_op_282 + tmp_kernel_op_217*tmp_kernel_op_283 + tmp_kernel_op_220*tmp_kernel_op_284) + src_dof_5*(tmp_kernel_op_223*tmp_kernel_op_281 + tmp_kernel_op_226*tmp_kernel_op_282 + tmp_kernel_op_229*tmp_kernel_op_283 + tmp_kernel_op_232*tmp_kernel_op_284) + src_dof_6*(tmp_kernel_op_235*tmp_kernel_op_281 + tmp_kernel_op_238*tmp_kernel_op_282 + tmp_kernel_op_241*tmp_kernel_op_283 + tmp_kernel_op_244*tmp_kernel_op_284) + src_dof_7*(tmp_kernel_op_246*tmp_kernel_op_281 + tmp_kernel_op_248*tmp_kernel_op_282 + tmp_kernel_op_250*tmp_kernel_op_283 + tmp_kernel_op_252*tmp_kernel_op_284) + src_dof_8*(tmp_kernel_op_254*tmp_kernel_op_281 + tmp_kernel_op_256*tmp_kernel_op_282 + tmp_kernel_op_258*tmp_kernel_op_283 + tmp_kernel_op_260*tmp_kernel_op_284) + src_dof_9*(tmp_kernel_op_261*tmp_kernel_op_281 + tmp_kernel_op_262*tmp_kernel_op_282 + tmp_kernel_op_263*tmp_kernel_op_283 + tmp_kernel_op_264*tmp_kernel_op_284);
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       {
          /* CellType.BLUE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_0 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0);
                const __m256d tmp_kernel_op_1 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0);
                const __m256d tmp_kernel_op_2 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0);
                const __m256d tmp_kernel_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_kernel_op_4 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1);
                const __m256d tmp_kernel_op_5 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1);
                const __m256d tmp_kernel_op_6 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1);
                const __m256d tmp_kernel_op_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_kernel_op_8 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2);
                const __m256d tmp_kernel_op_9 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2);
                const __m256d tmp_kernel_op_10 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2);
                const __m256d tmp_kernel_op_11 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_kernel_op_12 = _mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_3);
                const __m256d tmp_kernel_op_13 = _mm256_mul_pd(tmp_kernel_op_7,tmp_kernel_op_7);
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_11);
                const __m256d tmp_kernel_op_15 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_12,tmp_kernel_op_13),tmp_kernel_op_14);
                const __m256d tmp_kernel_op_16 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_15),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_15,tmp_kernel_op_15),tmp_kernel_op_15),tmp_kernel_op_15),tmp_kernel_op_15));
                const __m256d tmp_kernel_op_38 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_11,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_39 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_40 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_41 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_39,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_39,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_42 = _mm256_mul_pd(tmp_kernel_op_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_45 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_48 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_7),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_7,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_41)),_mm256_mul_pd(tmp_kernel_op_13,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_51 = _mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_53 = _mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_54 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_43),tmp_kernel_op_53);
                const __m256d tmp_kernel_op_55 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_11,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_41)),_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_56 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_51),tmp_kernel_op_7);
                const __m256d tmp_kernel_op_57 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_41)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_41),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_58 = _mm256_mul_pd(tmp_kernel_op_57,tmp_kernel_op_7);
                const __m256d tmp_kernel_op_59 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_54),tmp_kernel_op_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_51),tmp_kernel_op_54),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_53,tmp_kernel_op_55),tmp_kernel_op_56),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_16,tmp_kernel_op_50),tmp_kernel_op_55),tmp_kernel_op_57),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_16),tmp_kernel_op_3),tmp_kernel_op_43),tmp_kernel_op_45),tmp_kernel_op_48),tmp_kernel_op_7),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_60 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_59))));
                const __m256d tmp_kernel_op_61 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.13819660112501053,0.13819660112501053,0.13819660112501053,0.13819660112501053));
                const __m256d tmp_kernel_op_62 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_59);
                const __m256d tmp_kernel_op_63 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_15),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_15)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_15));
                const __m256d tmp_kernel_op_66 = _mm256_mul_pd(tmp_kernel_op_63,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_67 = _mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_66);
                const __m256d tmp_kernel_op_68 = _mm256_mul_pd(tmp_kernel_op_62,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_58,tmp_kernel_op_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_43),tmp_kernel_op_45),tmp_kernel_op_63),tmp_kernel_op_7),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_69 = _mm256_mul_pd(tmp_kernel_op_62,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_50),tmp_kernel_op_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_43),tmp_kernel_op_48),tmp_kernel_op_63),tmp_kernel_op_7),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_70 = _mm256_mul_pd(tmp_kernel_op_62,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_56,tmp_kernel_op_66),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_57),tmp_kernel_op_66)));
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)));
                const __m256d tmp_kernel_op_73 = _mm256_mul_pd(tmp_kernel_op_71,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72)));
                const __m256d tmp_kernel_op_74 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_kernel_op_75 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_kernel_op_76 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_kernel_op_77 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_74);
                const __m256d tmp_kernel_op_78 = _mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_75);
                const __m256d tmp_kernel_op_79 = _mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_76);
                const __m256d tmp_kernel_op_80 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_77,tmp_kernel_op_78),tmp_kernel_op_79);
                const __m256d tmp_kernel_op_81 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_80),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_80,tmp_kernel_op_80),tmp_kernel_op_80),tmp_kernel_op_80),tmp_kernel_op_80));
                const __m256d tmp_kernel_op_82 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_76,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_83 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_74,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_75,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_85 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_82,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_82,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_86 = _mm256_mul_pd(tmp_kernel_op_85,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_87 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_88 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_89 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_90 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_75,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_91 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_88);
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_81,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_93 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_87),tmp_kernel_op_92);
                const __m256d tmp_kernel_op_94 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_76,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_79,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_95 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_89),tmp_kernel_op_91);
                const __m256d tmp_kernel_op_96 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_74,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_85)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_77,tmp_kernel_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_97 = _mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_98 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_89,tmp_kernel_op_93),tmp_kernel_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_90,tmp_kernel_op_91),tmp_kernel_op_93),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_94),tmp_kernel_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_81,tmp_kernel_op_90),tmp_kernel_op_94),tmp_kernel_op_96),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_75),tmp_kernel_op_76),tmp_kernel_op_81),tmp_kernel_op_87),tmp_kernel_op_88),tmp_kernel_op_89),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_99 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_98))));
                const __m256d tmp_kernel_op_100 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_101 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_98);
                const __m256d tmp_kernel_op_102 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_80),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_80)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_80));
                const __m256d tmp_kernel_op_103 = _mm256_mul_pd(tmp_kernel_op_102,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_104 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_105 = _mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_74),tmp_kernel_op_75),tmp_kernel_op_87),tmp_kernel_op_88),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_106 = _mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_74),tmp_kernel_op_90),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_74),tmp_kernel_op_75),tmp_kernel_op_87),tmp_kernel_op_89),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_107 = _mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_90),tmp_kernel_op_96)));
                const __m256d tmp_kernel_op_108 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_mul_pd(tmp_kernel_op_105,_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)));
                const __m256d tmp_kernel_op_110 = _mm256_mul_pd(tmp_kernel_op_108,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)));
                const __m256d tmp_kernel_op_111 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_kernel_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_kernel_op_113 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_kernel_op_114 = _mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_111);
                const __m256d tmp_kernel_op_115 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_112);
                const __m256d tmp_kernel_op_116 = _mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_113);
                const __m256d tmp_kernel_op_117 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_114,tmp_kernel_op_115),tmp_kernel_op_116);
                const __m256d tmp_kernel_op_118 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_117),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_117,tmp_kernel_op_117),tmp_kernel_op_117),tmp_kernel_op_117),tmp_kernel_op_117));
                const __m256d tmp_kernel_op_119 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_120 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_111,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_121 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_112,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_122 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_119,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_121,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_121,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_119,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_123 = _mm256_mul_pd(tmp_kernel_op_122,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_124 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_125 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_126 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_122),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_127 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_112,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_122)),_mm256_mul_pd(tmp_kernel_op_115,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_128 = _mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_125);
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(tmp_kernel_op_118,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_130 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_124),tmp_kernel_op_129);
                const __m256d tmp_kernel_op_131 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_122)),_mm256_mul_pd(tmp_kernel_op_116,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_132 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_126),tmp_kernel_op_128);
                const __m256d tmp_kernel_op_133 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_111,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_122)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_114,tmp_kernel_op_122),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_134 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_133);
                const __m256d tmp_kernel_op_135 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_130),tmp_kernel_op_134),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_128),tmp_kernel_op_130),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_129,tmp_kernel_op_131),tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_127),tmp_kernel_op_131),tmp_kernel_op_133),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_112),tmp_kernel_op_113),tmp_kernel_op_118),tmp_kernel_op_124),tmp_kernel_op_125),tmp_kernel_op_126),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_135))));
                const __m256d tmp_kernel_op_137 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_138 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_135);
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_117),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_117)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_117));
                const __m256d tmp_kernel_op_140 = _mm256_mul_pd(tmp_kernel_op_139,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_141 = _mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_140);
                const __m256d tmp_kernel_op_142 = _mm256_mul_pd(tmp_kernel_op_138,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_141),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_112),tmp_kernel_op_124),tmp_kernel_op_125),tmp_kernel_op_139),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_143 = _mm256_mul_pd(tmp_kernel_op_138,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_127),tmp_kernel_op_141),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_112),tmp_kernel_op_124),tmp_kernel_op_126),tmp_kernel_op_139),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_144 = _mm256_mul_pd(tmp_kernel_op_138,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_140),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_133),tmp_kernel_op_140)));
                const __m256d tmp_kernel_op_145 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP))),_mm256_mul_pd(tmp_kernel_op_144,_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)));
                const __m256d tmp_kernel_op_147 = _mm256_mul_pd(tmp_kernel_op_145,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146)));
                const __m256d tmp_kernel_op_148 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_0);
                const __m256d tmp_kernel_op_149 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_1);
                const __m256d tmp_kernel_op_150 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_2);
                const __m256d tmp_kernel_op_151 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_148);
                const __m256d tmp_kernel_op_152 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_149);
                const __m256d tmp_kernel_op_153 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_150);
                const __m256d tmp_kernel_op_154 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_151,tmp_kernel_op_152),tmp_kernel_op_153);
                const __m256d tmp_kernel_op_155 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_154),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_154),tmp_kernel_op_154),tmp_kernel_op_154),tmp_kernel_op_154));
                const __m256d tmp_kernel_op_156 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_150,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_157 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_158 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_149,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_159 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_156,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_156,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_160 = _mm256_mul_pd(tmp_kernel_op_159,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_161 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_162 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_163 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_164 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_149,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_159)),_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_165 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_162);
                const __m256d tmp_kernel_op_166 = _mm256_mul_pd(tmp_kernel_op_155,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_167 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_161),tmp_kernel_op_166);
                const __m256d tmp_kernel_op_168 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_150,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_159)),_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_169 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_163),tmp_kernel_op_165);
                const __m256d tmp_kernel_op_170 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_159)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_171 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_170);
                const __m256d tmp_kernel_op_172 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_167),tmp_kernel_op_171),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_164,tmp_kernel_op_165),tmp_kernel_op_167),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_166,tmp_kernel_op_168),tmp_kernel_op_169),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_164),tmp_kernel_op_168),tmp_kernel_op_170),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_149),tmp_kernel_op_150),tmp_kernel_op_155),tmp_kernel_op_161),tmp_kernel_op_162),tmp_kernel_op_163),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_173 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_172))));
                const __m256d tmp_kernel_op_174 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_175 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_172);
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_154),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_154)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_154));
                const __m256d tmp_kernel_op_177 = _mm256_mul_pd(tmp_kernel_op_176,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_178 = _mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_177);
                const __m256d tmp_kernel_op_179 = _mm256_mul_pd(tmp_kernel_op_175,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_178),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_149),tmp_kernel_op_161),tmp_kernel_op_162),tmp_kernel_op_176),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_180 = _mm256_mul_pd(tmp_kernel_op_175,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_164),tmp_kernel_op_178),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_149),tmp_kernel_op_161),tmp_kernel_op_163),tmp_kernel_op_176),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_181 = _mm256_mul_pd(tmp_kernel_op_175,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_177),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_164,tmp_kernel_op_170),tmp_kernel_op_177)));
                const __m256d tmp_kernel_op_182 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP)),_mm256_mul_pd(tmp_kernel_op_179,_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP))),_mm256_mul_pd(tmp_kernel_op_181,_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP)));
                const __m256d tmp_kernel_op_184 = _mm256_mul_pd(tmp_kernel_op_182,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183)));
                const __m256d tmp_kernel_op_185 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)));
                const __m256d tmp_kernel_op_187 = _mm256_mul_pd(tmp_kernel_op_185,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186)));
                const __m256d tmp_kernel_op_188 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_mul_pd(tmp_kernel_op_105,_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)));
                const __m256d tmp_kernel_op_190 = _mm256_mul_pd(tmp_kernel_op_188,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189)));
                const __m256d tmp_kernel_op_191 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP))),_mm256_mul_pd(tmp_kernel_op_144,_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)));
                const __m256d tmp_kernel_op_193 = _mm256_mul_pd(tmp_kernel_op_191,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192)));
                const __m256d tmp_kernel_op_194 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_mul_pd(tmp_kernel_op_179,_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP))),_mm256_mul_pd(tmp_kernel_op_181,_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)));
                const __m256d tmp_kernel_op_196 = _mm256_mul_pd(tmp_kernel_op_194,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195)));
                const __m256d tmp_kernel_op_197 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)));
                const __m256d tmp_kernel_op_199 = _mm256_mul_pd(tmp_kernel_op_197,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198)));
                const __m256d tmp_kernel_op_200 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_mul_pd(tmp_kernel_op_105,_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)));
                const __m256d tmp_kernel_op_202 = _mm256_mul_pd(tmp_kernel_op_200,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201)));
                const __m256d tmp_kernel_op_203 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_mul_pd(tmp_kernel_op_144,_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)));
                const __m256d tmp_kernel_op_205 = _mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204)));
                const __m256d tmp_kernel_op_206 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_mul_pd(tmp_kernel_op_179,_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_mul_pd(tmp_kernel_op_181,_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)));
                const __m256d tmp_kernel_op_208 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207)));
                const __m256d tmp_kernel_op_209 = _mm256_mul_pd(tmp_kernel_op_197,_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186));
                const __m256d tmp_kernel_op_210 = _mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198));
                const __m256d tmp_kernel_op_211 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_209,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_212 = _mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189));
                const __m256d tmp_kernel_op_213 = _mm256_mul_pd(tmp_kernel_op_188,_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201));
                const __m256d tmp_kernel_op_214 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_212,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_213,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_215 = _mm256_mul_pd(tmp_kernel_op_203,_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192));
                const __m256d tmp_kernel_op_216 = _mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204));
                const __m256d tmp_kernel_op_217 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_215,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_216,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_218 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195));
                const __m256d tmp_kernel_op_219 = _mm256_mul_pd(tmp_kernel_op_194,_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207));
                const __m256d tmp_kernel_op_220 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_218,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_219,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_221 = _mm256_mul_pd(tmp_kernel_op_197,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72));
                const __m256d tmp_kernel_op_222 = _mm256_mul_pd(tmp_kernel_op_71,_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198));
                const __m256d tmp_kernel_op_223 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_222,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_224 = _mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_225 = _mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201));
                const __m256d tmp_kernel_op_226 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_224,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_225,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_227 = _mm256_mul_pd(tmp_kernel_op_203,_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146));
                const __m256d tmp_kernel_op_228 = _mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204));
                const __m256d tmp_kernel_op_229 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_227,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_228,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_230 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183));
                const __m256d tmp_kernel_op_231 = _mm256_mul_pd(tmp_kernel_op_182,_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207));
                const __m256d tmp_kernel_op_232 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_230,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_231,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_233 = _mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72));
                const __m256d tmp_kernel_op_234 = _mm256_mul_pd(tmp_kernel_op_71,_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186));
                const __m256d tmp_kernel_op_235 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_233,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_234,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_236 = _mm256_mul_pd(tmp_kernel_op_188,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_237 = _mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189));
                const __m256d tmp_kernel_op_238 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_236,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_237,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_239 = _mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146));
                const __m256d tmp_kernel_op_240 = _mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192));
                const __m256d tmp_kernel_op_241 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_239,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_240,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_242 = _mm256_mul_pd(tmp_kernel_op_194,_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183));
                const __m256d tmp_kernel_op_243 = _mm256_mul_pd(tmp_kernel_op_182,_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195));
                const __m256d tmp_kernel_op_244 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_243,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_246 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245)),_mm256_set_pd(-0.68328157299974723,-0.68328157299974723,-0.68328157299974723,-0.68328157299974723))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_210),tmp_kernel_op_222);
                const __m256d tmp_kernel_op_248 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_200,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247)),_mm256_set_pd(2.8944271909999157,2.8944271909999157,2.8944271909999157,2.8944271909999157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_213),tmp_kernel_op_225);
                const __m256d tmp_kernel_op_250 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249)),_mm256_set_pd(2.8944271909999157,2.8944271909999157,2.8944271909999157,2.8944271909999157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_216),tmp_kernel_op_228);
                const __m256d tmp_kernel_op_252 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_206,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251)),_mm256_set_pd(2.8944271909999157,2.8944271909999157,2.8944271909999157,2.8944271909999157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_219),tmp_kernel_op_231);
                const __m256d tmp_kernel_op_254 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_209),tmp_kernel_op_234);
                const __m256d tmp_kernel_op_256 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_188,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))),_mm256_set_pd(-4.6832815729997472,-4.6832815729997472,-4.6832815729997472,-4.6832815729997472))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_212),tmp_kernel_op_237);
                const __m256d tmp_kernel_op_258 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_191,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_215),tmp_kernel_op_240);
                const __m256d tmp_kernel_op_260 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_218),tmp_kernel_op_243);
                const __m256d tmp_kernel_op_261 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_221),tmp_kernel_op_233);
                const __m256d tmp_kernel_op_262 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_108,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_224),tmp_kernel_op_236);
                const __m256d tmp_kernel_op_263 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_145,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257))),_mm256_set_pd(-4.6832815729997472,-4.6832815729997472,-4.6832815729997472,-4.6832815729997472))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_227),tmp_kernel_op_239);
                const __m256d tmp_kernel_op_264 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_182,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_230),tmp_kernel_op_242);
                const __m256d tmp_kernel_op_266 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265)));
                const __m256d tmp_kernel_op_268 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_188,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267)));
                const __m256d tmp_kernel_op_270 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_203,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269)));
                const __m256d tmp_kernel_op_272 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_182,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271)));
                const __m256d tmp_kernel_op_273 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_274 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_275 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_276 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_277 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_278 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_279 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_280 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_281 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_282 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_283 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_284 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_214),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_217)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_220)),_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_61))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_226),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_229)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_232)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_238),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_241)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_244)),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_248),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_250)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_252)),_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_256),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_258)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_260)),_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_262),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_263)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_264)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_268),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_270)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_272)),_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_110),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_184),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_190),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_193),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_196),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_202),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_205),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_208),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_276))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_232,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_241,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_258,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_262,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_268,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_270,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_272,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_110,tmp_kernel_op_274),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_275),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_276),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_273,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_273),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_190,tmp_kernel_op_274),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_275),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_276),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_273),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_274),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_275),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_276),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_280))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_232,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_241,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_258,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_262,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_268,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_270,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_272,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_110,tmp_kernel_op_278),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_279),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_280),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_277),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_190,tmp_kernel_op_278),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_279),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_280),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_277),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_278),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_279),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_280),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_284))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_232,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_241,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_258,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_262,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_268,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_270,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_272,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_110,tmp_kernel_op_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_283),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_284),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_281,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_281),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_190,tmp_kernel_op_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_283),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_284),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_281),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_283),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_284),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_0 = -p_affine_0_0 + p_affine_1_0;
                const real_t tmp_kernel_op_1 = -p_affine_0_0 + p_affine_2_0;
                const real_t tmp_kernel_op_2 = -p_affine_0_0 + p_affine_3_0;
                const real_t tmp_kernel_op_3 = p_affine_0_0 + tmp_kernel_op_0*0.1381966011250105 + tmp_kernel_op_1*0.1381966011250105 + tmp_kernel_op_2*0.5854101966249684;
                const real_t tmp_kernel_op_4 = -p_affine_0_1 + p_affine_1_1;
                const real_t tmp_kernel_op_5 = -p_affine_0_1 + p_affine_2_1;
                const real_t tmp_kernel_op_6 = -p_affine_0_1 + p_affine_3_1;
                const real_t tmp_kernel_op_7 = p_affine_0_1 + tmp_kernel_op_4*0.1381966011250105 + tmp_kernel_op_5*0.1381966011250105 + tmp_kernel_op_6*0.5854101966249684;
                const real_t tmp_kernel_op_8 = -p_affine_0_2 + p_affine_1_2;
                const real_t tmp_kernel_op_9 = -p_affine_0_2 + p_affine_2_2;
                const real_t tmp_kernel_op_10 = -p_affine_0_2 + p_affine_3_2;
                const real_t tmp_kernel_op_11 = p_affine_0_2 + tmp_kernel_op_10*0.5854101966249684 + tmp_kernel_op_8*0.1381966011250105 + tmp_kernel_op_9*0.1381966011250105;
                const real_t tmp_kernel_op_12 = (tmp_kernel_op_3*tmp_kernel_op_3);
                const real_t tmp_kernel_op_13 = (tmp_kernel_op_7*tmp_kernel_op_7);
                const real_t tmp_kernel_op_14 = (tmp_kernel_op_11*tmp_kernel_op_11);
                const real_t tmp_kernel_op_15 = tmp_kernel_op_12 + tmp_kernel_op_13 + tmp_kernel_op_14;
                const real_t tmp_kernel_op_16 = pow(tmp_kernel_op_15, -4.5000000000000000);
                const real_t tmp_kernel_op_38 = -tmp_kernel_op_11 - tmp_kernel_op_29;
                const real_t tmp_kernel_op_39 = -tmp_kernel_op_18 - tmp_kernel_op_3;
                const real_t tmp_kernel_op_40 = -tmp_kernel_op_25 - tmp_kernel_op_7;
                const real_t tmp_kernel_op_41 = -tmp_kernel_op_35*(tmp_kernel_op_19*tmp_kernel_op_20*tmp_kernel_op_40 + tmp_kernel_op_23*tmp_kernel_op_30*tmp_kernel_op_39 - tmp_kernel_op_24*tmp_kernel_op_38 + tmp_kernel_op_26*tmp_kernel_op_27*tmp_kernel_op_38 - tmp_kernel_op_31*tmp_kernel_op_39 - tmp_kernel_op_32*tmp_kernel_op_40) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_42 = -tmp_kernel_op_41;
                const real_t tmp_kernel_op_43 = tmp_kernel_op_11*tmp_kernel_op_42 + tmp_kernel_op_15*tmp_kernel_op_36;
                const real_t tmp_kernel_op_45 = tmp_kernel_op_15*tmp_kernel_op_44 + tmp_kernel_op_3*tmp_kernel_op_42;
                const real_t tmp_kernel_op_48 = -tmp_kernel_op_15*tmp_kernel_op_47 - tmp_kernel_op_41*tmp_kernel_op_7;
                const real_t tmp_kernel_op_50 = tmp_kernel_op_13*tmp_kernel_op_42 + tmp_kernel_op_15*(tmp_kernel_op_41 + tmp_kernel_op_49*tmp_kernel_op_7);
                const real_t tmp_kernel_op_51 = tmp_kernel_op_3*tmp_kernel_op_45;
                const real_t tmp_kernel_op_53 = tmp_kernel_op_16*tmp_kernel_op_52;
                const real_t tmp_kernel_op_54 = tmp_kernel_op_11*tmp_kernel_op_43*tmp_kernel_op_53;
                const real_t tmp_kernel_op_55 = tmp_kernel_op_14*tmp_kernel_op_42 + tmp_kernel_op_15*(tmp_kernel_op_11*tmp_kernel_op_36 + tmp_kernel_op_41);
                const real_t tmp_kernel_op_56 = tmp_kernel_op_48*tmp_kernel_op_51*tmp_kernel_op_7;
                const real_t tmp_kernel_op_57 = -tmp_kernel_op_12*tmp_kernel_op_41 + tmp_kernel_op_15*(tmp_kernel_op_3*tmp_kernel_op_44 + tmp_kernel_op_41);
                const real_t tmp_kernel_op_58 = tmp_kernel_op_57*tmp_kernel_op_7;
                const real_t tmp_kernel_op_59 = tmp_kernel_op_11*tmp_kernel_op_16*tmp_kernel_op_3*tmp_kernel_op_34*tmp_kernel_op_43*tmp_kernel_op_45*tmp_kernel_op_48*tmp_kernel_op_7*2.0 + tmp_kernel_op_16*tmp_kernel_op_34*tmp_kernel_op_50*tmp_kernel_op_55*tmp_kernel_op_57*1.0 - tmp_kernel_op_48*tmp_kernel_op_54*tmp_kernel_op_58 - tmp_kernel_op_50*tmp_kernel_op_51*tmp_kernel_op_54 - tmp_kernel_op_53*tmp_kernel_op_55*tmp_kernel_op_56;
                const real_t tmp_kernel_op_60 = abs_det_jac_affine_BLUE_UP*0.041666666666666657*abs(tmp_kernel_op_59);
                const real_t tmp_kernel_op_61 = tmp_kernel_op_60*0.13819660112501053;
                const real_t tmp_kernel_op_62 = 1.0 / (tmp_kernel_op_59);
                const real_t tmp_kernel_op_63 = 1.0 / (tmp_kernel_op_15*tmp_kernel_op_15*tmp_kernel_op_15);
                const real_t tmp_kernel_op_66 = tmp_kernel_op_63*tmp_kernel_op_65;
                const real_t tmp_kernel_op_67 = tmp_kernel_op_43*tmp_kernel_op_66;
                const real_t tmp_kernel_op_68 = tmp_kernel_op_62*(tmp_kernel_op_3*tmp_kernel_op_43*tmp_kernel_op_45*tmp_kernel_op_63*tmp_kernel_op_64*tmp_kernel_op_7*1.0 - tmp_kernel_op_58*tmp_kernel_op_67);
                const real_t tmp_kernel_op_69 = tmp_kernel_op_62*(tmp_kernel_op_3*tmp_kernel_op_43*tmp_kernel_op_48*tmp_kernel_op_63*tmp_kernel_op_64*tmp_kernel_op_7*1.0 - tmp_kernel_op_3*tmp_kernel_op_50*tmp_kernel_op_67);
                const real_t tmp_kernel_op_70 = tmp_kernel_op_62*(tmp_kernel_op_50*tmp_kernel_op_57*tmp_kernel_op_66 - tmp_kernel_op_56*tmp_kernel_op_66);
                const real_t tmp_kernel_op_71 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_69 + jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_68 + jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_70;
                const real_t tmp_kernel_op_73 = tmp_kernel_op_71*(tmp_kernel_op_72 - 1.0);
                const real_t tmp_kernel_op_74 = p_affine_0_0 + tmp_kernel_op_0*0.1381966011250105 + tmp_kernel_op_1*0.5854101966249684 + tmp_kernel_op_2*0.1381966011250105;
                const real_t tmp_kernel_op_75 = p_affine_0_1 + tmp_kernel_op_4*0.1381966011250105 + tmp_kernel_op_5*0.5854101966249684 + tmp_kernel_op_6*0.1381966011250105;
                const real_t tmp_kernel_op_76 = p_affine_0_2 + tmp_kernel_op_10*0.1381966011250105 + tmp_kernel_op_8*0.1381966011250105 + tmp_kernel_op_9*0.5854101966249684;
                const real_t tmp_kernel_op_77 = (tmp_kernel_op_74*tmp_kernel_op_74);
                const real_t tmp_kernel_op_78 = (tmp_kernel_op_75*tmp_kernel_op_75);
                const real_t tmp_kernel_op_79 = (tmp_kernel_op_76*tmp_kernel_op_76);
                const real_t tmp_kernel_op_80 = tmp_kernel_op_77 + tmp_kernel_op_78 + tmp_kernel_op_79;
                const real_t tmp_kernel_op_81 = pow(tmp_kernel_op_80, -4.5000000000000000);
                const real_t tmp_kernel_op_82 = -tmp_kernel_op_29 - tmp_kernel_op_76;
                const real_t tmp_kernel_op_83 = -tmp_kernel_op_18 - tmp_kernel_op_74;
                const real_t tmp_kernel_op_84 = -tmp_kernel_op_25 - tmp_kernel_op_75;
                const real_t tmp_kernel_op_85 = -tmp_kernel_op_35*(tmp_kernel_op_19*tmp_kernel_op_20*tmp_kernel_op_84 + tmp_kernel_op_23*tmp_kernel_op_30*tmp_kernel_op_83 - tmp_kernel_op_24*tmp_kernel_op_82 + tmp_kernel_op_26*tmp_kernel_op_27*tmp_kernel_op_82 - tmp_kernel_op_31*tmp_kernel_op_83 - tmp_kernel_op_32*tmp_kernel_op_84) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_86 = -tmp_kernel_op_85;
                const real_t tmp_kernel_op_87 = tmp_kernel_op_36*tmp_kernel_op_80 + tmp_kernel_op_76*tmp_kernel_op_86;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_44*tmp_kernel_op_80 + tmp_kernel_op_74*tmp_kernel_op_86;
                const real_t tmp_kernel_op_89 = -tmp_kernel_op_47*tmp_kernel_op_80 - tmp_kernel_op_75*tmp_kernel_op_85;
                const real_t tmp_kernel_op_90 = tmp_kernel_op_78*tmp_kernel_op_86 + tmp_kernel_op_80*(tmp_kernel_op_49*tmp_kernel_op_75 + tmp_kernel_op_85);
                const real_t tmp_kernel_op_91 = tmp_kernel_op_74*tmp_kernel_op_88;
                const real_t tmp_kernel_op_92 = tmp_kernel_op_52*tmp_kernel_op_81;
                const real_t tmp_kernel_op_93 = tmp_kernel_op_76*tmp_kernel_op_87*tmp_kernel_op_92;
                const real_t tmp_kernel_op_94 = tmp_kernel_op_79*tmp_kernel_op_86 + tmp_kernel_op_80*(tmp_kernel_op_36*tmp_kernel_op_76 + tmp_kernel_op_85);
                const real_t tmp_kernel_op_95 = tmp_kernel_op_75*tmp_kernel_op_89*tmp_kernel_op_91;
                const real_t tmp_kernel_op_96 = -tmp_kernel_op_77*tmp_kernel_op_85 + tmp_kernel_op_80*(tmp_kernel_op_44*tmp_kernel_op_74 + tmp_kernel_op_85);
                const real_t tmp_kernel_op_97 = tmp_kernel_op_75*tmp_kernel_op_96;
                const real_t tmp_kernel_op_98 = tmp_kernel_op_34*tmp_kernel_op_74*tmp_kernel_op_75*tmp_kernel_op_76*tmp_kernel_op_81*tmp_kernel_op_87*tmp_kernel_op_88*tmp_kernel_op_89*2.0 + tmp_kernel_op_34*tmp_kernel_op_81*tmp_kernel_op_90*tmp_kernel_op_94*tmp_kernel_op_96*1.0 - tmp_kernel_op_89*tmp_kernel_op_93*tmp_kernel_op_97 - tmp_kernel_op_90*tmp_kernel_op_91*tmp_kernel_op_93 - tmp_kernel_op_92*tmp_kernel_op_94*tmp_kernel_op_95;
                const real_t tmp_kernel_op_99 = abs_det_jac_affine_BLUE_UP*0.041666666666666657*abs(tmp_kernel_op_98);
                const real_t tmp_kernel_op_100 = tmp_kernel_op_99*0.13819660112501056;
                const real_t tmp_kernel_op_101 = 1.0 / (tmp_kernel_op_98);
                const real_t tmp_kernel_op_102 = 1.0 / (tmp_kernel_op_80*tmp_kernel_op_80*tmp_kernel_op_80);
                const real_t tmp_kernel_op_103 = tmp_kernel_op_102*tmp_kernel_op_65;
                const real_t tmp_kernel_op_104 = tmp_kernel_op_103*tmp_kernel_op_87;
                const real_t tmp_kernel_op_105 = tmp_kernel_op_101*(tmp_kernel_op_102*tmp_kernel_op_64*tmp_kernel_op_74*tmp_kernel_op_75*tmp_kernel_op_87*tmp_kernel_op_88*1.0 - tmp_kernel_op_104*tmp_kernel_op_97);
                const real_t tmp_kernel_op_106 = tmp_kernel_op_101*(tmp_kernel_op_102*tmp_kernel_op_64*tmp_kernel_op_74*tmp_kernel_op_75*tmp_kernel_op_87*tmp_kernel_op_89*1.0 - tmp_kernel_op_104*tmp_kernel_op_74*tmp_kernel_op_90);
                const real_t tmp_kernel_op_107 = tmp_kernel_op_101*(tmp_kernel_op_103*tmp_kernel_op_90*tmp_kernel_op_96 - tmp_kernel_op_103*tmp_kernel_op_95);
                const real_t tmp_kernel_op_108 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_106 + jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_105 + jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_107;
                const real_t tmp_kernel_op_110 = tmp_kernel_op_108*(tmp_kernel_op_109 - 1.0);
                const real_t tmp_kernel_op_111 = p_affine_0_0 + tmp_kernel_op_0*0.5854101966249684 + tmp_kernel_op_1*0.1381966011250105 + tmp_kernel_op_2*0.1381966011250105;
                const real_t tmp_kernel_op_112 = p_affine_0_1 + tmp_kernel_op_4*0.5854101966249684 + tmp_kernel_op_5*0.1381966011250105 + tmp_kernel_op_6*0.1381966011250105;
                const real_t tmp_kernel_op_113 = p_affine_0_2 + tmp_kernel_op_10*0.1381966011250105 + tmp_kernel_op_8*0.5854101966249684 + tmp_kernel_op_9*0.1381966011250105;
                const real_t tmp_kernel_op_114 = (tmp_kernel_op_111*tmp_kernel_op_111);
                const real_t tmp_kernel_op_115 = (tmp_kernel_op_112*tmp_kernel_op_112);
                const real_t tmp_kernel_op_116 = (tmp_kernel_op_113*tmp_kernel_op_113);
                const real_t tmp_kernel_op_117 = tmp_kernel_op_114 + tmp_kernel_op_115 + tmp_kernel_op_116;
                const real_t tmp_kernel_op_118 = pow(tmp_kernel_op_117, -4.5000000000000000);
                const real_t tmp_kernel_op_119 = -tmp_kernel_op_113 - tmp_kernel_op_29;
                const real_t tmp_kernel_op_120 = -tmp_kernel_op_111 - tmp_kernel_op_18;
                const real_t tmp_kernel_op_121 = -tmp_kernel_op_112 - tmp_kernel_op_25;
                const real_t tmp_kernel_op_122 = -tmp_kernel_op_35*(-tmp_kernel_op_119*tmp_kernel_op_24 + tmp_kernel_op_119*tmp_kernel_op_26*tmp_kernel_op_27 + tmp_kernel_op_120*tmp_kernel_op_23*tmp_kernel_op_30 - tmp_kernel_op_120*tmp_kernel_op_31 + tmp_kernel_op_121*tmp_kernel_op_19*tmp_kernel_op_20 - tmp_kernel_op_121*tmp_kernel_op_32) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_123 = -tmp_kernel_op_122;
                const real_t tmp_kernel_op_124 = tmp_kernel_op_113*tmp_kernel_op_123 + tmp_kernel_op_117*tmp_kernel_op_36;
                const real_t tmp_kernel_op_125 = tmp_kernel_op_111*tmp_kernel_op_123 + tmp_kernel_op_117*tmp_kernel_op_44;
                const real_t tmp_kernel_op_126 = -tmp_kernel_op_112*tmp_kernel_op_122 - tmp_kernel_op_117*tmp_kernel_op_47;
                const real_t tmp_kernel_op_127 = tmp_kernel_op_115*tmp_kernel_op_123 + tmp_kernel_op_117*(tmp_kernel_op_112*tmp_kernel_op_49 + tmp_kernel_op_122);
                const real_t tmp_kernel_op_128 = tmp_kernel_op_111*tmp_kernel_op_125;
                const real_t tmp_kernel_op_129 = tmp_kernel_op_118*tmp_kernel_op_52;
                const real_t tmp_kernel_op_130 = tmp_kernel_op_113*tmp_kernel_op_124*tmp_kernel_op_129;
                const real_t tmp_kernel_op_131 = tmp_kernel_op_116*tmp_kernel_op_123 + tmp_kernel_op_117*(tmp_kernel_op_113*tmp_kernel_op_36 + tmp_kernel_op_122);
                const real_t tmp_kernel_op_132 = tmp_kernel_op_112*tmp_kernel_op_126*tmp_kernel_op_128;
                const real_t tmp_kernel_op_133 = -tmp_kernel_op_114*tmp_kernel_op_122 + tmp_kernel_op_117*(tmp_kernel_op_111*tmp_kernel_op_44 + tmp_kernel_op_122);
                const real_t tmp_kernel_op_134 = tmp_kernel_op_112*tmp_kernel_op_133;
                const real_t tmp_kernel_op_135 = tmp_kernel_op_111*tmp_kernel_op_112*tmp_kernel_op_113*tmp_kernel_op_118*tmp_kernel_op_124*tmp_kernel_op_125*tmp_kernel_op_126*tmp_kernel_op_34*2.0 + tmp_kernel_op_118*tmp_kernel_op_127*tmp_kernel_op_131*tmp_kernel_op_133*tmp_kernel_op_34*1.0 - tmp_kernel_op_126*tmp_kernel_op_130*tmp_kernel_op_134 - tmp_kernel_op_127*tmp_kernel_op_128*tmp_kernel_op_130 - tmp_kernel_op_129*tmp_kernel_op_131*tmp_kernel_op_132;
                const real_t tmp_kernel_op_136 = abs_det_jac_affine_BLUE_UP*0.041666666666666657*abs(tmp_kernel_op_135);
                const real_t tmp_kernel_op_137 = tmp_kernel_op_136*0.13819660112501056;
                const real_t tmp_kernel_op_138 = 1.0 / (tmp_kernel_op_135);
                const real_t tmp_kernel_op_139 = 1.0 / (tmp_kernel_op_117*tmp_kernel_op_117*tmp_kernel_op_117);
                const real_t tmp_kernel_op_140 = tmp_kernel_op_139*tmp_kernel_op_65;
                const real_t tmp_kernel_op_141 = tmp_kernel_op_124*tmp_kernel_op_140;
                const real_t tmp_kernel_op_142 = tmp_kernel_op_138*(tmp_kernel_op_111*tmp_kernel_op_112*tmp_kernel_op_124*tmp_kernel_op_125*tmp_kernel_op_139*tmp_kernel_op_64*1.0 - tmp_kernel_op_134*tmp_kernel_op_141);
                const real_t tmp_kernel_op_143 = tmp_kernel_op_138*(tmp_kernel_op_111*tmp_kernel_op_112*tmp_kernel_op_124*tmp_kernel_op_126*tmp_kernel_op_139*tmp_kernel_op_64*1.0 - tmp_kernel_op_111*tmp_kernel_op_127*tmp_kernel_op_141);
                const real_t tmp_kernel_op_144 = tmp_kernel_op_138*(tmp_kernel_op_127*tmp_kernel_op_133*tmp_kernel_op_140 - tmp_kernel_op_132*tmp_kernel_op_140);
                const real_t tmp_kernel_op_145 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_143 + jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_142 + jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_144;
                const real_t tmp_kernel_op_147 = tmp_kernel_op_145*(tmp_kernel_op_146 - 1.0);
                const real_t tmp_kernel_op_148 = p_affine_0_0 + tmp_kernel_op_0*0.1381966011250105 + tmp_kernel_op_1*0.1381966011250105 + tmp_kernel_op_2*0.1381966011250105;
                const real_t tmp_kernel_op_149 = p_affine_0_1 + tmp_kernel_op_4*0.1381966011250105 + tmp_kernel_op_5*0.1381966011250105 + tmp_kernel_op_6*0.1381966011250105;
                const real_t tmp_kernel_op_150 = p_affine_0_2 + tmp_kernel_op_10*0.1381966011250105 + tmp_kernel_op_8*0.1381966011250105 + tmp_kernel_op_9*0.1381966011250105;
                const real_t tmp_kernel_op_151 = (tmp_kernel_op_148*tmp_kernel_op_148);
                const real_t tmp_kernel_op_152 = (tmp_kernel_op_149*tmp_kernel_op_149);
                const real_t tmp_kernel_op_153 = (tmp_kernel_op_150*tmp_kernel_op_150);
                const real_t tmp_kernel_op_154 = tmp_kernel_op_151 + tmp_kernel_op_152 + tmp_kernel_op_153;
                const real_t tmp_kernel_op_155 = pow(tmp_kernel_op_154, -4.5000000000000000);
                const real_t tmp_kernel_op_156 = -tmp_kernel_op_150 - tmp_kernel_op_29;
                const real_t tmp_kernel_op_157 = -tmp_kernel_op_148 - tmp_kernel_op_18;
                const real_t tmp_kernel_op_158 = -tmp_kernel_op_149 - tmp_kernel_op_25;
                const real_t tmp_kernel_op_159 = -tmp_kernel_op_35*(-tmp_kernel_op_156*tmp_kernel_op_24 + tmp_kernel_op_156*tmp_kernel_op_26*tmp_kernel_op_27 + tmp_kernel_op_157*tmp_kernel_op_23*tmp_kernel_op_30 - tmp_kernel_op_157*tmp_kernel_op_31 + tmp_kernel_op_158*tmp_kernel_op_19*tmp_kernel_op_20 - tmp_kernel_op_158*tmp_kernel_op_32) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_160 = -tmp_kernel_op_159;
                const real_t tmp_kernel_op_161 = tmp_kernel_op_150*tmp_kernel_op_160 + tmp_kernel_op_154*tmp_kernel_op_36;
                const real_t tmp_kernel_op_162 = tmp_kernel_op_148*tmp_kernel_op_160 + tmp_kernel_op_154*tmp_kernel_op_44;
                const real_t tmp_kernel_op_163 = -tmp_kernel_op_149*tmp_kernel_op_159 - tmp_kernel_op_154*tmp_kernel_op_47;
                const real_t tmp_kernel_op_164 = tmp_kernel_op_152*tmp_kernel_op_160 + tmp_kernel_op_154*(tmp_kernel_op_149*tmp_kernel_op_49 + tmp_kernel_op_159);
                const real_t tmp_kernel_op_165 = tmp_kernel_op_148*tmp_kernel_op_162;
                const real_t tmp_kernel_op_166 = tmp_kernel_op_155*tmp_kernel_op_52;
                const real_t tmp_kernel_op_167 = tmp_kernel_op_150*tmp_kernel_op_161*tmp_kernel_op_166;
                const real_t tmp_kernel_op_168 = tmp_kernel_op_153*tmp_kernel_op_160 + tmp_kernel_op_154*(tmp_kernel_op_150*tmp_kernel_op_36 + tmp_kernel_op_159);
                const real_t tmp_kernel_op_169 = tmp_kernel_op_149*tmp_kernel_op_163*tmp_kernel_op_165;
                const real_t tmp_kernel_op_170 = -tmp_kernel_op_151*tmp_kernel_op_159 + tmp_kernel_op_154*(tmp_kernel_op_148*tmp_kernel_op_44 + tmp_kernel_op_159);
                const real_t tmp_kernel_op_171 = tmp_kernel_op_149*tmp_kernel_op_170;
                const real_t tmp_kernel_op_172 = tmp_kernel_op_148*tmp_kernel_op_149*tmp_kernel_op_150*tmp_kernel_op_155*tmp_kernel_op_161*tmp_kernel_op_162*tmp_kernel_op_163*tmp_kernel_op_34*2.0 + tmp_kernel_op_155*tmp_kernel_op_164*tmp_kernel_op_168*tmp_kernel_op_170*tmp_kernel_op_34*1.0 - tmp_kernel_op_163*tmp_kernel_op_167*tmp_kernel_op_171 - tmp_kernel_op_164*tmp_kernel_op_165*tmp_kernel_op_167 - tmp_kernel_op_166*tmp_kernel_op_168*tmp_kernel_op_169;
                const real_t tmp_kernel_op_173 = abs_det_jac_affine_BLUE_UP*0.041666666666666657*abs(tmp_kernel_op_172);
                const real_t tmp_kernel_op_174 = tmp_kernel_op_173*0.5854101966249684;
                const real_t tmp_kernel_op_175 = 1.0 / (tmp_kernel_op_172);
                const real_t tmp_kernel_op_176 = 1.0 / (tmp_kernel_op_154*tmp_kernel_op_154*tmp_kernel_op_154);
                const real_t tmp_kernel_op_177 = tmp_kernel_op_176*tmp_kernel_op_65;
                const real_t tmp_kernel_op_178 = tmp_kernel_op_161*tmp_kernel_op_177;
                const real_t tmp_kernel_op_179 = tmp_kernel_op_175*(tmp_kernel_op_148*tmp_kernel_op_149*tmp_kernel_op_161*tmp_kernel_op_162*tmp_kernel_op_176*tmp_kernel_op_64*1.0 - tmp_kernel_op_171*tmp_kernel_op_178);
                const real_t tmp_kernel_op_180 = tmp_kernel_op_175*(tmp_kernel_op_148*tmp_kernel_op_149*tmp_kernel_op_161*tmp_kernel_op_163*tmp_kernel_op_176*tmp_kernel_op_64*1.0 - tmp_kernel_op_148*tmp_kernel_op_164*tmp_kernel_op_178);
                const real_t tmp_kernel_op_181 = tmp_kernel_op_175*(tmp_kernel_op_164*tmp_kernel_op_170*tmp_kernel_op_177 - tmp_kernel_op_169*tmp_kernel_op_177);
                const real_t tmp_kernel_op_182 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_180 + jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_179 + jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_181;
                const real_t tmp_kernel_op_184 = tmp_kernel_op_182*(tmp_kernel_op_183 - 1.0);
                const real_t tmp_kernel_op_185 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_69 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_68 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_70;
                const real_t tmp_kernel_op_187 = tmp_kernel_op_185*(tmp_kernel_op_186 - 1.0);
                const real_t tmp_kernel_op_188 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_106 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_105 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_107;
                const real_t tmp_kernel_op_190 = tmp_kernel_op_188*(tmp_kernel_op_189 - 1.0);
                const real_t tmp_kernel_op_191 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_143 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_142 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_144;
                const real_t tmp_kernel_op_193 = tmp_kernel_op_191*(tmp_kernel_op_192 - 1.0);
                const real_t tmp_kernel_op_194 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_180 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_179 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_181;
                const real_t tmp_kernel_op_196 = tmp_kernel_op_194*(tmp_kernel_op_195 - 1.0);
                const real_t tmp_kernel_op_197 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_69 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_68 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_70;
                const real_t tmp_kernel_op_199 = tmp_kernel_op_197*(tmp_kernel_op_198 - 1.0);
                const real_t tmp_kernel_op_200 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_106 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_105 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_107;
                const real_t tmp_kernel_op_202 = tmp_kernel_op_200*(tmp_kernel_op_201 - 1.0);
                const real_t tmp_kernel_op_203 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_143 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_142 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_144;
                const real_t tmp_kernel_op_205 = tmp_kernel_op_203*(tmp_kernel_op_204 - 1.0);
                const real_t tmp_kernel_op_206 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_180 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_179 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_181;
                const real_t tmp_kernel_op_208 = tmp_kernel_op_206*(tmp_kernel_op_207 - 1.0);
                const real_t tmp_kernel_op_209 = tmp_kernel_op_186*tmp_kernel_op_197;
                const real_t tmp_kernel_op_210 = tmp_kernel_op_185*tmp_kernel_op_198;
                const real_t tmp_kernel_op_211 = -tmp_kernel_op_209 - tmp_kernel_op_210;
                const real_t tmp_kernel_op_212 = tmp_kernel_op_189*tmp_kernel_op_200;
                const real_t tmp_kernel_op_213 = tmp_kernel_op_188*tmp_kernel_op_201;
                const real_t tmp_kernel_op_214 = -tmp_kernel_op_212 - tmp_kernel_op_213;
                const real_t tmp_kernel_op_215 = tmp_kernel_op_192*tmp_kernel_op_203;
                const real_t tmp_kernel_op_216 = tmp_kernel_op_191*tmp_kernel_op_204;
                const real_t tmp_kernel_op_217 = -tmp_kernel_op_215 - tmp_kernel_op_216;
                const real_t tmp_kernel_op_218 = tmp_kernel_op_195*tmp_kernel_op_206;
                const real_t tmp_kernel_op_219 = tmp_kernel_op_194*tmp_kernel_op_207;
                const real_t tmp_kernel_op_220 = -tmp_kernel_op_218 - tmp_kernel_op_219;
                const real_t tmp_kernel_op_221 = tmp_kernel_op_197*tmp_kernel_op_72;
                const real_t tmp_kernel_op_222 = tmp_kernel_op_198*tmp_kernel_op_71;
                const real_t tmp_kernel_op_223 = -tmp_kernel_op_221 - tmp_kernel_op_222;
                const real_t tmp_kernel_op_224 = tmp_kernel_op_109*tmp_kernel_op_200;
                const real_t tmp_kernel_op_225 = tmp_kernel_op_108*tmp_kernel_op_201;
                const real_t tmp_kernel_op_226 = -tmp_kernel_op_224 - tmp_kernel_op_225;
                const real_t tmp_kernel_op_227 = tmp_kernel_op_146*tmp_kernel_op_203;
                const real_t tmp_kernel_op_228 = tmp_kernel_op_145*tmp_kernel_op_204;
                const real_t tmp_kernel_op_229 = -tmp_kernel_op_227 - tmp_kernel_op_228;
                const real_t tmp_kernel_op_230 = tmp_kernel_op_183*tmp_kernel_op_206;
                const real_t tmp_kernel_op_231 = tmp_kernel_op_182*tmp_kernel_op_207;
                const real_t tmp_kernel_op_232 = -tmp_kernel_op_230 - tmp_kernel_op_231;
                const real_t tmp_kernel_op_233 = tmp_kernel_op_185*tmp_kernel_op_72;
                const real_t tmp_kernel_op_234 = tmp_kernel_op_186*tmp_kernel_op_71;
                const real_t tmp_kernel_op_235 = -tmp_kernel_op_233 - tmp_kernel_op_234;
                const real_t tmp_kernel_op_236 = tmp_kernel_op_109*tmp_kernel_op_188;
                const real_t tmp_kernel_op_237 = tmp_kernel_op_108*tmp_kernel_op_189;
                const real_t tmp_kernel_op_238 = -tmp_kernel_op_236 - tmp_kernel_op_237;
                const real_t tmp_kernel_op_239 = tmp_kernel_op_146*tmp_kernel_op_191;
                const real_t tmp_kernel_op_240 = tmp_kernel_op_145*tmp_kernel_op_192;
                const real_t tmp_kernel_op_241 = -tmp_kernel_op_239 - tmp_kernel_op_240;
                const real_t tmp_kernel_op_242 = tmp_kernel_op_183*tmp_kernel_op_194;
                const real_t tmp_kernel_op_243 = tmp_kernel_op_182*tmp_kernel_op_195;
                const real_t tmp_kernel_op_244 = -tmp_kernel_op_242 - tmp_kernel_op_243;
                const real_t tmp_kernel_op_246 = -tmp_kernel_op_197*(-tmp_kernel_op_245 - 0.68328157299974723) + tmp_kernel_op_210 + tmp_kernel_op_222;
                const real_t tmp_kernel_op_248 = -tmp_kernel_op_200*(-tmp_kernel_op_247 + 2.8944271909999157) + tmp_kernel_op_213 + tmp_kernel_op_225;
                const real_t tmp_kernel_op_250 = -tmp_kernel_op_203*(-tmp_kernel_op_249 + 2.8944271909999157) + tmp_kernel_op_216 + tmp_kernel_op_228;
                const real_t tmp_kernel_op_252 = -tmp_kernel_op_206*(-tmp_kernel_op_251 + 2.8944271909999157) + tmp_kernel_op_219 + tmp_kernel_op_231;
                const real_t tmp_kernel_op_254 = -tmp_kernel_op_185*(-tmp_kernel_op_253 - tmp_kernel_op_72 - 1.105572809000084) + tmp_kernel_op_209 + tmp_kernel_op_234;
                const real_t tmp_kernel_op_256 = -tmp_kernel_op_188*(-tmp_kernel_op_109 - tmp_kernel_op_255 - 4.6832815729997472) + tmp_kernel_op_212 + tmp_kernel_op_237;
                const real_t tmp_kernel_op_258 = -tmp_kernel_op_191*(-tmp_kernel_op_146 - tmp_kernel_op_257 - 1.105572809000084) + tmp_kernel_op_215 + tmp_kernel_op_240;
                const real_t tmp_kernel_op_260 = -tmp_kernel_op_194*(-tmp_kernel_op_183 - tmp_kernel_op_259 - 1.105572809000084) + tmp_kernel_op_218 + tmp_kernel_op_243;
                const real_t tmp_kernel_op_261 = tmp_kernel_op_221 + tmp_kernel_op_233 - tmp_kernel_op_71*(-tmp_kernel_op_186 - tmp_kernel_op_253 - 1.105572809000084);
                const real_t tmp_kernel_op_262 = -tmp_kernel_op_108*(-tmp_kernel_op_189 - tmp_kernel_op_255 - 1.105572809000084) + tmp_kernel_op_224 + tmp_kernel_op_236;
                const real_t tmp_kernel_op_263 = -tmp_kernel_op_145*(-tmp_kernel_op_192 - tmp_kernel_op_257 - 4.6832815729997472) + tmp_kernel_op_227 + tmp_kernel_op_239;
                const real_t tmp_kernel_op_264 = -tmp_kernel_op_182*(-tmp_kernel_op_195 - tmp_kernel_op_259 - 1.105572809000084) + tmp_kernel_op_230 + tmp_kernel_op_242;
                const real_t tmp_kernel_op_266 = -tmp_kernel_op_185*tmp_kernel_op_265 - tmp_kernel_op_197*tmp_kernel_op_265 - tmp_kernel_op_265*tmp_kernel_op_71;
                const real_t tmp_kernel_op_268 = -tmp_kernel_op_108*tmp_kernel_op_267 - tmp_kernel_op_188*tmp_kernel_op_267 - tmp_kernel_op_200*tmp_kernel_op_267;
                const real_t tmp_kernel_op_270 = -tmp_kernel_op_145*tmp_kernel_op_269 - tmp_kernel_op_191*tmp_kernel_op_269 - tmp_kernel_op_203*tmp_kernel_op_269;
                const real_t tmp_kernel_op_272 = -tmp_kernel_op_182*tmp_kernel_op_271 - tmp_kernel_op_194*tmp_kernel_op_271 - tmp_kernel_op_206*tmp_kernel_op_271;
                const real_t tmp_kernel_op_273 = tmp_kernel_op_60*0.1381966011250105;
                const real_t tmp_kernel_op_274 = tmp_kernel_op_99*0.1381966011250105;
                const real_t tmp_kernel_op_275 = tmp_kernel_op_136*0.5854101966249684;
                const real_t tmp_kernel_op_276 = tmp_kernel_op_173*0.1381966011250105;
                const real_t tmp_kernel_op_277 = tmp_kernel_op_60*0.1381966011250105;
                const real_t tmp_kernel_op_278 = tmp_kernel_op_99*0.5854101966249684;
                const real_t tmp_kernel_op_279 = tmp_kernel_op_136*0.1381966011250105;
                const real_t tmp_kernel_op_280 = tmp_kernel_op_173*0.1381966011250105;
                const real_t tmp_kernel_op_281 = tmp_kernel_op_60*0.5854101966249684;
                const real_t tmp_kernel_op_282 = tmp_kernel_op_99*0.1381966011250105;
                const real_t tmp_kernel_op_283 = tmp_kernel_op_136*0.1381966011250105;
                const real_t tmp_kernel_op_284 = tmp_kernel_op_173*0.1381966011250105;
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_100*tmp_kernel_op_268 + tmp_kernel_op_137*tmp_kernel_op_270 + tmp_kernel_op_174*tmp_kernel_op_272 + tmp_kernel_op_266*tmp_kernel_op_61) + src_dof_1*(-tmp_kernel_op_100*tmp_kernel_op_110 - tmp_kernel_op_137*tmp_kernel_op_147 - tmp_kernel_op_174*tmp_kernel_op_184 - tmp_kernel_op_61*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_100*tmp_kernel_op_190 - tmp_kernel_op_137*tmp_kernel_op_193 - tmp_kernel_op_174*tmp_kernel_op_196 - tmp_kernel_op_187*tmp_kernel_op_61) + src_dof_3*(-tmp_kernel_op_100*tmp_kernel_op_202 - tmp_kernel_op_137*tmp_kernel_op_205 - tmp_kernel_op_174*tmp_kernel_op_208 - tmp_kernel_op_199*tmp_kernel_op_61) + src_dof_4*(tmp_kernel_op_100*tmp_kernel_op_214 + tmp_kernel_op_137*tmp_kernel_op_217 + tmp_kernel_op_174*tmp_kernel_op_220 + tmp_kernel_op_211*tmp_kernel_op_61) + src_dof_5*(tmp_kernel_op_100*tmp_kernel_op_226 + tmp_kernel_op_137*tmp_kernel_op_229 + tmp_kernel_op_174*tmp_kernel_op_232 + tmp_kernel_op_223*tmp_kernel_op_61) + src_dof_6*(tmp_kernel_op_100*tmp_kernel_op_238 + tmp_kernel_op_137*tmp_kernel_op_241 + tmp_kernel_op_174*tmp_kernel_op_244 + tmp_kernel_op_235*tmp_kernel_op_61) + src_dof_7*(tmp_kernel_op_100*tmp_kernel_op_248 + tmp_kernel_op_137*tmp_kernel_op_250 + tmp_kernel_op_174*tmp_kernel_op_252 + tmp_kernel_op_246*tmp_kernel_op_61) + src_dof_8*(tmp_kernel_op_100*tmp_kernel_op_256 + tmp_kernel_op_137*tmp_kernel_op_258 + tmp_kernel_op_174*tmp_kernel_op_260 + tmp_kernel_op_254*tmp_kernel_op_61) + src_dof_9*(tmp_kernel_op_100*tmp_kernel_op_262 + tmp_kernel_op_137*tmp_kernel_op_263 + tmp_kernel_op_174*tmp_kernel_op_264 + tmp_kernel_op_261*tmp_kernel_op_61);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_266*tmp_kernel_op_273 + tmp_kernel_op_268*tmp_kernel_op_274 + tmp_kernel_op_270*tmp_kernel_op_275 + tmp_kernel_op_272*tmp_kernel_op_276) + src_dof_1*(-tmp_kernel_op_110*tmp_kernel_op_274 - tmp_kernel_op_147*tmp_kernel_op_275 - tmp_kernel_op_184*tmp_kernel_op_276 - tmp_kernel_op_273*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_187*tmp_kernel_op_273 - tmp_kernel_op_190*tmp_kernel_op_274 - tmp_kernel_op_193*tmp_kernel_op_275 - tmp_kernel_op_196*tmp_kernel_op_276) + src_dof_3*(-tmp_kernel_op_199*tmp_kernel_op_273 - tmp_kernel_op_202*tmp_kernel_op_274 - tmp_kernel_op_205*tmp_kernel_op_275 - tmp_kernel_op_208*tmp_kernel_op_276) + src_dof_4*(tmp_kernel_op_211*tmp_kernel_op_273 + tmp_kernel_op_214*tmp_kernel_op_274 + tmp_kernel_op_217*tmp_kernel_op_275 + tmp_kernel_op_220*tmp_kernel_op_276) + src_dof_5*(tmp_kernel_op_223*tmp_kernel_op_273 + tmp_kernel_op_226*tmp_kernel_op_274 + tmp_kernel_op_229*tmp_kernel_op_275 + tmp_kernel_op_232*tmp_kernel_op_276) + src_dof_6*(tmp_kernel_op_235*tmp_kernel_op_273 + tmp_kernel_op_238*tmp_kernel_op_274 + tmp_kernel_op_241*tmp_kernel_op_275 + tmp_kernel_op_244*tmp_kernel_op_276) + src_dof_7*(tmp_kernel_op_246*tmp_kernel_op_273 + tmp_kernel_op_248*tmp_kernel_op_274 + tmp_kernel_op_250*tmp_kernel_op_275 + tmp_kernel_op_252*tmp_kernel_op_276) + src_dof_8*(tmp_kernel_op_254*tmp_kernel_op_273 + tmp_kernel_op_256*tmp_kernel_op_274 + tmp_kernel_op_258*tmp_kernel_op_275 + tmp_kernel_op_260*tmp_kernel_op_276) + src_dof_9*(tmp_kernel_op_261*tmp_kernel_op_273 + tmp_kernel_op_262*tmp_kernel_op_274 + tmp_kernel_op_263*tmp_kernel_op_275 + tmp_kernel_op_264*tmp_kernel_op_276);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_266*tmp_kernel_op_277 + tmp_kernel_op_268*tmp_kernel_op_278 + tmp_kernel_op_270*tmp_kernel_op_279 + tmp_kernel_op_272*tmp_kernel_op_280) + src_dof_1*(-tmp_kernel_op_110*tmp_kernel_op_278 - tmp_kernel_op_147*tmp_kernel_op_279 - tmp_kernel_op_184*tmp_kernel_op_280 - tmp_kernel_op_277*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_187*tmp_kernel_op_277 - tmp_kernel_op_190*tmp_kernel_op_278 - tmp_kernel_op_193*tmp_kernel_op_279 - tmp_kernel_op_196*tmp_kernel_op_280) + src_dof_3*(-tmp_kernel_op_199*tmp_kernel_op_277 - tmp_kernel_op_202*tmp_kernel_op_278 - tmp_kernel_op_205*tmp_kernel_op_279 - tmp_kernel_op_208*tmp_kernel_op_280) + src_dof_4*(tmp_kernel_op_211*tmp_kernel_op_277 + tmp_kernel_op_214*tmp_kernel_op_278 + tmp_kernel_op_217*tmp_kernel_op_279 + tmp_kernel_op_220*tmp_kernel_op_280) + src_dof_5*(tmp_kernel_op_223*tmp_kernel_op_277 + tmp_kernel_op_226*tmp_kernel_op_278 + tmp_kernel_op_229*tmp_kernel_op_279 + tmp_kernel_op_232*tmp_kernel_op_280) + src_dof_6*(tmp_kernel_op_235*tmp_kernel_op_277 + tmp_kernel_op_238*tmp_kernel_op_278 + tmp_kernel_op_241*tmp_kernel_op_279 + tmp_kernel_op_244*tmp_kernel_op_280) + src_dof_7*(tmp_kernel_op_246*tmp_kernel_op_277 + tmp_kernel_op_248*tmp_kernel_op_278 + tmp_kernel_op_250*tmp_kernel_op_279 + tmp_kernel_op_252*tmp_kernel_op_280) + src_dof_8*(tmp_kernel_op_254*tmp_kernel_op_277 + tmp_kernel_op_256*tmp_kernel_op_278 + tmp_kernel_op_258*tmp_kernel_op_279 + tmp_kernel_op_260*tmp_kernel_op_280) + src_dof_9*(tmp_kernel_op_261*tmp_kernel_op_277 + tmp_kernel_op_262*tmp_kernel_op_278 + tmp_kernel_op_263*tmp_kernel_op_279 + tmp_kernel_op_264*tmp_kernel_op_280);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_266*tmp_kernel_op_281 + tmp_kernel_op_268*tmp_kernel_op_282 + tmp_kernel_op_270*tmp_kernel_op_283 + tmp_kernel_op_272*tmp_kernel_op_284) + src_dof_1*(-tmp_kernel_op_110*tmp_kernel_op_282 - tmp_kernel_op_147*tmp_kernel_op_283 - tmp_kernel_op_184*tmp_kernel_op_284 - tmp_kernel_op_281*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_187*tmp_kernel_op_281 - tmp_kernel_op_190*tmp_kernel_op_282 - tmp_kernel_op_193*tmp_kernel_op_283 - tmp_kernel_op_196*tmp_kernel_op_284) + src_dof_3*(-tmp_kernel_op_199*tmp_kernel_op_281 - tmp_kernel_op_202*tmp_kernel_op_282 - tmp_kernel_op_205*tmp_kernel_op_283 - tmp_kernel_op_208*tmp_kernel_op_284) + src_dof_4*(tmp_kernel_op_211*tmp_kernel_op_281 + tmp_kernel_op_214*tmp_kernel_op_282 + tmp_kernel_op_217*tmp_kernel_op_283 + tmp_kernel_op_220*tmp_kernel_op_284) + src_dof_5*(tmp_kernel_op_223*tmp_kernel_op_281 + tmp_kernel_op_226*tmp_kernel_op_282 + tmp_kernel_op_229*tmp_kernel_op_283 + tmp_kernel_op_232*tmp_kernel_op_284) + src_dof_6*(tmp_kernel_op_235*tmp_kernel_op_281 + tmp_kernel_op_238*tmp_kernel_op_282 + tmp_kernel_op_241*tmp_kernel_op_283 + tmp_kernel_op_244*tmp_kernel_op_284) + src_dof_7*(tmp_kernel_op_246*tmp_kernel_op_281 + tmp_kernel_op_248*tmp_kernel_op_282 + tmp_kernel_op_250*tmp_kernel_op_283 + tmp_kernel_op_252*tmp_kernel_op_284) + src_dof_8*(tmp_kernel_op_254*tmp_kernel_op_281 + tmp_kernel_op_256*tmp_kernel_op_282 + tmp_kernel_op_258*tmp_kernel_op_283 + tmp_kernel_op_260*tmp_kernel_op_284) + src_dof_9*(tmp_kernel_op_261*tmp_kernel_op_281 + tmp_kernel_op_262*tmp_kernel_op_282 + tmp_kernel_op_263*tmp_kernel_op_283 + tmp_kernel_op_264*tmp_kernel_op_284);
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       {
          /* CellType.BLUE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_0 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0);
                const __m256d tmp_kernel_op_1 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0);
                const __m256d tmp_kernel_op_2 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0);
                const __m256d tmp_kernel_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_kernel_op_4 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1);
                const __m256d tmp_kernel_op_5 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1);
                const __m256d tmp_kernel_op_6 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1);
                const __m256d tmp_kernel_op_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_kernel_op_8 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2);
                const __m256d tmp_kernel_op_9 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2);
                const __m256d tmp_kernel_op_10 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2);
                const __m256d tmp_kernel_op_11 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_kernel_op_12 = _mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_3);
                const __m256d tmp_kernel_op_13 = _mm256_mul_pd(tmp_kernel_op_7,tmp_kernel_op_7);
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_11);
                const __m256d tmp_kernel_op_15 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_12,tmp_kernel_op_13),tmp_kernel_op_14);
                const __m256d tmp_kernel_op_16 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_15),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_15,tmp_kernel_op_15),tmp_kernel_op_15),tmp_kernel_op_15),tmp_kernel_op_15));
                const __m256d tmp_kernel_op_38 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_11,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_39 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_40 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_41 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_39,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_39,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_42 = _mm256_mul_pd(tmp_kernel_op_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_45 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_48 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_7),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_7,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_41)),_mm256_mul_pd(tmp_kernel_op_13,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_51 = _mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_53 = _mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_54 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_43),tmp_kernel_op_53);
                const __m256d tmp_kernel_op_55 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_11,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_41)),_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_56 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_51),tmp_kernel_op_7);
                const __m256d tmp_kernel_op_57 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_41)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_41),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_58 = _mm256_mul_pd(tmp_kernel_op_57,tmp_kernel_op_7);
                const __m256d tmp_kernel_op_59 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_54),tmp_kernel_op_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_51),tmp_kernel_op_54),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_53,tmp_kernel_op_55),tmp_kernel_op_56),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_16,tmp_kernel_op_50),tmp_kernel_op_55),tmp_kernel_op_57),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_16),tmp_kernel_op_3),tmp_kernel_op_43),tmp_kernel_op_45),tmp_kernel_op_48),tmp_kernel_op_7),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_60 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_59))));
                const __m256d tmp_kernel_op_61 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.13819660112501053,0.13819660112501053,0.13819660112501053,0.13819660112501053));
                const __m256d tmp_kernel_op_62 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_59);
                const __m256d tmp_kernel_op_63 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_15),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_15)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_15));
                const __m256d tmp_kernel_op_66 = _mm256_mul_pd(tmp_kernel_op_63,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_67 = _mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_66);
                const __m256d tmp_kernel_op_68 = _mm256_mul_pd(tmp_kernel_op_62,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_58,tmp_kernel_op_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_43),tmp_kernel_op_45),tmp_kernel_op_63),tmp_kernel_op_7),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_69 = _mm256_mul_pd(tmp_kernel_op_62,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_50),tmp_kernel_op_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_43),tmp_kernel_op_48),tmp_kernel_op_63),tmp_kernel_op_7),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_70 = _mm256_mul_pd(tmp_kernel_op_62,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_56,tmp_kernel_op_66),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_57),tmp_kernel_op_66)));
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)));
                const __m256d tmp_kernel_op_73 = _mm256_mul_pd(tmp_kernel_op_71,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72)));
                const __m256d tmp_kernel_op_74 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_kernel_op_75 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_kernel_op_76 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_kernel_op_77 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_74);
                const __m256d tmp_kernel_op_78 = _mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_75);
                const __m256d tmp_kernel_op_79 = _mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_76);
                const __m256d tmp_kernel_op_80 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_77,tmp_kernel_op_78),tmp_kernel_op_79);
                const __m256d tmp_kernel_op_81 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_80),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_80,tmp_kernel_op_80),tmp_kernel_op_80),tmp_kernel_op_80),tmp_kernel_op_80));
                const __m256d tmp_kernel_op_82 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_76,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_83 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_74,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_75,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_85 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_82,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_82,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_86 = _mm256_mul_pd(tmp_kernel_op_85,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_87 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_88 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_89 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_90 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_75,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_91 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_88);
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_81,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_93 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_87),tmp_kernel_op_92);
                const __m256d tmp_kernel_op_94 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_76,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_79,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_95 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_89),tmp_kernel_op_91);
                const __m256d tmp_kernel_op_96 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_74,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_85)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_77,tmp_kernel_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_97 = _mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_98 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_89,tmp_kernel_op_93),tmp_kernel_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_90,tmp_kernel_op_91),tmp_kernel_op_93),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_94),tmp_kernel_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_81,tmp_kernel_op_90),tmp_kernel_op_94),tmp_kernel_op_96),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_75),tmp_kernel_op_76),tmp_kernel_op_81),tmp_kernel_op_87),tmp_kernel_op_88),tmp_kernel_op_89),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_99 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_98))));
                const __m256d tmp_kernel_op_100 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_101 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_98);
                const __m256d tmp_kernel_op_102 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_80),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_80)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_80));
                const __m256d tmp_kernel_op_103 = _mm256_mul_pd(tmp_kernel_op_102,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_104 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_105 = _mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_74),tmp_kernel_op_75),tmp_kernel_op_87),tmp_kernel_op_88),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_106 = _mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_74),tmp_kernel_op_90),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_74),tmp_kernel_op_75),tmp_kernel_op_87),tmp_kernel_op_89),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_107 = _mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_90),tmp_kernel_op_96)));
                const __m256d tmp_kernel_op_108 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_mul_pd(tmp_kernel_op_105,_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)));
                const __m256d tmp_kernel_op_110 = _mm256_mul_pd(tmp_kernel_op_108,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)));
                const __m256d tmp_kernel_op_111 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_kernel_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_kernel_op_113 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_kernel_op_114 = _mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_111);
                const __m256d tmp_kernel_op_115 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_112);
                const __m256d tmp_kernel_op_116 = _mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_113);
                const __m256d tmp_kernel_op_117 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_114,tmp_kernel_op_115),tmp_kernel_op_116);
                const __m256d tmp_kernel_op_118 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_117),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_117,tmp_kernel_op_117),tmp_kernel_op_117),tmp_kernel_op_117),tmp_kernel_op_117));
                const __m256d tmp_kernel_op_119 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_120 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_111,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_121 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_112,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_122 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_119,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_121,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_121,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_119,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_123 = _mm256_mul_pd(tmp_kernel_op_122,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_124 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_125 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_126 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_122),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_127 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_112,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_122)),_mm256_mul_pd(tmp_kernel_op_115,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_128 = _mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_125);
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(tmp_kernel_op_118,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_130 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_124),tmp_kernel_op_129);
                const __m256d tmp_kernel_op_131 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_122)),_mm256_mul_pd(tmp_kernel_op_116,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_132 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_126),tmp_kernel_op_128);
                const __m256d tmp_kernel_op_133 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_111,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_122)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_114,tmp_kernel_op_122),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_134 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_133);
                const __m256d tmp_kernel_op_135 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_130),tmp_kernel_op_134),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_128),tmp_kernel_op_130),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_129,tmp_kernel_op_131),tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_127),tmp_kernel_op_131),tmp_kernel_op_133),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_112),tmp_kernel_op_113),tmp_kernel_op_118),tmp_kernel_op_124),tmp_kernel_op_125),tmp_kernel_op_126),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_135))));
                const __m256d tmp_kernel_op_137 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_138 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_135);
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_117),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_117)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_117));
                const __m256d tmp_kernel_op_140 = _mm256_mul_pd(tmp_kernel_op_139,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_141 = _mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_140);
                const __m256d tmp_kernel_op_142 = _mm256_mul_pd(tmp_kernel_op_138,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_141),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_112),tmp_kernel_op_124),tmp_kernel_op_125),tmp_kernel_op_139),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_143 = _mm256_mul_pd(tmp_kernel_op_138,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_127),tmp_kernel_op_141),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_112),tmp_kernel_op_124),tmp_kernel_op_126),tmp_kernel_op_139),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_144 = _mm256_mul_pd(tmp_kernel_op_138,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_140),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_133),tmp_kernel_op_140)));
                const __m256d tmp_kernel_op_145 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN))),_mm256_mul_pd(tmp_kernel_op_144,_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)));
                const __m256d tmp_kernel_op_147 = _mm256_mul_pd(tmp_kernel_op_145,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146)));
                const __m256d tmp_kernel_op_148 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_0);
                const __m256d tmp_kernel_op_149 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_1);
                const __m256d tmp_kernel_op_150 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_2);
                const __m256d tmp_kernel_op_151 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_148);
                const __m256d tmp_kernel_op_152 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_149);
                const __m256d tmp_kernel_op_153 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_150);
                const __m256d tmp_kernel_op_154 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_151,tmp_kernel_op_152),tmp_kernel_op_153);
                const __m256d tmp_kernel_op_155 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_154),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_154),tmp_kernel_op_154),tmp_kernel_op_154),tmp_kernel_op_154));
                const __m256d tmp_kernel_op_156 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_150,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_157 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_158 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_149,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_159 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_156,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_156,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_160 = _mm256_mul_pd(tmp_kernel_op_159,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_161 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_162 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_163 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_164 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_149,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_159)),_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_165 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_162);
                const __m256d tmp_kernel_op_166 = _mm256_mul_pd(tmp_kernel_op_155,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_167 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_161),tmp_kernel_op_166);
                const __m256d tmp_kernel_op_168 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_150,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_159)),_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_169 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_163),tmp_kernel_op_165);
                const __m256d tmp_kernel_op_170 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_159)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_171 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_170);
                const __m256d tmp_kernel_op_172 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_167),tmp_kernel_op_171),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_164,tmp_kernel_op_165),tmp_kernel_op_167),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_166,tmp_kernel_op_168),tmp_kernel_op_169),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_164),tmp_kernel_op_168),tmp_kernel_op_170),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_149),tmp_kernel_op_150),tmp_kernel_op_155),tmp_kernel_op_161),tmp_kernel_op_162),tmp_kernel_op_163),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_173 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_172))));
                const __m256d tmp_kernel_op_174 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_175 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_172);
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_154),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_154)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_154));
                const __m256d tmp_kernel_op_177 = _mm256_mul_pd(tmp_kernel_op_176,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_178 = _mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_177);
                const __m256d tmp_kernel_op_179 = _mm256_mul_pd(tmp_kernel_op_175,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_178),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_149),tmp_kernel_op_161),tmp_kernel_op_162),tmp_kernel_op_176),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_180 = _mm256_mul_pd(tmp_kernel_op_175,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_164),tmp_kernel_op_178),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_149),tmp_kernel_op_161),tmp_kernel_op_163),tmp_kernel_op_176),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_181 = _mm256_mul_pd(tmp_kernel_op_175,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_177),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_164,tmp_kernel_op_170),tmp_kernel_op_177)));
                const __m256d tmp_kernel_op_182 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN)),_mm256_mul_pd(tmp_kernel_op_179,_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN))),_mm256_mul_pd(tmp_kernel_op_181,_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN)));
                const __m256d tmp_kernel_op_184 = _mm256_mul_pd(tmp_kernel_op_182,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183)));
                const __m256d tmp_kernel_op_185 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)));
                const __m256d tmp_kernel_op_187 = _mm256_mul_pd(tmp_kernel_op_185,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186)));
                const __m256d tmp_kernel_op_188 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_mul_pd(tmp_kernel_op_105,_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)));
                const __m256d tmp_kernel_op_190 = _mm256_mul_pd(tmp_kernel_op_188,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189)));
                const __m256d tmp_kernel_op_191 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN))),_mm256_mul_pd(tmp_kernel_op_144,_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)));
                const __m256d tmp_kernel_op_193 = _mm256_mul_pd(tmp_kernel_op_191,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192)));
                const __m256d tmp_kernel_op_194 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_mul_pd(tmp_kernel_op_179,_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN))),_mm256_mul_pd(tmp_kernel_op_181,_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)));
                const __m256d tmp_kernel_op_196 = _mm256_mul_pd(tmp_kernel_op_194,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195)));
                const __m256d tmp_kernel_op_197 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)));
                const __m256d tmp_kernel_op_199 = _mm256_mul_pd(tmp_kernel_op_197,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198)));
                const __m256d tmp_kernel_op_200 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_mul_pd(tmp_kernel_op_105,_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)));
                const __m256d tmp_kernel_op_202 = _mm256_mul_pd(tmp_kernel_op_200,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201)));
                const __m256d tmp_kernel_op_203 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_mul_pd(tmp_kernel_op_144,_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)));
                const __m256d tmp_kernel_op_205 = _mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204)));
                const __m256d tmp_kernel_op_206 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_mul_pd(tmp_kernel_op_179,_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_mul_pd(tmp_kernel_op_181,_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)));
                const __m256d tmp_kernel_op_208 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207)));
                const __m256d tmp_kernel_op_209 = _mm256_mul_pd(tmp_kernel_op_197,_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186));
                const __m256d tmp_kernel_op_210 = _mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198));
                const __m256d tmp_kernel_op_211 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_209,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_212 = _mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189));
                const __m256d tmp_kernel_op_213 = _mm256_mul_pd(tmp_kernel_op_188,_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201));
                const __m256d tmp_kernel_op_214 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_212,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_213,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_215 = _mm256_mul_pd(tmp_kernel_op_203,_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192));
                const __m256d tmp_kernel_op_216 = _mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204));
                const __m256d tmp_kernel_op_217 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_215,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_216,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_218 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195));
                const __m256d tmp_kernel_op_219 = _mm256_mul_pd(tmp_kernel_op_194,_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207));
                const __m256d tmp_kernel_op_220 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_218,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_219,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_221 = _mm256_mul_pd(tmp_kernel_op_197,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72));
                const __m256d tmp_kernel_op_222 = _mm256_mul_pd(tmp_kernel_op_71,_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198));
                const __m256d tmp_kernel_op_223 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_222,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_224 = _mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_225 = _mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201));
                const __m256d tmp_kernel_op_226 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_224,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_225,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_227 = _mm256_mul_pd(tmp_kernel_op_203,_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146));
                const __m256d tmp_kernel_op_228 = _mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204));
                const __m256d tmp_kernel_op_229 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_227,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_228,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_230 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183));
                const __m256d tmp_kernel_op_231 = _mm256_mul_pd(tmp_kernel_op_182,_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207));
                const __m256d tmp_kernel_op_232 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_230,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_231,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_233 = _mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72));
                const __m256d tmp_kernel_op_234 = _mm256_mul_pd(tmp_kernel_op_71,_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186));
                const __m256d tmp_kernel_op_235 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_233,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_234,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_236 = _mm256_mul_pd(tmp_kernel_op_188,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_237 = _mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189));
                const __m256d tmp_kernel_op_238 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_236,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_237,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_239 = _mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146));
                const __m256d tmp_kernel_op_240 = _mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192));
                const __m256d tmp_kernel_op_241 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_239,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_240,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_242 = _mm256_mul_pd(tmp_kernel_op_194,_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183));
                const __m256d tmp_kernel_op_243 = _mm256_mul_pd(tmp_kernel_op_182,_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195));
                const __m256d tmp_kernel_op_244 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_243,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_246 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245)),_mm256_set_pd(-0.68328157299974723,-0.68328157299974723,-0.68328157299974723,-0.68328157299974723))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_210),tmp_kernel_op_222);
                const __m256d tmp_kernel_op_248 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_200,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247)),_mm256_set_pd(2.8944271909999157,2.8944271909999157,2.8944271909999157,2.8944271909999157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_213),tmp_kernel_op_225);
                const __m256d tmp_kernel_op_250 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249)),_mm256_set_pd(2.8944271909999157,2.8944271909999157,2.8944271909999157,2.8944271909999157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_216),tmp_kernel_op_228);
                const __m256d tmp_kernel_op_252 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_206,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251)),_mm256_set_pd(2.8944271909999157,2.8944271909999157,2.8944271909999157,2.8944271909999157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_219),tmp_kernel_op_231);
                const __m256d tmp_kernel_op_254 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_209),tmp_kernel_op_234);
                const __m256d tmp_kernel_op_256 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_188,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))),_mm256_set_pd(-4.6832815729997472,-4.6832815729997472,-4.6832815729997472,-4.6832815729997472))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_212),tmp_kernel_op_237);
                const __m256d tmp_kernel_op_258 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_191,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_215),tmp_kernel_op_240);
                const __m256d tmp_kernel_op_260 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_218),tmp_kernel_op_243);
                const __m256d tmp_kernel_op_261 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_221),tmp_kernel_op_233);
                const __m256d tmp_kernel_op_262 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_108,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_224),tmp_kernel_op_236);
                const __m256d tmp_kernel_op_263 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_145,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257))),_mm256_set_pd(-4.6832815729997472,-4.6832815729997472,-4.6832815729997472,-4.6832815729997472))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_227),tmp_kernel_op_239);
                const __m256d tmp_kernel_op_264 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_182,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_230),tmp_kernel_op_242);
                const __m256d tmp_kernel_op_266 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265)));
                const __m256d tmp_kernel_op_268 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_188,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267)));
                const __m256d tmp_kernel_op_270 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_203,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269)));
                const __m256d tmp_kernel_op_272 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_182,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271)));
                const __m256d tmp_kernel_op_273 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_274 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_275 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_276 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_277 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_278 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_279 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_280 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_281 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_282 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_283 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_284 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_214),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_217)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_220)),_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_61))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_226),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_229)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_232)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_238),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_241)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_244)),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_248),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_250)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_252)),_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_256),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_258)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_260)),_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_262),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_263)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_264)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_268),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_270)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_272)),_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_110),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_184),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_190),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_193),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_196),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_202),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_205),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_208),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_276))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_232,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_241,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_258,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_262,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_268,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_270,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_272,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_110,tmp_kernel_op_274),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_275),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_276),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_273,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_273),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_190,tmp_kernel_op_274),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_275),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_276),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_273),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_274),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_275),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_276),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_280))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_232,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_241,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_258,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_262,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_268,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_270,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_272,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_110,tmp_kernel_op_278),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_279),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_280),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_277),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_190,tmp_kernel_op_278),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_279),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_280),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_277),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_278),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_279),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_280),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_284))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_232,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_241,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_258,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_262,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_268,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_270,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_272,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_110,tmp_kernel_op_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_283),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_284),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_281,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_281),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_190,tmp_kernel_op_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_283),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_284),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_281),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_283),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_284),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_0 = -p_affine_0_0 + p_affine_1_0;
                const real_t tmp_kernel_op_1 = -p_affine_0_0 + p_affine_2_0;
                const real_t tmp_kernel_op_2 = -p_affine_0_0 + p_affine_3_0;
                const real_t tmp_kernel_op_3 = p_affine_0_0 + tmp_kernel_op_0*0.1381966011250105 + tmp_kernel_op_1*0.1381966011250105 + tmp_kernel_op_2*0.5854101966249684;
                const real_t tmp_kernel_op_4 = -p_affine_0_1 + p_affine_1_1;
                const real_t tmp_kernel_op_5 = -p_affine_0_1 + p_affine_2_1;
                const real_t tmp_kernel_op_6 = -p_affine_0_1 + p_affine_3_1;
                const real_t tmp_kernel_op_7 = p_affine_0_1 + tmp_kernel_op_4*0.1381966011250105 + tmp_kernel_op_5*0.1381966011250105 + tmp_kernel_op_6*0.5854101966249684;
                const real_t tmp_kernel_op_8 = -p_affine_0_2 + p_affine_1_2;
                const real_t tmp_kernel_op_9 = -p_affine_0_2 + p_affine_2_2;
                const real_t tmp_kernel_op_10 = -p_affine_0_2 + p_affine_3_2;
                const real_t tmp_kernel_op_11 = p_affine_0_2 + tmp_kernel_op_10*0.5854101966249684 + tmp_kernel_op_8*0.1381966011250105 + tmp_kernel_op_9*0.1381966011250105;
                const real_t tmp_kernel_op_12 = (tmp_kernel_op_3*tmp_kernel_op_3);
                const real_t tmp_kernel_op_13 = (tmp_kernel_op_7*tmp_kernel_op_7);
                const real_t tmp_kernel_op_14 = (tmp_kernel_op_11*tmp_kernel_op_11);
                const real_t tmp_kernel_op_15 = tmp_kernel_op_12 + tmp_kernel_op_13 + tmp_kernel_op_14;
                const real_t tmp_kernel_op_16 = pow(tmp_kernel_op_15, -4.5000000000000000);
                const real_t tmp_kernel_op_38 = -tmp_kernel_op_11 - tmp_kernel_op_29;
                const real_t tmp_kernel_op_39 = -tmp_kernel_op_18 - tmp_kernel_op_3;
                const real_t tmp_kernel_op_40 = -tmp_kernel_op_25 - tmp_kernel_op_7;
                const real_t tmp_kernel_op_41 = -tmp_kernel_op_35*(tmp_kernel_op_19*tmp_kernel_op_20*tmp_kernel_op_40 + tmp_kernel_op_23*tmp_kernel_op_30*tmp_kernel_op_39 - tmp_kernel_op_24*tmp_kernel_op_38 + tmp_kernel_op_26*tmp_kernel_op_27*tmp_kernel_op_38 - tmp_kernel_op_31*tmp_kernel_op_39 - tmp_kernel_op_32*tmp_kernel_op_40) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_42 = -tmp_kernel_op_41;
                const real_t tmp_kernel_op_43 = tmp_kernel_op_11*tmp_kernel_op_42 + tmp_kernel_op_15*tmp_kernel_op_36;
                const real_t tmp_kernel_op_45 = tmp_kernel_op_15*tmp_kernel_op_44 + tmp_kernel_op_3*tmp_kernel_op_42;
                const real_t tmp_kernel_op_48 = -tmp_kernel_op_15*tmp_kernel_op_47 - tmp_kernel_op_41*tmp_kernel_op_7;
                const real_t tmp_kernel_op_50 = tmp_kernel_op_13*tmp_kernel_op_42 + tmp_kernel_op_15*(tmp_kernel_op_41 + tmp_kernel_op_49*tmp_kernel_op_7);
                const real_t tmp_kernel_op_51 = tmp_kernel_op_3*tmp_kernel_op_45;
                const real_t tmp_kernel_op_53 = tmp_kernel_op_16*tmp_kernel_op_52;
                const real_t tmp_kernel_op_54 = tmp_kernel_op_11*tmp_kernel_op_43*tmp_kernel_op_53;
                const real_t tmp_kernel_op_55 = tmp_kernel_op_14*tmp_kernel_op_42 + tmp_kernel_op_15*(tmp_kernel_op_11*tmp_kernel_op_36 + tmp_kernel_op_41);
                const real_t tmp_kernel_op_56 = tmp_kernel_op_48*tmp_kernel_op_51*tmp_kernel_op_7;
                const real_t tmp_kernel_op_57 = -tmp_kernel_op_12*tmp_kernel_op_41 + tmp_kernel_op_15*(tmp_kernel_op_3*tmp_kernel_op_44 + tmp_kernel_op_41);
                const real_t tmp_kernel_op_58 = tmp_kernel_op_57*tmp_kernel_op_7;
                const real_t tmp_kernel_op_59 = tmp_kernel_op_11*tmp_kernel_op_16*tmp_kernel_op_3*tmp_kernel_op_34*tmp_kernel_op_43*tmp_kernel_op_45*tmp_kernel_op_48*tmp_kernel_op_7*2.0 + tmp_kernel_op_16*tmp_kernel_op_34*tmp_kernel_op_50*tmp_kernel_op_55*tmp_kernel_op_57*1.0 - tmp_kernel_op_48*tmp_kernel_op_54*tmp_kernel_op_58 - tmp_kernel_op_50*tmp_kernel_op_51*tmp_kernel_op_54 - tmp_kernel_op_53*tmp_kernel_op_55*tmp_kernel_op_56;
                const real_t tmp_kernel_op_60 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657*abs(tmp_kernel_op_59);
                const real_t tmp_kernel_op_61 = tmp_kernel_op_60*0.13819660112501053;
                const real_t tmp_kernel_op_62 = 1.0 / (tmp_kernel_op_59);
                const real_t tmp_kernel_op_63 = 1.0 / (tmp_kernel_op_15*tmp_kernel_op_15*tmp_kernel_op_15);
                const real_t tmp_kernel_op_66 = tmp_kernel_op_63*tmp_kernel_op_65;
                const real_t tmp_kernel_op_67 = tmp_kernel_op_43*tmp_kernel_op_66;
                const real_t tmp_kernel_op_68 = tmp_kernel_op_62*(tmp_kernel_op_3*tmp_kernel_op_43*tmp_kernel_op_45*tmp_kernel_op_63*tmp_kernel_op_64*tmp_kernel_op_7*1.0 - tmp_kernel_op_58*tmp_kernel_op_67);
                const real_t tmp_kernel_op_69 = tmp_kernel_op_62*(tmp_kernel_op_3*tmp_kernel_op_43*tmp_kernel_op_48*tmp_kernel_op_63*tmp_kernel_op_64*tmp_kernel_op_7*1.0 - tmp_kernel_op_3*tmp_kernel_op_50*tmp_kernel_op_67);
                const real_t tmp_kernel_op_70 = tmp_kernel_op_62*(tmp_kernel_op_50*tmp_kernel_op_57*tmp_kernel_op_66 - tmp_kernel_op_56*tmp_kernel_op_66);
                const real_t tmp_kernel_op_71 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_69 + jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_68 + jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_70;
                const real_t tmp_kernel_op_73 = tmp_kernel_op_71*(tmp_kernel_op_72 - 1.0);
                const real_t tmp_kernel_op_74 = p_affine_0_0 + tmp_kernel_op_0*0.1381966011250105 + tmp_kernel_op_1*0.5854101966249684 + tmp_kernel_op_2*0.1381966011250105;
                const real_t tmp_kernel_op_75 = p_affine_0_1 + tmp_kernel_op_4*0.1381966011250105 + tmp_kernel_op_5*0.5854101966249684 + tmp_kernel_op_6*0.1381966011250105;
                const real_t tmp_kernel_op_76 = p_affine_0_2 + tmp_kernel_op_10*0.1381966011250105 + tmp_kernel_op_8*0.1381966011250105 + tmp_kernel_op_9*0.5854101966249684;
                const real_t tmp_kernel_op_77 = (tmp_kernel_op_74*tmp_kernel_op_74);
                const real_t tmp_kernel_op_78 = (tmp_kernel_op_75*tmp_kernel_op_75);
                const real_t tmp_kernel_op_79 = (tmp_kernel_op_76*tmp_kernel_op_76);
                const real_t tmp_kernel_op_80 = tmp_kernel_op_77 + tmp_kernel_op_78 + tmp_kernel_op_79;
                const real_t tmp_kernel_op_81 = pow(tmp_kernel_op_80, -4.5000000000000000);
                const real_t tmp_kernel_op_82 = -tmp_kernel_op_29 - tmp_kernel_op_76;
                const real_t tmp_kernel_op_83 = -tmp_kernel_op_18 - tmp_kernel_op_74;
                const real_t tmp_kernel_op_84 = -tmp_kernel_op_25 - tmp_kernel_op_75;
                const real_t tmp_kernel_op_85 = -tmp_kernel_op_35*(tmp_kernel_op_19*tmp_kernel_op_20*tmp_kernel_op_84 + tmp_kernel_op_23*tmp_kernel_op_30*tmp_kernel_op_83 - tmp_kernel_op_24*tmp_kernel_op_82 + tmp_kernel_op_26*tmp_kernel_op_27*tmp_kernel_op_82 - tmp_kernel_op_31*tmp_kernel_op_83 - tmp_kernel_op_32*tmp_kernel_op_84) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_86 = -tmp_kernel_op_85;
                const real_t tmp_kernel_op_87 = tmp_kernel_op_36*tmp_kernel_op_80 + tmp_kernel_op_76*tmp_kernel_op_86;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_44*tmp_kernel_op_80 + tmp_kernel_op_74*tmp_kernel_op_86;
                const real_t tmp_kernel_op_89 = -tmp_kernel_op_47*tmp_kernel_op_80 - tmp_kernel_op_75*tmp_kernel_op_85;
                const real_t tmp_kernel_op_90 = tmp_kernel_op_78*tmp_kernel_op_86 + tmp_kernel_op_80*(tmp_kernel_op_49*tmp_kernel_op_75 + tmp_kernel_op_85);
                const real_t tmp_kernel_op_91 = tmp_kernel_op_74*tmp_kernel_op_88;
                const real_t tmp_kernel_op_92 = tmp_kernel_op_52*tmp_kernel_op_81;
                const real_t tmp_kernel_op_93 = tmp_kernel_op_76*tmp_kernel_op_87*tmp_kernel_op_92;
                const real_t tmp_kernel_op_94 = tmp_kernel_op_79*tmp_kernel_op_86 + tmp_kernel_op_80*(tmp_kernel_op_36*tmp_kernel_op_76 + tmp_kernel_op_85);
                const real_t tmp_kernel_op_95 = tmp_kernel_op_75*tmp_kernel_op_89*tmp_kernel_op_91;
                const real_t tmp_kernel_op_96 = -tmp_kernel_op_77*tmp_kernel_op_85 + tmp_kernel_op_80*(tmp_kernel_op_44*tmp_kernel_op_74 + tmp_kernel_op_85);
                const real_t tmp_kernel_op_97 = tmp_kernel_op_75*tmp_kernel_op_96;
                const real_t tmp_kernel_op_98 = tmp_kernel_op_34*tmp_kernel_op_74*tmp_kernel_op_75*tmp_kernel_op_76*tmp_kernel_op_81*tmp_kernel_op_87*tmp_kernel_op_88*tmp_kernel_op_89*2.0 + tmp_kernel_op_34*tmp_kernel_op_81*tmp_kernel_op_90*tmp_kernel_op_94*tmp_kernel_op_96*1.0 - tmp_kernel_op_89*tmp_kernel_op_93*tmp_kernel_op_97 - tmp_kernel_op_90*tmp_kernel_op_91*tmp_kernel_op_93 - tmp_kernel_op_92*tmp_kernel_op_94*tmp_kernel_op_95;
                const real_t tmp_kernel_op_99 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657*abs(tmp_kernel_op_98);
                const real_t tmp_kernel_op_100 = tmp_kernel_op_99*0.13819660112501056;
                const real_t tmp_kernel_op_101 = 1.0 / (tmp_kernel_op_98);
                const real_t tmp_kernel_op_102 = 1.0 / (tmp_kernel_op_80*tmp_kernel_op_80*tmp_kernel_op_80);
                const real_t tmp_kernel_op_103 = tmp_kernel_op_102*tmp_kernel_op_65;
                const real_t tmp_kernel_op_104 = tmp_kernel_op_103*tmp_kernel_op_87;
                const real_t tmp_kernel_op_105 = tmp_kernel_op_101*(tmp_kernel_op_102*tmp_kernel_op_64*tmp_kernel_op_74*tmp_kernel_op_75*tmp_kernel_op_87*tmp_kernel_op_88*1.0 - tmp_kernel_op_104*tmp_kernel_op_97);
                const real_t tmp_kernel_op_106 = tmp_kernel_op_101*(tmp_kernel_op_102*tmp_kernel_op_64*tmp_kernel_op_74*tmp_kernel_op_75*tmp_kernel_op_87*tmp_kernel_op_89*1.0 - tmp_kernel_op_104*tmp_kernel_op_74*tmp_kernel_op_90);
                const real_t tmp_kernel_op_107 = tmp_kernel_op_101*(tmp_kernel_op_103*tmp_kernel_op_90*tmp_kernel_op_96 - tmp_kernel_op_103*tmp_kernel_op_95);
                const real_t tmp_kernel_op_108 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_106 + jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_105 + jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_107;
                const real_t tmp_kernel_op_110 = tmp_kernel_op_108*(tmp_kernel_op_109 - 1.0);
                const real_t tmp_kernel_op_111 = p_affine_0_0 + tmp_kernel_op_0*0.5854101966249684 + tmp_kernel_op_1*0.1381966011250105 + tmp_kernel_op_2*0.1381966011250105;
                const real_t tmp_kernel_op_112 = p_affine_0_1 + tmp_kernel_op_4*0.5854101966249684 + tmp_kernel_op_5*0.1381966011250105 + tmp_kernel_op_6*0.1381966011250105;
                const real_t tmp_kernel_op_113 = p_affine_0_2 + tmp_kernel_op_10*0.1381966011250105 + tmp_kernel_op_8*0.5854101966249684 + tmp_kernel_op_9*0.1381966011250105;
                const real_t tmp_kernel_op_114 = (tmp_kernel_op_111*tmp_kernel_op_111);
                const real_t tmp_kernel_op_115 = (tmp_kernel_op_112*tmp_kernel_op_112);
                const real_t tmp_kernel_op_116 = (tmp_kernel_op_113*tmp_kernel_op_113);
                const real_t tmp_kernel_op_117 = tmp_kernel_op_114 + tmp_kernel_op_115 + tmp_kernel_op_116;
                const real_t tmp_kernel_op_118 = pow(tmp_kernel_op_117, -4.5000000000000000);
                const real_t tmp_kernel_op_119 = -tmp_kernel_op_113 - tmp_kernel_op_29;
                const real_t tmp_kernel_op_120 = -tmp_kernel_op_111 - tmp_kernel_op_18;
                const real_t tmp_kernel_op_121 = -tmp_kernel_op_112 - tmp_kernel_op_25;
                const real_t tmp_kernel_op_122 = -tmp_kernel_op_35*(-tmp_kernel_op_119*tmp_kernel_op_24 + tmp_kernel_op_119*tmp_kernel_op_26*tmp_kernel_op_27 + tmp_kernel_op_120*tmp_kernel_op_23*tmp_kernel_op_30 - tmp_kernel_op_120*tmp_kernel_op_31 + tmp_kernel_op_121*tmp_kernel_op_19*tmp_kernel_op_20 - tmp_kernel_op_121*tmp_kernel_op_32) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_123 = -tmp_kernel_op_122;
                const real_t tmp_kernel_op_124 = tmp_kernel_op_113*tmp_kernel_op_123 + tmp_kernel_op_117*tmp_kernel_op_36;
                const real_t tmp_kernel_op_125 = tmp_kernel_op_111*tmp_kernel_op_123 + tmp_kernel_op_117*tmp_kernel_op_44;
                const real_t tmp_kernel_op_126 = -tmp_kernel_op_112*tmp_kernel_op_122 - tmp_kernel_op_117*tmp_kernel_op_47;
                const real_t tmp_kernel_op_127 = tmp_kernel_op_115*tmp_kernel_op_123 + tmp_kernel_op_117*(tmp_kernel_op_112*tmp_kernel_op_49 + tmp_kernel_op_122);
                const real_t tmp_kernel_op_128 = tmp_kernel_op_111*tmp_kernel_op_125;
                const real_t tmp_kernel_op_129 = tmp_kernel_op_118*tmp_kernel_op_52;
                const real_t tmp_kernel_op_130 = tmp_kernel_op_113*tmp_kernel_op_124*tmp_kernel_op_129;
                const real_t tmp_kernel_op_131 = tmp_kernel_op_116*tmp_kernel_op_123 + tmp_kernel_op_117*(tmp_kernel_op_113*tmp_kernel_op_36 + tmp_kernel_op_122);
                const real_t tmp_kernel_op_132 = tmp_kernel_op_112*tmp_kernel_op_126*tmp_kernel_op_128;
                const real_t tmp_kernel_op_133 = -tmp_kernel_op_114*tmp_kernel_op_122 + tmp_kernel_op_117*(tmp_kernel_op_111*tmp_kernel_op_44 + tmp_kernel_op_122);
                const real_t tmp_kernel_op_134 = tmp_kernel_op_112*tmp_kernel_op_133;
                const real_t tmp_kernel_op_135 = tmp_kernel_op_111*tmp_kernel_op_112*tmp_kernel_op_113*tmp_kernel_op_118*tmp_kernel_op_124*tmp_kernel_op_125*tmp_kernel_op_126*tmp_kernel_op_34*2.0 + tmp_kernel_op_118*tmp_kernel_op_127*tmp_kernel_op_131*tmp_kernel_op_133*tmp_kernel_op_34*1.0 - tmp_kernel_op_126*tmp_kernel_op_130*tmp_kernel_op_134 - tmp_kernel_op_127*tmp_kernel_op_128*tmp_kernel_op_130 - tmp_kernel_op_129*tmp_kernel_op_131*tmp_kernel_op_132;
                const real_t tmp_kernel_op_136 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657*abs(tmp_kernel_op_135);
                const real_t tmp_kernel_op_137 = tmp_kernel_op_136*0.13819660112501056;
                const real_t tmp_kernel_op_138 = 1.0 / (tmp_kernel_op_135);
                const real_t tmp_kernel_op_139 = 1.0 / (tmp_kernel_op_117*tmp_kernel_op_117*tmp_kernel_op_117);
                const real_t tmp_kernel_op_140 = tmp_kernel_op_139*tmp_kernel_op_65;
                const real_t tmp_kernel_op_141 = tmp_kernel_op_124*tmp_kernel_op_140;
                const real_t tmp_kernel_op_142 = tmp_kernel_op_138*(tmp_kernel_op_111*tmp_kernel_op_112*tmp_kernel_op_124*tmp_kernel_op_125*tmp_kernel_op_139*tmp_kernel_op_64*1.0 - tmp_kernel_op_134*tmp_kernel_op_141);
                const real_t tmp_kernel_op_143 = tmp_kernel_op_138*(tmp_kernel_op_111*tmp_kernel_op_112*tmp_kernel_op_124*tmp_kernel_op_126*tmp_kernel_op_139*tmp_kernel_op_64*1.0 - tmp_kernel_op_111*tmp_kernel_op_127*tmp_kernel_op_141);
                const real_t tmp_kernel_op_144 = tmp_kernel_op_138*(tmp_kernel_op_127*tmp_kernel_op_133*tmp_kernel_op_140 - tmp_kernel_op_132*tmp_kernel_op_140);
                const real_t tmp_kernel_op_145 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_143 + jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_142 + jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_144;
                const real_t tmp_kernel_op_147 = tmp_kernel_op_145*(tmp_kernel_op_146 - 1.0);
                const real_t tmp_kernel_op_148 = p_affine_0_0 + tmp_kernel_op_0*0.1381966011250105 + tmp_kernel_op_1*0.1381966011250105 + tmp_kernel_op_2*0.1381966011250105;
                const real_t tmp_kernel_op_149 = p_affine_0_1 + tmp_kernel_op_4*0.1381966011250105 + tmp_kernel_op_5*0.1381966011250105 + tmp_kernel_op_6*0.1381966011250105;
                const real_t tmp_kernel_op_150 = p_affine_0_2 + tmp_kernel_op_10*0.1381966011250105 + tmp_kernel_op_8*0.1381966011250105 + tmp_kernel_op_9*0.1381966011250105;
                const real_t tmp_kernel_op_151 = (tmp_kernel_op_148*tmp_kernel_op_148);
                const real_t tmp_kernel_op_152 = (tmp_kernel_op_149*tmp_kernel_op_149);
                const real_t tmp_kernel_op_153 = (tmp_kernel_op_150*tmp_kernel_op_150);
                const real_t tmp_kernel_op_154 = tmp_kernel_op_151 + tmp_kernel_op_152 + tmp_kernel_op_153;
                const real_t tmp_kernel_op_155 = pow(tmp_kernel_op_154, -4.5000000000000000);
                const real_t tmp_kernel_op_156 = -tmp_kernel_op_150 - tmp_kernel_op_29;
                const real_t tmp_kernel_op_157 = -tmp_kernel_op_148 - tmp_kernel_op_18;
                const real_t tmp_kernel_op_158 = -tmp_kernel_op_149 - tmp_kernel_op_25;
                const real_t tmp_kernel_op_159 = -tmp_kernel_op_35*(-tmp_kernel_op_156*tmp_kernel_op_24 + tmp_kernel_op_156*tmp_kernel_op_26*tmp_kernel_op_27 + tmp_kernel_op_157*tmp_kernel_op_23*tmp_kernel_op_30 - tmp_kernel_op_157*tmp_kernel_op_31 + tmp_kernel_op_158*tmp_kernel_op_19*tmp_kernel_op_20 - tmp_kernel_op_158*tmp_kernel_op_32) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_160 = -tmp_kernel_op_159;
                const real_t tmp_kernel_op_161 = tmp_kernel_op_150*tmp_kernel_op_160 + tmp_kernel_op_154*tmp_kernel_op_36;
                const real_t tmp_kernel_op_162 = tmp_kernel_op_148*tmp_kernel_op_160 + tmp_kernel_op_154*tmp_kernel_op_44;
                const real_t tmp_kernel_op_163 = -tmp_kernel_op_149*tmp_kernel_op_159 - tmp_kernel_op_154*tmp_kernel_op_47;
                const real_t tmp_kernel_op_164 = tmp_kernel_op_152*tmp_kernel_op_160 + tmp_kernel_op_154*(tmp_kernel_op_149*tmp_kernel_op_49 + tmp_kernel_op_159);
                const real_t tmp_kernel_op_165 = tmp_kernel_op_148*tmp_kernel_op_162;
                const real_t tmp_kernel_op_166 = tmp_kernel_op_155*tmp_kernel_op_52;
                const real_t tmp_kernel_op_167 = tmp_kernel_op_150*tmp_kernel_op_161*tmp_kernel_op_166;
                const real_t tmp_kernel_op_168 = tmp_kernel_op_153*tmp_kernel_op_160 + tmp_kernel_op_154*(tmp_kernel_op_150*tmp_kernel_op_36 + tmp_kernel_op_159);
                const real_t tmp_kernel_op_169 = tmp_kernel_op_149*tmp_kernel_op_163*tmp_kernel_op_165;
                const real_t tmp_kernel_op_170 = -tmp_kernel_op_151*tmp_kernel_op_159 + tmp_kernel_op_154*(tmp_kernel_op_148*tmp_kernel_op_44 + tmp_kernel_op_159);
                const real_t tmp_kernel_op_171 = tmp_kernel_op_149*tmp_kernel_op_170;
                const real_t tmp_kernel_op_172 = tmp_kernel_op_148*tmp_kernel_op_149*tmp_kernel_op_150*tmp_kernel_op_155*tmp_kernel_op_161*tmp_kernel_op_162*tmp_kernel_op_163*tmp_kernel_op_34*2.0 + tmp_kernel_op_155*tmp_kernel_op_164*tmp_kernel_op_168*tmp_kernel_op_170*tmp_kernel_op_34*1.0 - tmp_kernel_op_163*tmp_kernel_op_167*tmp_kernel_op_171 - tmp_kernel_op_164*tmp_kernel_op_165*tmp_kernel_op_167 - tmp_kernel_op_166*tmp_kernel_op_168*tmp_kernel_op_169;
                const real_t tmp_kernel_op_173 = abs_det_jac_affine_BLUE_DOWN*0.041666666666666657*abs(tmp_kernel_op_172);
                const real_t tmp_kernel_op_174 = tmp_kernel_op_173*0.5854101966249684;
                const real_t tmp_kernel_op_175 = 1.0 / (tmp_kernel_op_172);
                const real_t tmp_kernel_op_176 = 1.0 / (tmp_kernel_op_154*tmp_kernel_op_154*tmp_kernel_op_154);
                const real_t tmp_kernel_op_177 = tmp_kernel_op_176*tmp_kernel_op_65;
                const real_t tmp_kernel_op_178 = tmp_kernel_op_161*tmp_kernel_op_177;
                const real_t tmp_kernel_op_179 = tmp_kernel_op_175*(tmp_kernel_op_148*tmp_kernel_op_149*tmp_kernel_op_161*tmp_kernel_op_162*tmp_kernel_op_176*tmp_kernel_op_64*1.0 - tmp_kernel_op_171*tmp_kernel_op_178);
                const real_t tmp_kernel_op_180 = tmp_kernel_op_175*(tmp_kernel_op_148*tmp_kernel_op_149*tmp_kernel_op_161*tmp_kernel_op_163*tmp_kernel_op_176*tmp_kernel_op_64*1.0 - tmp_kernel_op_148*tmp_kernel_op_164*tmp_kernel_op_178);
                const real_t tmp_kernel_op_181 = tmp_kernel_op_175*(tmp_kernel_op_164*tmp_kernel_op_170*tmp_kernel_op_177 - tmp_kernel_op_169*tmp_kernel_op_177);
                const real_t tmp_kernel_op_182 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_180 + jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_179 + jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_181;
                const real_t tmp_kernel_op_184 = tmp_kernel_op_182*(tmp_kernel_op_183 - 1.0);
                const real_t tmp_kernel_op_185 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_69 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_68 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_70;
                const real_t tmp_kernel_op_187 = tmp_kernel_op_185*(tmp_kernel_op_186 - 1.0);
                const real_t tmp_kernel_op_188 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_106 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_105 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_107;
                const real_t tmp_kernel_op_190 = tmp_kernel_op_188*(tmp_kernel_op_189 - 1.0);
                const real_t tmp_kernel_op_191 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_143 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_142 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_144;
                const real_t tmp_kernel_op_193 = tmp_kernel_op_191*(tmp_kernel_op_192 - 1.0);
                const real_t tmp_kernel_op_194 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_180 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_179 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_181;
                const real_t tmp_kernel_op_196 = tmp_kernel_op_194*(tmp_kernel_op_195 - 1.0);
                const real_t tmp_kernel_op_197 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_69 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_68 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_70;
                const real_t tmp_kernel_op_199 = tmp_kernel_op_197*(tmp_kernel_op_198 - 1.0);
                const real_t tmp_kernel_op_200 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_106 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_105 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_107;
                const real_t tmp_kernel_op_202 = tmp_kernel_op_200*(tmp_kernel_op_201 - 1.0);
                const real_t tmp_kernel_op_203 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_143 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_142 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_144;
                const real_t tmp_kernel_op_205 = tmp_kernel_op_203*(tmp_kernel_op_204 - 1.0);
                const real_t tmp_kernel_op_206 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_180 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_179 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_181;
                const real_t tmp_kernel_op_208 = tmp_kernel_op_206*(tmp_kernel_op_207 - 1.0);
                const real_t tmp_kernel_op_209 = tmp_kernel_op_186*tmp_kernel_op_197;
                const real_t tmp_kernel_op_210 = tmp_kernel_op_185*tmp_kernel_op_198;
                const real_t tmp_kernel_op_211 = -tmp_kernel_op_209 - tmp_kernel_op_210;
                const real_t tmp_kernel_op_212 = tmp_kernel_op_189*tmp_kernel_op_200;
                const real_t tmp_kernel_op_213 = tmp_kernel_op_188*tmp_kernel_op_201;
                const real_t tmp_kernel_op_214 = -tmp_kernel_op_212 - tmp_kernel_op_213;
                const real_t tmp_kernel_op_215 = tmp_kernel_op_192*tmp_kernel_op_203;
                const real_t tmp_kernel_op_216 = tmp_kernel_op_191*tmp_kernel_op_204;
                const real_t tmp_kernel_op_217 = -tmp_kernel_op_215 - tmp_kernel_op_216;
                const real_t tmp_kernel_op_218 = tmp_kernel_op_195*tmp_kernel_op_206;
                const real_t tmp_kernel_op_219 = tmp_kernel_op_194*tmp_kernel_op_207;
                const real_t tmp_kernel_op_220 = -tmp_kernel_op_218 - tmp_kernel_op_219;
                const real_t tmp_kernel_op_221 = tmp_kernel_op_197*tmp_kernel_op_72;
                const real_t tmp_kernel_op_222 = tmp_kernel_op_198*tmp_kernel_op_71;
                const real_t tmp_kernel_op_223 = -tmp_kernel_op_221 - tmp_kernel_op_222;
                const real_t tmp_kernel_op_224 = tmp_kernel_op_109*tmp_kernel_op_200;
                const real_t tmp_kernel_op_225 = tmp_kernel_op_108*tmp_kernel_op_201;
                const real_t tmp_kernel_op_226 = -tmp_kernel_op_224 - tmp_kernel_op_225;
                const real_t tmp_kernel_op_227 = tmp_kernel_op_146*tmp_kernel_op_203;
                const real_t tmp_kernel_op_228 = tmp_kernel_op_145*tmp_kernel_op_204;
                const real_t tmp_kernel_op_229 = -tmp_kernel_op_227 - tmp_kernel_op_228;
                const real_t tmp_kernel_op_230 = tmp_kernel_op_183*tmp_kernel_op_206;
                const real_t tmp_kernel_op_231 = tmp_kernel_op_182*tmp_kernel_op_207;
                const real_t tmp_kernel_op_232 = -tmp_kernel_op_230 - tmp_kernel_op_231;
                const real_t tmp_kernel_op_233 = tmp_kernel_op_185*tmp_kernel_op_72;
                const real_t tmp_kernel_op_234 = tmp_kernel_op_186*tmp_kernel_op_71;
                const real_t tmp_kernel_op_235 = -tmp_kernel_op_233 - tmp_kernel_op_234;
                const real_t tmp_kernel_op_236 = tmp_kernel_op_109*tmp_kernel_op_188;
                const real_t tmp_kernel_op_237 = tmp_kernel_op_108*tmp_kernel_op_189;
                const real_t tmp_kernel_op_238 = -tmp_kernel_op_236 - tmp_kernel_op_237;
                const real_t tmp_kernel_op_239 = tmp_kernel_op_146*tmp_kernel_op_191;
                const real_t tmp_kernel_op_240 = tmp_kernel_op_145*tmp_kernel_op_192;
                const real_t tmp_kernel_op_241 = -tmp_kernel_op_239 - tmp_kernel_op_240;
                const real_t tmp_kernel_op_242 = tmp_kernel_op_183*tmp_kernel_op_194;
                const real_t tmp_kernel_op_243 = tmp_kernel_op_182*tmp_kernel_op_195;
                const real_t tmp_kernel_op_244 = -tmp_kernel_op_242 - tmp_kernel_op_243;
                const real_t tmp_kernel_op_246 = -tmp_kernel_op_197*(-tmp_kernel_op_245 - 0.68328157299974723) + tmp_kernel_op_210 + tmp_kernel_op_222;
                const real_t tmp_kernel_op_248 = -tmp_kernel_op_200*(-tmp_kernel_op_247 + 2.8944271909999157) + tmp_kernel_op_213 + tmp_kernel_op_225;
                const real_t tmp_kernel_op_250 = -tmp_kernel_op_203*(-tmp_kernel_op_249 + 2.8944271909999157) + tmp_kernel_op_216 + tmp_kernel_op_228;
                const real_t tmp_kernel_op_252 = -tmp_kernel_op_206*(-tmp_kernel_op_251 + 2.8944271909999157) + tmp_kernel_op_219 + tmp_kernel_op_231;
                const real_t tmp_kernel_op_254 = -tmp_kernel_op_185*(-tmp_kernel_op_253 - tmp_kernel_op_72 - 1.105572809000084) + tmp_kernel_op_209 + tmp_kernel_op_234;
                const real_t tmp_kernel_op_256 = -tmp_kernel_op_188*(-tmp_kernel_op_109 - tmp_kernel_op_255 - 4.6832815729997472) + tmp_kernel_op_212 + tmp_kernel_op_237;
                const real_t tmp_kernel_op_258 = -tmp_kernel_op_191*(-tmp_kernel_op_146 - tmp_kernel_op_257 - 1.105572809000084) + tmp_kernel_op_215 + tmp_kernel_op_240;
                const real_t tmp_kernel_op_260 = -tmp_kernel_op_194*(-tmp_kernel_op_183 - tmp_kernel_op_259 - 1.105572809000084) + tmp_kernel_op_218 + tmp_kernel_op_243;
                const real_t tmp_kernel_op_261 = tmp_kernel_op_221 + tmp_kernel_op_233 - tmp_kernel_op_71*(-tmp_kernel_op_186 - tmp_kernel_op_253 - 1.105572809000084);
                const real_t tmp_kernel_op_262 = -tmp_kernel_op_108*(-tmp_kernel_op_189 - tmp_kernel_op_255 - 1.105572809000084) + tmp_kernel_op_224 + tmp_kernel_op_236;
                const real_t tmp_kernel_op_263 = -tmp_kernel_op_145*(-tmp_kernel_op_192 - tmp_kernel_op_257 - 4.6832815729997472) + tmp_kernel_op_227 + tmp_kernel_op_239;
                const real_t tmp_kernel_op_264 = -tmp_kernel_op_182*(-tmp_kernel_op_195 - tmp_kernel_op_259 - 1.105572809000084) + tmp_kernel_op_230 + tmp_kernel_op_242;
                const real_t tmp_kernel_op_266 = -tmp_kernel_op_185*tmp_kernel_op_265 - tmp_kernel_op_197*tmp_kernel_op_265 - tmp_kernel_op_265*tmp_kernel_op_71;
                const real_t tmp_kernel_op_268 = -tmp_kernel_op_108*tmp_kernel_op_267 - tmp_kernel_op_188*tmp_kernel_op_267 - tmp_kernel_op_200*tmp_kernel_op_267;
                const real_t tmp_kernel_op_270 = -tmp_kernel_op_145*tmp_kernel_op_269 - tmp_kernel_op_191*tmp_kernel_op_269 - tmp_kernel_op_203*tmp_kernel_op_269;
                const real_t tmp_kernel_op_272 = -tmp_kernel_op_182*tmp_kernel_op_271 - tmp_kernel_op_194*tmp_kernel_op_271 - tmp_kernel_op_206*tmp_kernel_op_271;
                const real_t tmp_kernel_op_273 = tmp_kernel_op_60*0.1381966011250105;
                const real_t tmp_kernel_op_274 = tmp_kernel_op_99*0.1381966011250105;
                const real_t tmp_kernel_op_275 = tmp_kernel_op_136*0.5854101966249684;
                const real_t tmp_kernel_op_276 = tmp_kernel_op_173*0.1381966011250105;
                const real_t tmp_kernel_op_277 = tmp_kernel_op_60*0.1381966011250105;
                const real_t tmp_kernel_op_278 = tmp_kernel_op_99*0.5854101966249684;
                const real_t tmp_kernel_op_279 = tmp_kernel_op_136*0.1381966011250105;
                const real_t tmp_kernel_op_280 = tmp_kernel_op_173*0.1381966011250105;
                const real_t tmp_kernel_op_281 = tmp_kernel_op_60*0.5854101966249684;
                const real_t tmp_kernel_op_282 = tmp_kernel_op_99*0.1381966011250105;
                const real_t tmp_kernel_op_283 = tmp_kernel_op_136*0.1381966011250105;
                const real_t tmp_kernel_op_284 = tmp_kernel_op_173*0.1381966011250105;
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_100*tmp_kernel_op_268 + tmp_kernel_op_137*tmp_kernel_op_270 + tmp_kernel_op_174*tmp_kernel_op_272 + tmp_kernel_op_266*tmp_kernel_op_61) + src_dof_1*(-tmp_kernel_op_100*tmp_kernel_op_110 - tmp_kernel_op_137*tmp_kernel_op_147 - tmp_kernel_op_174*tmp_kernel_op_184 - tmp_kernel_op_61*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_100*tmp_kernel_op_190 - tmp_kernel_op_137*tmp_kernel_op_193 - tmp_kernel_op_174*tmp_kernel_op_196 - tmp_kernel_op_187*tmp_kernel_op_61) + src_dof_3*(-tmp_kernel_op_100*tmp_kernel_op_202 - tmp_kernel_op_137*tmp_kernel_op_205 - tmp_kernel_op_174*tmp_kernel_op_208 - tmp_kernel_op_199*tmp_kernel_op_61) + src_dof_4*(tmp_kernel_op_100*tmp_kernel_op_214 + tmp_kernel_op_137*tmp_kernel_op_217 + tmp_kernel_op_174*tmp_kernel_op_220 + tmp_kernel_op_211*tmp_kernel_op_61) + src_dof_5*(tmp_kernel_op_100*tmp_kernel_op_226 + tmp_kernel_op_137*tmp_kernel_op_229 + tmp_kernel_op_174*tmp_kernel_op_232 + tmp_kernel_op_223*tmp_kernel_op_61) + src_dof_6*(tmp_kernel_op_100*tmp_kernel_op_238 + tmp_kernel_op_137*tmp_kernel_op_241 + tmp_kernel_op_174*tmp_kernel_op_244 + tmp_kernel_op_235*tmp_kernel_op_61) + src_dof_7*(tmp_kernel_op_100*tmp_kernel_op_248 + tmp_kernel_op_137*tmp_kernel_op_250 + tmp_kernel_op_174*tmp_kernel_op_252 + tmp_kernel_op_246*tmp_kernel_op_61) + src_dof_8*(tmp_kernel_op_100*tmp_kernel_op_256 + tmp_kernel_op_137*tmp_kernel_op_258 + tmp_kernel_op_174*tmp_kernel_op_260 + tmp_kernel_op_254*tmp_kernel_op_61) + src_dof_9*(tmp_kernel_op_100*tmp_kernel_op_262 + tmp_kernel_op_137*tmp_kernel_op_263 + tmp_kernel_op_174*tmp_kernel_op_264 + tmp_kernel_op_261*tmp_kernel_op_61);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_266*tmp_kernel_op_273 + tmp_kernel_op_268*tmp_kernel_op_274 + tmp_kernel_op_270*tmp_kernel_op_275 + tmp_kernel_op_272*tmp_kernel_op_276) + src_dof_1*(-tmp_kernel_op_110*tmp_kernel_op_274 - tmp_kernel_op_147*tmp_kernel_op_275 - tmp_kernel_op_184*tmp_kernel_op_276 - tmp_kernel_op_273*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_187*tmp_kernel_op_273 - tmp_kernel_op_190*tmp_kernel_op_274 - tmp_kernel_op_193*tmp_kernel_op_275 - tmp_kernel_op_196*tmp_kernel_op_276) + src_dof_3*(-tmp_kernel_op_199*tmp_kernel_op_273 - tmp_kernel_op_202*tmp_kernel_op_274 - tmp_kernel_op_205*tmp_kernel_op_275 - tmp_kernel_op_208*tmp_kernel_op_276) + src_dof_4*(tmp_kernel_op_211*tmp_kernel_op_273 + tmp_kernel_op_214*tmp_kernel_op_274 + tmp_kernel_op_217*tmp_kernel_op_275 + tmp_kernel_op_220*tmp_kernel_op_276) + src_dof_5*(tmp_kernel_op_223*tmp_kernel_op_273 + tmp_kernel_op_226*tmp_kernel_op_274 + tmp_kernel_op_229*tmp_kernel_op_275 + tmp_kernel_op_232*tmp_kernel_op_276) + src_dof_6*(tmp_kernel_op_235*tmp_kernel_op_273 + tmp_kernel_op_238*tmp_kernel_op_274 + tmp_kernel_op_241*tmp_kernel_op_275 + tmp_kernel_op_244*tmp_kernel_op_276) + src_dof_7*(tmp_kernel_op_246*tmp_kernel_op_273 + tmp_kernel_op_248*tmp_kernel_op_274 + tmp_kernel_op_250*tmp_kernel_op_275 + tmp_kernel_op_252*tmp_kernel_op_276) + src_dof_8*(tmp_kernel_op_254*tmp_kernel_op_273 + tmp_kernel_op_256*tmp_kernel_op_274 + tmp_kernel_op_258*tmp_kernel_op_275 + tmp_kernel_op_260*tmp_kernel_op_276) + src_dof_9*(tmp_kernel_op_261*tmp_kernel_op_273 + tmp_kernel_op_262*tmp_kernel_op_274 + tmp_kernel_op_263*tmp_kernel_op_275 + tmp_kernel_op_264*tmp_kernel_op_276);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_266*tmp_kernel_op_277 + tmp_kernel_op_268*tmp_kernel_op_278 + tmp_kernel_op_270*tmp_kernel_op_279 + tmp_kernel_op_272*tmp_kernel_op_280) + src_dof_1*(-tmp_kernel_op_110*tmp_kernel_op_278 - tmp_kernel_op_147*tmp_kernel_op_279 - tmp_kernel_op_184*tmp_kernel_op_280 - tmp_kernel_op_277*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_187*tmp_kernel_op_277 - tmp_kernel_op_190*tmp_kernel_op_278 - tmp_kernel_op_193*tmp_kernel_op_279 - tmp_kernel_op_196*tmp_kernel_op_280) + src_dof_3*(-tmp_kernel_op_199*tmp_kernel_op_277 - tmp_kernel_op_202*tmp_kernel_op_278 - tmp_kernel_op_205*tmp_kernel_op_279 - tmp_kernel_op_208*tmp_kernel_op_280) + src_dof_4*(tmp_kernel_op_211*tmp_kernel_op_277 + tmp_kernel_op_214*tmp_kernel_op_278 + tmp_kernel_op_217*tmp_kernel_op_279 + tmp_kernel_op_220*tmp_kernel_op_280) + src_dof_5*(tmp_kernel_op_223*tmp_kernel_op_277 + tmp_kernel_op_226*tmp_kernel_op_278 + tmp_kernel_op_229*tmp_kernel_op_279 + tmp_kernel_op_232*tmp_kernel_op_280) + src_dof_6*(tmp_kernel_op_235*tmp_kernel_op_277 + tmp_kernel_op_238*tmp_kernel_op_278 + tmp_kernel_op_241*tmp_kernel_op_279 + tmp_kernel_op_244*tmp_kernel_op_280) + src_dof_7*(tmp_kernel_op_246*tmp_kernel_op_277 + tmp_kernel_op_248*tmp_kernel_op_278 + tmp_kernel_op_250*tmp_kernel_op_279 + tmp_kernel_op_252*tmp_kernel_op_280) + src_dof_8*(tmp_kernel_op_254*tmp_kernel_op_277 + tmp_kernel_op_256*tmp_kernel_op_278 + tmp_kernel_op_258*tmp_kernel_op_279 + tmp_kernel_op_260*tmp_kernel_op_280) + src_dof_9*(tmp_kernel_op_261*tmp_kernel_op_277 + tmp_kernel_op_262*tmp_kernel_op_278 + tmp_kernel_op_263*tmp_kernel_op_279 + tmp_kernel_op_264*tmp_kernel_op_280);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_266*tmp_kernel_op_281 + tmp_kernel_op_268*tmp_kernel_op_282 + tmp_kernel_op_270*tmp_kernel_op_283 + tmp_kernel_op_272*tmp_kernel_op_284) + src_dof_1*(-tmp_kernel_op_110*tmp_kernel_op_282 - tmp_kernel_op_147*tmp_kernel_op_283 - tmp_kernel_op_184*tmp_kernel_op_284 - tmp_kernel_op_281*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_187*tmp_kernel_op_281 - tmp_kernel_op_190*tmp_kernel_op_282 - tmp_kernel_op_193*tmp_kernel_op_283 - tmp_kernel_op_196*tmp_kernel_op_284) + src_dof_3*(-tmp_kernel_op_199*tmp_kernel_op_281 - tmp_kernel_op_202*tmp_kernel_op_282 - tmp_kernel_op_205*tmp_kernel_op_283 - tmp_kernel_op_208*tmp_kernel_op_284) + src_dof_4*(tmp_kernel_op_211*tmp_kernel_op_281 + tmp_kernel_op_214*tmp_kernel_op_282 + tmp_kernel_op_217*tmp_kernel_op_283 + tmp_kernel_op_220*tmp_kernel_op_284) + src_dof_5*(tmp_kernel_op_223*tmp_kernel_op_281 + tmp_kernel_op_226*tmp_kernel_op_282 + tmp_kernel_op_229*tmp_kernel_op_283 + tmp_kernel_op_232*tmp_kernel_op_284) + src_dof_6*(tmp_kernel_op_235*tmp_kernel_op_281 + tmp_kernel_op_238*tmp_kernel_op_282 + tmp_kernel_op_241*tmp_kernel_op_283 + tmp_kernel_op_244*tmp_kernel_op_284) + src_dof_7*(tmp_kernel_op_246*tmp_kernel_op_281 + tmp_kernel_op_248*tmp_kernel_op_282 + tmp_kernel_op_250*tmp_kernel_op_283 + tmp_kernel_op_252*tmp_kernel_op_284) + src_dof_8*(tmp_kernel_op_254*tmp_kernel_op_281 + tmp_kernel_op_256*tmp_kernel_op_282 + tmp_kernel_op_258*tmp_kernel_op_283 + tmp_kernel_op_260*tmp_kernel_op_284) + src_dof_9*(tmp_kernel_op_261*tmp_kernel_op_281 + tmp_kernel_op_262*tmp_kernel_op_282 + tmp_kernel_op_263*tmp_kernel_op_283 + tmp_kernel_op_264*tmp_kernel_op_284);
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       {
          /* CellType.GREEN_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_0 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0);
                const __m256d tmp_kernel_op_1 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0);
                const __m256d tmp_kernel_op_2 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0);
                const __m256d tmp_kernel_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_kernel_op_4 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1);
                const __m256d tmp_kernel_op_5 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1);
                const __m256d tmp_kernel_op_6 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1);
                const __m256d tmp_kernel_op_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_kernel_op_8 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2);
                const __m256d tmp_kernel_op_9 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2);
                const __m256d tmp_kernel_op_10 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2);
                const __m256d tmp_kernel_op_11 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_kernel_op_12 = _mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_3);
                const __m256d tmp_kernel_op_13 = _mm256_mul_pd(tmp_kernel_op_7,tmp_kernel_op_7);
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_11);
                const __m256d tmp_kernel_op_15 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_12,tmp_kernel_op_13),tmp_kernel_op_14);
                const __m256d tmp_kernel_op_16 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_15),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_15,tmp_kernel_op_15),tmp_kernel_op_15),tmp_kernel_op_15),tmp_kernel_op_15));
                const __m256d tmp_kernel_op_38 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_11,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_39 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_40 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_41 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_39,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_39,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_42 = _mm256_mul_pd(tmp_kernel_op_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_45 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_48 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_7),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_7,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_41)),_mm256_mul_pd(tmp_kernel_op_13,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_51 = _mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_53 = _mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_54 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_43),tmp_kernel_op_53);
                const __m256d tmp_kernel_op_55 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_11,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_41)),_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_56 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_51),tmp_kernel_op_7);
                const __m256d tmp_kernel_op_57 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_41)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_41),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_58 = _mm256_mul_pd(tmp_kernel_op_57,tmp_kernel_op_7);
                const __m256d tmp_kernel_op_59 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_54),tmp_kernel_op_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_51),tmp_kernel_op_54),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_53,tmp_kernel_op_55),tmp_kernel_op_56),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_16,tmp_kernel_op_50),tmp_kernel_op_55),tmp_kernel_op_57),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_16),tmp_kernel_op_3),tmp_kernel_op_43),tmp_kernel_op_45),tmp_kernel_op_48),tmp_kernel_op_7),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_60 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_59))));
                const __m256d tmp_kernel_op_61 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.13819660112501053,0.13819660112501053,0.13819660112501053,0.13819660112501053));
                const __m256d tmp_kernel_op_62 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_59);
                const __m256d tmp_kernel_op_63 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_15),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_15)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_15));
                const __m256d tmp_kernel_op_66 = _mm256_mul_pd(tmp_kernel_op_63,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_67 = _mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_66);
                const __m256d tmp_kernel_op_68 = _mm256_mul_pd(tmp_kernel_op_62,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_58,tmp_kernel_op_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_43),tmp_kernel_op_45),tmp_kernel_op_63),tmp_kernel_op_7),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_69 = _mm256_mul_pd(tmp_kernel_op_62,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_50),tmp_kernel_op_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_43),tmp_kernel_op_48),tmp_kernel_op_63),tmp_kernel_op_7),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_70 = _mm256_mul_pd(tmp_kernel_op_62,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_56,tmp_kernel_op_66),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_57),tmp_kernel_op_66)));
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)));
                const __m256d tmp_kernel_op_73 = _mm256_mul_pd(tmp_kernel_op_71,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72)));
                const __m256d tmp_kernel_op_74 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_kernel_op_75 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_kernel_op_76 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_kernel_op_77 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_74);
                const __m256d tmp_kernel_op_78 = _mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_75);
                const __m256d tmp_kernel_op_79 = _mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_76);
                const __m256d tmp_kernel_op_80 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_77,tmp_kernel_op_78),tmp_kernel_op_79);
                const __m256d tmp_kernel_op_81 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_80),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_80,tmp_kernel_op_80),tmp_kernel_op_80),tmp_kernel_op_80),tmp_kernel_op_80));
                const __m256d tmp_kernel_op_82 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_76,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_83 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_74,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_75,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_85 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_82,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_82,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_86 = _mm256_mul_pd(tmp_kernel_op_85,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_87 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_88 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_89 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_90 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_75,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_91 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_88);
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_81,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_93 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_87),tmp_kernel_op_92);
                const __m256d tmp_kernel_op_94 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_76,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_79,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_95 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_89),tmp_kernel_op_91);
                const __m256d tmp_kernel_op_96 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_74,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_85)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_77,tmp_kernel_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_97 = _mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_98 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_89,tmp_kernel_op_93),tmp_kernel_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_90,tmp_kernel_op_91),tmp_kernel_op_93),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_94),tmp_kernel_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_81,tmp_kernel_op_90),tmp_kernel_op_94),tmp_kernel_op_96),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_75),tmp_kernel_op_76),tmp_kernel_op_81),tmp_kernel_op_87),tmp_kernel_op_88),tmp_kernel_op_89),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_99 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_98))));
                const __m256d tmp_kernel_op_100 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_101 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_98);
                const __m256d tmp_kernel_op_102 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_80),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_80)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_80));
                const __m256d tmp_kernel_op_103 = _mm256_mul_pd(tmp_kernel_op_102,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_104 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_105 = _mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_74),tmp_kernel_op_75),tmp_kernel_op_87),tmp_kernel_op_88),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_106 = _mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_74),tmp_kernel_op_90),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_74),tmp_kernel_op_75),tmp_kernel_op_87),tmp_kernel_op_89),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_107 = _mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_90),tmp_kernel_op_96)));
                const __m256d tmp_kernel_op_108 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_mul_pd(tmp_kernel_op_105,_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)));
                const __m256d tmp_kernel_op_110 = _mm256_mul_pd(tmp_kernel_op_108,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)));
                const __m256d tmp_kernel_op_111 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_kernel_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_kernel_op_113 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_kernel_op_114 = _mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_111);
                const __m256d tmp_kernel_op_115 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_112);
                const __m256d tmp_kernel_op_116 = _mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_113);
                const __m256d tmp_kernel_op_117 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_114,tmp_kernel_op_115),tmp_kernel_op_116);
                const __m256d tmp_kernel_op_118 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_117),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_117,tmp_kernel_op_117),tmp_kernel_op_117),tmp_kernel_op_117),tmp_kernel_op_117));
                const __m256d tmp_kernel_op_119 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_120 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_111,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_121 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_112,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_122 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_119,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_121,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_121,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_119,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_123 = _mm256_mul_pd(tmp_kernel_op_122,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_124 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_125 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_126 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_122),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_127 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_112,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_122)),_mm256_mul_pd(tmp_kernel_op_115,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_128 = _mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_125);
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(tmp_kernel_op_118,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_130 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_124),tmp_kernel_op_129);
                const __m256d tmp_kernel_op_131 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_122)),_mm256_mul_pd(tmp_kernel_op_116,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_132 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_126),tmp_kernel_op_128);
                const __m256d tmp_kernel_op_133 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_111,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_122)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_114,tmp_kernel_op_122),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_134 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_133);
                const __m256d tmp_kernel_op_135 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_130),tmp_kernel_op_134),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_128),tmp_kernel_op_130),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_129,tmp_kernel_op_131),tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_127),tmp_kernel_op_131),tmp_kernel_op_133),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_112),tmp_kernel_op_113),tmp_kernel_op_118),tmp_kernel_op_124),tmp_kernel_op_125),tmp_kernel_op_126),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_135))));
                const __m256d tmp_kernel_op_137 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_138 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_135);
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_117),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_117)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_117));
                const __m256d tmp_kernel_op_140 = _mm256_mul_pd(tmp_kernel_op_139,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_141 = _mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_140);
                const __m256d tmp_kernel_op_142 = _mm256_mul_pd(tmp_kernel_op_138,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_141),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_112),tmp_kernel_op_124),tmp_kernel_op_125),tmp_kernel_op_139),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_143 = _mm256_mul_pd(tmp_kernel_op_138,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_127),tmp_kernel_op_141),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_112),tmp_kernel_op_124),tmp_kernel_op_126),tmp_kernel_op_139),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_144 = _mm256_mul_pd(tmp_kernel_op_138,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_140),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_133),tmp_kernel_op_140)));
                const __m256d tmp_kernel_op_145 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP))),_mm256_mul_pd(tmp_kernel_op_144,_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)));
                const __m256d tmp_kernel_op_147 = _mm256_mul_pd(tmp_kernel_op_145,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146)));
                const __m256d tmp_kernel_op_148 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_0);
                const __m256d tmp_kernel_op_149 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_1);
                const __m256d tmp_kernel_op_150 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_2);
                const __m256d tmp_kernel_op_151 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_148);
                const __m256d tmp_kernel_op_152 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_149);
                const __m256d tmp_kernel_op_153 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_150);
                const __m256d tmp_kernel_op_154 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_151,tmp_kernel_op_152),tmp_kernel_op_153);
                const __m256d tmp_kernel_op_155 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_154),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_154),tmp_kernel_op_154),tmp_kernel_op_154),tmp_kernel_op_154));
                const __m256d tmp_kernel_op_156 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_150,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_157 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_158 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_149,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_159 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_156,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_156,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_160 = _mm256_mul_pd(tmp_kernel_op_159,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_161 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_162 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_163 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_164 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_149,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_159)),_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_165 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_162);
                const __m256d tmp_kernel_op_166 = _mm256_mul_pd(tmp_kernel_op_155,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_167 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_161),tmp_kernel_op_166);
                const __m256d tmp_kernel_op_168 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_150,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_159)),_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_169 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_163),tmp_kernel_op_165);
                const __m256d tmp_kernel_op_170 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_159)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_171 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_170);
                const __m256d tmp_kernel_op_172 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_167),tmp_kernel_op_171),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_164,tmp_kernel_op_165),tmp_kernel_op_167),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_166,tmp_kernel_op_168),tmp_kernel_op_169),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_164),tmp_kernel_op_168),tmp_kernel_op_170),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_149),tmp_kernel_op_150),tmp_kernel_op_155),tmp_kernel_op_161),tmp_kernel_op_162),tmp_kernel_op_163),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_173 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_172))));
                const __m256d tmp_kernel_op_174 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_175 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_172);
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_154),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_154)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_154));
                const __m256d tmp_kernel_op_177 = _mm256_mul_pd(tmp_kernel_op_176,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_178 = _mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_177);
                const __m256d tmp_kernel_op_179 = _mm256_mul_pd(tmp_kernel_op_175,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_178),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_149),tmp_kernel_op_161),tmp_kernel_op_162),tmp_kernel_op_176),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_180 = _mm256_mul_pd(tmp_kernel_op_175,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_164),tmp_kernel_op_178),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_149),tmp_kernel_op_161),tmp_kernel_op_163),tmp_kernel_op_176),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_181 = _mm256_mul_pd(tmp_kernel_op_175,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_177),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_164,tmp_kernel_op_170),tmp_kernel_op_177)));
                const __m256d tmp_kernel_op_182 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP)),_mm256_mul_pd(tmp_kernel_op_179,_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP))),_mm256_mul_pd(tmp_kernel_op_181,_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP)));
                const __m256d tmp_kernel_op_184 = _mm256_mul_pd(tmp_kernel_op_182,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183)));
                const __m256d tmp_kernel_op_185 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)));
                const __m256d tmp_kernel_op_187 = _mm256_mul_pd(tmp_kernel_op_185,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186)));
                const __m256d tmp_kernel_op_188 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_mul_pd(tmp_kernel_op_105,_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)));
                const __m256d tmp_kernel_op_190 = _mm256_mul_pd(tmp_kernel_op_188,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189)));
                const __m256d tmp_kernel_op_191 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP))),_mm256_mul_pd(tmp_kernel_op_144,_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)));
                const __m256d tmp_kernel_op_193 = _mm256_mul_pd(tmp_kernel_op_191,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192)));
                const __m256d tmp_kernel_op_194 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_mul_pd(tmp_kernel_op_179,_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP))),_mm256_mul_pd(tmp_kernel_op_181,_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)));
                const __m256d tmp_kernel_op_196 = _mm256_mul_pd(tmp_kernel_op_194,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195)));
                const __m256d tmp_kernel_op_197 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)));
                const __m256d tmp_kernel_op_199 = _mm256_mul_pd(tmp_kernel_op_197,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198)));
                const __m256d tmp_kernel_op_200 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_mul_pd(tmp_kernel_op_105,_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)));
                const __m256d tmp_kernel_op_202 = _mm256_mul_pd(tmp_kernel_op_200,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201)));
                const __m256d tmp_kernel_op_203 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_mul_pd(tmp_kernel_op_144,_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)));
                const __m256d tmp_kernel_op_205 = _mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204)));
                const __m256d tmp_kernel_op_206 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_mul_pd(tmp_kernel_op_179,_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_mul_pd(tmp_kernel_op_181,_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)));
                const __m256d tmp_kernel_op_208 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207)));
                const __m256d tmp_kernel_op_209 = _mm256_mul_pd(tmp_kernel_op_197,_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186));
                const __m256d tmp_kernel_op_210 = _mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198));
                const __m256d tmp_kernel_op_211 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_209,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_212 = _mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189));
                const __m256d tmp_kernel_op_213 = _mm256_mul_pd(tmp_kernel_op_188,_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201));
                const __m256d tmp_kernel_op_214 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_212,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_213,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_215 = _mm256_mul_pd(tmp_kernel_op_203,_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192));
                const __m256d tmp_kernel_op_216 = _mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204));
                const __m256d tmp_kernel_op_217 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_215,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_216,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_218 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195));
                const __m256d tmp_kernel_op_219 = _mm256_mul_pd(tmp_kernel_op_194,_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207));
                const __m256d tmp_kernel_op_220 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_218,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_219,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_221 = _mm256_mul_pd(tmp_kernel_op_197,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72));
                const __m256d tmp_kernel_op_222 = _mm256_mul_pd(tmp_kernel_op_71,_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198));
                const __m256d tmp_kernel_op_223 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_222,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_224 = _mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_225 = _mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201));
                const __m256d tmp_kernel_op_226 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_224,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_225,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_227 = _mm256_mul_pd(tmp_kernel_op_203,_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146));
                const __m256d tmp_kernel_op_228 = _mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204));
                const __m256d tmp_kernel_op_229 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_227,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_228,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_230 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183));
                const __m256d tmp_kernel_op_231 = _mm256_mul_pd(tmp_kernel_op_182,_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207));
                const __m256d tmp_kernel_op_232 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_230,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_231,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_233 = _mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72));
                const __m256d tmp_kernel_op_234 = _mm256_mul_pd(tmp_kernel_op_71,_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186));
                const __m256d tmp_kernel_op_235 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_233,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_234,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_236 = _mm256_mul_pd(tmp_kernel_op_188,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_237 = _mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189));
                const __m256d tmp_kernel_op_238 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_236,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_237,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_239 = _mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146));
                const __m256d tmp_kernel_op_240 = _mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192));
                const __m256d tmp_kernel_op_241 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_239,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_240,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_242 = _mm256_mul_pd(tmp_kernel_op_194,_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183));
                const __m256d tmp_kernel_op_243 = _mm256_mul_pd(tmp_kernel_op_182,_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195));
                const __m256d tmp_kernel_op_244 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_243,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_246 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245)),_mm256_set_pd(-0.68328157299974723,-0.68328157299974723,-0.68328157299974723,-0.68328157299974723))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_210),tmp_kernel_op_222);
                const __m256d tmp_kernel_op_248 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_200,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247)),_mm256_set_pd(2.8944271909999157,2.8944271909999157,2.8944271909999157,2.8944271909999157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_213),tmp_kernel_op_225);
                const __m256d tmp_kernel_op_250 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249)),_mm256_set_pd(2.8944271909999157,2.8944271909999157,2.8944271909999157,2.8944271909999157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_216),tmp_kernel_op_228);
                const __m256d tmp_kernel_op_252 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_206,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251)),_mm256_set_pd(2.8944271909999157,2.8944271909999157,2.8944271909999157,2.8944271909999157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_219),tmp_kernel_op_231);
                const __m256d tmp_kernel_op_254 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_209),tmp_kernel_op_234);
                const __m256d tmp_kernel_op_256 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_188,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))),_mm256_set_pd(-4.6832815729997472,-4.6832815729997472,-4.6832815729997472,-4.6832815729997472))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_212),tmp_kernel_op_237);
                const __m256d tmp_kernel_op_258 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_191,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_215),tmp_kernel_op_240);
                const __m256d tmp_kernel_op_260 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_218),tmp_kernel_op_243);
                const __m256d tmp_kernel_op_261 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_221),tmp_kernel_op_233);
                const __m256d tmp_kernel_op_262 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_108,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_224),tmp_kernel_op_236);
                const __m256d tmp_kernel_op_263 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_145,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257))),_mm256_set_pd(-4.6832815729997472,-4.6832815729997472,-4.6832815729997472,-4.6832815729997472))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_227),tmp_kernel_op_239);
                const __m256d tmp_kernel_op_264 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_182,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_230),tmp_kernel_op_242);
                const __m256d tmp_kernel_op_266 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265)));
                const __m256d tmp_kernel_op_268 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_188,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267)));
                const __m256d tmp_kernel_op_270 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_203,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269)));
                const __m256d tmp_kernel_op_272 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_182,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271)));
                const __m256d tmp_kernel_op_273 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_274 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_275 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_276 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_277 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_278 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_279 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_280 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_281 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_282 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_283 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_284 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_214),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_217)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_220)),_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_61))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_226),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_229)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_232)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_238),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_241)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_244)),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_248),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_250)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_252)),_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_256),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_258)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_260)),_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_262),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_263)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_264)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_268),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_270)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_272)),_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_110),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_184),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_190),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_193),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_196),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_202),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_205),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_208),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_276))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_232,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_241,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_258,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_262,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_268,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_270,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_272,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_110,tmp_kernel_op_274),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_275),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_276),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_273,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_273),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_190,tmp_kernel_op_274),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_275),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_276),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_273),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_274),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_275),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_276),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_280))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_232,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_241,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_258,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_262,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_268,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_270,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_272,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_110,tmp_kernel_op_278),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_279),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_280),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_277),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_190,tmp_kernel_op_278),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_279),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_280),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_277),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_278),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_279),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_280),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_284))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_232,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_241,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_258,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_262,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_268,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_270,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_272,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_110,tmp_kernel_op_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_283),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_284),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_281,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_281),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_190,tmp_kernel_op_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_283),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_284),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_281),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_283),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_284),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_0 = -p_affine_0_0 + p_affine_1_0;
                const real_t tmp_kernel_op_1 = -p_affine_0_0 + p_affine_2_0;
                const real_t tmp_kernel_op_2 = -p_affine_0_0 + p_affine_3_0;
                const real_t tmp_kernel_op_3 = p_affine_0_0 + tmp_kernel_op_0*0.1381966011250105 + tmp_kernel_op_1*0.1381966011250105 + tmp_kernel_op_2*0.5854101966249684;
                const real_t tmp_kernel_op_4 = -p_affine_0_1 + p_affine_1_1;
                const real_t tmp_kernel_op_5 = -p_affine_0_1 + p_affine_2_1;
                const real_t tmp_kernel_op_6 = -p_affine_0_1 + p_affine_3_1;
                const real_t tmp_kernel_op_7 = p_affine_0_1 + tmp_kernel_op_4*0.1381966011250105 + tmp_kernel_op_5*0.1381966011250105 + tmp_kernel_op_6*0.5854101966249684;
                const real_t tmp_kernel_op_8 = -p_affine_0_2 + p_affine_1_2;
                const real_t tmp_kernel_op_9 = -p_affine_0_2 + p_affine_2_2;
                const real_t tmp_kernel_op_10 = -p_affine_0_2 + p_affine_3_2;
                const real_t tmp_kernel_op_11 = p_affine_0_2 + tmp_kernel_op_10*0.5854101966249684 + tmp_kernel_op_8*0.1381966011250105 + tmp_kernel_op_9*0.1381966011250105;
                const real_t tmp_kernel_op_12 = (tmp_kernel_op_3*tmp_kernel_op_3);
                const real_t tmp_kernel_op_13 = (tmp_kernel_op_7*tmp_kernel_op_7);
                const real_t tmp_kernel_op_14 = (tmp_kernel_op_11*tmp_kernel_op_11);
                const real_t tmp_kernel_op_15 = tmp_kernel_op_12 + tmp_kernel_op_13 + tmp_kernel_op_14;
                const real_t tmp_kernel_op_16 = pow(tmp_kernel_op_15, -4.5000000000000000);
                const real_t tmp_kernel_op_38 = -tmp_kernel_op_11 - tmp_kernel_op_29;
                const real_t tmp_kernel_op_39 = -tmp_kernel_op_18 - tmp_kernel_op_3;
                const real_t tmp_kernel_op_40 = -tmp_kernel_op_25 - tmp_kernel_op_7;
                const real_t tmp_kernel_op_41 = -tmp_kernel_op_35*(tmp_kernel_op_19*tmp_kernel_op_20*tmp_kernel_op_40 + tmp_kernel_op_23*tmp_kernel_op_30*tmp_kernel_op_39 - tmp_kernel_op_24*tmp_kernel_op_38 + tmp_kernel_op_26*tmp_kernel_op_27*tmp_kernel_op_38 - tmp_kernel_op_31*tmp_kernel_op_39 - tmp_kernel_op_32*tmp_kernel_op_40) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_42 = -tmp_kernel_op_41;
                const real_t tmp_kernel_op_43 = tmp_kernel_op_11*tmp_kernel_op_42 + tmp_kernel_op_15*tmp_kernel_op_36;
                const real_t tmp_kernel_op_45 = tmp_kernel_op_15*tmp_kernel_op_44 + tmp_kernel_op_3*tmp_kernel_op_42;
                const real_t tmp_kernel_op_48 = -tmp_kernel_op_15*tmp_kernel_op_47 - tmp_kernel_op_41*tmp_kernel_op_7;
                const real_t tmp_kernel_op_50 = tmp_kernel_op_13*tmp_kernel_op_42 + tmp_kernel_op_15*(tmp_kernel_op_41 + tmp_kernel_op_49*tmp_kernel_op_7);
                const real_t tmp_kernel_op_51 = tmp_kernel_op_3*tmp_kernel_op_45;
                const real_t tmp_kernel_op_53 = tmp_kernel_op_16*tmp_kernel_op_52;
                const real_t tmp_kernel_op_54 = tmp_kernel_op_11*tmp_kernel_op_43*tmp_kernel_op_53;
                const real_t tmp_kernel_op_55 = tmp_kernel_op_14*tmp_kernel_op_42 + tmp_kernel_op_15*(tmp_kernel_op_11*tmp_kernel_op_36 + tmp_kernel_op_41);
                const real_t tmp_kernel_op_56 = tmp_kernel_op_48*tmp_kernel_op_51*tmp_kernel_op_7;
                const real_t tmp_kernel_op_57 = -tmp_kernel_op_12*tmp_kernel_op_41 + tmp_kernel_op_15*(tmp_kernel_op_3*tmp_kernel_op_44 + tmp_kernel_op_41);
                const real_t tmp_kernel_op_58 = tmp_kernel_op_57*tmp_kernel_op_7;
                const real_t tmp_kernel_op_59 = tmp_kernel_op_11*tmp_kernel_op_16*tmp_kernel_op_3*tmp_kernel_op_34*tmp_kernel_op_43*tmp_kernel_op_45*tmp_kernel_op_48*tmp_kernel_op_7*2.0 + tmp_kernel_op_16*tmp_kernel_op_34*tmp_kernel_op_50*tmp_kernel_op_55*tmp_kernel_op_57*1.0 - tmp_kernel_op_48*tmp_kernel_op_54*tmp_kernel_op_58 - tmp_kernel_op_50*tmp_kernel_op_51*tmp_kernel_op_54 - tmp_kernel_op_53*tmp_kernel_op_55*tmp_kernel_op_56;
                const real_t tmp_kernel_op_60 = abs_det_jac_affine_GREEN_UP*0.041666666666666657*abs(tmp_kernel_op_59);
                const real_t tmp_kernel_op_61 = tmp_kernel_op_60*0.13819660112501053;
                const real_t tmp_kernel_op_62 = 1.0 / (tmp_kernel_op_59);
                const real_t tmp_kernel_op_63 = 1.0 / (tmp_kernel_op_15*tmp_kernel_op_15*tmp_kernel_op_15);
                const real_t tmp_kernel_op_66 = tmp_kernel_op_63*tmp_kernel_op_65;
                const real_t tmp_kernel_op_67 = tmp_kernel_op_43*tmp_kernel_op_66;
                const real_t tmp_kernel_op_68 = tmp_kernel_op_62*(tmp_kernel_op_3*tmp_kernel_op_43*tmp_kernel_op_45*tmp_kernel_op_63*tmp_kernel_op_64*tmp_kernel_op_7*1.0 - tmp_kernel_op_58*tmp_kernel_op_67);
                const real_t tmp_kernel_op_69 = tmp_kernel_op_62*(tmp_kernel_op_3*tmp_kernel_op_43*tmp_kernel_op_48*tmp_kernel_op_63*tmp_kernel_op_64*tmp_kernel_op_7*1.0 - tmp_kernel_op_3*tmp_kernel_op_50*tmp_kernel_op_67);
                const real_t tmp_kernel_op_70 = tmp_kernel_op_62*(tmp_kernel_op_50*tmp_kernel_op_57*tmp_kernel_op_66 - tmp_kernel_op_56*tmp_kernel_op_66);
                const real_t tmp_kernel_op_71 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_69 + jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_68 + jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_70;
                const real_t tmp_kernel_op_73 = tmp_kernel_op_71*(tmp_kernel_op_72 - 1.0);
                const real_t tmp_kernel_op_74 = p_affine_0_0 + tmp_kernel_op_0*0.1381966011250105 + tmp_kernel_op_1*0.5854101966249684 + tmp_kernel_op_2*0.1381966011250105;
                const real_t tmp_kernel_op_75 = p_affine_0_1 + tmp_kernel_op_4*0.1381966011250105 + tmp_kernel_op_5*0.5854101966249684 + tmp_kernel_op_6*0.1381966011250105;
                const real_t tmp_kernel_op_76 = p_affine_0_2 + tmp_kernel_op_10*0.1381966011250105 + tmp_kernel_op_8*0.1381966011250105 + tmp_kernel_op_9*0.5854101966249684;
                const real_t tmp_kernel_op_77 = (tmp_kernel_op_74*tmp_kernel_op_74);
                const real_t tmp_kernel_op_78 = (tmp_kernel_op_75*tmp_kernel_op_75);
                const real_t tmp_kernel_op_79 = (tmp_kernel_op_76*tmp_kernel_op_76);
                const real_t tmp_kernel_op_80 = tmp_kernel_op_77 + tmp_kernel_op_78 + tmp_kernel_op_79;
                const real_t tmp_kernel_op_81 = pow(tmp_kernel_op_80, -4.5000000000000000);
                const real_t tmp_kernel_op_82 = -tmp_kernel_op_29 - tmp_kernel_op_76;
                const real_t tmp_kernel_op_83 = -tmp_kernel_op_18 - tmp_kernel_op_74;
                const real_t tmp_kernel_op_84 = -tmp_kernel_op_25 - tmp_kernel_op_75;
                const real_t tmp_kernel_op_85 = -tmp_kernel_op_35*(tmp_kernel_op_19*tmp_kernel_op_20*tmp_kernel_op_84 + tmp_kernel_op_23*tmp_kernel_op_30*tmp_kernel_op_83 - tmp_kernel_op_24*tmp_kernel_op_82 + tmp_kernel_op_26*tmp_kernel_op_27*tmp_kernel_op_82 - tmp_kernel_op_31*tmp_kernel_op_83 - tmp_kernel_op_32*tmp_kernel_op_84) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_86 = -tmp_kernel_op_85;
                const real_t tmp_kernel_op_87 = tmp_kernel_op_36*tmp_kernel_op_80 + tmp_kernel_op_76*tmp_kernel_op_86;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_44*tmp_kernel_op_80 + tmp_kernel_op_74*tmp_kernel_op_86;
                const real_t tmp_kernel_op_89 = -tmp_kernel_op_47*tmp_kernel_op_80 - tmp_kernel_op_75*tmp_kernel_op_85;
                const real_t tmp_kernel_op_90 = tmp_kernel_op_78*tmp_kernel_op_86 + tmp_kernel_op_80*(tmp_kernel_op_49*tmp_kernel_op_75 + tmp_kernel_op_85);
                const real_t tmp_kernel_op_91 = tmp_kernel_op_74*tmp_kernel_op_88;
                const real_t tmp_kernel_op_92 = tmp_kernel_op_52*tmp_kernel_op_81;
                const real_t tmp_kernel_op_93 = tmp_kernel_op_76*tmp_kernel_op_87*tmp_kernel_op_92;
                const real_t tmp_kernel_op_94 = tmp_kernel_op_79*tmp_kernel_op_86 + tmp_kernel_op_80*(tmp_kernel_op_36*tmp_kernel_op_76 + tmp_kernel_op_85);
                const real_t tmp_kernel_op_95 = tmp_kernel_op_75*tmp_kernel_op_89*tmp_kernel_op_91;
                const real_t tmp_kernel_op_96 = -tmp_kernel_op_77*tmp_kernel_op_85 + tmp_kernel_op_80*(tmp_kernel_op_44*tmp_kernel_op_74 + tmp_kernel_op_85);
                const real_t tmp_kernel_op_97 = tmp_kernel_op_75*tmp_kernel_op_96;
                const real_t tmp_kernel_op_98 = tmp_kernel_op_34*tmp_kernel_op_74*tmp_kernel_op_75*tmp_kernel_op_76*tmp_kernel_op_81*tmp_kernel_op_87*tmp_kernel_op_88*tmp_kernel_op_89*2.0 + tmp_kernel_op_34*tmp_kernel_op_81*tmp_kernel_op_90*tmp_kernel_op_94*tmp_kernel_op_96*1.0 - tmp_kernel_op_89*tmp_kernel_op_93*tmp_kernel_op_97 - tmp_kernel_op_90*tmp_kernel_op_91*tmp_kernel_op_93 - tmp_kernel_op_92*tmp_kernel_op_94*tmp_kernel_op_95;
                const real_t tmp_kernel_op_99 = abs_det_jac_affine_GREEN_UP*0.041666666666666657*abs(tmp_kernel_op_98);
                const real_t tmp_kernel_op_100 = tmp_kernel_op_99*0.13819660112501056;
                const real_t tmp_kernel_op_101 = 1.0 / (tmp_kernel_op_98);
                const real_t tmp_kernel_op_102 = 1.0 / (tmp_kernel_op_80*tmp_kernel_op_80*tmp_kernel_op_80);
                const real_t tmp_kernel_op_103 = tmp_kernel_op_102*tmp_kernel_op_65;
                const real_t tmp_kernel_op_104 = tmp_kernel_op_103*tmp_kernel_op_87;
                const real_t tmp_kernel_op_105 = tmp_kernel_op_101*(tmp_kernel_op_102*tmp_kernel_op_64*tmp_kernel_op_74*tmp_kernel_op_75*tmp_kernel_op_87*tmp_kernel_op_88*1.0 - tmp_kernel_op_104*tmp_kernel_op_97);
                const real_t tmp_kernel_op_106 = tmp_kernel_op_101*(tmp_kernel_op_102*tmp_kernel_op_64*tmp_kernel_op_74*tmp_kernel_op_75*tmp_kernel_op_87*tmp_kernel_op_89*1.0 - tmp_kernel_op_104*tmp_kernel_op_74*tmp_kernel_op_90);
                const real_t tmp_kernel_op_107 = tmp_kernel_op_101*(tmp_kernel_op_103*tmp_kernel_op_90*tmp_kernel_op_96 - tmp_kernel_op_103*tmp_kernel_op_95);
                const real_t tmp_kernel_op_108 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_106 + jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_105 + jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_107;
                const real_t tmp_kernel_op_110 = tmp_kernel_op_108*(tmp_kernel_op_109 - 1.0);
                const real_t tmp_kernel_op_111 = p_affine_0_0 + tmp_kernel_op_0*0.5854101966249684 + tmp_kernel_op_1*0.1381966011250105 + tmp_kernel_op_2*0.1381966011250105;
                const real_t tmp_kernel_op_112 = p_affine_0_1 + tmp_kernel_op_4*0.5854101966249684 + tmp_kernel_op_5*0.1381966011250105 + tmp_kernel_op_6*0.1381966011250105;
                const real_t tmp_kernel_op_113 = p_affine_0_2 + tmp_kernel_op_10*0.1381966011250105 + tmp_kernel_op_8*0.5854101966249684 + tmp_kernel_op_9*0.1381966011250105;
                const real_t tmp_kernel_op_114 = (tmp_kernel_op_111*tmp_kernel_op_111);
                const real_t tmp_kernel_op_115 = (tmp_kernel_op_112*tmp_kernel_op_112);
                const real_t tmp_kernel_op_116 = (tmp_kernel_op_113*tmp_kernel_op_113);
                const real_t tmp_kernel_op_117 = tmp_kernel_op_114 + tmp_kernel_op_115 + tmp_kernel_op_116;
                const real_t tmp_kernel_op_118 = pow(tmp_kernel_op_117, -4.5000000000000000);
                const real_t tmp_kernel_op_119 = -tmp_kernel_op_113 - tmp_kernel_op_29;
                const real_t tmp_kernel_op_120 = -tmp_kernel_op_111 - tmp_kernel_op_18;
                const real_t tmp_kernel_op_121 = -tmp_kernel_op_112 - tmp_kernel_op_25;
                const real_t tmp_kernel_op_122 = -tmp_kernel_op_35*(-tmp_kernel_op_119*tmp_kernel_op_24 + tmp_kernel_op_119*tmp_kernel_op_26*tmp_kernel_op_27 + tmp_kernel_op_120*tmp_kernel_op_23*tmp_kernel_op_30 - tmp_kernel_op_120*tmp_kernel_op_31 + tmp_kernel_op_121*tmp_kernel_op_19*tmp_kernel_op_20 - tmp_kernel_op_121*tmp_kernel_op_32) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_123 = -tmp_kernel_op_122;
                const real_t tmp_kernel_op_124 = tmp_kernel_op_113*tmp_kernel_op_123 + tmp_kernel_op_117*tmp_kernel_op_36;
                const real_t tmp_kernel_op_125 = tmp_kernel_op_111*tmp_kernel_op_123 + tmp_kernel_op_117*tmp_kernel_op_44;
                const real_t tmp_kernel_op_126 = -tmp_kernel_op_112*tmp_kernel_op_122 - tmp_kernel_op_117*tmp_kernel_op_47;
                const real_t tmp_kernel_op_127 = tmp_kernel_op_115*tmp_kernel_op_123 + tmp_kernel_op_117*(tmp_kernel_op_112*tmp_kernel_op_49 + tmp_kernel_op_122);
                const real_t tmp_kernel_op_128 = tmp_kernel_op_111*tmp_kernel_op_125;
                const real_t tmp_kernel_op_129 = tmp_kernel_op_118*tmp_kernel_op_52;
                const real_t tmp_kernel_op_130 = tmp_kernel_op_113*tmp_kernel_op_124*tmp_kernel_op_129;
                const real_t tmp_kernel_op_131 = tmp_kernel_op_116*tmp_kernel_op_123 + tmp_kernel_op_117*(tmp_kernel_op_113*tmp_kernel_op_36 + tmp_kernel_op_122);
                const real_t tmp_kernel_op_132 = tmp_kernel_op_112*tmp_kernel_op_126*tmp_kernel_op_128;
                const real_t tmp_kernel_op_133 = -tmp_kernel_op_114*tmp_kernel_op_122 + tmp_kernel_op_117*(tmp_kernel_op_111*tmp_kernel_op_44 + tmp_kernel_op_122);
                const real_t tmp_kernel_op_134 = tmp_kernel_op_112*tmp_kernel_op_133;
                const real_t tmp_kernel_op_135 = tmp_kernel_op_111*tmp_kernel_op_112*tmp_kernel_op_113*tmp_kernel_op_118*tmp_kernel_op_124*tmp_kernel_op_125*tmp_kernel_op_126*tmp_kernel_op_34*2.0 + tmp_kernel_op_118*tmp_kernel_op_127*tmp_kernel_op_131*tmp_kernel_op_133*tmp_kernel_op_34*1.0 - tmp_kernel_op_126*tmp_kernel_op_130*tmp_kernel_op_134 - tmp_kernel_op_127*tmp_kernel_op_128*tmp_kernel_op_130 - tmp_kernel_op_129*tmp_kernel_op_131*tmp_kernel_op_132;
                const real_t tmp_kernel_op_136 = abs_det_jac_affine_GREEN_UP*0.041666666666666657*abs(tmp_kernel_op_135);
                const real_t tmp_kernel_op_137 = tmp_kernel_op_136*0.13819660112501056;
                const real_t tmp_kernel_op_138 = 1.0 / (tmp_kernel_op_135);
                const real_t tmp_kernel_op_139 = 1.0 / (tmp_kernel_op_117*tmp_kernel_op_117*tmp_kernel_op_117);
                const real_t tmp_kernel_op_140 = tmp_kernel_op_139*tmp_kernel_op_65;
                const real_t tmp_kernel_op_141 = tmp_kernel_op_124*tmp_kernel_op_140;
                const real_t tmp_kernel_op_142 = tmp_kernel_op_138*(tmp_kernel_op_111*tmp_kernel_op_112*tmp_kernel_op_124*tmp_kernel_op_125*tmp_kernel_op_139*tmp_kernel_op_64*1.0 - tmp_kernel_op_134*tmp_kernel_op_141);
                const real_t tmp_kernel_op_143 = tmp_kernel_op_138*(tmp_kernel_op_111*tmp_kernel_op_112*tmp_kernel_op_124*tmp_kernel_op_126*tmp_kernel_op_139*tmp_kernel_op_64*1.0 - tmp_kernel_op_111*tmp_kernel_op_127*tmp_kernel_op_141);
                const real_t tmp_kernel_op_144 = tmp_kernel_op_138*(tmp_kernel_op_127*tmp_kernel_op_133*tmp_kernel_op_140 - tmp_kernel_op_132*tmp_kernel_op_140);
                const real_t tmp_kernel_op_145 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_143 + jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_142 + jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_144;
                const real_t tmp_kernel_op_147 = tmp_kernel_op_145*(tmp_kernel_op_146 - 1.0);
                const real_t tmp_kernel_op_148 = p_affine_0_0 + tmp_kernel_op_0*0.1381966011250105 + tmp_kernel_op_1*0.1381966011250105 + tmp_kernel_op_2*0.1381966011250105;
                const real_t tmp_kernel_op_149 = p_affine_0_1 + tmp_kernel_op_4*0.1381966011250105 + tmp_kernel_op_5*0.1381966011250105 + tmp_kernel_op_6*0.1381966011250105;
                const real_t tmp_kernel_op_150 = p_affine_0_2 + tmp_kernel_op_10*0.1381966011250105 + tmp_kernel_op_8*0.1381966011250105 + tmp_kernel_op_9*0.1381966011250105;
                const real_t tmp_kernel_op_151 = (tmp_kernel_op_148*tmp_kernel_op_148);
                const real_t tmp_kernel_op_152 = (tmp_kernel_op_149*tmp_kernel_op_149);
                const real_t tmp_kernel_op_153 = (tmp_kernel_op_150*tmp_kernel_op_150);
                const real_t tmp_kernel_op_154 = tmp_kernel_op_151 + tmp_kernel_op_152 + tmp_kernel_op_153;
                const real_t tmp_kernel_op_155 = pow(tmp_kernel_op_154, -4.5000000000000000);
                const real_t tmp_kernel_op_156 = -tmp_kernel_op_150 - tmp_kernel_op_29;
                const real_t tmp_kernel_op_157 = -tmp_kernel_op_148 - tmp_kernel_op_18;
                const real_t tmp_kernel_op_158 = -tmp_kernel_op_149 - tmp_kernel_op_25;
                const real_t tmp_kernel_op_159 = -tmp_kernel_op_35*(-tmp_kernel_op_156*tmp_kernel_op_24 + tmp_kernel_op_156*tmp_kernel_op_26*tmp_kernel_op_27 + tmp_kernel_op_157*tmp_kernel_op_23*tmp_kernel_op_30 - tmp_kernel_op_157*tmp_kernel_op_31 + tmp_kernel_op_158*tmp_kernel_op_19*tmp_kernel_op_20 - tmp_kernel_op_158*tmp_kernel_op_32) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_160 = -tmp_kernel_op_159;
                const real_t tmp_kernel_op_161 = tmp_kernel_op_150*tmp_kernel_op_160 + tmp_kernel_op_154*tmp_kernel_op_36;
                const real_t tmp_kernel_op_162 = tmp_kernel_op_148*tmp_kernel_op_160 + tmp_kernel_op_154*tmp_kernel_op_44;
                const real_t tmp_kernel_op_163 = -tmp_kernel_op_149*tmp_kernel_op_159 - tmp_kernel_op_154*tmp_kernel_op_47;
                const real_t tmp_kernel_op_164 = tmp_kernel_op_152*tmp_kernel_op_160 + tmp_kernel_op_154*(tmp_kernel_op_149*tmp_kernel_op_49 + tmp_kernel_op_159);
                const real_t tmp_kernel_op_165 = tmp_kernel_op_148*tmp_kernel_op_162;
                const real_t tmp_kernel_op_166 = tmp_kernel_op_155*tmp_kernel_op_52;
                const real_t tmp_kernel_op_167 = tmp_kernel_op_150*tmp_kernel_op_161*tmp_kernel_op_166;
                const real_t tmp_kernel_op_168 = tmp_kernel_op_153*tmp_kernel_op_160 + tmp_kernel_op_154*(tmp_kernel_op_150*tmp_kernel_op_36 + tmp_kernel_op_159);
                const real_t tmp_kernel_op_169 = tmp_kernel_op_149*tmp_kernel_op_163*tmp_kernel_op_165;
                const real_t tmp_kernel_op_170 = -tmp_kernel_op_151*tmp_kernel_op_159 + tmp_kernel_op_154*(tmp_kernel_op_148*tmp_kernel_op_44 + tmp_kernel_op_159);
                const real_t tmp_kernel_op_171 = tmp_kernel_op_149*tmp_kernel_op_170;
                const real_t tmp_kernel_op_172 = tmp_kernel_op_148*tmp_kernel_op_149*tmp_kernel_op_150*tmp_kernel_op_155*tmp_kernel_op_161*tmp_kernel_op_162*tmp_kernel_op_163*tmp_kernel_op_34*2.0 + tmp_kernel_op_155*tmp_kernel_op_164*tmp_kernel_op_168*tmp_kernel_op_170*tmp_kernel_op_34*1.0 - tmp_kernel_op_163*tmp_kernel_op_167*tmp_kernel_op_171 - tmp_kernel_op_164*tmp_kernel_op_165*tmp_kernel_op_167 - tmp_kernel_op_166*tmp_kernel_op_168*tmp_kernel_op_169;
                const real_t tmp_kernel_op_173 = abs_det_jac_affine_GREEN_UP*0.041666666666666657*abs(tmp_kernel_op_172);
                const real_t tmp_kernel_op_174 = tmp_kernel_op_173*0.5854101966249684;
                const real_t tmp_kernel_op_175 = 1.0 / (tmp_kernel_op_172);
                const real_t tmp_kernel_op_176 = 1.0 / (tmp_kernel_op_154*tmp_kernel_op_154*tmp_kernel_op_154);
                const real_t tmp_kernel_op_177 = tmp_kernel_op_176*tmp_kernel_op_65;
                const real_t tmp_kernel_op_178 = tmp_kernel_op_161*tmp_kernel_op_177;
                const real_t tmp_kernel_op_179 = tmp_kernel_op_175*(tmp_kernel_op_148*tmp_kernel_op_149*tmp_kernel_op_161*tmp_kernel_op_162*tmp_kernel_op_176*tmp_kernel_op_64*1.0 - tmp_kernel_op_171*tmp_kernel_op_178);
                const real_t tmp_kernel_op_180 = tmp_kernel_op_175*(tmp_kernel_op_148*tmp_kernel_op_149*tmp_kernel_op_161*tmp_kernel_op_163*tmp_kernel_op_176*tmp_kernel_op_64*1.0 - tmp_kernel_op_148*tmp_kernel_op_164*tmp_kernel_op_178);
                const real_t tmp_kernel_op_181 = tmp_kernel_op_175*(tmp_kernel_op_164*tmp_kernel_op_170*tmp_kernel_op_177 - tmp_kernel_op_169*tmp_kernel_op_177);
                const real_t tmp_kernel_op_182 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_180 + jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_179 + jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_181;
                const real_t tmp_kernel_op_184 = tmp_kernel_op_182*(tmp_kernel_op_183 - 1.0);
                const real_t tmp_kernel_op_185 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_69 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_68 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_70;
                const real_t tmp_kernel_op_187 = tmp_kernel_op_185*(tmp_kernel_op_186 - 1.0);
                const real_t tmp_kernel_op_188 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_106 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_105 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_107;
                const real_t tmp_kernel_op_190 = tmp_kernel_op_188*(tmp_kernel_op_189 - 1.0);
                const real_t tmp_kernel_op_191 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_143 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_142 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_144;
                const real_t tmp_kernel_op_193 = tmp_kernel_op_191*(tmp_kernel_op_192 - 1.0);
                const real_t tmp_kernel_op_194 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_180 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_179 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_181;
                const real_t tmp_kernel_op_196 = tmp_kernel_op_194*(tmp_kernel_op_195 - 1.0);
                const real_t tmp_kernel_op_197 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_69 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_68 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_70;
                const real_t tmp_kernel_op_199 = tmp_kernel_op_197*(tmp_kernel_op_198 - 1.0);
                const real_t tmp_kernel_op_200 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_106 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_105 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_107;
                const real_t tmp_kernel_op_202 = tmp_kernel_op_200*(tmp_kernel_op_201 - 1.0);
                const real_t tmp_kernel_op_203 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_143 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_142 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_144;
                const real_t tmp_kernel_op_205 = tmp_kernel_op_203*(tmp_kernel_op_204 - 1.0);
                const real_t tmp_kernel_op_206 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_180 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_179 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_181;
                const real_t tmp_kernel_op_208 = tmp_kernel_op_206*(tmp_kernel_op_207 - 1.0);
                const real_t tmp_kernel_op_209 = tmp_kernel_op_186*tmp_kernel_op_197;
                const real_t tmp_kernel_op_210 = tmp_kernel_op_185*tmp_kernel_op_198;
                const real_t tmp_kernel_op_211 = -tmp_kernel_op_209 - tmp_kernel_op_210;
                const real_t tmp_kernel_op_212 = tmp_kernel_op_189*tmp_kernel_op_200;
                const real_t tmp_kernel_op_213 = tmp_kernel_op_188*tmp_kernel_op_201;
                const real_t tmp_kernel_op_214 = -tmp_kernel_op_212 - tmp_kernel_op_213;
                const real_t tmp_kernel_op_215 = tmp_kernel_op_192*tmp_kernel_op_203;
                const real_t tmp_kernel_op_216 = tmp_kernel_op_191*tmp_kernel_op_204;
                const real_t tmp_kernel_op_217 = -tmp_kernel_op_215 - tmp_kernel_op_216;
                const real_t tmp_kernel_op_218 = tmp_kernel_op_195*tmp_kernel_op_206;
                const real_t tmp_kernel_op_219 = tmp_kernel_op_194*tmp_kernel_op_207;
                const real_t tmp_kernel_op_220 = -tmp_kernel_op_218 - tmp_kernel_op_219;
                const real_t tmp_kernel_op_221 = tmp_kernel_op_197*tmp_kernel_op_72;
                const real_t tmp_kernel_op_222 = tmp_kernel_op_198*tmp_kernel_op_71;
                const real_t tmp_kernel_op_223 = -tmp_kernel_op_221 - tmp_kernel_op_222;
                const real_t tmp_kernel_op_224 = tmp_kernel_op_109*tmp_kernel_op_200;
                const real_t tmp_kernel_op_225 = tmp_kernel_op_108*tmp_kernel_op_201;
                const real_t tmp_kernel_op_226 = -tmp_kernel_op_224 - tmp_kernel_op_225;
                const real_t tmp_kernel_op_227 = tmp_kernel_op_146*tmp_kernel_op_203;
                const real_t tmp_kernel_op_228 = tmp_kernel_op_145*tmp_kernel_op_204;
                const real_t tmp_kernel_op_229 = -tmp_kernel_op_227 - tmp_kernel_op_228;
                const real_t tmp_kernel_op_230 = tmp_kernel_op_183*tmp_kernel_op_206;
                const real_t tmp_kernel_op_231 = tmp_kernel_op_182*tmp_kernel_op_207;
                const real_t tmp_kernel_op_232 = -tmp_kernel_op_230 - tmp_kernel_op_231;
                const real_t tmp_kernel_op_233 = tmp_kernel_op_185*tmp_kernel_op_72;
                const real_t tmp_kernel_op_234 = tmp_kernel_op_186*tmp_kernel_op_71;
                const real_t tmp_kernel_op_235 = -tmp_kernel_op_233 - tmp_kernel_op_234;
                const real_t tmp_kernel_op_236 = tmp_kernel_op_109*tmp_kernel_op_188;
                const real_t tmp_kernel_op_237 = tmp_kernel_op_108*tmp_kernel_op_189;
                const real_t tmp_kernel_op_238 = -tmp_kernel_op_236 - tmp_kernel_op_237;
                const real_t tmp_kernel_op_239 = tmp_kernel_op_146*tmp_kernel_op_191;
                const real_t tmp_kernel_op_240 = tmp_kernel_op_145*tmp_kernel_op_192;
                const real_t tmp_kernel_op_241 = -tmp_kernel_op_239 - tmp_kernel_op_240;
                const real_t tmp_kernel_op_242 = tmp_kernel_op_183*tmp_kernel_op_194;
                const real_t tmp_kernel_op_243 = tmp_kernel_op_182*tmp_kernel_op_195;
                const real_t tmp_kernel_op_244 = -tmp_kernel_op_242 - tmp_kernel_op_243;
                const real_t tmp_kernel_op_246 = -tmp_kernel_op_197*(-tmp_kernel_op_245 - 0.68328157299974723) + tmp_kernel_op_210 + tmp_kernel_op_222;
                const real_t tmp_kernel_op_248 = -tmp_kernel_op_200*(-tmp_kernel_op_247 + 2.8944271909999157) + tmp_kernel_op_213 + tmp_kernel_op_225;
                const real_t tmp_kernel_op_250 = -tmp_kernel_op_203*(-tmp_kernel_op_249 + 2.8944271909999157) + tmp_kernel_op_216 + tmp_kernel_op_228;
                const real_t tmp_kernel_op_252 = -tmp_kernel_op_206*(-tmp_kernel_op_251 + 2.8944271909999157) + tmp_kernel_op_219 + tmp_kernel_op_231;
                const real_t tmp_kernel_op_254 = -tmp_kernel_op_185*(-tmp_kernel_op_253 - tmp_kernel_op_72 - 1.105572809000084) + tmp_kernel_op_209 + tmp_kernel_op_234;
                const real_t tmp_kernel_op_256 = -tmp_kernel_op_188*(-tmp_kernel_op_109 - tmp_kernel_op_255 - 4.6832815729997472) + tmp_kernel_op_212 + tmp_kernel_op_237;
                const real_t tmp_kernel_op_258 = -tmp_kernel_op_191*(-tmp_kernel_op_146 - tmp_kernel_op_257 - 1.105572809000084) + tmp_kernel_op_215 + tmp_kernel_op_240;
                const real_t tmp_kernel_op_260 = -tmp_kernel_op_194*(-tmp_kernel_op_183 - tmp_kernel_op_259 - 1.105572809000084) + tmp_kernel_op_218 + tmp_kernel_op_243;
                const real_t tmp_kernel_op_261 = tmp_kernel_op_221 + tmp_kernel_op_233 - tmp_kernel_op_71*(-tmp_kernel_op_186 - tmp_kernel_op_253 - 1.105572809000084);
                const real_t tmp_kernel_op_262 = -tmp_kernel_op_108*(-tmp_kernel_op_189 - tmp_kernel_op_255 - 1.105572809000084) + tmp_kernel_op_224 + tmp_kernel_op_236;
                const real_t tmp_kernel_op_263 = -tmp_kernel_op_145*(-tmp_kernel_op_192 - tmp_kernel_op_257 - 4.6832815729997472) + tmp_kernel_op_227 + tmp_kernel_op_239;
                const real_t tmp_kernel_op_264 = -tmp_kernel_op_182*(-tmp_kernel_op_195 - tmp_kernel_op_259 - 1.105572809000084) + tmp_kernel_op_230 + tmp_kernel_op_242;
                const real_t tmp_kernel_op_266 = -tmp_kernel_op_185*tmp_kernel_op_265 - tmp_kernel_op_197*tmp_kernel_op_265 - tmp_kernel_op_265*tmp_kernel_op_71;
                const real_t tmp_kernel_op_268 = -tmp_kernel_op_108*tmp_kernel_op_267 - tmp_kernel_op_188*tmp_kernel_op_267 - tmp_kernel_op_200*tmp_kernel_op_267;
                const real_t tmp_kernel_op_270 = -tmp_kernel_op_145*tmp_kernel_op_269 - tmp_kernel_op_191*tmp_kernel_op_269 - tmp_kernel_op_203*tmp_kernel_op_269;
                const real_t tmp_kernel_op_272 = -tmp_kernel_op_182*tmp_kernel_op_271 - tmp_kernel_op_194*tmp_kernel_op_271 - tmp_kernel_op_206*tmp_kernel_op_271;
                const real_t tmp_kernel_op_273 = tmp_kernel_op_60*0.1381966011250105;
                const real_t tmp_kernel_op_274 = tmp_kernel_op_99*0.1381966011250105;
                const real_t tmp_kernel_op_275 = tmp_kernel_op_136*0.5854101966249684;
                const real_t tmp_kernel_op_276 = tmp_kernel_op_173*0.1381966011250105;
                const real_t tmp_kernel_op_277 = tmp_kernel_op_60*0.1381966011250105;
                const real_t tmp_kernel_op_278 = tmp_kernel_op_99*0.5854101966249684;
                const real_t tmp_kernel_op_279 = tmp_kernel_op_136*0.1381966011250105;
                const real_t tmp_kernel_op_280 = tmp_kernel_op_173*0.1381966011250105;
                const real_t tmp_kernel_op_281 = tmp_kernel_op_60*0.5854101966249684;
                const real_t tmp_kernel_op_282 = tmp_kernel_op_99*0.1381966011250105;
                const real_t tmp_kernel_op_283 = tmp_kernel_op_136*0.1381966011250105;
                const real_t tmp_kernel_op_284 = tmp_kernel_op_173*0.1381966011250105;
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_100*tmp_kernel_op_268 + tmp_kernel_op_137*tmp_kernel_op_270 + tmp_kernel_op_174*tmp_kernel_op_272 + tmp_kernel_op_266*tmp_kernel_op_61) + src_dof_1*(-tmp_kernel_op_100*tmp_kernel_op_110 - tmp_kernel_op_137*tmp_kernel_op_147 - tmp_kernel_op_174*tmp_kernel_op_184 - tmp_kernel_op_61*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_100*tmp_kernel_op_190 - tmp_kernel_op_137*tmp_kernel_op_193 - tmp_kernel_op_174*tmp_kernel_op_196 - tmp_kernel_op_187*tmp_kernel_op_61) + src_dof_3*(-tmp_kernel_op_100*tmp_kernel_op_202 - tmp_kernel_op_137*tmp_kernel_op_205 - tmp_kernel_op_174*tmp_kernel_op_208 - tmp_kernel_op_199*tmp_kernel_op_61) + src_dof_4*(tmp_kernel_op_100*tmp_kernel_op_214 + tmp_kernel_op_137*tmp_kernel_op_217 + tmp_kernel_op_174*tmp_kernel_op_220 + tmp_kernel_op_211*tmp_kernel_op_61) + src_dof_5*(tmp_kernel_op_100*tmp_kernel_op_226 + tmp_kernel_op_137*tmp_kernel_op_229 + tmp_kernel_op_174*tmp_kernel_op_232 + tmp_kernel_op_223*tmp_kernel_op_61) + src_dof_6*(tmp_kernel_op_100*tmp_kernel_op_238 + tmp_kernel_op_137*tmp_kernel_op_241 + tmp_kernel_op_174*tmp_kernel_op_244 + tmp_kernel_op_235*tmp_kernel_op_61) + src_dof_7*(tmp_kernel_op_100*tmp_kernel_op_248 + tmp_kernel_op_137*tmp_kernel_op_250 + tmp_kernel_op_174*tmp_kernel_op_252 + tmp_kernel_op_246*tmp_kernel_op_61) + src_dof_8*(tmp_kernel_op_100*tmp_kernel_op_256 + tmp_kernel_op_137*tmp_kernel_op_258 + tmp_kernel_op_174*tmp_kernel_op_260 + tmp_kernel_op_254*tmp_kernel_op_61) + src_dof_9*(tmp_kernel_op_100*tmp_kernel_op_262 + tmp_kernel_op_137*tmp_kernel_op_263 + tmp_kernel_op_174*tmp_kernel_op_264 + tmp_kernel_op_261*tmp_kernel_op_61);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_266*tmp_kernel_op_273 + tmp_kernel_op_268*tmp_kernel_op_274 + tmp_kernel_op_270*tmp_kernel_op_275 + tmp_kernel_op_272*tmp_kernel_op_276) + src_dof_1*(-tmp_kernel_op_110*tmp_kernel_op_274 - tmp_kernel_op_147*tmp_kernel_op_275 - tmp_kernel_op_184*tmp_kernel_op_276 - tmp_kernel_op_273*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_187*tmp_kernel_op_273 - tmp_kernel_op_190*tmp_kernel_op_274 - tmp_kernel_op_193*tmp_kernel_op_275 - tmp_kernel_op_196*tmp_kernel_op_276) + src_dof_3*(-tmp_kernel_op_199*tmp_kernel_op_273 - tmp_kernel_op_202*tmp_kernel_op_274 - tmp_kernel_op_205*tmp_kernel_op_275 - tmp_kernel_op_208*tmp_kernel_op_276) + src_dof_4*(tmp_kernel_op_211*tmp_kernel_op_273 + tmp_kernel_op_214*tmp_kernel_op_274 + tmp_kernel_op_217*tmp_kernel_op_275 + tmp_kernel_op_220*tmp_kernel_op_276) + src_dof_5*(tmp_kernel_op_223*tmp_kernel_op_273 + tmp_kernel_op_226*tmp_kernel_op_274 + tmp_kernel_op_229*tmp_kernel_op_275 + tmp_kernel_op_232*tmp_kernel_op_276) + src_dof_6*(tmp_kernel_op_235*tmp_kernel_op_273 + tmp_kernel_op_238*tmp_kernel_op_274 + tmp_kernel_op_241*tmp_kernel_op_275 + tmp_kernel_op_244*tmp_kernel_op_276) + src_dof_7*(tmp_kernel_op_246*tmp_kernel_op_273 + tmp_kernel_op_248*tmp_kernel_op_274 + tmp_kernel_op_250*tmp_kernel_op_275 + tmp_kernel_op_252*tmp_kernel_op_276) + src_dof_8*(tmp_kernel_op_254*tmp_kernel_op_273 + tmp_kernel_op_256*tmp_kernel_op_274 + tmp_kernel_op_258*tmp_kernel_op_275 + tmp_kernel_op_260*tmp_kernel_op_276) + src_dof_9*(tmp_kernel_op_261*tmp_kernel_op_273 + tmp_kernel_op_262*tmp_kernel_op_274 + tmp_kernel_op_263*tmp_kernel_op_275 + tmp_kernel_op_264*tmp_kernel_op_276);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_266*tmp_kernel_op_277 + tmp_kernel_op_268*tmp_kernel_op_278 + tmp_kernel_op_270*tmp_kernel_op_279 + tmp_kernel_op_272*tmp_kernel_op_280) + src_dof_1*(-tmp_kernel_op_110*tmp_kernel_op_278 - tmp_kernel_op_147*tmp_kernel_op_279 - tmp_kernel_op_184*tmp_kernel_op_280 - tmp_kernel_op_277*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_187*tmp_kernel_op_277 - tmp_kernel_op_190*tmp_kernel_op_278 - tmp_kernel_op_193*tmp_kernel_op_279 - tmp_kernel_op_196*tmp_kernel_op_280) + src_dof_3*(-tmp_kernel_op_199*tmp_kernel_op_277 - tmp_kernel_op_202*tmp_kernel_op_278 - tmp_kernel_op_205*tmp_kernel_op_279 - tmp_kernel_op_208*tmp_kernel_op_280) + src_dof_4*(tmp_kernel_op_211*tmp_kernel_op_277 + tmp_kernel_op_214*tmp_kernel_op_278 + tmp_kernel_op_217*tmp_kernel_op_279 + tmp_kernel_op_220*tmp_kernel_op_280) + src_dof_5*(tmp_kernel_op_223*tmp_kernel_op_277 + tmp_kernel_op_226*tmp_kernel_op_278 + tmp_kernel_op_229*tmp_kernel_op_279 + tmp_kernel_op_232*tmp_kernel_op_280) + src_dof_6*(tmp_kernel_op_235*tmp_kernel_op_277 + tmp_kernel_op_238*tmp_kernel_op_278 + tmp_kernel_op_241*tmp_kernel_op_279 + tmp_kernel_op_244*tmp_kernel_op_280) + src_dof_7*(tmp_kernel_op_246*tmp_kernel_op_277 + tmp_kernel_op_248*tmp_kernel_op_278 + tmp_kernel_op_250*tmp_kernel_op_279 + tmp_kernel_op_252*tmp_kernel_op_280) + src_dof_8*(tmp_kernel_op_254*tmp_kernel_op_277 + tmp_kernel_op_256*tmp_kernel_op_278 + tmp_kernel_op_258*tmp_kernel_op_279 + tmp_kernel_op_260*tmp_kernel_op_280) + src_dof_9*(tmp_kernel_op_261*tmp_kernel_op_277 + tmp_kernel_op_262*tmp_kernel_op_278 + tmp_kernel_op_263*tmp_kernel_op_279 + tmp_kernel_op_264*tmp_kernel_op_280);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_266*tmp_kernel_op_281 + tmp_kernel_op_268*tmp_kernel_op_282 + tmp_kernel_op_270*tmp_kernel_op_283 + tmp_kernel_op_272*tmp_kernel_op_284) + src_dof_1*(-tmp_kernel_op_110*tmp_kernel_op_282 - tmp_kernel_op_147*tmp_kernel_op_283 - tmp_kernel_op_184*tmp_kernel_op_284 - tmp_kernel_op_281*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_187*tmp_kernel_op_281 - tmp_kernel_op_190*tmp_kernel_op_282 - tmp_kernel_op_193*tmp_kernel_op_283 - tmp_kernel_op_196*tmp_kernel_op_284) + src_dof_3*(-tmp_kernel_op_199*tmp_kernel_op_281 - tmp_kernel_op_202*tmp_kernel_op_282 - tmp_kernel_op_205*tmp_kernel_op_283 - tmp_kernel_op_208*tmp_kernel_op_284) + src_dof_4*(tmp_kernel_op_211*tmp_kernel_op_281 + tmp_kernel_op_214*tmp_kernel_op_282 + tmp_kernel_op_217*tmp_kernel_op_283 + tmp_kernel_op_220*tmp_kernel_op_284) + src_dof_5*(tmp_kernel_op_223*tmp_kernel_op_281 + tmp_kernel_op_226*tmp_kernel_op_282 + tmp_kernel_op_229*tmp_kernel_op_283 + tmp_kernel_op_232*tmp_kernel_op_284) + src_dof_6*(tmp_kernel_op_235*tmp_kernel_op_281 + tmp_kernel_op_238*tmp_kernel_op_282 + tmp_kernel_op_241*tmp_kernel_op_283 + tmp_kernel_op_244*tmp_kernel_op_284) + src_dof_7*(tmp_kernel_op_246*tmp_kernel_op_281 + tmp_kernel_op_248*tmp_kernel_op_282 + tmp_kernel_op_250*tmp_kernel_op_283 + tmp_kernel_op_252*tmp_kernel_op_284) + src_dof_8*(tmp_kernel_op_254*tmp_kernel_op_281 + tmp_kernel_op_256*tmp_kernel_op_282 + tmp_kernel_op_258*tmp_kernel_op_283 + tmp_kernel_op_260*tmp_kernel_op_284) + src_dof_9*(tmp_kernel_op_261*tmp_kernel_op_281 + tmp_kernel_op_262*tmp_kernel_op_282 + tmp_kernel_op_263*tmp_kernel_op_283 + tmp_kernel_op_264*tmp_kernel_op_284);
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             }
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       {
          /* CellType.GREEN_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_0 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0);
                const __m256d tmp_kernel_op_1 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0);
                const __m256d tmp_kernel_op_2 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0);
                const __m256d tmp_kernel_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_kernel_op_4 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1);
                const __m256d tmp_kernel_op_5 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1);
                const __m256d tmp_kernel_op_6 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1);
                const __m256d tmp_kernel_op_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_kernel_op_8 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2);
                const __m256d tmp_kernel_op_9 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2);
                const __m256d tmp_kernel_op_10 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2);
                const __m256d tmp_kernel_op_11 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_kernel_op_12 = _mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_3);
                const __m256d tmp_kernel_op_13 = _mm256_mul_pd(tmp_kernel_op_7,tmp_kernel_op_7);
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_11);
                const __m256d tmp_kernel_op_15 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_12,tmp_kernel_op_13),tmp_kernel_op_14);
                const __m256d tmp_kernel_op_16 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_15),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_15,tmp_kernel_op_15),tmp_kernel_op_15),tmp_kernel_op_15),tmp_kernel_op_15));
                const __m256d tmp_kernel_op_38 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_11,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_39 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_40 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_41 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_39,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_39,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_42 = _mm256_mul_pd(tmp_kernel_op_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_45 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_48 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_7),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_7,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_41)),_mm256_mul_pd(tmp_kernel_op_13,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_51 = _mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_53 = _mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_54 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_43),tmp_kernel_op_53);
                const __m256d tmp_kernel_op_55 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_11,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_41)),_mm256_mul_pd(tmp_kernel_op_14,tmp_kernel_op_42));
                const __m256d tmp_kernel_op_56 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_51),tmp_kernel_op_7);
                const __m256d tmp_kernel_op_57 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_41)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_12,tmp_kernel_op_41),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_58 = _mm256_mul_pd(tmp_kernel_op_57,tmp_kernel_op_7);
                const __m256d tmp_kernel_op_59 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_54),tmp_kernel_op_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_51),tmp_kernel_op_54),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_53,tmp_kernel_op_55),tmp_kernel_op_56),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_16,tmp_kernel_op_50),tmp_kernel_op_55),tmp_kernel_op_57),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_11,tmp_kernel_op_16),tmp_kernel_op_3),tmp_kernel_op_43),tmp_kernel_op_45),tmp_kernel_op_48),tmp_kernel_op_7),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_60 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_59))));
                const __m256d tmp_kernel_op_61 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.13819660112501053,0.13819660112501053,0.13819660112501053,0.13819660112501053));
                const __m256d tmp_kernel_op_62 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_59);
                const __m256d tmp_kernel_op_63 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_15),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_15)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_15));
                const __m256d tmp_kernel_op_66 = _mm256_mul_pd(tmp_kernel_op_63,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_67 = _mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_66);
                const __m256d tmp_kernel_op_68 = _mm256_mul_pd(tmp_kernel_op_62,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_58,tmp_kernel_op_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_43),tmp_kernel_op_45),tmp_kernel_op_63),tmp_kernel_op_7),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_69 = _mm256_mul_pd(tmp_kernel_op_62,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_50),tmp_kernel_op_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,tmp_kernel_op_43),tmp_kernel_op_48),tmp_kernel_op_63),tmp_kernel_op_7),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_70 = _mm256_mul_pd(tmp_kernel_op_62,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_56,tmp_kernel_op_66),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_57),tmp_kernel_op_66)));
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)));
                const __m256d tmp_kernel_op_73 = _mm256_mul_pd(tmp_kernel_op_71,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72)));
                const __m256d tmp_kernel_op_74 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_kernel_op_75 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_kernel_op_76 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_kernel_op_77 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_74);
                const __m256d tmp_kernel_op_78 = _mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_75);
                const __m256d tmp_kernel_op_79 = _mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_76);
                const __m256d tmp_kernel_op_80 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_77,tmp_kernel_op_78),tmp_kernel_op_79);
                const __m256d tmp_kernel_op_81 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_80),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_80,tmp_kernel_op_80),tmp_kernel_op_80),tmp_kernel_op_80),tmp_kernel_op_80));
                const __m256d tmp_kernel_op_82 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_76,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_83 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_74,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_75,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_85 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_82,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_83,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_82,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_86 = _mm256_mul_pd(tmp_kernel_op_85,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_87 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_88 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_89 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_90 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_75,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_91 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_88);
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_81,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_93 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_87),tmp_kernel_op_92);
                const __m256d tmp_kernel_op_94 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_76,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_85)),_mm256_mul_pd(tmp_kernel_op_79,tmp_kernel_op_86));
                const __m256d tmp_kernel_op_95 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_89),tmp_kernel_op_91);
                const __m256d tmp_kernel_op_96 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_80,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_74,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_85)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_77,tmp_kernel_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_97 = _mm256_mul_pd(tmp_kernel_op_75,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_98 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_89,tmp_kernel_op_93),tmp_kernel_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_90,tmp_kernel_op_91),tmp_kernel_op_93),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_92,tmp_kernel_op_94),tmp_kernel_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_81,tmp_kernel_op_90),tmp_kernel_op_94),tmp_kernel_op_96),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_75),tmp_kernel_op_76),tmp_kernel_op_81),tmp_kernel_op_87),tmp_kernel_op_88),tmp_kernel_op_89),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_99 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_98))));
                const __m256d tmp_kernel_op_100 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_101 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_98);
                const __m256d tmp_kernel_op_102 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_80),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_80)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_80));
                const __m256d tmp_kernel_op_103 = _mm256_mul_pd(tmp_kernel_op_102,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_104 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_105 = _mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_74),tmp_kernel_op_75),tmp_kernel_op_87),tmp_kernel_op_88),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_106 = _mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_74),tmp_kernel_op_90),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_74),tmp_kernel_op_75),tmp_kernel_op_87),tmp_kernel_op_89),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_107 = _mm256_mul_pd(tmp_kernel_op_101,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_90),tmp_kernel_op_96)));
                const __m256d tmp_kernel_op_108 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_mul_pd(tmp_kernel_op_105,_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)));
                const __m256d tmp_kernel_op_110 = _mm256_mul_pd(tmp_kernel_op_108,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)));
                const __m256d tmp_kernel_op_111 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_0);
                const __m256d tmp_kernel_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_1);
                const __m256d tmp_kernel_op_113 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684))),p_affine_0_2);
                const __m256d tmp_kernel_op_114 = _mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_111);
                const __m256d tmp_kernel_op_115 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_112);
                const __m256d tmp_kernel_op_116 = _mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_113);
                const __m256d tmp_kernel_op_117 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_114,tmp_kernel_op_115),tmp_kernel_op_116);
                const __m256d tmp_kernel_op_118 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_117),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_117,tmp_kernel_op_117),tmp_kernel_op_117),tmp_kernel_op_117),tmp_kernel_op_117));
                const __m256d tmp_kernel_op_119 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_120 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_111,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_121 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_112,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_122 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_119,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_121,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_121,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_119,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_123 = _mm256_mul_pd(tmp_kernel_op_122,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_124 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_125 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_126 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_122),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_127 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_112,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_122)),_mm256_mul_pd(tmp_kernel_op_115,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_128 = _mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_125);
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(tmp_kernel_op_118,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_130 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_124),tmp_kernel_op_129);
                const __m256d tmp_kernel_op_131 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_122)),_mm256_mul_pd(tmp_kernel_op_116,tmp_kernel_op_123));
                const __m256d tmp_kernel_op_132 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_126),tmp_kernel_op_128);
                const __m256d tmp_kernel_op_133 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_111,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_122)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_114,tmp_kernel_op_122),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_134 = _mm256_mul_pd(tmp_kernel_op_112,tmp_kernel_op_133);
                const __m256d tmp_kernel_op_135 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_130),tmp_kernel_op_134),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_128),tmp_kernel_op_130),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_129,tmp_kernel_op_131),tmp_kernel_op_132),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_127),tmp_kernel_op_131),tmp_kernel_op_133),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_112),tmp_kernel_op_113),tmp_kernel_op_118),tmp_kernel_op_124),tmp_kernel_op_125),tmp_kernel_op_126),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_135))));
                const __m256d tmp_kernel_op_137 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.13819660112501056,0.13819660112501056,0.13819660112501056,0.13819660112501056));
                const __m256d tmp_kernel_op_138 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_135);
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_117),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_117)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_117));
                const __m256d tmp_kernel_op_140 = _mm256_mul_pd(tmp_kernel_op_139,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_141 = _mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_140);
                const __m256d tmp_kernel_op_142 = _mm256_mul_pd(tmp_kernel_op_138,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_141),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_112),tmp_kernel_op_124),tmp_kernel_op_125),tmp_kernel_op_139),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_143 = _mm256_mul_pd(tmp_kernel_op_138,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_127),tmp_kernel_op_141),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_112),tmp_kernel_op_124),tmp_kernel_op_126),tmp_kernel_op_139),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_144 = _mm256_mul_pd(tmp_kernel_op_138,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_140),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_133),tmp_kernel_op_140)));
                const __m256d tmp_kernel_op_145 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN))),_mm256_mul_pd(tmp_kernel_op_144,_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)));
                const __m256d tmp_kernel_op_147 = _mm256_mul_pd(tmp_kernel_op_145,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146)));
                const __m256d tmp_kernel_op_148 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_0,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_1,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_2,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_0);
                const __m256d tmp_kernel_op_149 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_4,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_5,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_6,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_1);
                const __m256d tmp_kernel_op_150 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105)),_mm256_mul_pd(tmp_kernel_op_8,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),_mm256_mul_pd(tmp_kernel_op_9,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105))),p_affine_0_2);
                const __m256d tmp_kernel_op_151 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_148);
                const __m256d tmp_kernel_op_152 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_149);
                const __m256d tmp_kernel_op_153 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_150);
                const __m256d tmp_kernel_op_154 = _mm256_add_pd(_mm256_add_pd(tmp_kernel_op_151,tmp_kernel_op_152),tmp_kernel_op_153);
                const __m256d tmp_kernel_op_155 = _mm256_div_pd(_mm256_sqrt_pd(tmp_kernel_op_154),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_154),tmp_kernel_op_154),tmp_kernel_op_154),tmp_kernel_op_154));
                const __m256d tmp_kernel_op_156 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29)),_mm256_mul_pd(tmp_kernel_op_150,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_157 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18,tmp_kernel_op_18)),_mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_158 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)),_mm256_mul_pd(tmp_kernel_op_149,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_159 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_156,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_156,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)),_mm256_set_pd(tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27,tmp_kernel_op_27))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37));
                const __m256d tmp_kernel_op_160 = _mm256_mul_pd(tmp_kernel_op_159,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_kernel_op_161 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_162 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_163 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_164 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_149,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),tmp_kernel_op_159)),_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_165 = _mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_162);
                const __m256d tmp_kernel_op_166 = _mm256_mul_pd(tmp_kernel_op_155,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52));
                const __m256d tmp_kernel_op_167 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_161),tmp_kernel_op_166);
                const __m256d tmp_kernel_op_168 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_150,_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),tmp_kernel_op_159)),_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_160));
                const __m256d tmp_kernel_op_169 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_163),tmp_kernel_op_165);
                const __m256d tmp_kernel_op_170 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_154,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),tmp_kernel_op_159)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_171 = _mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_170);
                const __m256d tmp_kernel_op_172 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_163,tmp_kernel_op_167),tmp_kernel_op_171),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_164,tmp_kernel_op_165),tmp_kernel_op_167),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_166,tmp_kernel_op_168),tmp_kernel_op_169),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_164),tmp_kernel_op_168),tmp_kernel_op_170),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_149),tmp_kernel_op_150),tmp_kernel_op_155),tmp_kernel_op_161),tmp_kernel_op_162),tmp_kernel_op_163),_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d tmp_kernel_op_173 = _mm256_mul_pd(_mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_set_pd(abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN)),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_172))));
                const __m256d tmp_kernel_op_174 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_175 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_172);
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(_mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_154),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_154)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_154));
                const __m256d tmp_kernel_op_177 = _mm256_mul_pd(tmp_kernel_op_176,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_178 = _mm256_mul_pd(tmp_kernel_op_161,tmp_kernel_op_177);
                const __m256d tmp_kernel_op_179 = _mm256_mul_pd(tmp_kernel_op_175,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_171,tmp_kernel_op_178),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_149),tmp_kernel_op_161),tmp_kernel_op_162),tmp_kernel_op_176),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_180 = _mm256_mul_pd(tmp_kernel_op_175,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_164),tmp_kernel_op_178),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_149),tmp_kernel_op_161),tmp_kernel_op_163),tmp_kernel_op_176),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))));
                const __m256d tmp_kernel_op_181 = _mm256_mul_pd(tmp_kernel_op_175,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_169,tmp_kernel_op_177),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_164,tmp_kernel_op_170),tmp_kernel_op_177)));
                const __m256d tmp_kernel_op_182 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN)),_mm256_mul_pd(tmp_kernel_op_179,_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN))),_mm256_mul_pd(tmp_kernel_op_181,_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN)));
                const __m256d tmp_kernel_op_184 = _mm256_mul_pd(tmp_kernel_op_182,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183)));
                const __m256d tmp_kernel_op_185 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)));
                const __m256d tmp_kernel_op_187 = _mm256_mul_pd(tmp_kernel_op_185,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186)));
                const __m256d tmp_kernel_op_188 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_mul_pd(tmp_kernel_op_105,_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)));
                const __m256d tmp_kernel_op_190 = _mm256_mul_pd(tmp_kernel_op_188,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189)));
                const __m256d tmp_kernel_op_191 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN))),_mm256_mul_pd(tmp_kernel_op_144,_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)));
                const __m256d tmp_kernel_op_193 = _mm256_mul_pd(tmp_kernel_op_191,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192)));
                const __m256d tmp_kernel_op_194 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_mul_pd(tmp_kernel_op_179,_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN))),_mm256_mul_pd(tmp_kernel_op_181,_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)));
                const __m256d tmp_kernel_op_196 = _mm256_mul_pd(tmp_kernel_op_194,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195)));
                const __m256d tmp_kernel_op_197 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_69,_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)));
                const __m256d tmp_kernel_op_199 = _mm256_mul_pd(tmp_kernel_op_197,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198)));
                const __m256d tmp_kernel_op_200 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_106,_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_mul_pd(tmp_kernel_op_105,_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)));
                const __m256d tmp_kernel_op_202 = _mm256_mul_pd(tmp_kernel_op_200,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201)));
                const __m256d tmp_kernel_op_203 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_mul_pd(tmp_kernel_op_142,_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_mul_pd(tmp_kernel_op_144,_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)));
                const __m256d tmp_kernel_op_205 = _mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204)));
                const __m256d tmp_kernel_op_206 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_mul_pd(tmp_kernel_op_179,_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_mul_pd(tmp_kernel_op_181,_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)));
                const __m256d tmp_kernel_op_208 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_add_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207)));
                const __m256d tmp_kernel_op_209 = _mm256_mul_pd(tmp_kernel_op_197,_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186));
                const __m256d tmp_kernel_op_210 = _mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198));
                const __m256d tmp_kernel_op_211 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_209,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_210,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_212 = _mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189));
                const __m256d tmp_kernel_op_213 = _mm256_mul_pd(tmp_kernel_op_188,_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201));
                const __m256d tmp_kernel_op_214 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_212,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_213,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_215 = _mm256_mul_pd(tmp_kernel_op_203,_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192));
                const __m256d tmp_kernel_op_216 = _mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204));
                const __m256d tmp_kernel_op_217 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_215,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_216,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_218 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195));
                const __m256d tmp_kernel_op_219 = _mm256_mul_pd(tmp_kernel_op_194,_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207));
                const __m256d tmp_kernel_op_220 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_218,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_219,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_221 = _mm256_mul_pd(tmp_kernel_op_197,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72));
                const __m256d tmp_kernel_op_222 = _mm256_mul_pd(tmp_kernel_op_71,_mm256_set_pd(tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198,tmp_kernel_op_198));
                const __m256d tmp_kernel_op_223 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_222,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_224 = _mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_225 = _mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201,tmp_kernel_op_201));
                const __m256d tmp_kernel_op_226 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_224,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_225,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_227 = _mm256_mul_pd(tmp_kernel_op_203,_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146));
                const __m256d tmp_kernel_op_228 = _mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204,tmp_kernel_op_204));
                const __m256d tmp_kernel_op_229 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_227,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_228,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_230 = _mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183));
                const __m256d tmp_kernel_op_231 = _mm256_mul_pd(tmp_kernel_op_182,_mm256_set_pd(tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207,tmp_kernel_op_207));
                const __m256d tmp_kernel_op_232 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_230,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_231,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_233 = _mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72));
                const __m256d tmp_kernel_op_234 = _mm256_mul_pd(tmp_kernel_op_71,_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186));
                const __m256d tmp_kernel_op_235 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_233,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_234,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_236 = _mm256_mul_pd(tmp_kernel_op_188,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_237 = _mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189));
                const __m256d tmp_kernel_op_238 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_236,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_237,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_239 = _mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146));
                const __m256d tmp_kernel_op_240 = _mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192));
                const __m256d tmp_kernel_op_241 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_239,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_240,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_242 = _mm256_mul_pd(tmp_kernel_op_194,_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183));
                const __m256d tmp_kernel_op_243 = _mm256_mul_pd(tmp_kernel_op_182,_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195));
                const __m256d tmp_kernel_op_244 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_243,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_246 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245)),_mm256_set_pd(-0.68328157299974723,-0.68328157299974723,-0.68328157299974723,-0.68328157299974723))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_210),tmp_kernel_op_222);
                const __m256d tmp_kernel_op_248 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_200,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247)),_mm256_set_pd(2.8944271909999157,2.8944271909999157,2.8944271909999157,2.8944271909999157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_213),tmp_kernel_op_225);
                const __m256d tmp_kernel_op_250 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_203,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249)),_mm256_set_pd(2.8944271909999157,2.8944271909999157,2.8944271909999157,2.8944271909999157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_216),tmp_kernel_op_228);
                const __m256d tmp_kernel_op_252 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_206,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251)),_mm256_set_pd(2.8944271909999157,2.8944271909999157,2.8944271909999157,2.8944271909999157))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_219),tmp_kernel_op_231);
                const __m256d tmp_kernel_op_254 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_209),tmp_kernel_op_234);
                const __m256d tmp_kernel_op_256 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_188,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))),_mm256_set_pd(-4.6832815729997472,-4.6832815729997472,-4.6832815729997472,-4.6832815729997472))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_212),tmp_kernel_op_237);
                const __m256d tmp_kernel_op_258 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_191,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_215),tmp_kernel_op_240);
                const __m256d tmp_kernel_op_260 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183,tmp_kernel_op_183)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_218),tmp_kernel_op_243);
                const __m256d tmp_kernel_op_261 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186,tmp_kernel_op_186)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_221),tmp_kernel_op_233);
                const __m256d tmp_kernel_op_262 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_108,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189,tmp_kernel_op_189)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_224),tmp_kernel_op_236);
                const __m256d tmp_kernel_op_263 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_145,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192,tmp_kernel_op_192)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257))),_mm256_set_pd(-4.6832815729997472,-4.6832815729997472,-4.6832815729997472,-4.6832815729997472))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_227),tmp_kernel_op_239);
                const __m256d tmp_kernel_op_264 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_182,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195,tmp_kernel_op_195)),_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))),_mm256_set_pd(-1.105572809000084,-1.105572809000084,-1.105572809000084,-1.105572809000084))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_230),tmp_kernel_op_242);
                const __m256d tmp_kernel_op_266 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265,tmp_kernel_op_265)));
                const __m256d tmp_kernel_op_268 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_188,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267)));
                const __m256d tmp_kernel_op_270 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_191,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_203,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269)));
                const __m256d tmp_kernel_op_272 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_182,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_206,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271,tmp_kernel_op_271)));
                const __m256d tmp_kernel_op_273 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_274 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_275 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_276 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_277 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_278 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_279 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_280 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_281 = _mm256_mul_pd(tmp_kernel_op_60,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_282 = _mm256_mul_pd(tmp_kernel_op_99,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_283 = _mm256_mul_pd(tmp_kernel_op_136,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_284 = _mm256_mul_pd(tmp_kernel_op_173,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_214),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_217)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_220)),_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_61))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_226),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_229)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_232)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_238),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_241)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_244)),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_248),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_250)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_252)),_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_256),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_258)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_260)),_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_262),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_263)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_264)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_268),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_270)),_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_272)),_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_61)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_110),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_184),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_61,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_190),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_193),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_196),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_202),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_205),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_174,tmp_kernel_op_208),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_276))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_232,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_241,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_258,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_262,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_273),_mm256_mul_pd(tmp_kernel_op_268,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_270,tmp_kernel_op_275)),_mm256_mul_pd(tmp_kernel_op_272,tmp_kernel_op_276)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_110,tmp_kernel_op_274),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_275),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_276),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_273,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_273),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_190,tmp_kernel_op_274),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_275),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_276),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_273),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_274),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_275),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_276),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_280))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_232,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_241,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_258,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_262,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_277),_mm256_mul_pd(tmp_kernel_op_268,tmp_kernel_op_278)),_mm256_mul_pd(tmp_kernel_op_270,tmp_kernel_op_279)),_mm256_mul_pd(tmp_kernel_op_272,tmp_kernel_op_280)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_110,tmp_kernel_op_278),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_279),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_280),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_277),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_190,tmp_kernel_op_278),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_279),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_280),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_277),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_278),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_279),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_280),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_284))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_232,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_241,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_258,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_262,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_266,tmp_kernel_op_281),_mm256_mul_pd(tmp_kernel_op_268,tmp_kernel_op_282)),_mm256_mul_pd(tmp_kernel_op_270,tmp_kernel_op_283)),_mm256_mul_pd(tmp_kernel_op_272,tmp_kernel_op_284)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_110,tmp_kernel_op_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_147,tmp_kernel_op_283),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_284),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_281,tmp_kernel_op_73),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_187,tmp_kernel_op_281),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_190,tmp_kernel_op_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_193,tmp_kernel_op_283),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_196,tmp_kernel_op_284),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_199,tmp_kernel_op_281),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_283),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_284),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_0 = -p_affine_0_0 + p_affine_1_0;
                const real_t tmp_kernel_op_1 = -p_affine_0_0 + p_affine_2_0;
                const real_t tmp_kernel_op_2 = -p_affine_0_0 + p_affine_3_0;
                const real_t tmp_kernel_op_3 = p_affine_0_0 + tmp_kernel_op_0*0.1381966011250105 + tmp_kernel_op_1*0.1381966011250105 + tmp_kernel_op_2*0.5854101966249684;
                const real_t tmp_kernel_op_4 = -p_affine_0_1 + p_affine_1_1;
                const real_t tmp_kernel_op_5 = -p_affine_0_1 + p_affine_2_1;
                const real_t tmp_kernel_op_6 = -p_affine_0_1 + p_affine_3_1;
                const real_t tmp_kernel_op_7 = p_affine_0_1 + tmp_kernel_op_4*0.1381966011250105 + tmp_kernel_op_5*0.1381966011250105 + tmp_kernel_op_6*0.5854101966249684;
                const real_t tmp_kernel_op_8 = -p_affine_0_2 + p_affine_1_2;
                const real_t tmp_kernel_op_9 = -p_affine_0_2 + p_affine_2_2;
                const real_t tmp_kernel_op_10 = -p_affine_0_2 + p_affine_3_2;
                const real_t tmp_kernel_op_11 = p_affine_0_2 + tmp_kernel_op_10*0.5854101966249684 + tmp_kernel_op_8*0.1381966011250105 + tmp_kernel_op_9*0.1381966011250105;
                const real_t tmp_kernel_op_12 = (tmp_kernel_op_3*tmp_kernel_op_3);
                const real_t tmp_kernel_op_13 = (tmp_kernel_op_7*tmp_kernel_op_7);
                const real_t tmp_kernel_op_14 = (tmp_kernel_op_11*tmp_kernel_op_11);
                const real_t tmp_kernel_op_15 = tmp_kernel_op_12 + tmp_kernel_op_13 + tmp_kernel_op_14;
                const real_t tmp_kernel_op_16 = pow(tmp_kernel_op_15, -4.5000000000000000);
                const real_t tmp_kernel_op_38 = -tmp_kernel_op_11 - tmp_kernel_op_29;
                const real_t tmp_kernel_op_39 = -tmp_kernel_op_18 - tmp_kernel_op_3;
                const real_t tmp_kernel_op_40 = -tmp_kernel_op_25 - tmp_kernel_op_7;
                const real_t tmp_kernel_op_41 = -tmp_kernel_op_35*(tmp_kernel_op_19*tmp_kernel_op_20*tmp_kernel_op_40 + tmp_kernel_op_23*tmp_kernel_op_30*tmp_kernel_op_39 - tmp_kernel_op_24*tmp_kernel_op_38 + tmp_kernel_op_26*tmp_kernel_op_27*tmp_kernel_op_38 - tmp_kernel_op_31*tmp_kernel_op_39 - tmp_kernel_op_32*tmp_kernel_op_40) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_42 = -tmp_kernel_op_41;
                const real_t tmp_kernel_op_43 = tmp_kernel_op_11*tmp_kernel_op_42 + tmp_kernel_op_15*tmp_kernel_op_36;
                const real_t tmp_kernel_op_45 = tmp_kernel_op_15*tmp_kernel_op_44 + tmp_kernel_op_3*tmp_kernel_op_42;
                const real_t tmp_kernel_op_48 = -tmp_kernel_op_15*tmp_kernel_op_47 - tmp_kernel_op_41*tmp_kernel_op_7;
                const real_t tmp_kernel_op_50 = tmp_kernel_op_13*tmp_kernel_op_42 + tmp_kernel_op_15*(tmp_kernel_op_41 + tmp_kernel_op_49*tmp_kernel_op_7);
                const real_t tmp_kernel_op_51 = tmp_kernel_op_3*tmp_kernel_op_45;
                const real_t tmp_kernel_op_53 = tmp_kernel_op_16*tmp_kernel_op_52;
                const real_t tmp_kernel_op_54 = tmp_kernel_op_11*tmp_kernel_op_43*tmp_kernel_op_53;
                const real_t tmp_kernel_op_55 = tmp_kernel_op_14*tmp_kernel_op_42 + tmp_kernel_op_15*(tmp_kernel_op_11*tmp_kernel_op_36 + tmp_kernel_op_41);
                const real_t tmp_kernel_op_56 = tmp_kernel_op_48*tmp_kernel_op_51*tmp_kernel_op_7;
                const real_t tmp_kernel_op_57 = -tmp_kernel_op_12*tmp_kernel_op_41 + tmp_kernel_op_15*(tmp_kernel_op_3*tmp_kernel_op_44 + tmp_kernel_op_41);
                const real_t tmp_kernel_op_58 = tmp_kernel_op_57*tmp_kernel_op_7;
                const real_t tmp_kernel_op_59 = tmp_kernel_op_11*tmp_kernel_op_16*tmp_kernel_op_3*tmp_kernel_op_34*tmp_kernel_op_43*tmp_kernel_op_45*tmp_kernel_op_48*tmp_kernel_op_7*2.0 + tmp_kernel_op_16*tmp_kernel_op_34*tmp_kernel_op_50*tmp_kernel_op_55*tmp_kernel_op_57*1.0 - tmp_kernel_op_48*tmp_kernel_op_54*tmp_kernel_op_58 - tmp_kernel_op_50*tmp_kernel_op_51*tmp_kernel_op_54 - tmp_kernel_op_53*tmp_kernel_op_55*tmp_kernel_op_56;
                const real_t tmp_kernel_op_60 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657*abs(tmp_kernel_op_59);
                const real_t tmp_kernel_op_61 = tmp_kernel_op_60*0.13819660112501053;
                const real_t tmp_kernel_op_62 = 1.0 / (tmp_kernel_op_59);
                const real_t tmp_kernel_op_63 = 1.0 / (tmp_kernel_op_15*tmp_kernel_op_15*tmp_kernel_op_15);
                const real_t tmp_kernel_op_66 = tmp_kernel_op_63*tmp_kernel_op_65;
                const real_t tmp_kernel_op_67 = tmp_kernel_op_43*tmp_kernel_op_66;
                const real_t tmp_kernel_op_68 = tmp_kernel_op_62*(tmp_kernel_op_3*tmp_kernel_op_43*tmp_kernel_op_45*tmp_kernel_op_63*tmp_kernel_op_64*tmp_kernel_op_7*1.0 - tmp_kernel_op_58*tmp_kernel_op_67);
                const real_t tmp_kernel_op_69 = tmp_kernel_op_62*(tmp_kernel_op_3*tmp_kernel_op_43*tmp_kernel_op_48*tmp_kernel_op_63*tmp_kernel_op_64*tmp_kernel_op_7*1.0 - tmp_kernel_op_3*tmp_kernel_op_50*tmp_kernel_op_67);
                const real_t tmp_kernel_op_70 = tmp_kernel_op_62*(tmp_kernel_op_50*tmp_kernel_op_57*tmp_kernel_op_66 - tmp_kernel_op_56*tmp_kernel_op_66);
                const real_t tmp_kernel_op_71 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_69 + jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_68 + jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_70;
                const real_t tmp_kernel_op_73 = tmp_kernel_op_71*(tmp_kernel_op_72 - 1.0);
                const real_t tmp_kernel_op_74 = p_affine_0_0 + tmp_kernel_op_0*0.1381966011250105 + tmp_kernel_op_1*0.5854101966249684 + tmp_kernel_op_2*0.1381966011250105;
                const real_t tmp_kernel_op_75 = p_affine_0_1 + tmp_kernel_op_4*0.1381966011250105 + tmp_kernel_op_5*0.5854101966249684 + tmp_kernel_op_6*0.1381966011250105;
                const real_t tmp_kernel_op_76 = p_affine_0_2 + tmp_kernel_op_10*0.1381966011250105 + tmp_kernel_op_8*0.1381966011250105 + tmp_kernel_op_9*0.5854101966249684;
                const real_t tmp_kernel_op_77 = (tmp_kernel_op_74*tmp_kernel_op_74);
                const real_t tmp_kernel_op_78 = (tmp_kernel_op_75*tmp_kernel_op_75);
                const real_t tmp_kernel_op_79 = (tmp_kernel_op_76*tmp_kernel_op_76);
                const real_t tmp_kernel_op_80 = tmp_kernel_op_77 + tmp_kernel_op_78 + tmp_kernel_op_79;
                const real_t tmp_kernel_op_81 = pow(tmp_kernel_op_80, -4.5000000000000000);
                const real_t tmp_kernel_op_82 = -tmp_kernel_op_29 - tmp_kernel_op_76;
                const real_t tmp_kernel_op_83 = -tmp_kernel_op_18 - tmp_kernel_op_74;
                const real_t tmp_kernel_op_84 = -tmp_kernel_op_25 - tmp_kernel_op_75;
                const real_t tmp_kernel_op_85 = -tmp_kernel_op_35*(tmp_kernel_op_19*tmp_kernel_op_20*tmp_kernel_op_84 + tmp_kernel_op_23*tmp_kernel_op_30*tmp_kernel_op_83 - tmp_kernel_op_24*tmp_kernel_op_82 + tmp_kernel_op_26*tmp_kernel_op_27*tmp_kernel_op_82 - tmp_kernel_op_31*tmp_kernel_op_83 - tmp_kernel_op_32*tmp_kernel_op_84) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_86 = -tmp_kernel_op_85;
                const real_t tmp_kernel_op_87 = tmp_kernel_op_36*tmp_kernel_op_80 + tmp_kernel_op_76*tmp_kernel_op_86;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_44*tmp_kernel_op_80 + tmp_kernel_op_74*tmp_kernel_op_86;
                const real_t tmp_kernel_op_89 = -tmp_kernel_op_47*tmp_kernel_op_80 - tmp_kernel_op_75*tmp_kernel_op_85;
                const real_t tmp_kernel_op_90 = tmp_kernel_op_78*tmp_kernel_op_86 + tmp_kernel_op_80*(tmp_kernel_op_49*tmp_kernel_op_75 + tmp_kernel_op_85);
                const real_t tmp_kernel_op_91 = tmp_kernel_op_74*tmp_kernel_op_88;
                const real_t tmp_kernel_op_92 = tmp_kernel_op_52*tmp_kernel_op_81;
                const real_t tmp_kernel_op_93 = tmp_kernel_op_76*tmp_kernel_op_87*tmp_kernel_op_92;
                const real_t tmp_kernel_op_94 = tmp_kernel_op_79*tmp_kernel_op_86 + tmp_kernel_op_80*(tmp_kernel_op_36*tmp_kernel_op_76 + tmp_kernel_op_85);
                const real_t tmp_kernel_op_95 = tmp_kernel_op_75*tmp_kernel_op_89*tmp_kernel_op_91;
                const real_t tmp_kernel_op_96 = -tmp_kernel_op_77*tmp_kernel_op_85 + tmp_kernel_op_80*(tmp_kernel_op_44*tmp_kernel_op_74 + tmp_kernel_op_85);
                const real_t tmp_kernel_op_97 = tmp_kernel_op_75*tmp_kernel_op_96;
                const real_t tmp_kernel_op_98 = tmp_kernel_op_34*tmp_kernel_op_74*tmp_kernel_op_75*tmp_kernel_op_76*tmp_kernel_op_81*tmp_kernel_op_87*tmp_kernel_op_88*tmp_kernel_op_89*2.0 + tmp_kernel_op_34*tmp_kernel_op_81*tmp_kernel_op_90*tmp_kernel_op_94*tmp_kernel_op_96*1.0 - tmp_kernel_op_89*tmp_kernel_op_93*tmp_kernel_op_97 - tmp_kernel_op_90*tmp_kernel_op_91*tmp_kernel_op_93 - tmp_kernel_op_92*tmp_kernel_op_94*tmp_kernel_op_95;
                const real_t tmp_kernel_op_99 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657*abs(tmp_kernel_op_98);
                const real_t tmp_kernel_op_100 = tmp_kernel_op_99*0.13819660112501056;
                const real_t tmp_kernel_op_101 = 1.0 / (tmp_kernel_op_98);
                const real_t tmp_kernel_op_102 = 1.0 / (tmp_kernel_op_80*tmp_kernel_op_80*tmp_kernel_op_80);
                const real_t tmp_kernel_op_103 = tmp_kernel_op_102*tmp_kernel_op_65;
                const real_t tmp_kernel_op_104 = tmp_kernel_op_103*tmp_kernel_op_87;
                const real_t tmp_kernel_op_105 = tmp_kernel_op_101*(tmp_kernel_op_102*tmp_kernel_op_64*tmp_kernel_op_74*tmp_kernel_op_75*tmp_kernel_op_87*tmp_kernel_op_88*1.0 - tmp_kernel_op_104*tmp_kernel_op_97);
                const real_t tmp_kernel_op_106 = tmp_kernel_op_101*(tmp_kernel_op_102*tmp_kernel_op_64*tmp_kernel_op_74*tmp_kernel_op_75*tmp_kernel_op_87*tmp_kernel_op_89*1.0 - tmp_kernel_op_104*tmp_kernel_op_74*tmp_kernel_op_90);
                const real_t tmp_kernel_op_107 = tmp_kernel_op_101*(tmp_kernel_op_103*tmp_kernel_op_90*tmp_kernel_op_96 - tmp_kernel_op_103*tmp_kernel_op_95);
                const real_t tmp_kernel_op_108 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_106 + jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_105 + jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_107;
                const real_t tmp_kernel_op_110 = tmp_kernel_op_108*(tmp_kernel_op_109 - 1.0);
                const real_t tmp_kernel_op_111 = p_affine_0_0 + tmp_kernel_op_0*0.5854101966249684 + tmp_kernel_op_1*0.1381966011250105 + tmp_kernel_op_2*0.1381966011250105;
                const real_t tmp_kernel_op_112 = p_affine_0_1 + tmp_kernel_op_4*0.5854101966249684 + tmp_kernel_op_5*0.1381966011250105 + tmp_kernel_op_6*0.1381966011250105;
                const real_t tmp_kernel_op_113 = p_affine_0_2 + tmp_kernel_op_10*0.1381966011250105 + tmp_kernel_op_8*0.5854101966249684 + tmp_kernel_op_9*0.1381966011250105;
                const real_t tmp_kernel_op_114 = (tmp_kernel_op_111*tmp_kernel_op_111);
                const real_t tmp_kernel_op_115 = (tmp_kernel_op_112*tmp_kernel_op_112);
                const real_t tmp_kernel_op_116 = (tmp_kernel_op_113*tmp_kernel_op_113);
                const real_t tmp_kernel_op_117 = tmp_kernel_op_114 + tmp_kernel_op_115 + tmp_kernel_op_116;
                const real_t tmp_kernel_op_118 = pow(tmp_kernel_op_117, -4.5000000000000000);
                const real_t tmp_kernel_op_119 = -tmp_kernel_op_113 - tmp_kernel_op_29;
                const real_t tmp_kernel_op_120 = -tmp_kernel_op_111 - tmp_kernel_op_18;
                const real_t tmp_kernel_op_121 = -tmp_kernel_op_112 - tmp_kernel_op_25;
                const real_t tmp_kernel_op_122 = -tmp_kernel_op_35*(-tmp_kernel_op_119*tmp_kernel_op_24 + tmp_kernel_op_119*tmp_kernel_op_26*tmp_kernel_op_27 + tmp_kernel_op_120*tmp_kernel_op_23*tmp_kernel_op_30 - tmp_kernel_op_120*tmp_kernel_op_31 + tmp_kernel_op_121*tmp_kernel_op_19*tmp_kernel_op_20 - tmp_kernel_op_121*tmp_kernel_op_32) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_123 = -tmp_kernel_op_122;
                const real_t tmp_kernel_op_124 = tmp_kernel_op_113*tmp_kernel_op_123 + tmp_kernel_op_117*tmp_kernel_op_36;
                const real_t tmp_kernel_op_125 = tmp_kernel_op_111*tmp_kernel_op_123 + tmp_kernel_op_117*tmp_kernel_op_44;
                const real_t tmp_kernel_op_126 = -tmp_kernel_op_112*tmp_kernel_op_122 - tmp_kernel_op_117*tmp_kernel_op_47;
                const real_t tmp_kernel_op_127 = tmp_kernel_op_115*tmp_kernel_op_123 + tmp_kernel_op_117*(tmp_kernel_op_112*tmp_kernel_op_49 + tmp_kernel_op_122);
                const real_t tmp_kernel_op_128 = tmp_kernel_op_111*tmp_kernel_op_125;
                const real_t tmp_kernel_op_129 = tmp_kernel_op_118*tmp_kernel_op_52;
                const real_t tmp_kernel_op_130 = tmp_kernel_op_113*tmp_kernel_op_124*tmp_kernel_op_129;
                const real_t tmp_kernel_op_131 = tmp_kernel_op_116*tmp_kernel_op_123 + tmp_kernel_op_117*(tmp_kernel_op_113*tmp_kernel_op_36 + tmp_kernel_op_122);
                const real_t tmp_kernel_op_132 = tmp_kernel_op_112*tmp_kernel_op_126*tmp_kernel_op_128;
                const real_t tmp_kernel_op_133 = -tmp_kernel_op_114*tmp_kernel_op_122 + tmp_kernel_op_117*(tmp_kernel_op_111*tmp_kernel_op_44 + tmp_kernel_op_122);
                const real_t tmp_kernel_op_134 = tmp_kernel_op_112*tmp_kernel_op_133;
                const real_t tmp_kernel_op_135 = tmp_kernel_op_111*tmp_kernel_op_112*tmp_kernel_op_113*tmp_kernel_op_118*tmp_kernel_op_124*tmp_kernel_op_125*tmp_kernel_op_126*tmp_kernel_op_34*2.0 + tmp_kernel_op_118*tmp_kernel_op_127*tmp_kernel_op_131*tmp_kernel_op_133*tmp_kernel_op_34*1.0 - tmp_kernel_op_126*tmp_kernel_op_130*tmp_kernel_op_134 - tmp_kernel_op_127*tmp_kernel_op_128*tmp_kernel_op_130 - tmp_kernel_op_129*tmp_kernel_op_131*tmp_kernel_op_132;
                const real_t tmp_kernel_op_136 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657*abs(tmp_kernel_op_135);
                const real_t tmp_kernel_op_137 = tmp_kernel_op_136*0.13819660112501056;
                const real_t tmp_kernel_op_138 = 1.0 / (tmp_kernel_op_135);
                const real_t tmp_kernel_op_139 = 1.0 / (tmp_kernel_op_117*tmp_kernel_op_117*tmp_kernel_op_117);
                const real_t tmp_kernel_op_140 = tmp_kernel_op_139*tmp_kernel_op_65;
                const real_t tmp_kernel_op_141 = tmp_kernel_op_124*tmp_kernel_op_140;
                const real_t tmp_kernel_op_142 = tmp_kernel_op_138*(tmp_kernel_op_111*tmp_kernel_op_112*tmp_kernel_op_124*tmp_kernel_op_125*tmp_kernel_op_139*tmp_kernel_op_64*1.0 - tmp_kernel_op_134*tmp_kernel_op_141);
                const real_t tmp_kernel_op_143 = tmp_kernel_op_138*(tmp_kernel_op_111*tmp_kernel_op_112*tmp_kernel_op_124*tmp_kernel_op_126*tmp_kernel_op_139*tmp_kernel_op_64*1.0 - tmp_kernel_op_111*tmp_kernel_op_127*tmp_kernel_op_141);
                const real_t tmp_kernel_op_144 = tmp_kernel_op_138*(tmp_kernel_op_127*tmp_kernel_op_133*tmp_kernel_op_140 - tmp_kernel_op_132*tmp_kernel_op_140);
                const real_t tmp_kernel_op_145 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_143 + jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_142 + jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_144;
                const real_t tmp_kernel_op_147 = tmp_kernel_op_145*(tmp_kernel_op_146 - 1.0);
                const real_t tmp_kernel_op_148 = p_affine_0_0 + tmp_kernel_op_0*0.1381966011250105 + tmp_kernel_op_1*0.1381966011250105 + tmp_kernel_op_2*0.1381966011250105;
                const real_t tmp_kernel_op_149 = p_affine_0_1 + tmp_kernel_op_4*0.1381966011250105 + tmp_kernel_op_5*0.1381966011250105 + tmp_kernel_op_6*0.1381966011250105;
                const real_t tmp_kernel_op_150 = p_affine_0_2 + tmp_kernel_op_10*0.1381966011250105 + tmp_kernel_op_8*0.1381966011250105 + tmp_kernel_op_9*0.1381966011250105;
                const real_t tmp_kernel_op_151 = (tmp_kernel_op_148*tmp_kernel_op_148);
                const real_t tmp_kernel_op_152 = (tmp_kernel_op_149*tmp_kernel_op_149);
                const real_t tmp_kernel_op_153 = (tmp_kernel_op_150*tmp_kernel_op_150);
                const real_t tmp_kernel_op_154 = tmp_kernel_op_151 + tmp_kernel_op_152 + tmp_kernel_op_153;
                const real_t tmp_kernel_op_155 = pow(tmp_kernel_op_154, -4.5000000000000000);
                const real_t tmp_kernel_op_156 = -tmp_kernel_op_150 - tmp_kernel_op_29;
                const real_t tmp_kernel_op_157 = -tmp_kernel_op_148 - tmp_kernel_op_18;
                const real_t tmp_kernel_op_158 = -tmp_kernel_op_149 - tmp_kernel_op_25;
                const real_t tmp_kernel_op_159 = -tmp_kernel_op_35*(-tmp_kernel_op_156*tmp_kernel_op_24 + tmp_kernel_op_156*tmp_kernel_op_26*tmp_kernel_op_27 + tmp_kernel_op_157*tmp_kernel_op_23*tmp_kernel_op_30 - tmp_kernel_op_157*tmp_kernel_op_31 + tmp_kernel_op_158*tmp_kernel_op_19*tmp_kernel_op_20 - tmp_kernel_op_158*tmp_kernel_op_32) + tmp_kernel_op_37;
                const real_t tmp_kernel_op_160 = -tmp_kernel_op_159;
                const real_t tmp_kernel_op_161 = tmp_kernel_op_150*tmp_kernel_op_160 + tmp_kernel_op_154*tmp_kernel_op_36;
                const real_t tmp_kernel_op_162 = tmp_kernel_op_148*tmp_kernel_op_160 + tmp_kernel_op_154*tmp_kernel_op_44;
                const real_t tmp_kernel_op_163 = -tmp_kernel_op_149*tmp_kernel_op_159 - tmp_kernel_op_154*tmp_kernel_op_47;
                const real_t tmp_kernel_op_164 = tmp_kernel_op_152*tmp_kernel_op_160 + tmp_kernel_op_154*(tmp_kernel_op_149*tmp_kernel_op_49 + tmp_kernel_op_159);
                const real_t tmp_kernel_op_165 = tmp_kernel_op_148*tmp_kernel_op_162;
                const real_t tmp_kernel_op_166 = tmp_kernel_op_155*tmp_kernel_op_52;
                const real_t tmp_kernel_op_167 = tmp_kernel_op_150*tmp_kernel_op_161*tmp_kernel_op_166;
                const real_t tmp_kernel_op_168 = tmp_kernel_op_153*tmp_kernel_op_160 + tmp_kernel_op_154*(tmp_kernel_op_150*tmp_kernel_op_36 + tmp_kernel_op_159);
                const real_t tmp_kernel_op_169 = tmp_kernel_op_149*tmp_kernel_op_163*tmp_kernel_op_165;
                const real_t tmp_kernel_op_170 = -tmp_kernel_op_151*tmp_kernel_op_159 + tmp_kernel_op_154*(tmp_kernel_op_148*tmp_kernel_op_44 + tmp_kernel_op_159);
                const real_t tmp_kernel_op_171 = tmp_kernel_op_149*tmp_kernel_op_170;
                const real_t tmp_kernel_op_172 = tmp_kernel_op_148*tmp_kernel_op_149*tmp_kernel_op_150*tmp_kernel_op_155*tmp_kernel_op_161*tmp_kernel_op_162*tmp_kernel_op_163*tmp_kernel_op_34*2.0 + tmp_kernel_op_155*tmp_kernel_op_164*tmp_kernel_op_168*tmp_kernel_op_170*tmp_kernel_op_34*1.0 - tmp_kernel_op_163*tmp_kernel_op_167*tmp_kernel_op_171 - tmp_kernel_op_164*tmp_kernel_op_165*tmp_kernel_op_167 - tmp_kernel_op_166*tmp_kernel_op_168*tmp_kernel_op_169;
                const real_t tmp_kernel_op_173 = abs_det_jac_affine_GREEN_DOWN*0.041666666666666657*abs(tmp_kernel_op_172);
                const real_t tmp_kernel_op_174 = tmp_kernel_op_173*0.5854101966249684;
                const real_t tmp_kernel_op_175 = 1.0 / (tmp_kernel_op_172);
                const real_t tmp_kernel_op_176 = 1.0 / (tmp_kernel_op_154*tmp_kernel_op_154*tmp_kernel_op_154);
                const real_t tmp_kernel_op_177 = tmp_kernel_op_176*tmp_kernel_op_65;
                const real_t tmp_kernel_op_178 = tmp_kernel_op_161*tmp_kernel_op_177;
                const real_t tmp_kernel_op_179 = tmp_kernel_op_175*(tmp_kernel_op_148*tmp_kernel_op_149*tmp_kernel_op_161*tmp_kernel_op_162*tmp_kernel_op_176*tmp_kernel_op_64*1.0 - tmp_kernel_op_171*tmp_kernel_op_178);
                const real_t tmp_kernel_op_180 = tmp_kernel_op_175*(tmp_kernel_op_148*tmp_kernel_op_149*tmp_kernel_op_161*tmp_kernel_op_163*tmp_kernel_op_176*tmp_kernel_op_64*1.0 - tmp_kernel_op_148*tmp_kernel_op_164*tmp_kernel_op_178);
                const real_t tmp_kernel_op_181 = tmp_kernel_op_175*(tmp_kernel_op_164*tmp_kernel_op_170*tmp_kernel_op_177 - tmp_kernel_op_169*tmp_kernel_op_177);
                const real_t tmp_kernel_op_182 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_180 + jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_179 + jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_181;
                const real_t tmp_kernel_op_184 = tmp_kernel_op_182*(tmp_kernel_op_183 - 1.0);
                const real_t tmp_kernel_op_185 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_69 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_68 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_70;
                const real_t tmp_kernel_op_187 = tmp_kernel_op_185*(tmp_kernel_op_186 - 1.0);
                const real_t tmp_kernel_op_188 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_106 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_105 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_107;
                const real_t tmp_kernel_op_190 = tmp_kernel_op_188*(tmp_kernel_op_189 - 1.0);
                const real_t tmp_kernel_op_191 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_143 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_142 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_144;
                const real_t tmp_kernel_op_193 = tmp_kernel_op_191*(tmp_kernel_op_192 - 1.0);
                const real_t tmp_kernel_op_194 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_180 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_179 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_181;
                const real_t tmp_kernel_op_196 = tmp_kernel_op_194*(tmp_kernel_op_195 - 1.0);
                const real_t tmp_kernel_op_197 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_69 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_68 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_70;
                const real_t tmp_kernel_op_199 = tmp_kernel_op_197*(tmp_kernel_op_198 - 1.0);
                const real_t tmp_kernel_op_200 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_106 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_105 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_107;
                const real_t tmp_kernel_op_202 = tmp_kernel_op_200*(tmp_kernel_op_201 - 1.0);
                const real_t tmp_kernel_op_203 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_143 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_142 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_144;
                const real_t tmp_kernel_op_205 = tmp_kernel_op_203*(tmp_kernel_op_204 - 1.0);
                const real_t tmp_kernel_op_206 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_180 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_179 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_181;
                const real_t tmp_kernel_op_208 = tmp_kernel_op_206*(tmp_kernel_op_207 - 1.0);
                const real_t tmp_kernel_op_209 = tmp_kernel_op_186*tmp_kernel_op_197;
                const real_t tmp_kernel_op_210 = tmp_kernel_op_185*tmp_kernel_op_198;
                const real_t tmp_kernel_op_211 = -tmp_kernel_op_209 - tmp_kernel_op_210;
                const real_t tmp_kernel_op_212 = tmp_kernel_op_189*tmp_kernel_op_200;
                const real_t tmp_kernel_op_213 = tmp_kernel_op_188*tmp_kernel_op_201;
                const real_t tmp_kernel_op_214 = -tmp_kernel_op_212 - tmp_kernel_op_213;
                const real_t tmp_kernel_op_215 = tmp_kernel_op_192*tmp_kernel_op_203;
                const real_t tmp_kernel_op_216 = tmp_kernel_op_191*tmp_kernel_op_204;
                const real_t tmp_kernel_op_217 = -tmp_kernel_op_215 - tmp_kernel_op_216;
                const real_t tmp_kernel_op_218 = tmp_kernel_op_195*tmp_kernel_op_206;
                const real_t tmp_kernel_op_219 = tmp_kernel_op_194*tmp_kernel_op_207;
                const real_t tmp_kernel_op_220 = -tmp_kernel_op_218 - tmp_kernel_op_219;
                const real_t tmp_kernel_op_221 = tmp_kernel_op_197*tmp_kernel_op_72;
                const real_t tmp_kernel_op_222 = tmp_kernel_op_198*tmp_kernel_op_71;
                const real_t tmp_kernel_op_223 = -tmp_kernel_op_221 - tmp_kernel_op_222;
                const real_t tmp_kernel_op_224 = tmp_kernel_op_109*tmp_kernel_op_200;
                const real_t tmp_kernel_op_225 = tmp_kernel_op_108*tmp_kernel_op_201;
                const real_t tmp_kernel_op_226 = -tmp_kernel_op_224 - tmp_kernel_op_225;
                const real_t tmp_kernel_op_227 = tmp_kernel_op_146*tmp_kernel_op_203;
                const real_t tmp_kernel_op_228 = tmp_kernel_op_145*tmp_kernel_op_204;
                const real_t tmp_kernel_op_229 = -tmp_kernel_op_227 - tmp_kernel_op_228;
                const real_t tmp_kernel_op_230 = tmp_kernel_op_183*tmp_kernel_op_206;
                const real_t tmp_kernel_op_231 = tmp_kernel_op_182*tmp_kernel_op_207;
                const real_t tmp_kernel_op_232 = -tmp_kernel_op_230 - tmp_kernel_op_231;
                const real_t tmp_kernel_op_233 = tmp_kernel_op_185*tmp_kernel_op_72;
                const real_t tmp_kernel_op_234 = tmp_kernel_op_186*tmp_kernel_op_71;
                const real_t tmp_kernel_op_235 = -tmp_kernel_op_233 - tmp_kernel_op_234;
                const real_t tmp_kernel_op_236 = tmp_kernel_op_109*tmp_kernel_op_188;
                const real_t tmp_kernel_op_237 = tmp_kernel_op_108*tmp_kernel_op_189;
                const real_t tmp_kernel_op_238 = -tmp_kernel_op_236 - tmp_kernel_op_237;
                const real_t tmp_kernel_op_239 = tmp_kernel_op_146*tmp_kernel_op_191;
                const real_t tmp_kernel_op_240 = tmp_kernel_op_145*tmp_kernel_op_192;
                const real_t tmp_kernel_op_241 = -tmp_kernel_op_239 - tmp_kernel_op_240;
                const real_t tmp_kernel_op_242 = tmp_kernel_op_183*tmp_kernel_op_194;
                const real_t tmp_kernel_op_243 = tmp_kernel_op_182*tmp_kernel_op_195;
                const real_t tmp_kernel_op_244 = -tmp_kernel_op_242 - tmp_kernel_op_243;
                const real_t tmp_kernel_op_246 = -tmp_kernel_op_197*(-tmp_kernel_op_245 - 0.68328157299974723) + tmp_kernel_op_210 + tmp_kernel_op_222;
                const real_t tmp_kernel_op_248 = -tmp_kernel_op_200*(-tmp_kernel_op_247 + 2.8944271909999157) + tmp_kernel_op_213 + tmp_kernel_op_225;
                const real_t tmp_kernel_op_250 = -tmp_kernel_op_203*(-tmp_kernel_op_249 + 2.8944271909999157) + tmp_kernel_op_216 + tmp_kernel_op_228;
                const real_t tmp_kernel_op_252 = -tmp_kernel_op_206*(-tmp_kernel_op_251 + 2.8944271909999157) + tmp_kernel_op_219 + tmp_kernel_op_231;
                const real_t tmp_kernel_op_254 = -tmp_kernel_op_185*(-tmp_kernel_op_253 - tmp_kernel_op_72 - 1.105572809000084) + tmp_kernel_op_209 + tmp_kernel_op_234;
                const real_t tmp_kernel_op_256 = -tmp_kernel_op_188*(-tmp_kernel_op_109 - tmp_kernel_op_255 - 4.6832815729997472) + tmp_kernel_op_212 + tmp_kernel_op_237;
                const real_t tmp_kernel_op_258 = -tmp_kernel_op_191*(-tmp_kernel_op_146 - tmp_kernel_op_257 - 1.105572809000084) + tmp_kernel_op_215 + tmp_kernel_op_240;
                const real_t tmp_kernel_op_260 = -tmp_kernel_op_194*(-tmp_kernel_op_183 - tmp_kernel_op_259 - 1.105572809000084) + tmp_kernel_op_218 + tmp_kernel_op_243;
                const real_t tmp_kernel_op_261 = tmp_kernel_op_221 + tmp_kernel_op_233 - tmp_kernel_op_71*(-tmp_kernel_op_186 - tmp_kernel_op_253 - 1.105572809000084);
                const real_t tmp_kernel_op_262 = -tmp_kernel_op_108*(-tmp_kernel_op_189 - tmp_kernel_op_255 - 1.105572809000084) + tmp_kernel_op_224 + tmp_kernel_op_236;
                const real_t tmp_kernel_op_263 = -tmp_kernel_op_145*(-tmp_kernel_op_192 - tmp_kernel_op_257 - 4.6832815729997472) + tmp_kernel_op_227 + tmp_kernel_op_239;
                const real_t tmp_kernel_op_264 = -tmp_kernel_op_182*(-tmp_kernel_op_195 - tmp_kernel_op_259 - 1.105572809000084) + tmp_kernel_op_230 + tmp_kernel_op_242;
                const real_t tmp_kernel_op_266 = -tmp_kernel_op_185*tmp_kernel_op_265 - tmp_kernel_op_197*tmp_kernel_op_265 - tmp_kernel_op_265*tmp_kernel_op_71;
                const real_t tmp_kernel_op_268 = -tmp_kernel_op_108*tmp_kernel_op_267 - tmp_kernel_op_188*tmp_kernel_op_267 - tmp_kernel_op_200*tmp_kernel_op_267;
                const real_t tmp_kernel_op_270 = -tmp_kernel_op_145*tmp_kernel_op_269 - tmp_kernel_op_191*tmp_kernel_op_269 - tmp_kernel_op_203*tmp_kernel_op_269;
                const real_t tmp_kernel_op_272 = -tmp_kernel_op_182*tmp_kernel_op_271 - tmp_kernel_op_194*tmp_kernel_op_271 - tmp_kernel_op_206*tmp_kernel_op_271;
                const real_t tmp_kernel_op_273 = tmp_kernel_op_60*0.1381966011250105;
                const real_t tmp_kernel_op_274 = tmp_kernel_op_99*0.1381966011250105;
                const real_t tmp_kernel_op_275 = tmp_kernel_op_136*0.5854101966249684;
                const real_t tmp_kernel_op_276 = tmp_kernel_op_173*0.1381966011250105;
                const real_t tmp_kernel_op_277 = tmp_kernel_op_60*0.1381966011250105;
                const real_t tmp_kernel_op_278 = tmp_kernel_op_99*0.5854101966249684;
                const real_t tmp_kernel_op_279 = tmp_kernel_op_136*0.1381966011250105;
                const real_t tmp_kernel_op_280 = tmp_kernel_op_173*0.1381966011250105;
                const real_t tmp_kernel_op_281 = tmp_kernel_op_60*0.5854101966249684;
                const real_t tmp_kernel_op_282 = tmp_kernel_op_99*0.1381966011250105;
                const real_t tmp_kernel_op_283 = tmp_kernel_op_136*0.1381966011250105;
                const real_t tmp_kernel_op_284 = tmp_kernel_op_173*0.1381966011250105;
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_100*tmp_kernel_op_268 + tmp_kernel_op_137*tmp_kernel_op_270 + tmp_kernel_op_174*tmp_kernel_op_272 + tmp_kernel_op_266*tmp_kernel_op_61) + src_dof_1*(-tmp_kernel_op_100*tmp_kernel_op_110 - tmp_kernel_op_137*tmp_kernel_op_147 - tmp_kernel_op_174*tmp_kernel_op_184 - tmp_kernel_op_61*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_100*tmp_kernel_op_190 - tmp_kernel_op_137*tmp_kernel_op_193 - tmp_kernel_op_174*tmp_kernel_op_196 - tmp_kernel_op_187*tmp_kernel_op_61) + src_dof_3*(-tmp_kernel_op_100*tmp_kernel_op_202 - tmp_kernel_op_137*tmp_kernel_op_205 - tmp_kernel_op_174*tmp_kernel_op_208 - tmp_kernel_op_199*tmp_kernel_op_61) + src_dof_4*(tmp_kernel_op_100*tmp_kernel_op_214 + tmp_kernel_op_137*tmp_kernel_op_217 + tmp_kernel_op_174*tmp_kernel_op_220 + tmp_kernel_op_211*tmp_kernel_op_61) + src_dof_5*(tmp_kernel_op_100*tmp_kernel_op_226 + tmp_kernel_op_137*tmp_kernel_op_229 + tmp_kernel_op_174*tmp_kernel_op_232 + tmp_kernel_op_223*tmp_kernel_op_61) + src_dof_6*(tmp_kernel_op_100*tmp_kernel_op_238 + tmp_kernel_op_137*tmp_kernel_op_241 + tmp_kernel_op_174*tmp_kernel_op_244 + tmp_kernel_op_235*tmp_kernel_op_61) + src_dof_7*(tmp_kernel_op_100*tmp_kernel_op_248 + tmp_kernel_op_137*tmp_kernel_op_250 + tmp_kernel_op_174*tmp_kernel_op_252 + tmp_kernel_op_246*tmp_kernel_op_61) + src_dof_8*(tmp_kernel_op_100*tmp_kernel_op_256 + tmp_kernel_op_137*tmp_kernel_op_258 + tmp_kernel_op_174*tmp_kernel_op_260 + tmp_kernel_op_254*tmp_kernel_op_61) + src_dof_9*(tmp_kernel_op_100*tmp_kernel_op_262 + tmp_kernel_op_137*tmp_kernel_op_263 + tmp_kernel_op_174*tmp_kernel_op_264 + tmp_kernel_op_261*tmp_kernel_op_61);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_266*tmp_kernel_op_273 + tmp_kernel_op_268*tmp_kernel_op_274 + tmp_kernel_op_270*tmp_kernel_op_275 + tmp_kernel_op_272*tmp_kernel_op_276) + src_dof_1*(-tmp_kernel_op_110*tmp_kernel_op_274 - tmp_kernel_op_147*tmp_kernel_op_275 - tmp_kernel_op_184*tmp_kernel_op_276 - tmp_kernel_op_273*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_187*tmp_kernel_op_273 - tmp_kernel_op_190*tmp_kernel_op_274 - tmp_kernel_op_193*tmp_kernel_op_275 - tmp_kernel_op_196*tmp_kernel_op_276) + src_dof_3*(-tmp_kernel_op_199*tmp_kernel_op_273 - tmp_kernel_op_202*tmp_kernel_op_274 - tmp_kernel_op_205*tmp_kernel_op_275 - tmp_kernel_op_208*tmp_kernel_op_276) + src_dof_4*(tmp_kernel_op_211*tmp_kernel_op_273 + tmp_kernel_op_214*tmp_kernel_op_274 + tmp_kernel_op_217*tmp_kernel_op_275 + tmp_kernel_op_220*tmp_kernel_op_276) + src_dof_5*(tmp_kernel_op_223*tmp_kernel_op_273 + tmp_kernel_op_226*tmp_kernel_op_274 + tmp_kernel_op_229*tmp_kernel_op_275 + tmp_kernel_op_232*tmp_kernel_op_276) + src_dof_6*(tmp_kernel_op_235*tmp_kernel_op_273 + tmp_kernel_op_238*tmp_kernel_op_274 + tmp_kernel_op_241*tmp_kernel_op_275 + tmp_kernel_op_244*tmp_kernel_op_276) + src_dof_7*(tmp_kernel_op_246*tmp_kernel_op_273 + tmp_kernel_op_248*tmp_kernel_op_274 + tmp_kernel_op_250*tmp_kernel_op_275 + tmp_kernel_op_252*tmp_kernel_op_276) + src_dof_8*(tmp_kernel_op_254*tmp_kernel_op_273 + tmp_kernel_op_256*tmp_kernel_op_274 + tmp_kernel_op_258*tmp_kernel_op_275 + tmp_kernel_op_260*tmp_kernel_op_276) + src_dof_9*(tmp_kernel_op_261*tmp_kernel_op_273 + tmp_kernel_op_262*tmp_kernel_op_274 + tmp_kernel_op_263*tmp_kernel_op_275 + tmp_kernel_op_264*tmp_kernel_op_276);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_266*tmp_kernel_op_277 + tmp_kernel_op_268*tmp_kernel_op_278 + tmp_kernel_op_270*tmp_kernel_op_279 + tmp_kernel_op_272*tmp_kernel_op_280) + src_dof_1*(-tmp_kernel_op_110*tmp_kernel_op_278 - tmp_kernel_op_147*tmp_kernel_op_279 - tmp_kernel_op_184*tmp_kernel_op_280 - tmp_kernel_op_277*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_187*tmp_kernel_op_277 - tmp_kernel_op_190*tmp_kernel_op_278 - tmp_kernel_op_193*tmp_kernel_op_279 - tmp_kernel_op_196*tmp_kernel_op_280) + src_dof_3*(-tmp_kernel_op_199*tmp_kernel_op_277 - tmp_kernel_op_202*tmp_kernel_op_278 - tmp_kernel_op_205*tmp_kernel_op_279 - tmp_kernel_op_208*tmp_kernel_op_280) + src_dof_4*(tmp_kernel_op_211*tmp_kernel_op_277 + tmp_kernel_op_214*tmp_kernel_op_278 + tmp_kernel_op_217*tmp_kernel_op_279 + tmp_kernel_op_220*tmp_kernel_op_280) + src_dof_5*(tmp_kernel_op_223*tmp_kernel_op_277 + tmp_kernel_op_226*tmp_kernel_op_278 + tmp_kernel_op_229*tmp_kernel_op_279 + tmp_kernel_op_232*tmp_kernel_op_280) + src_dof_6*(tmp_kernel_op_235*tmp_kernel_op_277 + tmp_kernel_op_238*tmp_kernel_op_278 + tmp_kernel_op_241*tmp_kernel_op_279 + tmp_kernel_op_244*tmp_kernel_op_280) + src_dof_7*(tmp_kernel_op_246*tmp_kernel_op_277 + tmp_kernel_op_248*tmp_kernel_op_278 + tmp_kernel_op_250*tmp_kernel_op_279 + tmp_kernel_op_252*tmp_kernel_op_280) + src_dof_8*(tmp_kernel_op_254*tmp_kernel_op_277 + tmp_kernel_op_256*tmp_kernel_op_278 + tmp_kernel_op_258*tmp_kernel_op_279 + tmp_kernel_op_260*tmp_kernel_op_280) + src_dof_9*(tmp_kernel_op_261*tmp_kernel_op_277 + tmp_kernel_op_262*tmp_kernel_op_278 + tmp_kernel_op_263*tmp_kernel_op_279 + tmp_kernel_op_264*tmp_kernel_op_280);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_266*tmp_kernel_op_281 + tmp_kernel_op_268*tmp_kernel_op_282 + tmp_kernel_op_270*tmp_kernel_op_283 + tmp_kernel_op_272*tmp_kernel_op_284) + src_dof_1*(-tmp_kernel_op_110*tmp_kernel_op_282 - tmp_kernel_op_147*tmp_kernel_op_283 - tmp_kernel_op_184*tmp_kernel_op_284 - tmp_kernel_op_281*tmp_kernel_op_73) + src_dof_2*(-tmp_kernel_op_187*tmp_kernel_op_281 - tmp_kernel_op_190*tmp_kernel_op_282 - tmp_kernel_op_193*tmp_kernel_op_283 - tmp_kernel_op_196*tmp_kernel_op_284) + src_dof_3*(-tmp_kernel_op_199*tmp_kernel_op_281 - tmp_kernel_op_202*tmp_kernel_op_282 - tmp_kernel_op_205*tmp_kernel_op_283 - tmp_kernel_op_208*tmp_kernel_op_284) + src_dof_4*(tmp_kernel_op_211*tmp_kernel_op_281 + tmp_kernel_op_214*tmp_kernel_op_282 + tmp_kernel_op_217*tmp_kernel_op_283 + tmp_kernel_op_220*tmp_kernel_op_284) + src_dof_5*(tmp_kernel_op_223*tmp_kernel_op_281 + tmp_kernel_op_226*tmp_kernel_op_282 + tmp_kernel_op_229*tmp_kernel_op_283 + tmp_kernel_op_232*tmp_kernel_op_284) + src_dof_6*(tmp_kernel_op_235*tmp_kernel_op_281 + tmp_kernel_op_238*tmp_kernel_op_282 + tmp_kernel_op_241*tmp_kernel_op_283 + tmp_kernel_op_244*tmp_kernel_op_284) + src_dof_7*(tmp_kernel_op_246*tmp_kernel_op_281 + tmp_kernel_op_248*tmp_kernel_op_282 + tmp_kernel_op_250*tmp_kernel_op_283 + tmp_kernel_op_252*tmp_kernel_op_284) + src_dof_8*(tmp_kernel_op_254*tmp_kernel_op_281 + tmp_kernel_op_256*tmp_kernel_op_282 + tmp_kernel_op_258*tmp_kernel_op_283 + tmp_kernel_op_260*tmp_kernel_op_284) + src_dof_9*(tmp_kernel_op_261*tmp_kernel_op_281 + tmp_kernel_op_262*tmp_kernel_op_282 + tmp_kernel_op_263*tmp_kernel_op_283 + tmp_kernel_op_264*tmp_kernel_op_284);
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
