/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/































#include "../P2ElementwiseFullStokesIcosahedralShellMap_0_0.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseFullStokesIcosahedralShellMap_0_0::apply_P2ElementwiseFullStokesIcosahedralShellMap_0_0_macro_3D( real_t * RESTRICT  _data_dstEdge, real_t * RESTRICT  _data_dstVertex, real_t * RESTRICT  _data_muEdge, real_t * RESTRICT  _data_muVertex, real_t * RESTRICT  _data_srcEdge, real_t * RESTRICT  _data_srcVertex, real_t forVertex_0, real_t forVertex_1, real_t forVertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t rayVertex_2, real_t refVertex_0, real_t refVertex_1, real_t refVertex_2, real_t thrVertex_0, real_t thrVertex_1, real_t thrVertex_2 ) const
{
    {
       const real_t _data_q_w [] = {-0.1333333333333333, 0.074999999999999983, 0.074999999999999983, 0.074999999999999983, 0.074999999999999983};
   
       const real_t _data_q_p_0 [] = {0.25, 0.16666666666666666, 0.16666666666666666, 0.5, 0.16666666666666666};
   
       const real_t _data_q_p_1 [] = {0.25, 0.16666666666666666, 0.5, 0.16666666666666666, 0.16666666666666666};
   
       const real_t _data_q_p_2 [] = {0.25, 0.5, 0.16666666666666666, 0.16666666666666666, 0.16666666666666666};
   
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
       const real_t tmp_qloop_1 = -rayVertex_0;
       const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
       const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
       const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
       const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
       const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
       const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
       const real_t tmp_qloop_8 = -rayVertex_1;
       const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
       const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
       const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
       const real_t tmp_qloop_12 = -rayVertex_2;
       const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
       const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
       const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
       const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
       const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
       const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
       const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
       const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
       const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
       const real_t tmp_qloop_40 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
       const real_t tmp_qloop_41 = tmp_qloop_21*tmp_qloop_40;
       const real_t tmp_qloop_46 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
       const real_t tmp_qloop_47 = -tmp_qloop_21*tmp_qloop_46;
       const real_t tmp_qloop_54 = -tmp_qloop_21*tmp_qloop_40;
       const real_t tmp_qloop_69 = tmp_qloop_21*tmp_qloop_32;
       const real_t tmp_qloop_73 = tmp_qloop_21*tmp_qloop_46;
       const real_t tmp_qloop_105 = 1.0 / (tmp_qloop_16*tmp_qloop_16);
       const real_t tmp_qloop_112 = 1.0 / (tmp_qloop_16*tmp_qloop_16*tmp_qloop_16);
       {
          /* CellType.WHITE_UP */
          const real_t _data_phi_0_0_WHITE_UP [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_1_0_WHITE_UP)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), ((real_t)(-jac_affine_inv_1_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_0_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_1_1_WHITE_UP)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), ((real_t)(-jac_affine_inv_1_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_1_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_1_2_WHITE_UP)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), ((real_t)(-jac_affine_inv_1_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_2_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_1_0_WHITE_UP)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), ((real_t)(-jac_affine_inv_1_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_0_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_1_1_WHITE_UP)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), ((real_t)(-jac_affine_inv_1_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_1_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_1_2_WHITE_UP)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), ((real_t)(-jac_affine_inv_1_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_2_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_3 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_7 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 1.0 / (tmp_qloop_31*tmp_qloop_31*tmp_qloop_31);
                const real_t tmp_qloop_106 = tmp_qloop_59*1.0;
                const real_t tmp_qloop_107 = tmp_qloop_104*tmp_qloop_105;
                const real_t tmp_qloop_108 = tmp_qloop_107*tmp_qloop_52;
                const real_t tmp_qloop_109 = tmp_qloop_108*tmp_qloop_25;
                const real_t tmp_qloop_110 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_22*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0 - tmp_qloop_106*tmp_qloop_109;
                const real_t tmp_qloop_111 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_113 = tmp_qloop_56*1.0;
                const real_t tmp_qloop_114 = tmp_qloop_113*tmp_qloop_50;
                const real_t tmp_qloop_115 = tmp_qloop_111*tmp_qloop_112;
                const real_t tmp_qloop_116 = tmp_qloop_115*tmp_qloop_52;
                const real_t tmp_qloop_117 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_118 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_119 = tmp_qloop_117*tmp_qloop_118*1.0;
                const real_t tmp_qloop_120 = -tmp_qloop_106*tmp_qloop_116*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43 + tmp_qloop_111*tmp_qloop_112*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*2.0 + tmp_qloop_111*tmp_qloop_112*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59*1.0 - tmp_qloop_114*tmp_qloop_116*tmp_qloop_86 - tmp_qloop_115*tmp_qloop_119*tmp_qloop_36;
                const real_t tmp_qloop_121 = 1.0 / (tmp_qloop_120);
                const real_t tmp_qloop_122 = tmp_qloop_121*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q];
                const real_t tmp_qloop_123 = tmp_qloop_110*tmp_qloop_122;
                const real_t tmp_qloop_124 = tmp_qloop_121*(tmp_qloop_104*tmp_qloop_105*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_52*1.0 - tmp_qloop_108*tmp_qloop_113*tmp_qloop_22);
                const real_t tmp_qloop_125 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q];
                const real_t tmp_qloop_126 = tmp_qloop_121*(tmp_qloop_107*tmp_qloop_113*tmp_qloop_59 - tmp_qloop_107*tmp_qloop_119);
                const real_t tmp_qloop_127 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q];
                const real_t tmp_qloop_128 = tmp_qloop_110*tmp_qloop_121;
                const real_t tmp_qloop_129 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q];
                const real_t tmp_qloop_130 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q];
                const real_t tmp_qloop_131 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q];
                const real_t tmp_qloop_132 = tmp_qloop_129*1.0 + tmp_qloop_130*1.0 + tmp_qloop_131*1.0;
                const real_t tmp_qloop_133 = tmp_qloop_107*tmp_qloop_36;
                const real_t tmp_qloop_134 = tmp_qloop_106*tmp_qloop_133 - tmp_qloop_108*tmp_qloop_50*tmp_qloop_86;
                const real_t tmp_qloop_135 = tmp_qloop_107*tmp_qloop_18;
                const real_t tmp_qloop_136 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_50*1.0 - tmp_qloop_106*tmp_qloop_135*tmp_qloop_43;
                const real_t tmp_qloop_137 = tmp_qloop_121*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q];
                const real_t tmp_qloop_138 = tmp_qloop_133*1.0;
                const real_t tmp_qloop_139 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_52*1.0 - tmp_qloop_117*tmp_qloop_138;
                const real_t tmp_qloop_140 = tmp_qloop_121*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q];
                const real_t tmp_qloop_141 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP[q] + tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP[q] + tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP[q];
                const real_t tmp_qloop_142 = tmp_qloop_121*tmp_qloop_134;
                const real_t tmp_qloop_143 = 0.5*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q];
                const real_t tmp_qloop_144 = tmp_qloop_121*tmp_qloop_136;
                const real_t tmp_qloop_145 = 0.5*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q];
                const real_t tmp_qloop_146 = tmp_qloop_121*tmp_qloop_139;
                const real_t tmp_qloop_147 = 0.5*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q];
                const real_t tmp_qloop_148 = tmp_qloop_126*0.5;
                const real_t tmp_qloop_149 = tmp_qloop_124*0.5;
                const real_t tmp_qloop_150 = tmp_qloop_128*0.5;
                const real_t tmp_qloop_151 = tmp_qloop_148*_data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP[q] + tmp_qloop_149*_data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP[q] + tmp_qloop_150*_data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP[q];
                const real_t tmp_qloop_152 = tmp_qloop_142*tmp_qloop_143*2.0 + tmp_qloop_144*tmp_qloop_145*2.0 + tmp_qloop_146*tmp_qloop_147*2.0 + tmp_qloop_151*2.0;
                const real_t tmp_qloop_153 = -tmp_qloop_109*tmp_qloop_18*tmp_qloop_43 + tmp_qloop_113*tmp_qloop_133;
                const real_t tmp_qloop_154 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*1.0 - tmp_qloop_114*tmp_qloop_135;
                const real_t tmp_qloop_155 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0 - tmp_qloop_118*tmp_qloop_138;
                const real_t tmp_qloop_156 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[q] + tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[q] + tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[q];
                const real_t tmp_qloop_157 = tmp_qloop_121*tmp_qloop_153;
                const real_t tmp_qloop_158 = tmp_qloop_121*tmp_qloop_154;
                const real_t tmp_qloop_159 = tmp_qloop_121*tmp_qloop_155;
                const real_t tmp_qloop_160 = tmp_qloop_148*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[q] + tmp_qloop_149*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[q] + tmp_qloop_150*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[q];
                const real_t tmp_qloop_161 = tmp_qloop_143*tmp_qloop_159*2.0 + tmp_qloop_145*tmp_qloop_158*2.0 + tmp_qloop_147*tmp_qloop_157*2.0 + tmp_qloop_160*2.0;
                const real_t tmp_qloop_162 = tmp_qloop_129*0.66666666666666667 + tmp_qloop_130*0.66666666666666667 + tmp_qloop_131*0.66666666666666667;
                const real_t tmp_qloop_163 = tmp_qloop_159*0.5;
                const real_t tmp_qloop_164 = tmp_qloop_158*0.5;
                const real_t tmp_qloop_165 = tmp_qloop_144*0.5;
                const real_t tmp_qloop_166 = tmp_qloop_146*0.5;
                const real_t tmp_qloop_167 = tmp_qloop_142*0.5;
                const real_t tmp_qloop_168 = tmp_qloop_157*0.5;
                const real_t tmp_qloop_169 = (tmp_qloop_142*1.0*_data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP[q] + tmp_qloop_144*1.0*_data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP[q] + tmp_qloop_146*1.0*_data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP[q])*(tmp_qloop_142*2.0*_data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP[q] + tmp_qloop_144*2.0*_data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP[q] + tmp_qloop_146*2.0*_data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP[q]) + (tmp_qloop_157*1.0*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[q] + tmp_qloop_158*1.0*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[q] + tmp_qloop_159*1.0*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[q])*(tmp_qloop_157*2.0*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[q] + tmp_qloop_158*2.0*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[q] + tmp_qloop_159*2.0*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[q]) + (tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_UP[q] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_UP[q] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_UP[q] + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_1_WHITE_UP[q] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_1_WHITE_UP[q] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_1_WHITE_UP[q])*(tmp_qloop_163*_data_jac_affine_inv_T_grad_psi_1_1_WHITE_UP[q] + tmp_qloop_164*_data_jac_affine_inv_T_grad_psi_0_1_WHITE_UP[q] + tmp_qloop_165*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_UP[q] + tmp_qloop_166*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_UP[q] + tmp_qloop_167*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_UP[q] + tmp_qloop_168*_data_jac_affine_inv_T_grad_psi_2_1_WHITE_UP[q])*2.0;
                const real_t tmp_qloop_170 = abs_det_jac_affine_WHITE_UP*(mu_dof_0*_data_phi_0_0_WHITE_UP[10*q] + mu_dof_1*_data_phi_0_0_WHITE_UP[10*q + 1] + mu_dof_2*_data_phi_0_0_WHITE_UP[10*q + 2] + mu_dof_3*_data_phi_0_0_WHITE_UP[10*q + 3] + mu_dof_4*_data_phi_0_0_WHITE_UP[10*q + 4] + mu_dof_5*_data_phi_0_0_WHITE_UP[10*q + 5] + mu_dof_6*_data_phi_0_0_WHITE_UP[10*q + 6] + mu_dof_7*_data_phi_0_0_WHITE_UP[10*q + 7] + mu_dof_8*_data_phi_0_0_WHITE_UP[10*q + 8] + mu_dof_9*_data_phi_0_0_WHITE_UP[10*q + 9])*abs(tmp_qloop_120)*_data_q_w[q];
                const real_t tmp_qloop_171 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_172 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_173 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_174 = tmp_qloop_171*2.0 + tmp_qloop_172*2.0 + tmp_qloop_173*2.0;
                const real_t tmp_qloop_175 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 1] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 1] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_176 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 1] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 1] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_177 = tmp_qloop_171 + tmp_qloop_172 + tmp_qloop_173;
                const real_t tmp_qloop_178 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_179 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_180 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_181 = tmp_qloop_178*2.0 + tmp_qloop_179*2.0 + tmp_qloop_180*2.0;
                const real_t tmp_qloop_182 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 2] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 2] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_183 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 2] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 2] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_184 = tmp_qloop_178 + tmp_qloop_179 + tmp_qloop_180;
                const real_t tmp_qloop_185 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_186 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_187 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_188 = tmp_qloop_185*2.0 + tmp_qloop_186*2.0 + tmp_qloop_187*2.0;
                const real_t tmp_qloop_189 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 3] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 3] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_190 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 3] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 3] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_191 = tmp_qloop_185 + tmp_qloop_186 + tmp_qloop_187;
                const real_t tmp_qloop_192 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_193 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_194 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_195 = tmp_qloop_192*2.0 + tmp_qloop_193*2.0 + tmp_qloop_194*2.0;
                const real_t tmp_qloop_196 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 4] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 4] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_197 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 4] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 4] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_198 = tmp_qloop_192 + tmp_qloop_193 + tmp_qloop_194;
                const real_t tmp_qloop_199 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_200 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_201 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_202 = tmp_qloop_199*2.0 + tmp_qloop_200*2.0 + tmp_qloop_201*2.0;
                const real_t tmp_qloop_203 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 5] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 5] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_204 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 5] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 5] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_205 = tmp_qloop_199 + tmp_qloop_200 + tmp_qloop_201;
                const real_t tmp_qloop_206 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_207 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_208 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_209 = tmp_qloop_206*2.0 + tmp_qloop_207*2.0 + tmp_qloop_208*2.0;
                const real_t tmp_qloop_210 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 6] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 6] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_211 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 6] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 6] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_212 = tmp_qloop_206 + tmp_qloop_207 + tmp_qloop_208;
                const real_t tmp_qloop_213 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_214 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_215 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_216 = tmp_qloop_213*2.0 + tmp_qloop_214*2.0 + tmp_qloop_215*2.0;
                const real_t tmp_qloop_217 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 7] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 7] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_218 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 7] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 7] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_219 = tmp_qloop_213 + tmp_qloop_214 + tmp_qloop_215;
                const real_t tmp_qloop_220 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_221 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_222 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_223 = tmp_qloop_220*2.0 + tmp_qloop_221*2.0 + tmp_qloop_222*2.0;
                const real_t tmp_qloop_224 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 8] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 8] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_225 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 8] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 8] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_226 = tmp_qloop_220 + tmp_qloop_221 + tmp_qloop_222;
                const real_t tmp_qloop_227 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 9];
                const real_t tmp_qloop_228 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 9];
                const real_t tmp_qloop_229 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 9];
                const real_t tmp_qloop_230 = tmp_qloop_227*2.0 + tmp_qloop_228*2.0 + tmp_qloop_229*2.0;
                const real_t tmp_qloop_231 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 9] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 9] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 9];
                const real_t tmp_qloop_232 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_UP[10*q + 9] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_UP[10*q + 9] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_UP[10*q + 9];
                const real_t tmp_qloop_233 = tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229;
                const real_t tmp_qloop_234 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_235 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_236 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_237 = tmp_qloop_234*1.0 + tmp_qloop_235*1.0 + tmp_qloop_236*1.0;
                const real_t tmp_qloop_238 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 1] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 1] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_239 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 1] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 1] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_240 = tmp_qloop_234*0.66666666666666667 + tmp_qloop_235*0.66666666666666667 + tmp_qloop_236*0.66666666666666667;
                const real_t tmp_qloop_241 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_242 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_243 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_244 = tmp_qloop_241*1.0 + tmp_qloop_242*1.0 + tmp_qloop_243*1.0;
                const real_t tmp_qloop_245 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 2] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 2] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_246 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 2] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 2] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_247 = tmp_qloop_241*0.66666666666666667 + tmp_qloop_242*0.66666666666666667 + tmp_qloop_243*0.66666666666666667;
                const real_t tmp_qloop_248 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_249 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_250 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_251 = tmp_qloop_248*1.0 + tmp_qloop_249*1.0 + tmp_qloop_250*1.0;
                const real_t tmp_qloop_252 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 3] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 3] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_253 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 3] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 3] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_254 = tmp_qloop_248*0.66666666666666667 + tmp_qloop_249*0.66666666666666667 + tmp_qloop_250*0.66666666666666667;
                const real_t tmp_qloop_255 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_256 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_257 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_258 = tmp_qloop_255*1.0 + tmp_qloop_256*1.0 + tmp_qloop_257*1.0;
                const real_t tmp_qloop_259 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 4] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 4] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_260 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 4] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 4] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_261 = tmp_qloop_255*0.66666666666666667 + tmp_qloop_256*0.66666666666666667 + tmp_qloop_257*0.66666666666666667;
                const real_t tmp_qloop_262 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_263 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_264 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_265 = tmp_qloop_262*1.0 + tmp_qloop_263*1.0 + tmp_qloop_264*1.0;
                const real_t tmp_qloop_266 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 5] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 5] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_267 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 5] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 5] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_268 = tmp_qloop_262*0.66666666666666667 + tmp_qloop_263*0.66666666666666667 + tmp_qloop_264*0.66666666666666667;
                const real_t tmp_qloop_269 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_270 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_271 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_272 = tmp_qloop_269*1.0 + tmp_qloop_270*1.0 + tmp_qloop_271*1.0;
                const real_t tmp_qloop_273 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 6] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 6] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_274 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 6] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 6] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_275 = tmp_qloop_269*0.66666666666666667 + tmp_qloop_270*0.66666666666666667 + tmp_qloop_271*0.66666666666666667;
                const real_t tmp_qloop_276 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_277 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_278 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_279 = tmp_qloop_276*1.0 + tmp_qloop_277*1.0 + tmp_qloop_278*1.0;
                const real_t tmp_qloop_280 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 7] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 7] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_281 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 7] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 7] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_282 = tmp_qloop_276*0.66666666666666667 + tmp_qloop_277*0.66666666666666667 + tmp_qloop_278*0.66666666666666667;
                const real_t tmp_qloop_283 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_284 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_285 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_286 = tmp_qloop_283*1.0 + tmp_qloop_284*1.0 + tmp_qloop_285*1.0;
                const real_t tmp_qloop_287 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 8] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 8] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_288 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 8] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 8] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_289 = tmp_qloop_283*0.66666666666666667 + tmp_qloop_284*0.66666666666666667 + tmp_qloop_285*0.66666666666666667;
                const real_t tmp_qloop_290 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 9];
                const real_t tmp_qloop_291 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 9];
                const real_t tmp_qloop_292 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 9];
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_170*(tmp_qloop_132*(tmp_qloop_123*2.0 + tmp_qloop_125*2.0 + tmp_qloop_127*2.0) + tmp_qloop_152*(tmp_qloop_122*tmp_qloop_134 + tmp_qloop_136*tmp_qloop_137 + tmp_qloop_139*tmp_qloop_140 + tmp_qloop_141) + tmp_qloop_161*(tmp_qloop_122*tmp_qloop_155 + tmp_qloop_137*tmp_qloop_154 + tmp_qloop_140*tmp_qloop_153 + tmp_qloop_156) - tmp_qloop_162*(tmp_qloop_123 + tmp_qloop_125 + tmp_qloop_127) + tmp_qloop_169);
                const real_t q_tmp_0_1 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_174 + tmp_qloop_152*tmp_qloop_175 + tmp_qloop_161*tmp_qloop_176 - tmp_qloop_162*tmp_qloop_177 + tmp_qloop_169);
                const real_t q_tmp_0_2 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_181 + tmp_qloop_152*tmp_qloop_182 + tmp_qloop_161*tmp_qloop_183 - tmp_qloop_162*tmp_qloop_184 + tmp_qloop_169);
                const real_t q_tmp_0_3 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_188 + tmp_qloop_152*tmp_qloop_189 + tmp_qloop_161*tmp_qloop_190 - tmp_qloop_162*tmp_qloop_191 + tmp_qloop_169);
                const real_t q_tmp_0_4 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_195 + tmp_qloop_152*tmp_qloop_196 + tmp_qloop_161*tmp_qloop_197 - tmp_qloop_162*tmp_qloop_198 + tmp_qloop_169);
                const real_t q_tmp_0_5 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_202 + tmp_qloop_152*tmp_qloop_203 + tmp_qloop_161*tmp_qloop_204 - tmp_qloop_162*tmp_qloop_205 + tmp_qloop_169);
                const real_t q_tmp_0_6 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_209 + tmp_qloop_152*tmp_qloop_210 + tmp_qloop_161*tmp_qloop_211 - tmp_qloop_162*tmp_qloop_212 + tmp_qloop_169);
                const real_t q_tmp_0_7 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_216 + tmp_qloop_152*tmp_qloop_217 + tmp_qloop_161*tmp_qloop_218 - tmp_qloop_162*tmp_qloop_219 + tmp_qloop_169);
                const real_t q_tmp_0_8 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_223 + tmp_qloop_152*tmp_qloop_224 + tmp_qloop_161*tmp_qloop_225 - tmp_qloop_162*tmp_qloop_226 + tmp_qloop_169);
                const real_t q_tmp_0_9 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_230 + tmp_qloop_152*tmp_qloop_231 + tmp_qloop_161*tmp_qloop_232 - tmp_qloop_162*tmp_qloop_233 + tmp_qloop_169);
                const real_t q_tmp_1_1 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_174*tmp_qloop_237 + tmp_qloop_175*tmp_qloop_238 + tmp_qloop_176*tmp_qloop_239 - tmp_qloop_177*tmp_qloop_240);
                const real_t q_tmp_1_2 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_181*tmp_qloop_237 + tmp_qloop_182*tmp_qloop_238 + tmp_qloop_183*tmp_qloop_239 - tmp_qloop_184*tmp_qloop_240);
                const real_t q_tmp_1_3 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_188*tmp_qloop_237 + tmp_qloop_189*tmp_qloop_238 + tmp_qloop_190*tmp_qloop_239 - tmp_qloop_191*tmp_qloop_240);
                const real_t q_tmp_1_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_237 + tmp_qloop_196*tmp_qloop_238 + tmp_qloop_197*tmp_qloop_239 - tmp_qloop_198*tmp_qloop_240);
                const real_t q_tmp_1_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_237 + tmp_qloop_203*tmp_qloop_238 + tmp_qloop_204*tmp_qloop_239 - tmp_qloop_205*tmp_qloop_240);
                const real_t q_tmp_1_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_237 + tmp_qloop_210*tmp_qloop_238 + tmp_qloop_211*tmp_qloop_239 - tmp_qloop_212*tmp_qloop_240);
                const real_t q_tmp_1_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_237 + tmp_qloop_217*tmp_qloop_238 + tmp_qloop_218*tmp_qloop_239 - tmp_qloop_219*tmp_qloop_240);
                const real_t q_tmp_1_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_237 + tmp_qloop_224*tmp_qloop_238 + tmp_qloop_225*tmp_qloop_239 - tmp_qloop_226*tmp_qloop_240);
                const real_t q_tmp_1_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_237 + tmp_qloop_231*tmp_qloop_238 + tmp_qloop_232*tmp_qloop_239 - tmp_qloop_233*tmp_qloop_240);
                const real_t q_tmp_2_2 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_181*tmp_qloop_244 + tmp_qloop_182*tmp_qloop_245 + tmp_qloop_183*tmp_qloop_246 - tmp_qloop_184*tmp_qloop_247);
                const real_t q_tmp_2_3 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_188*tmp_qloop_244 + tmp_qloop_189*tmp_qloop_245 + tmp_qloop_190*tmp_qloop_246 - tmp_qloop_191*tmp_qloop_247);
                const real_t q_tmp_2_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_244 + tmp_qloop_196*tmp_qloop_245 + tmp_qloop_197*tmp_qloop_246 - tmp_qloop_198*tmp_qloop_247);
                const real_t q_tmp_2_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_244 + tmp_qloop_203*tmp_qloop_245 + tmp_qloop_204*tmp_qloop_246 - tmp_qloop_205*tmp_qloop_247);
                const real_t q_tmp_2_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_244 + tmp_qloop_210*tmp_qloop_245 + tmp_qloop_211*tmp_qloop_246 - tmp_qloop_212*tmp_qloop_247);
                const real_t q_tmp_2_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_244 + tmp_qloop_217*tmp_qloop_245 + tmp_qloop_218*tmp_qloop_246 - tmp_qloop_219*tmp_qloop_247);
                const real_t q_tmp_2_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_244 + tmp_qloop_224*tmp_qloop_245 + tmp_qloop_225*tmp_qloop_246 - tmp_qloop_226*tmp_qloop_247);
                const real_t q_tmp_2_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_244 + tmp_qloop_231*tmp_qloop_245 + tmp_qloop_232*tmp_qloop_246 - tmp_qloop_233*tmp_qloop_247);
                const real_t q_tmp_3_3 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_188*tmp_qloop_251 + tmp_qloop_189*tmp_qloop_252 + tmp_qloop_190*tmp_qloop_253 - tmp_qloop_191*tmp_qloop_254);
                const real_t q_tmp_3_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_251 + tmp_qloop_196*tmp_qloop_252 + tmp_qloop_197*tmp_qloop_253 - tmp_qloop_198*tmp_qloop_254);
                const real_t q_tmp_3_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_251 + tmp_qloop_203*tmp_qloop_252 + tmp_qloop_204*tmp_qloop_253 - tmp_qloop_205*tmp_qloop_254);
                const real_t q_tmp_3_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_251 + tmp_qloop_210*tmp_qloop_252 + tmp_qloop_211*tmp_qloop_253 - tmp_qloop_212*tmp_qloop_254);
                const real_t q_tmp_3_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_251 + tmp_qloop_217*tmp_qloop_252 + tmp_qloop_218*tmp_qloop_253 - tmp_qloop_219*tmp_qloop_254);
                const real_t q_tmp_3_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_251 + tmp_qloop_224*tmp_qloop_252 + tmp_qloop_225*tmp_qloop_253 - tmp_qloop_226*tmp_qloop_254);
                const real_t q_tmp_3_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_251 + tmp_qloop_231*tmp_qloop_252 + tmp_qloop_232*tmp_qloop_253 - tmp_qloop_233*tmp_qloop_254);
                const real_t q_tmp_4_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_258 + tmp_qloop_196*tmp_qloop_259 + tmp_qloop_197*tmp_qloop_260 - tmp_qloop_198*tmp_qloop_261);
                const real_t q_tmp_4_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_258 + tmp_qloop_203*tmp_qloop_259 + tmp_qloop_204*tmp_qloop_260 - tmp_qloop_205*tmp_qloop_261);
                const real_t q_tmp_4_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_258 + tmp_qloop_210*tmp_qloop_259 + tmp_qloop_211*tmp_qloop_260 - tmp_qloop_212*tmp_qloop_261);
                const real_t q_tmp_4_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_258 + tmp_qloop_217*tmp_qloop_259 + tmp_qloop_218*tmp_qloop_260 - tmp_qloop_219*tmp_qloop_261);
                const real_t q_tmp_4_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_258 + tmp_qloop_224*tmp_qloop_259 + tmp_qloop_225*tmp_qloop_260 - tmp_qloop_226*tmp_qloop_261);
                const real_t q_tmp_4_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_258 + tmp_qloop_231*tmp_qloop_259 + tmp_qloop_232*tmp_qloop_260 - tmp_qloop_233*tmp_qloop_261);
                const real_t q_tmp_5_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_265 + tmp_qloop_203*tmp_qloop_266 + tmp_qloop_204*tmp_qloop_267 - tmp_qloop_205*tmp_qloop_268);
                const real_t q_tmp_5_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_265 + tmp_qloop_210*tmp_qloop_266 + tmp_qloop_211*tmp_qloop_267 - tmp_qloop_212*tmp_qloop_268);
                const real_t q_tmp_5_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_265 + tmp_qloop_217*tmp_qloop_266 + tmp_qloop_218*tmp_qloop_267 - tmp_qloop_219*tmp_qloop_268);
                const real_t q_tmp_5_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_265 + tmp_qloop_224*tmp_qloop_266 + tmp_qloop_225*tmp_qloop_267 - tmp_qloop_226*tmp_qloop_268);
                const real_t q_tmp_5_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_265 + tmp_qloop_231*tmp_qloop_266 + tmp_qloop_232*tmp_qloop_267 - tmp_qloop_233*tmp_qloop_268);
                const real_t q_tmp_6_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_272 + tmp_qloop_210*tmp_qloop_273 + tmp_qloop_211*tmp_qloop_274 - tmp_qloop_212*tmp_qloop_275);
                const real_t q_tmp_6_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_272 + tmp_qloop_217*tmp_qloop_273 + tmp_qloop_218*tmp_qloop_274 - tmp_qloop_219*tmp_qloop_275);
                const real_t q_tmp_6_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_272 + tmp_qloop_224*tmp_qloop_273 + tmp_qloop_225*tmp_qloop_274 - tmp_qloop_226*tmp_qloop_275);
                const real_t q_tmp_6_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_272 + tmp_qloop_231*tmp_qloop_273 + tmp_qloop_232*tmp_qloop_274 - tmp_qloop_233*tmp_qloop_275);
                const real_t q_tmp_7_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_279 + tmp_qloop_217*tmp_qloop_280 + tmp_qloop_218*tmp_qloop_281 - tmp_qloop_219*tmp_qloop_282);
                const real_t q_tmp_7_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_279 + tmp_qloop_224*tmp_qloop_280 + tmp_qloop_225*tmp_qloop_281 - tmp_qloop_226*tmp_qloop_282);
                const real_t q_tmp_7_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_279 + tmp_qloop_231*tmp_qloop_280 + tmp_qloop_232*tmp_qloop_281 - tmp_qloop_233*tmp_qloop_282);
                const real_t q_tmp_8_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_286 + tmp_qloop_224*tmp_qloop_287 + tmp_qloop_225*tmp_qloop_288 - tmp_qloop_226*tmp_qloop_289);
                const real_t q_tmp_8_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_286 + tmp_qloop_231*tmp_qloop_287 + tmp_qloop_232*tmp_qloop_288 - tmp_qloop_233*tmp_qloop_289);
                const real_t q_tmp_9_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*(tmp_qloop_290*1.0 + tmp_qloop_291*1.0 + tmp_qloop_292*1.0) + tmp_qloop_231*(tmp_qloop_151 + tmp_qloop_165*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 9] + tmp_qloop_166*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 9] + tmp_qloop_167*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 9])*2.0 + tmp_qloop_232*(tmp_qloop_160 + tmp_qloop_163*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_UP[10*q + 9] + tmp_qloop_164*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_UP[10*q + 9] + tmp_qloop_168*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_UP[10*q + 9])*2.0 + tmp_qloop_233*(tmp_qloop_290 + tmp_qloop_291 + tmp_qloop_292)*-0.66666666666666667);
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_9*src_dof_9;
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       {
          /* CellType.WHITE_DOWN */
          const real_t _data_phi_0_0_WHITE_DOWN [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_1_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_1_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_1_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_1_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_1_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_1_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_3 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_7 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_8 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 1.0 / (tmp_qloop_31*tmp_qloop_31*tmp_qloop_31);
                const real_t tmp_qloop_106 = tmp_qloop_59*1.0;
                const real_t tmp_qloop_107 = tmp_qloop_104*tmp_qloop_105;
                const real_t tmp_qloop_108 = tmp_qloop_107*tmp_qloop_52;
                const real_t tmp_qloop_109 = tmp_qloop_108*tmp_qloop_25;
                const real_t tmp_qloop_110 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_22*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0 - tmp_qloop_106*tmp_qloop_109;
                const real_t tmp_qloop_111 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_113 = tmp_qloop_56*1.0;
                const real_t tmp_qloop_114 = tmp_qloop_113*tmp_qloop_50;
                const real_t tmp_qloop_115 = tmp_qloop_111*tmp_qloop_112;
                const real_t tmp_qloop_116 = tmp_qloop_115*tmp_qloop_52;
                const real_t tmp_qloop_117 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_118 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_119 = tmp_qloop_117*tmp_qloop_118*1.0;
                const real_t tmp_qloop_120 = -tmp_qloop_106*tmp_qloop_116*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43 + tmp_qloop_111*tmp_qloop_112*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*2.0 + tmp_qloop_111*tmp_qloop_112*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59*1.0 - tmp_qloop_114*tmp_qloop_116*tmp_qloop_86 - tmp_qloop_115*tmp_qloop_119*tmp_qloop_36;
                const real_t tmp_qloop_121 = 1.0 / (tmp_qloop_120);
                const real_t tmp_qloop_122 = tmp_qloop_121*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q];
                const real_t tmp_qloop_123 = tmp_qloop_110*tmp_qloop_122;
                const real_t tmp_qloop_124 = tmp_qloop_121*(tmp_qloop_104*tmp_qloop_105*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_52*1.0 - tmp_qloop_108*tmp_qloop_113*tmp_qloop_22);
                const real_t tmp_qloop_125 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q];
                const real_t tmp_qloop_126 = tmp_qloop_121*(tmp_qloop_107*tmp_qloop_113*tmp_qloop_59 - tmp_qloop_107*tmp_qloop_119);
                const real_t tmp_qloop_127 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q];
                const real_t tmp_qloop_128 = tmp_qloop_110*tmp_qloop_121;
                const real_t tmp_qloop_129 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q];
                const real_t tmp_qloop_130 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q];
                const real_t tmp_qloop_131 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q];
                const real_t tmp_qloop_132 = tmp_qloop_129*1.0 + tmp_qloop_130*1.0 + tmp_qloop_131*1.0;
                const real_t tmp_qloop_133 = tmp_qloop_107*tmp_qloop_36;
                const real_t tmp_qloop_134 = tmp_qloop_106*tmp_qloop_133 - tmp_qloop_108*tmp_qloop_50*tmp_qloop_86;
                const real_t tmp_qloop_135 = tmp_qloop_107*tmp_qloop_18;
                const real_t tmp_qloop_136 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_50*1.0 - tmp_qloop_106*tmp_qloop_135*tmp_qloop_43;
                const real_t tmp_qloop_137 = tmp_qloop_121*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q];
                const real_t tmp_qloop_138 = tmp_qloop_133*1.0;
                const real_t tmp_qloop_139 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_52*1.0 - tmp_qloop_117*tmp_qloop_138;
                const real_t tmp_qloop_140 = tmp_qloop_121*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q];
                const real_t tmp_qloop_141 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN[q] + tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN[q] + tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN[q];
                const real_t tmp_qloop_142 = tmp_qloop_121*tmp_qloop_134;
                const real_t tmp_qloop_143 = 0.5*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q];
                const real_t tmp_qloop_144 = tmp_qloop_121*tmp_qloop_136;
                const real_t tmp_qloop_145 = 0.5*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q];
                const real_t tmp_qloop_146 = tmp_qloop_121*tmp_qloop_139;
                const real_t tmp_qloop_147 = 0.5*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q];
                const real_t tmp_qloop_148 = tmp_qloop_126*0.5;
                const real_t tmp_qloop_149 = tmp_qloop_124*0.5;
                const real_t tmp_qloop_150 = tmp_qloop_128*0.5;
                const real_t tmp_qloop_151 = tmp_qloop_148*_data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN[q] + tmp_qloop_149*_data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN[q] + tmp_qloop_150*_data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN[q];
                const real_t tmp_qloop_152 = tmp_qloop_142*tmp_qloop_143*2.0 + tmp_qloop_144*tmp_qloop_145*2.0 + tmp_qloop_146*tmp_qloop_147*2.0 + tmp_qloop_151*2.0;
                const real_t tmp_qloop_153 = -tmp_qloop_109*tmp_qloop_18*tmp_qloop_43 + tmp_qloop_113*tmp_qloop_133;
                const real_t tmp_qloop_154 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*1.0 - tmp_qloop_114*tmp_qloop_135;
                const real_t tmp_qloop_155 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0 - tmp_qloop_118*tmp_qloop_138;
                const real_t tmp_qloop_156 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[q] + tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[q] + tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[q];
                const real_t tmp_qloop_157 = tmp_qloop_121*tmp_qloop_153;
                const real_t tmp_qloop_158 = tmp_qloop_121*tmp_qloop_154;
                const real_t tmp_qloop_159 = tmp_qloop_121*tmp_qloop_155;
                const real_t tmp_qloop_160 = tmp_qloop_148*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[q] + tmp_qloop_149*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[q] + tmp_qloop_150*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[q];
                const real_t tmp_qloop_161 = tmp_qloop_143*tmp_qloop_159*2.0 + tmp_qloop_145*tmp_qloop_158*2.0 + tmp_qloop_147*tmp_qloop_157*2.0 + tmp_qloop_160*2.0;
                const real_t tmp_qloop_162 = tmp_qloop_129*0.66666666666666667 + tmp_qloop_130*0.66666666666666667 + tmp_qloop_131*0.66666666666666667;
                const real_t tmp_qloop_163 = tmp_qloop_159*0.5;
                const real_t tmp_qloop_164 = tmp_qloop_158*0.5;
                const real_t tmp_qloop_165 = tmp_qloop_144*0.5;
                const real_t tmp_qloop_166 = tmp_qloop_146*0.5;
                const real_t tmp_qloop_167 = tmp_qloop_142*0.5;
                const real_t tmp_qloop_168 = tmp_qloop_157*0.5;
                const real_t tmp_qloop_169 = (tmp_qloop_142*1.0*_data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN[q] + tmp_qloop_144*1.0*_data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN[q] + tmp_qloop_146*1.0*_data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN[q])*(tmp_qloop_142*2.0*_data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN[q] + tmp_qloop_144*2.0*_data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN[q] + tmp_qloop_146*2.0*_data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN[q]) + (tmp_qloop_157*1.0*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[q] + tmp_qloop_158*1.0*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[q] + tmp_qloop_159*1.0*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[q])*(tmp_qloop_157*2.0*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[q] + tmp_qloop_158*2.0*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[q] + tmp_qloop_159*2.0*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[q]) + (tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_2_WHITE_DOWN[q] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_2_WHITE_DOWN[q] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_2_WHITE_DOWN[q] + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_1_WHITE_DOWN[q] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_1_WHITE_DOWN[q] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_1_WHITE_DOWN[q])*(tmp_qloop_163*_data_jac_affine_inv_T_grad_psi_1_1_WHITE_DOWN[q] + tmp_qloop_164*_data_jac_affine_inv_T_grad_psi_0_1_WHITE_DOWN[q] + tmp_qloop_165*_data_jac_affine_inv_T_grad_psi_0_2_WHITE_DOWN[q] + tmp_qloop_166*_data_jac_affine_inv_T_grad_psi_2_2_WHITE_DOWN[q] + tmp_qloop_167*_data_jac_affine_inv_T_grad_psi_1_2_WHITE_DOWN[q] + tmp_qloop_168*_data_jac_affine_inv_T_grad_psi_2_1_WHITE_DOWN[q])*2.0;
                const real_t tmp_qloop_170 = abs_det_jac_affine_WHITE_DOWN*(mu_dof_0*_data_phi_0_0_WHITE_DOWN[10*q] + mu_dof_1*_data_phi_0_0_WHITE_DOWN[10*q + 1] + mu_dof_2*_data_phi_0_0_WHITE_DOWN[10*q + 2] + mu_dof_3*_data_phi_0_0_WHITE_DOWN[10*q + 3] + mu_dof_4*_data_phi_0_0_WHITE_DOWN[10*q + 4] + mu_dof_5*_data_phi_0_0_WHITE_DOWN[10*q + 5] + mu_dof_6*_data_phi_0_0_WHITE_DOWN[10*q + 6] + mu_dof_7*_data_phi_0_0_WHITE_DOWN[10*q + 7] + mu_dof_8*_data_phi_0_0_WHITE_DOWN[10*q + 8] + mu_dof_9*_data_phi_0_0_WHITE_DOWN[10*q + 9])*abs(tmp_qloop_120)*_data_q_w[q];
                const real_t tmp_qloop_171 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_172 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_173 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_174 = tmp_qloop_171*2.0 + tmp_qloop_172*2.0 + tmp_qloop_173*2.0;
                const real_t tmp_qloop_175 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 1] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 1] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_176 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 1] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 1] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_177 = tmp_qloop_171 + tmp_qloop_172 + tmp_qloop_173;
                const real_t tmp_qloop_178 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_179 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_180 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_181 = tmp_qloop_178*2.0 + tmp_qloop_179*2.0 + tmp_qloop_180*2.0;
                const real_t tmp_qloop_182 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 2] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 2] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_183 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 2] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 2] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_184 = tmp_qloop_178 + tmp_qloop_179 + tmp_qloop_180;
                const real_t tmp_qloop_185 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_186 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_187 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_188 = tmp_qloop_185*2.0 + tmp_qloop_186*2.0 + tmp_qloop_187*2.0;
                const real_t tmp_qloop_189 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 3] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 3] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_190 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 3] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 3] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_191 = tmp_qloop_185 + tmp_qloop_186 + tmp_qloop_187;
                const real_t tmp_qloop_192 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_193 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_194 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_195 = tmp_qloop_192*2.0 + tmp_qloop_193*2.0 + tmp_qloop_194*2.0;
                const real_t tmp_qloop_196 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 4] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 4] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_197 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 4] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 4] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_198 = tmp_qloop_192 + tmp_qloop_193 + tmp_qloop_194;
                const real_t tmp_qloop_199 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_200 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_201 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_202 = tmp_qloop_199*2.0 + tmp_qloop_200*2.0 + tmp_qloop_201*2.0;
                const real_t tmp_qloop_203 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 5] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 5] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_204 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 5] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 5] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_205 = tmp_qloop_199 + tmp_qloop_200 + tmp_qloop_201;
                const real_t tmp_qloop_206 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_207 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_208 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_209 = tmp_qloop_206*2.0 + tmp_qloop_207*2.0 + tmp_qloop_208*2.0;
                const real_t tmp_qloop_210 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 6] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 6] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_211 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 6] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 6] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_212 = tmp_qloop_206 + tmp_qloop_207 + tmp_qloop_208;
                const real_t tmp_qloop_213 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_214 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_215 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_216 = tmp_qloop_213*2.0 + tmp_qloop_214*2.0 + tmp_qloop_215*2.0;
                const real_t tmp_qloop_217 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 7] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 7] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_218 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 7] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 7] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_219 = tmp_qloop_213 + tmp_qloop_214 + tmp_qloop_215;
                const real_t tmp_qloop_220 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_221 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_222 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_223 = tmp_qloop_220*2.0 + tmp_qloop_221*2.0 + tmp_qloop_222*2.0;
                const real_t tmp_qloop_224 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 8] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 8] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_225 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 8] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 8] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_226 = tmp_qloop_220 + tmp_qloop_221 + tmp_qloop_222;
                const real_t tmp_qloop_227 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 9];
                const real_t tmp_qloop_228 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 9];
                const real_t tmp_qloop_229 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 9];
                const real_t tmp_qloop_230 = tmp_qloop_227*2.0 + tmp_qloop_228*2.0 + tmp_qloop_229*2.0;
                const real_t tmp_qloop_231 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 9] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 9] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 9];
                const real_t tmp_qloop_232 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_WHITE_DOWN[10*q + 9] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_WHITE_DOWN[10*q + 9] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_WHITE_DOWN[10*q + 9];
                const real_t tmp_qloop_233 = tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229;
                const real_t tmp_qloop_234 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_235 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_236 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_237 = tmp_qloop_234*1.0 + tmp_qloop_235*1.0 + tmp_qloop_236*1.0;
                const real_t tmp_qloop_238 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 1] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 1] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_239 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 1] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 1] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_240 = tmp_qloop_234*0.66666666666666667 + tmp_qloop_235*0.66666666666666667 + tmp_qloop_236*0.66666666666666667;
                const real_t tmp_qloop_241 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_242 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_243 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_244 = tmp_qloop_241*1.0 + tmp_qloop_242*1.0 + tmp_qloop_243*1.0;
                const real_t tmp_qloop_245 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 2] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 2] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_246 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 2] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 2] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_247 = tmp_qloop_241*0.66666666666666667 + tmp_qloop_242*0.66666666666666667 + tmp_qloop_243*0.66666666666666667;
                const real_t tmp_qloop_248 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_249 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_250 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_251 = tmp_qloop_248*1.0 + tmp_qloop_249*1.0 + tmp_qloop_250*1.0;
                const real_t tmp_qloop_252 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 3] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 3] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_253 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 3] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 3] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_254 = tmp_qloop_248*0.66666666666666667 + tmp_qloop_249*0.66666666666666667 + tmp_qloop_250*0.66666666666666667;
                const real_t tmp_qloop_255 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_256 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_257 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_258 = tmp_qloop_255*1.0 + tmp_qloop_256*1.0 + tmp_qloop_257*1.0;
                const real_t tmp_qloop_259 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 4] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 4] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_260 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 4] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 4] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_261 = tmp_qloop_255*0.66666666666666667 + tmp_qloop_256*0.66666666666666667 + tmp_qloop_257*0.66666666666666667;
                const real_t tmp_qloop_262 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_263 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_264 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_265 = tmp_qloop_262*1.0 + tmp_qloop_263*1.0 + tmp_qloop_264*1.0;
                const real_t tmp_qloop_266 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 5] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 5] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_267 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 5] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 5] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_268 = tmp_qloop_262*0.66666666666666667 + tmp_qloop_263*0.66666666666666667 + tmp_qloop_264*0.66666666666666667;
                const real_t tmp_qloop_269 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_270 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_271 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_272 = tmp_qloop_269*1.0 + tmp_qloop_270*1.0 + tmp_qloop_271*1.0;
                const real_t tmp_qloop_273 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 6] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 6] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_274 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 6] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 6] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_275 = tmp_qloop_269*0.66666666666666667 + tmp_qloop_270*0.66666666666666667 + tmp_qloop_271*0.66666666666666667;
                const real_t tmp_qloop_276 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_277 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_278 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_279 = tmp_qloop_276*1.0 + tmp_qloop_277*1.0 + tmp_qloop_278*1.0;
                const real_t tmp_qloop_280 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 7] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 7] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_281 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 7] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 7] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_282 = tmp_qloop_276*0.66666666666666667 + tmp_qloop_277*0.66666666666666667 + tmp_qloop_278*0.66666666666666667;
                const real_t tmp_qloop_283 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_284 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_285 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_286 = tmp_qloop_283*1.0 + tmp_qloop_284*1.0 + tmp_qloop_285*1.0;
                const real_t tmp_qloop_287 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 8] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 8] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_288 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 8] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 8] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_289 = tmp_qloop_283*0.66666666666666667 + tmp_qloop_284*0.66666666666666667 + tmp_qloop_285*0.66666666666666667;
                const real_t tmp_qloop_290 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 9];
                const real_t tmp_qloop_291 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 9];
                const real_t tmp_qloop_292 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 9];
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_170*(tmp_qloop_132*(tmp_qloop_123*2.0 + tmp_qloop_125*2.0 + tmp_qloop_127*2.0) + tmp_qloop_152*(tmp_qloop_122*tmp_qloop_134 + tmp_qloop_136*tmp_qloop_137 + tmp_qloop_139*tmp_qloop_140 + tmp_qloop_141) + tmp_qloop_161*(tmp_qloop_122*tmp_qloop_155 + tmp_qloop_137*tmp_qloop_154 + tmp_qloop_140*tmp_qloop_153 + tmp_qloop_156) - tmp_qloop_162*(tmp_qloop_123 + tmp_qloop_125 + tmp_qloop_127) + tmp_qloop_169);
                const real_t q_tmp_0_1 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_174 + tmp_qloop_152*tmp_qloop_175 + tmp_qloop_161*tmp_qloop_176 - tmp_qloop_162*tmp_qloop_177 + tmp_qloop_169);
                const real_t q_tmp_0_2 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_181 + tmp_qloop_152*tmp_qloop_182 + tmp_qloop_161*tmp_qloop_183 - tmp_qloop_162*tmp_qloop_184 + tmp_qloop_169);
                const real_t q_tmp_0_3 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_188 + tmp_qloop_152*tmp_qloop_189 + tmp_qloop_161*tmp_qloop_190 - tmp_qloop_162*tmp_qloop_191 + tmp_qloop_169);
                const real_t q_tmp_0_4 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_195 + tmp_qloop_152*tmp_qloop_196 + tmp_qloop_161*tmp_qloop_197 - tmp_qloop_162*tmp_qloop_198 + tmp_qloop_169);
                const real_t q_tmp_0_5 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_202 + tmp_qloop_152*tmp_qloop_203 + tmp_qloop_161*tmp_qloop_204 - tmp_qloop_162*tmp_qloop_205 + tmp_qloop_169);
                const real_t q_tmp_0_6 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_209 + tmp_qloop_152*tmp_qloop_210 + tmp_qloop_161*tmp_qloop_211 - tmp_qloop_162*tmp_qloop_212 + tmp_qloop_169);
                const real_t q_tmp_0_7 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_216 + tmp_qloop_152*tmp_qloop_217 + tmp_qloop_161*tmp_qloop_218 - tmp_qloop_162*tmp_qloop_219 + tmp_qloop_169);
                const real_t q_tmp_0_8 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_223 + tmp_qloop_152*tmp_qloop_224 + tmp_qloop_161*tmp_qloop_225 - tmp_qloop_162*tmp_qloop_226 + tmp_qloop_169);
                const real_t q_tmp_0_9 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_230 + tmp_qloop_152*tmp_qloop_231 + tmp_qloop_161*tmp_qloop_232 - tmp_qloop_162*tmp_qloop_233 + tmp_qloop_169);
                const real_t q_tmp_1_1 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_174*tmp_qloop_237 + tmp_qloop_175*tmp_qloop_238 + tmp_qloop_176*tmp_qloop_239 - tmp_qloop_177*tmp_qloop_240);
                const real_t q_tmp_1_2 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_181*tmp_qloop_237 + tmp_qloop_182*tmp_qloop_238 + tmp_qloop_183*tmp_qloop_239 - tmp_qloop_184*tmp_qloop_240);
                const real_t q_tmp_1_3 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_188*tmp_qloop_237 + tmp_qloop_189*tmp_qloop_238 + tmp_qloop_190*tmp_qloop_239 - tmp_qloop_191*tmp_qloop_240);
                const real_t q_tmp_1_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_237 + tmp_qloop_196*tmp_qloop_238 + tmp_qloop_197*tmp_qloop_239 - tmp_qloop_198*tmp_qloop_240);
                const real_t q_tmp_1_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_237 + tmp_qloop_203*tmp_qloop_238 + tmp_qloop_204*tmp_qloop_239 - tmp_qloop_205*tmp_qloop_240);
                const real_t q_tmp_1_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_237 + tmp_qloop_210*tmp_qloop_238 + tmp_qloop_211*tmp_qloop_239 - tmp_qloop_212*tmp_qloop_240);
                const real_t q_tmp_1_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_237 + tmp_qloop_217*tmp_qloop_238 + tmp_qloop_218*tmp_qloop_239 - tmp_qloop_219*tmp_qloop_240);
                const real_t q_tmp_1_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_237 + tmp_qloop_224*tmp_qloop_238 + tmp_qloop_225*tmp_qloop_239 - tmp_qloop_226*tmp_qloop_240);
                const real_t q_tmp_1_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_237 + tmp_qloop_231*tmp_qloop_238 + tmp_qloop_232*tmp_qloop_239 - tmp_qloop_233*tmp_qloop_240);
                const real_t q_tmp_2_2 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_181*tmp_qloop_244 + tmp_qloop_182*tmp_qloop_245 + tmp_qloop_183*tmp_qloop_246 - tmp_qloop_184*tmp_qloop_247);
                const real_t q_tmp_2_3 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_188*tmp_qloop_244 + tmp_qloop_189*tmp_qloop_245 + tmp_qloop_190*tmp_qloop_246 - tmp_qloop_191*tmp_qloop_247);
                const real_t q_tmp_2_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_244 + tmp_qloop_196*tmp_qloop_245 + tmp_qloop_197*tmp_qloop_246 - tmp_qloop_198*tmp_qloop_247);
                const real_t q_tmp_2_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_244 + tmp_qloop_203*tmp_qloop_245 + tmp_qloop_204*tmp_qloop_246 - tmp_qloop_205*tmp_qloop_247);
                const real_t q_tmp_2_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_244 + tmp_qloop_210*tmp_qloop_245 + tmp_qloop_211*tmp_qloop_246 - tmp_qloop_212*tmp_qloop_247);
                const real_t q_tmp_2_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_244 + tmp_qloop_217*tmp_qloop_245 + tmp_qloop_218*tmp_qloop_246 - tmp_qloop_219*tmp_qloop_247);
                const real_t q_tmp_2_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_244 + tmp_qloop_224*tmp_qloop_245 + tmp_qloop_225*tmp_qloop_246 - tmp_qloop_226*tmp_qloop_247);
                const real_t q_tmp_2_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_244 + tmp_qloop_231*tmp_qloop_245 + tmp_qloop_232*tmp_qloop_246 - tmp_qloop_233*tmp_qloop_247);
                const real_t q_tmp_3_3 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_188*tmp_qloop_251 + tmp_qloop_189*tmp_qloop_252 + tmp_qloop_190*tmp_qloop_253 - tmp_qloop_191*tmp_qloop_254);
                const real_t q_tmp_3_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_251 + tmp_qloop_196*tmp_qloop_252 + tmp_qloop_197*tmp_qloop_253 - tmp_qloop_198*tmp_qloop_254);
                const real_t q_tmp_3_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_251 + tmp_qloop_203*tmp_qloop_252 + tmp_qloop_204*tmp_qloop_253 - tmp_qloop_205*tmp_qloop_254);
                const real_t q_tmp_3_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_251 + tmp_qloop_210*tmp_qloop_252 + tmp_qloop_211*tmp_qloop_253 - tmp_qloop_212*tmp_qloop_254);
                const real_t q_tmp_3_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_251 + tmp_qloop_217*tmp_qloop_252 + tmp_qloop_218*tmp_qloop_253 - tmp_qloop_219*tmp_qloop_254);
                const real_t q_tmp_3_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_251 + tmp_qloop_224*tmp_qloop_252 + tmp_qloop_225*tmp_qloop_253 - tmp_qloop_226*tmp_qloop_254);
                const real_t q_tmp_3_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_251 + tmp_qloop_231*tmp_qloop_252 + tmp_qloop_232*tmp_qloop_253 - tmp_qloop_233*tmp_qloop_254);
                const real_t q_tmp_4_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_258 + tmp_qloop_196*tmp_qloop_259 + tmp_qloop_197*tmp_qloop_260 - tmp_qloop_198*tmp_qloop_261);
                const real_t q_tmp_4_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_258 + tmp_qloop_203*tmp_qloop_259 + tmp_qloop_204*tmp_qloop_260 - tmp_qloop_205*tmp_qloop_261);
                const real_t q_tmp_4_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_258 + tmp_qloop_210*tmp_qloop_259 + tmp_qloop_211*tmp_qloop_260 - tmp_qloop_212*tmp_qloop_261);
                const real_t q_tmp_4_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_258 + tmp_qloop_217*tmp_qloop_259 + tmp_qloop_218*tmp_qloop_260 - tmp_qloop_219*tmp_qloop_261);
                const real_t q_tmp_4_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_258 + tmp_qloop_224*tmp_qloop_259 + tmp_qloop_225*tmp_qloop_260 - tmp_qloop_226*tmp_qloop_261);
                const real_t q_tmp_4_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_258 + tmp_qloop_231*tmp_qloop_259 + tmp_qloop_232*tmp_qloop_260 - tmp_qloop_233*tmp_qloop_261);
                const real_t q_tmp_5_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_265 + tmp_qloop_203*tmp_qloop_266 + tmp_qloop_204*tmp_qloop_267 - tmp_qloop_205*tmp_qloop_268);
                const real_t q_tmp_5_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_265 + tmp_qloop_210*tmp_qloop_266 + tmp_qloop_211*tmp_qloop_267 - tmp_qloop_212*tmp_qloop_268);
                const real_t q_tmp_5_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_265 + tmp_qloop_217*tmp_qloop_266 + tmp_qloop_218*tmp_qloop_267 - tmp_qloop_219*tmp_qloop_268);
                const real_t q_tmp_5_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_265 + tmp_qloop_224*tmp_qloop_266 + tmp_qloop_225*tmp_qloop_267 - tmp_qloop_226*tmp_qloop_268);
                const real_t q_tmp_5_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_265 + tmp_qloop_231*tmp_qloop_266 + tmp_qloop_232*tmp_qloop_267 - tmp_qloop_233*tmp_qloop_268);
                const real_t q_tmp_6_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_272 + tmp_qloop_210*tmp_qloop_273 + tmp_qloop_211*tmp_qloop_274 - tmp_qloop_212*tmp_qloop_275);
                const real_t q_tmp_6_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_272 + tmp_qloop_217*tmp_qloop_273 + tmp_qloop_218*tmp_qloop_274 - tmp_qloop_219*tmp_qloop_275);
                const real_t q_tmp_6_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_272 + tmp_qloop_224*tmp_qloop_273 + tmp_qloop_225*tmp_qloop_274 - tmp_qloop_226*tmp_qloop_275);
                const real_t q_tmp_6_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_272 + tmp_qloop_231*tmp_qloop_273 + tmp_qloop_232*tmp_qloop_274 - tmp_qloop_233*tmp_qloop_275);
                const real_t q_tmp_7_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_279 + tmp_qloop_217*tmp_qloop_280 + tmp_qloop_218*tmp_qloop_281 - tmp_qloop_219*tmp_qloop_282);
                const real_t q_tmp_7_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_279 + tmp_qloop_224*tmp_qloop_280 + tmp_qloop_225*tmp_qloop_281 - tmp_qloop_226*tmp_qloop_282);
                const real_t q_tmp_7_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_279 + tmp_qloop_231*tmp_qloop_280 + tmp_qloop_232*tmp_qloop_281 - tmp_qloop_233*tmp_qloop_282);
                const real_t q_tmp_8_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_286 + tmp_qloop_224*tmp_qloop_287 + tmp_qloop_225*tmp_qloop_288 - tmp_qloop_226*tmp_qloop_289);
                const real_t q_tmp_8_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_286 + tmp_qloop_231*tmp_qloop_287 + tmp_qloop_232*tmp_qloop_288 - tmp_qloop_233*tmp_qloop_289);
                const real_t q_tmp_9_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*(tmp_qloop_290*1.0 + tmp_qloop_291*1.0 + tmp_qloop_292*1.0) + tmp_qloop_231*(tmp_qloop_151 + tmp_qloop_165*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 9] + tmp_qloop_166*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 9] + tmp_qloop_167*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 9])*2.0 + tmp_qloop_232*(tmp_qloop_160 + tmp_qloop_163*_data_jac_affine_inv_T_grad_psi_1_0_WHITE_DOWN[10*q + 9] + tmp_qloop_164*_data_jac_affine_inv_T_grad_psi_0_0_WHITE_DOWN[10*q + 9] + tmp_qloop_168*_data_jac_affine_inv_T_grad_psi_2_0_WHITE_DOWN[10*q + 9])*2.0 + tmp_qloop_233*(tmp_qloop_290 + tmp_qloop_291 + tmp_qloop_292)*-0.66666666666666667);
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_9*src_dof_9;
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       {
          /* CellType.BLUE_UP */
          const real_t _data_phi_0_0_BLUE_UP [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_1_0_BLUE_UP)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), ((real_t)(-jac_affine_inv_1_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_0_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_1_1_BLUE_UP)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), ((real_t)(-jac_affine_inv_1_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_1_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_1_2_BLUE_UP)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), ((real_t)(-jac_affine_inv_1_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_2_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_1_0_BLUE_UP)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), ((real_t)(-jac_affine_inv_1_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_0_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_1_1_BLUE_UP)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), ((real_t)(-jac_affine_inv_1_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_1_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_1_2_BLUE_UP)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), ((real_t)(-jac_affine_inv_1_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_2_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_3 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_6 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_7 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 1.0 / (tmp_qloop_31*tmp_qloop_31*tmp_qloop_31);
                const real_t tmp_qloop_106 = tmp_qloop_59*1.0;
                const real_t tmp_qloop_107 = tmp_qloop_104*tmp_qloop_105;
                const real_t tmp_qloop_108 = tmp_qloop_107*tmp_qloop_52;
                const real_t tmp_qloop_109 = tmp_qloop_108*tmp_qloop_25;
                const real_t tmp_qloop_110 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_22*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0 - tmp_qloop_106*tmp_qloop_109;
                const real_t tmp_qloop_111 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_113 = tmp_qloop_56*1.0;
                const real_t tmp_qloop_114 = tmp_qloop_113*tmp_qloop_50;
                const real_t tmp_qloop_115 = tmp_qloop_111*tmp_qloop_112;
                const real_t tmp_qloop_116 = tmp_qloop_115*tmp_qloop_52;
                const real_t tmp_qloop_117 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_118 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_119 = tmp_qloop_117*tmp_qloop_118*1.0;
                const real_t tmp_qloop_120 = -tmp_qloop_106*tmp_qloop_116*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43 + tmp_qloop_111*tmp_qloop_112*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*2.0 + tmp_qloop_111*tmp_qloop_112*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59*1.0 - tmp_qloop_114*tmp_qloop_116*tmp_qloop_86 - tmp_qloop_115*tmp_qloop_119*tmp_qloop_36;
                const real_t tmp_qloop_121 = 1.0 / (tmp_qloop_120);
                const real_t tmp_qloop_122 = tmp_qloop_121*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q];
                const real_t tmp_qloop_123 = tmp_qloop_110*tmp_qloop_122;
                const real_t tmp_qloop_124 = tmp_qloop_121*(tmp_qloop_104*tmp_qloop_105*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_52*1.0 - tmp_qloop_108*tmp_qloop_113*tmp_qloop_22);
                const real_t tmp_qloop_125 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q];
                const real_t tmp_qloop_126 = tmp_qloop_121*(tmp_qloop_107*tmp_qloop_113*tmp_qloop_59 - tmp_qloop_107*tmp_qloop_119);
                const real_t tmp_qloop_127 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q];
                const real_t tmp_qloop_128 = tmp_qloop_110*tmp_qloop_121;
                const real_t tmp_qloop_129 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q];
                const real_t tmp_qloop_130 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q];
                const real_t tmp_qloop_131 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q];
                const real_t tmp_qloop_132 = tmp_qloop_129*1.0 + tmp_qloop_130*1.0 + tmp_qloop_131*1.0;
                const real_t tmp_qloop_133 = tmp_qloop_107*tmp_qloop_36;
                const real_t tmp_qloop_134 = tmp_qloop_106*tmp_qloop_133 - tmp_qloop_108*tmp_qloop_50*tmp_qloop_86;
                const real_t tmp_qloop_135 = tmp_qloop_107*tmp_qloop_18;
                const real_t tmp_qloop_136 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_50*1.0 - tmp_qloop_106*tmp_qloop_135*tmp_qloop_43;
                const real_t tmp_qloop_137 = tmp_qloop_121*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q];
                const real_t tmp_qloop_138 = tmp_qloop_133*1.0;
                const real_t tmp_qloop_139 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_52*1.0 - tmp_qloop_117*tmp_qloop_138;
                const real_t tmp_qloop_140 = tmp_qloop_121*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q];
                const real_t tmp_qloop_141 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP[q] + tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP[q] + tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP[q];
                const real_t tmp_qloop_142 = tmp_qloop_121*tmp_qloop_134;
                const real_t tmp_qloop_143 = 0.5*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q];
                const real_t tmp_qloop_144 = tmp_qloop_121*tmp_qloop_136;
                const real_t tmp_qloop_145 = 0.5*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q];
                const real_t tmp_qloop_146 = tmp_qloop_121*tmp_qloop_139;
                const real_t tmp_qloop_147 = 0.5*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q];
                const real_t tmp_qloop_148 = tmp_qloop_126*0.5;
                const real_t tmp_qloop_149 = tmp_qloop_124*0.5;
                const real_t tmp_qloop_150 = tmp_qloop_128*0.5;
                const real_t tmp_qloop_151 = tmp_qloop_148*_data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP[q] + tmp_qloop_149*_data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP[q] + tmp_qloop_150*_data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP[q];
                const real_t tmp_qloop_152 = tmp_qloop_142*tmp_qloop_143*2.0 + tmp_qloop_144*tmp_qloop_145*2.0 + tmp_qloop_146*tmp_qloop_147*2.0 + tmp_qloop_151*2.0;
                const real_t tmp_qloop_153 = -tmp_qloop_109*tmp_qloop_18*tmp_qloop_43 + tmp_qloop_113*tmp_qloop_133;
                const real_t tmp_qloop_154 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*1.0 - tmp_qloop_114*tmp_qloop_135;
                const real_t tmp_qloop_155 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0 - tmp_qloop_118*tmp_qloop_138;
                const real_t tmp_qloop_156 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[q] + tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[q] + tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[q];
                const real_t tmp_qloop_157 = tmp_qloop_121*tmp_qloop_153;
                const real_t tmp_qloop_158 = tmp_qloop_121*tmp_qloop_154;
                const real_t tmp_qloop_159 = tmp_qloop_121*tmp_qloop_155;
                const real_t tmp_qloop_160 = tmp_qloop_148*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[q] + tmp_qloop_149*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[q] + tmp_qloop_150*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[q];
                const real_t tmp_qloop_161 = tmp_qloop_143*tmp_qloop_159*2.0 + tmp_qloop_145*tmp_qloop_158*2.0 + tmp_qloop_147*tmp_qloop_157*2.0 + tmp_qloop_160*2.0;
                const real_t tmp_qloop_162 = tmp_qloop_129*0.66666666666666667 + tmp_qloop_130*0.66666666666666667 + tmp_qloop_131*0.66666666666666667;
                const real_t tmp_qloop_163 = tmp_qloop_159*0.5;
                const real_t tmp_qloop_164 = tmp_qloop_158*0.5;
                const real_t tmp_qloop_165 = tmp_qloop_144*0.5;
                const real_t tmp_qloop_166 = tmp_qloop_146*0.5;
                const real_t tmp_qloop_167 = tmp_qloop_142*0.5;
                const real_t tmp_qloop_168 = tmp_qloop_157*0.5;
                const real_t tmp_qloop_169 = (tmp_qloop_142*1.0*_data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP[q] + tmp_qloop_144*1.0*_data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP[q] + tmp_qloop_146*1.0*_data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP[q])*(tmp_qloop_142*2.0*_data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP[q] + tmp_qloop_144*2.0*_data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP[q] + tmp_qloop_146*2.0*_data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP[q]) + (tmp_qloop_157*1.0*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[q] + tmp_qloop_158*1.0*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[q] + tmp_qloop_159*1.0*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[q])*(tmp_qloop_157*2.0*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[q] + tmp_qloop_158*2.0*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[q] + tmp_qloop_159*2.0*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[q]) + (tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_UP[q] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_UP[q] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_UP[q] + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_1_BLUE_UP[q] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_1_BLUE_UP[q] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_1_BLUE_UP[q])*(tmp_qloop_163*_data_jac_affine_inv_T_grad_psi_1_1_BLUE_UP[q] + tmp_qloop_164*_data_jac_affine_inv_T_grad_psi_0_1_BLUE_UP[q] + tmp_qloop_165*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_UP[q] + tmp_qloop_166*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_UP[q] + tmp_qloop_167*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_UP[q] + tmp_qloop_168*_data_jac_affine_inv_T_grad_psi_2_1_BLUE_UP[q])*2.0;
                const real_t tmp_qloop_170 = abs_det_jac_affine_BLUE_UP*(mu_dof_0*_data_phi_0_0_BLUE_UP[10*q] + mu_dof_1*_data_phi_0_0_BLUE_UP[10*q + 1] + mu_dof_2*_data_phi_0_0_BLUE_UP[10*q + 2] + mu_dof_3*_data_phi_0_0_BLUE_UP[10*q + 3] + mu_dof_4*_data_phi_0_0_BLUE_UP[10*q + 4] + mu_dof_5*_data_phi_0_0_BLUE_UP[10*q + 5] + mu_dof_6*_data_phi_0_0_BLUE_UP[10*q + 6] + mu_dof_7*_data_phi_0_0_BLUE_UP[10*q + 7] + mu_dof_8*_data_phi_0_0_BLUE_UP[10*q + 8] + mu_dof_9*_data_phi_0_0_BLUE_UP[10*q + 9])*abs(tmp_qloop_120)*_data_q_w[q];
                const real_t tmp_qloop_171 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_172 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_173 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_174 = tmp_qloop_171*2.0 + tmp_qloop_172*2.0 + tmp_qloop_173*2.0;
                const real_t tmp_qloop_175 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 1] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 1] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_176 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 1] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 1] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_177 = tmp_qloop_171 + tmp_qloop_172 + tmp_qloop_173;
                const real_t tmp_qloop_178 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_179 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_180 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_181 = tmp_qloop_178*2.0 + tmp_qloop_179*2.0 + tmp_qloop_180*2.0;
                const real_t tmp_qloop_182 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 2] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 2] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_183 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 2] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 2] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_184 = tmp_qloop_178 + tmp_qloop_179 + tmp_qloop_180;
                const real_t tmp_qloop_185 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_186 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_187 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_188 = tmp_qloop_185*2.0 + tmp_qloop_186*2.0 + tmp_qloop_187*2.0;
                const real_t tmp_qloop_189 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 3] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 3] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_190 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 3] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 3] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_191 = tmp_qloop_185 + tmp_qloop_186 + tmp_qloop_187;
                const real_t tmp_qloop_192 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_193 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_194 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_195 = tmp_qloop_192*2.0 + tmp_qloop_193*2.0 + tmp_qloop_194*2.0;
                const real_t tmp_qloop_196 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 4] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 4] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_197 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 4] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 4] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_198 = tmp_qloop_192 + tmp_qloop_193 + tmp_qloop_194;
                const real_t tmp_qloop_199 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_200 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_201 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_202 = tmp_qloop_199*2.0 + tmp_qloop_200*2.0 + tmp_qloop_201*2.0;
                const real_t tmp_qloop_203 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 5] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 5] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_204 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 5] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 5] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_205 = tmp_qloop_199 + tmp_qloop_200 + tmp_qloop_201;
                const real_t tmp_qloop_206 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_207 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_208 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_209 = tmp_qloop_206*2.0 + tmp_qloop_207*2.0 + tmp_qloop_208*2.0;
                const real_t tmp_qloop_210 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 6] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 6] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_211 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 6] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 6] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_212 = tmp_qloop_206 + tmp_qloop_207 + tmp_qloop_208;
                const real_t tmp_qloop_213 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_214 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_215 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_216 = tmp_qloop_213*2.0 + tmp_qloop_214*2.0 + tmp_qloop_215*2.0;
                const real_t tmp_qloop_217 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 7] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 7] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_218 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 7] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 7] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_219 = tmp_qloop_213 + tmp_qloop_214 + tmp_qloop_215;
                const real_t tmp_qloop_220 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_221 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_222 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_223 = tmp_qloop_220*2.0 + tmp_qloop_221*2.0 + tmp_qloop_222*2.0;
                const real_t tmp_qloop_224 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 8] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 8] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_225 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 8] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 8] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_226 = tmp_qloop_220 + tmp_qloop_221 + tmp_qloop_222;
                const real_t tmp_qloop_227 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 9];
                const real_t tmp_qloop_228 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 9];
                const real_t tmp_qloop_229 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 9];
                const real_t tmp_qloop_230 = tmp_qloop_227*2.0 + tmp_qloop_228*2.0 + tmp_qloop_229*2.0;
                const real_t tmp_qloop_231 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 9] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 9] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 9];
                const real_t tmp_qloop_232 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_UP[10*q + 9] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_UP[10*q + 9] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_UP[10*q + 9];
                const real_t tmp_qloop_233 = tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229;
                const real_t tmp_qloop_234 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_235 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_236 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_237 = tmp_qloop_234*1.0 + tmp_qloop_235*1.0 + tmp_qloop_236*1.0;
                const real_t tmp_qloop_238 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 1] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 1] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_239 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 1] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 1] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_240 = tmp_qloop_234*0.66666666666666667 + tmp_qloop_235*0.66666666666666667 + tmp_qloop_236*0.66666666666666667;
                const real_t tmp_qloop_241 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_242 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_243 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_244 = tmp_qloop_241*1.0 + tmp_qloop_242*1.0 + tmp_qloop_243*1.0;
                const real_t tmp_qloop_245 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 2] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 2] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_246 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 2] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 2] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_247 = tmp_qloop_241*0.66666666666666667 + tmp_qloop_242*0.66666666666666667 + tmp_qloop_243*0.66666666666666667;
                const real_t tmp_qloop_248 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_249 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_250 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_251 = tmp_qloop_248*1.0 + tmp_qloop_249*1.0 + tmp_qloop_250*1.0;
                const real_t tmp_qloop_252 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 3] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 3] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_253 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 3] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 3] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_254 = tmp_qloop_248*0.66666666666666667 + tmp_qloop_249*0.66666666666666667 + tmp_qloop_250*0.66666666666666667;
                const real_t tmp_qloop_255 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_256 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_257 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_258 = tmp_qloop_255*1.0 + tmp_qloop_256*1.0 + tmp_qloop_257*1.0;
                const real_t tmp_qloop_259 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 4] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 4] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_260 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 4] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 4] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_261 = tmp_qloop_255*0.66666666666666667 + tmp_qloop_256*0.66666666666666667 + tmp_qloop_257*0.66666666666666667;
                const real_t tmp_qloop_262 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_263 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_264 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_265 = tmp_qloop_262*1.0 + tmp_qloop_263*1.0 + tmp_qloop_264*1.0;
                const real_t tmp_qloop_266 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 5] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 5] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_267 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 5] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 5] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_268 = tmp_qloop_262*0.66666666666666667 + tmp_qloop_263*0.66666666666666667 + tmp_qloop_264*0.66666666666666667;
                const real_t tmp_qloop_269 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_270 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_271 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_272 = tmp_qloop_269*1.0 + tmp_qloop_270*1.0 + tmp_qloop_271*1.0;
                const real_t tmp_qloop_273 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 6] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 6] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_274 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 6] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 6] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_275 = tmp_qloop_269*0.66666666666666667 + tmp_qloop_270*0.66666666666666667 + tmp_qloop_271*0.66666666666666667;
                const real_t tmp_qloop_276 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_277 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_278 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_279 = tmp_qloop_276*1.0 + tmp_qloop_277*1.0 + tmp_qloop_278*1.0;
                const real_t tmp_qloop_280 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 7] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 7] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_281 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 7] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 7] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_282 = tmp_qloop_276*0.66666666666666667 + tmp_qloop_277*0.66666666666666667 + tmp_qloop_278*0.66666666666666667;
                const real_t tmp_qloop_283 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_284 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_285 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_286 = tmp_qloop_283*1.0 + tmp_qloop_284*1.0 + tmp_qloop_285*1.0;
                const real_t tmp_qloop_287 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 8] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 8] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_288 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 8] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 8] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_289 = tmp_qloop_283*0.66666666666666667 + tmp_qloop_284*0.66666666666666667 + tmp_qloop_285*0.66666666666666667;
                const real_t tmp_qloop_290 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 9];
                const real_t tmp_qloop_291 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 9];
                const real_t tmp_qloop_292 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 9];
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_170*(tmp_qloop_132*(tmp_qloop_123*2.0 + tmp_qloop_125*2.0 + tmp_qloop_127*2.0) + tmp_qloop_152*(tmp_qloop_122*tmp_qloop_134 + tmp_qloop_136*tmp_qloop_137 + tmp_qloop_139*tmp_qloop_140 + tmp_qloop_141) + tmp_qloop_161*(tmp_qloop_122*tmp_qloop_155 + tmp_qloop_137*tmp_qloop_154 + tmp_qloop_140*tmp_qloop_153 + tmp_qloop_156) - tmp_qloop_162*(tmp_qloop_123 + tmp_qloop_125 + tmp_qloop_127) + tmp_qloop_169);
                const real_t q_tmp_0_1 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_174 + tmp_qloop_152*tmp_qloop_175 + tmp_qloop_161*tmp_qloop_176 - tmp_qloop_162*tmp_qloop_177 + tmp_qloop_169);
                const real_t q_tmp_0_2 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_181 + tmp_qloop_152*tmp_qloop_182 + tmp_qloop_161*tmp_qloop_183 - tmp_qloop_162*tmp_qloop_184 + tmp_qloop_169);
                const real_t q_tmp_0_3 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_188 + tmp_qloop_152*tmp_qloop_189 + tmp_qloop_161*tmp_qloop_190 - tmp_qloop_162*tmp_qloop_191 + tmp_qloop_169);
                const real_t q_tmp_0_4 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_195 + tmp_qloop_152*tmp_qloop_196 + tmp_qloop_161*tmp_qloop_197 - tmp_qloop_162*tmp_qloop_198 + tmp_qloop_169);
                const real_t q_tmp_0_5 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_202 + tmp_qloop_152*tmp_qloop_203 + tmp_qloop_161*tmp_qloop_204 - tmp_qloop_162*tmp_qloop_205 + tmp_qloop_169);
                const real_t q_tmp_0_6 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_209 + tmp_qloop_152*tmp_qloop_210 + tmp_qloop_161*tmp_qloop_211 - tmp_qloop_162*tmp_qloop_212 + tmp_qloop_169);
                const real_t q_tmp_0_7 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_216 + tmp_qloop_152*tmp_qloop_217 + tmp_qloop_161*tmp_qloop_218 - tmp_qloop_162*tmp_qloop_219 + tmp_qloop_169);
                const real_t q_tmp_0_8 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_223 + tmp_qloop_152*tmp_qloop_224 + tmp_qloop_161*tmp_qloop_225 - tmp_qloop_162*tmp_qloop_226 + tmp_qloop_169);
                const real_t q_tmp_0_9 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_230 + tmp_qloop_152*tmp_qloop_231 + tmp_qloop_161*tmp_qloop_232 - tmp_qloop_162*tmp_qloop_233 + tmp_qloop_169);
                const real_t q_tmp_1_1 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_174*tmp_qloop_237 + tmp_qloop_175*tmp_qloop_238 + tmp_qloop_176*tmp_qloop_239 - tmp_qloop_177*tmp_qloop_240);
                const real_t q_tmp_1_2 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_181*tmp_qloop_237 + tmp_qloop_182*tmp_qloop_238 + tmp_qloop_183*tmp_qloop_239 - tmp_qloop_184*tmp_qloop_240);
                const real_t q_tmp_1_3 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_188*tmp_qloop_237 + tmp_qloop_189*tmp_qloop_238 + tmp_qloop_190*tmp_qloop_239 - tmp_qloop_191*tmp_qloop_240);
                const real_t q_tmp_1_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_237 + tmp_qloop_196*tmp_qloop_238 + tmp_qloop_197*tmp_qloop_239 - tmp_qloop_198*tmp_qloop_240);
                const real_t q_tmp_1_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_237 + tmp_qloop_203*tmp_qloop_238 + tmp_qloop_204*tmp_qloop_239 - tmp_qloop_205*tmp_qloop_240);
                const real_t q_tmp_1_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_237 + tmp_qloop_210*tmp_qloop_238 + tmp_qloop_211*tmp_qloop_239 - tmp_qloop_212*tmp_qloop_240);
                const real_t q_tmp_1_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_237 + tmp_qloop_217*tmp_qloop_238 + tmp_qloop_218*tmp_qloop_239 - tmp_qloop_219*tmp_qloop_240);
                const real_t q_tmp_1_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_237 + tmp_qloop_224*tmp_qloop_238 + tmp_qloop_225*tmp_qloop_239 - tmp_qloop_226*tmp_qloop_240);
                const real_t q_tmp_1_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_237 + tmp_qloop_231*tmp_qloop_238 + tmp_qloop_232*tmp_qloop_239 - tmp_qloop_233*tmp_qloop_240);
                const real_t q_tmp_2_2 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_181*tmp_qloop_244 + tmp_qloop_182*tmp_qloop_245 + tmp_qloop_183*tmp_qloop_246 - tmp_qloop_184*tmp_qloop_247);
                const real_t q_tmp_2_3 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_188*tmp_qloop_244 + tmp_qloop_189*tmp_qloop_245 + tmp_qloop_190*tmp_qloop_246 - tmp_qloop_191*tmp_qloop_247);
                const real_t q_tmp_2_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_244 + tmp_qloop_196*tmp_qloop_245 + tmp_qloop_197*tmp_qloop_246 - tmp_qloop_198*tmp_qloop_247);
                const real_t q_tmp_2_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_244 + tmp_qloop_203*tmp_qloop_245 + tmp_qloop_204*tmp_qloop_246 - tmp_qloop_205*tmp_qloop_247);
                const real_t q_tmp_2_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_244 + tmp_qloop_210*tmp_qloop_245 + tmp_qloop_211*tmp_qloop_246 - tmp_qloop_212*tmp_qloop_247);
                const real_t q_tmp_2_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_244 + tmp_qloop_217*tmp_qloop_245 + tmp_qloop_218*tmp_qloop_246 - tmp_qloop_219*tmp_qloop_247);
                const real_t q_tmp_2_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_244 + tmp_qloop_224*tmp_qloop_245 + tmp_qloop_225*tmp_qloop_246 - tmp_qloop_226*tmp_qloop_247);
                const real_t q_tmp_2_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_244 + tmp_qloop_231*tmp_qloop_245 + tmp_qloop_232*tmp_qloop_246 - tmp_qloop_233*tmp_qloop_247);
                const real_t q_tmp_3_3 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_188*tmp_qloop_251 + tmp_qloop_189*tmp_qloop_252 + tmp_qloop_190*tmp_qloop_253 - tmp_qloop_191*tmp_qloop_254);
                const real_t q_tmp_3_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_251 + tmp_qloop_196*tmp_qloop_252 + tmp_qloop_197*tmp_qloop_253 - tmp_qloop_198*tmp_qloop_254);
                const real_t q_tmp_3_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_251 + tmp_qloop_203*tmp_qloop_252 + tmp_qloop_204*tmp_qloop_253 - tmp_qloop_205*tmp_qloop_254);
                const real_t q_tmp_3_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_251 + tmp_qloop_210*tmp_qloop_252 + tmp_qloop_211*tmp_qloop_253 - tmp_qloop_212*tmp_qloop_254);
                const real_t q_tmp_3_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_251 + tmp_qloop_217*tmp_qloop_252 + tmp_qloop_218*tmp_qloop_253 - tmp_qloop_219*tmp_qloop_254);
                const real_t q_tmp_3_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_251 + tmp_qloop_224*tmp_qloop_252 + tmp_qloop_225*tmp_qloop_253 - tmp_qloop_226*tmp_qloop_254);
                const real_t q_tmp_3_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_251 + tmp_qloop_231*tmp_qloop_252 + tmp_qloop_232*tmp_qloop_253 - tmp_qloop_233*tmp_qloop_254);
                const real_t q_tmp_4_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_258 + tmp_qloop_196*tmp_qloop_259 + tmp_qloop_197*tmp_qloop_260 - tmp_qloop_198*tmp_qloop_261);
                const real_t q_tmp_4_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_258 + tmp_qloop_203*tmp_qloop_259 + tmp_qloop_204*tmp_qloop_260 - tmp_qloop_205*tmp_qloop_261);
                const real_t q_tmp_4_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_258 + tmp_qloop_210*tmp_qloop_259 + tmp_qloop_211*tmp_qloop_260 - tmp_qloop_212*tmp_qloop_261);
                const real_t q_tmp_4_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_258 + tmp_qloop_217*tmp_qloop_259 + tmp_qloop_218*tmp_qloop_260 - tmp_qloop_219*tmp_qloop_261);
                const real_t q_tmp_4_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_258 + tmp_qloop_224*tmp_qloop_259 + tmp_qloop_225*tmp_qloop_260 - tmp_qloop_226*tmp_qloop_261);
                const real_t q_tmp_4_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_258 + tmp_qloop_231*tmp_qloop_259 + tmp_qloop_232*tmp_qloop_260 - tmp_qloop_233*tmp_qloop_261);
                const real_t q_tmp_5_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_265 + tmp_qloop_203*tmp_qloop_266 + tmp_qloop_204*tmp_qloop_267 - tmp_qloop_205*tmp_qloop_268);
                const real_t q_tmp_5_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_265 + tmp_qloop_210*tmp_qloop_266 + tmp_qloop_211*tmp_qloop_267 - tmp_qloop_212*tmp_qloop_268);
                const real_t q_tmp_5_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_265 + tmp_qloop_217*tmp_qloop_266 + tmp_qloop_218*tmp_qloop_267 - tmp_qloop_219*tmp_qloop_268);
                const real_t q_tmp_5_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_265 + tmp_qloop_224*tmp_qloop_266 + tmp_qloop_225*tmp_qloop_267 - tmp_qloop_226*tmp_qloop_268);
                const real_t q_tmp_5_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_265 + tmp_qloop_231*tmp_qloop_266 + tmp_qloop_232*tmp_qloop_267 - tmp_qloop_233*tmp_qloop_268);
                const real_t q_tmp_6_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_272 + tmp_qloop_210*tmp_qloop_273 + tmp_qloop_211*tmp_qloop_274 - tmp_qloop_212*tmp_qloop_275);
                const real_t q_tmp_6_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_272 + tmp_qloop_217*tmp_qloop_273 + tmp_qloop_218*tmp_qloop_274 - tmp_qloop_219*tmp_qloop_275);
                const real_t q_tmp_6_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_272 + tmp_qloop_224*tmp_qloop_273 + tmp_qloop_225*tmp_qloop_274 - tmp_qloop_226*tmp_qloop_275);
                const real_t q_tmp_6_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_272 + tmp_qloop_231*tmp_qloop_273 + tmp_qloop_232*tmp_qloop_274 - tmp_qloop_233*tmp_qloop_275);
                const real_t q_tmp_7_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_279 + tmp_qloop_217*tmp_qloop_280 + tmp_qloop_218*tmp_qloop_281 - tmp_qloop_219*tmp_qloop_282);
                const real_t q_tmp_7_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_279 + tmp_qloop_224*tmp_qloop_280 + tmp_qloop_225*tmp_qloop_281 - tmp_qloop_226*tmp_qloop_282);
                const real_t q_tmp_7_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_279 + tmp_qloop_231*tmp_qloop_280 + tmp_qloop_232*tmp_qloop_281 - tmp_qloop_233*tmp_qloop_282);
                const real_t q_tmp_8_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_286 + tmp_qloop_224*tmp_qloop_287 + tmp_qloop_225*tmp_qloop_288 - tmp_qloop_226*tmp_qloop_289);
                const real_t q_tmp_8_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_286 + tmp_qloop_231*tmp_qloop_287 + tmp_qloop_232*tmp_qloop_288 - tmp_qloop_233*tmp_qloop_289);
                const real_t q_tmp_9_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*(tmp_qloop_290*1.0 + tmp_qloop_291*1.0 + tmp_qloop_292*1.0) + tmp_qloop_231*(tmp_qloop_151 + tmp_qloop_165*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 9] + tmp_qloop_166*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 9] + tmp_qloop_167*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 9])*2.0 + tmp_qloop_232*(tmp_qloop_160 + tmp_qloop_163*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_UP[10*q + 9] + tmp_qloop_164*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_UP[10*q + 9] + tmp_qloop_168*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_UP[10*q + 9])*2.0 + tmp_qloop_233*(tmp_qloop_290 + tmp_qloop_291 + tmp_qloop_292)*-0.66666666666666667);
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_9*src_dof_9;
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       {
          /* CellType.BLUE_DOWN */
          const real_t _data_phi_0_0_BLUE_DOWN [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_1_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_1_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_1_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_1_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_1_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_1_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_3 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_7 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 1.0 / (tmp_qloop_31*tmp_qloop_31*tmp_qloop_31);
                const real_t tmp_qloop_106 = tmp_qloop_59*1.0;
                const real_t tmp_qloop_107 = tmp_qloop_104*tmp_qloop_105;
                const real_t tmp_qloop_108 = tmp_qloop_107*tmp_qloop_52;
                const real_t tmp_qloop_109 = tmp_qloop_108*tmp_qloop_25;
                const real_t tmp_qloop_110 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_22*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0 - tmp_qloop_106*tmp_qloop_109;
                const real_t tmp_qloop_111 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_113 = tmp_qloop_56*1.0;
                const real_t tmp_qloop_114 = tmp_qloop_113*tmp_qloop_50;
                const real_t tmp_qloop_115 = tmp_qloop_111*tmp_qloop_112;
                const real_t tmp_qloop_116 = tmp_qloop_115*tmp_qloop_52;
                const real_t tmp_qloop_117 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_118 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_119 = tmp_qloop_117*tmp_qloop_118*1.0;
                const real_t tmp_qloop_120 = -tmp_qloop_106*tmp_qloop_116*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43 + tmp_qloop_111*tmp_qloop_112*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*2.0 + tmp_qloop_111*tmp_qloop_112*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59*1.0 - tmp_qloop_114*tmp_qloop_116*tmp_qloop_86 - tmp_qloop_115*tmp_qloop_119*tmp_qloop_36;
                const real_t tmp_qloop_121 = 1.0 / (tmp_qloop_120);
                const real_t tmp_qloop_122 = tmp_qloop_121*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q];
                const real_t tmp_qloop_123 = tmp_qloop_110*tmp_qloop_122;
                const real_t tmp_qloop_124 = tmp_qloop_121*(tmp_qloop_104*tmp_qloop_105*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_52*1.0 - tmp_qloop_108*tmp_qloop_113*tmp_qloop_22);
                const real_t tmp_qloop_125 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q];
                const real_t tmp_qloop_126 = tmp_qloop_121*(tmp_qloop_107*tmp_qloop_113*tmp_qloop_59 - tmp_qloop_107*tmp_qloop_119);
                const real_t tmp_qloop_127 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q];
                const real_t tmp_qloop_128 = tmp_qloop_110*tmp_qloop_121;
                const real_t tmp_qloop_129 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q];
                const real_t tmp_qloop_130 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q];
                const real_t tmp_qloop_131 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q];
                const real_t tmp_qloop_132 = tmp_qloop_129*1.0 + tmp_qloop_130*1.0 + tmp_qloop_131*1.0;
                const real_t tmp_qloop_133 = tmp_qloop_107*tmp_qloop_36;
                const real_t tmp_qloop_134 = tmp_qloop_106*tmp_qloop_133 - tmp_qloop_108*tmp_qloop_50*tmp_qloop_86;
                const real_t tmp_qloop_135 = tmp_qloop_107*tmp_qloop_18;
                const real_t tmp_qloop_136 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_50*1.0 - tmp_qloop_106*tmp_qloop_135*tmp_qloop_43;
                const real_t tmp_qloop_137 = tmp_qloop_121*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q];
                const real_t tmp_qloop_138 = tmp_qloop_133*1.0;
                const real_t tmp_qloop_139 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_52*1.0 - tmp_qloop_117*tmp_qloop_138;
                const real_t tmp_qloop_140 = tmp_qloop_121*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q];
                const real_t tmp_qloop_141 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN[q] + tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN[q] + tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN[q];
                const real_t tmp_qloop_142 = tmp_qloop_121*tmp_qloop_134;
                const real_t tmp_qloop_143 = 0.5*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q];
                const real_t tmp_qloop_144 = tmp_qloop_121*tmp_qloop_136;
                const real_t tmp_qloop_145 = 0.5*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q];
                const real_t tmp_qloop_146 = tmp_qloop_121*tmp_qloop_139;
                const real_t tmp_qloop_147 = 0.5*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q];
                const real_t tmp_qloop_148 = tmp_qloop_126*0.5;
                const real_t tmp_qloop_149 = tmp_qloop_124*0.5;
                const real_t tmp_qloop_150 = tmp_qloop_128*0.5;
                const real_t tmp_qloop_151 = tmp_qloop_148*_data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN[q] + tmp_qloop_149*_data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN[q] + tmp_qloop_150*_data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN[q];
                const real_t tmp_qloop_152 = tmp_qloop_142*tmp_qloop_143*2.0 + tmp_qloop_144*tmp_qloop_145*2.0 + tmp_qloop_146*tmp_qloop_147*2.0 + tmp_qloop_151*2.0;
                const real_t tmp_qloop_153 = -tmp_qloop_109*tmp_qloop_18*tmp_qloop_43 + tmp_qloop_113*tmp_qloop_133;
                const real_t tmp_qloop_154 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*1.0 - tmp_qloop_114*tmp_qloop_135;
                const real_t tmp_qloop_155 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0 - tmp_qloop_118*tmp_qloop_138;
                const real_t tmp_qloop_156 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[q] + tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[q] + tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[q];
                const real_t tmp_qloop_157 = tmp_qloop_121*tmp_qloop_153;
                const real_t tmp_qloop_158 = tmp_qloop_121*tmp_qloop_154;
                const real_t tmp_qloop_159 = tmp_qloop_121*tmp_qloop_155;
                const real_t tmp_qloop_160 = tmp_qloop_148*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[q] + tmp_qloop_149*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[q] + tmp_qloop_150*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[q];
                const real_t tmp_qloop_161 = tmp_qloop_143*tmp_qloop_159*2.0 + tmp_qloop_145*tmp_qloop_158*2.0 + tmp_qloop_147*tmp_qloop_157*2.0 + tmp_qloop_160*2.0;
                const real_t tmp_qloop_162 = tmp_qloop_129*0.66666666666666667 + tmp_qloop_130*0.66666666666666667 + tmp_qloop_131*0.66666666666666667;
                const real_t tmp_qloop_163 = tmp_qloop_159*0.5;
                const real_t tmp_qloop_164 = tmp_qloop_158*0.5;
                const real_t tmp_qloop_165 = tmp_qloop_144*0.5;
                const real_t tmp_qloop_166 = tmp_qloop_146*0.5;
                const real_t tmp_qloop_167 = tmp_qloop_142*0.5;
                const real_t tmp_qloop_168 = tmp_qloop_157*0.5;
                const real_t tmp_qloop_169 = (tmp_qloop_142*1.0*_data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN[q] + tmp_qloop_144*1.0*_data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN[q] + tmp_qloop_146*1.0*_data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN[q])*(tmp_qloop_142*2.0*_data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN[q] + tmp_qloop_144*2.0*_data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN[q] + tmp_qloop_146*2.0*_data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN[q]) + (tmp_qloop_157*1.0*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[q] + tmp_qloop_158*1.0*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[q] + tmp_qloop_159*1.0*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[q])*(tmp_qloop_157*2.0*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[q] + tmp_qloop_158*2.0*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[q] + tmp_qloop_159*2.0*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[q]) + (tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_2_BLUE_DOWN[q] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_2_BLUE_DOWN[q] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_2_BLUE_DOWN[q] + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_1_BLUE_DOWN[q] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_1_BLUE_DOWN[q] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_1_BLUE_DOWN[q])*(tmp_qloop_163*_data_jac_affine_inv_T_grad_psi_1_1_BLUE_DOWN[q] + tmp_qloop_164*_data_jac_affine_inv_T_grad_psi_0_1_BLUE_DOWN[q] + tmp_qloop_165*_data_jac_affine_inv_T_grad_psi_0_2_BLUE_DOWN[q] + tmp_qloop_166*_data_jac_affine_inv_T_grad_psi_2_2_BLUE_DOWN[q] + tmp_qloop_167*_data_jac_affine_inv_T_grad_psi_1_2_BLUE_DOWN[q] + tmp_qloop_168*_data_jac_affine_inv_T_grad_psi_2_1_BLUE_DOWN[q])*2.0;
                const real_t tmp_qloop_170 = abs_det_jac_affine_BLUE_DOWN*(mu_dof_0*_data_phi_0_0_BLUE_DOWN[10*q] + mu_dof_1*_data_phi_0_0_BLUE_DOWN[10*q + 1] + mu_dof_2*_data_phi_0_0_BLUE_DOWN[10*q + 2] + mu_dof_3*_data_phi_0_0_BLUE_DOWN[10*q + 3] + mu_dof_4*_data_phi_0_0_BLUE_DOWN[10*q + 4] + mu_dof_5*_data_phi_0_0_BLUE_DOWN[10*q + 5] + mu_dof_6*_data_phi_0_0_BLUE_DOWN[10*q + 6] + mu_dof_7*_data_phi_0_0_BLUE_DOWN[10*q + 7] + mu_dof_8*_data_phi_0_0_BLUE_DOWN[10*q + 8] + mu_dof_9*_data_phi_0_0_BLUE_DOWN[10*q + 9])*abs(tmp_qloop_120)*_data_q_w[q];
                const real_t tmp_qloop_171 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_172 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_173 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_174 = tmp_qloop_171*2.0 + tmp_qloop_172*2.0 + tmp_qloop_173*2.0;
                const real_t tmp_qloop_175 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 1] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 1] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_176 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 1] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 1] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_177 = tmp_qloop_171 + tmp_qloop_172 + tmp_qloop_173;
                const real_t tmp_qloop_178 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_179 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_180 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_181 = tmp_qloop_178*2.0 + tmp_qloop_179*2.0 + tmp_qloop_180*2.0;
                const real_t tmp_qloop_182 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 2] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 2] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_183 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 2] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 2] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_184 = tmp_qloop_178 + tmp_qloop_179 + tmp_qloop_180;
                const real_t tmp_qloop_185 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_186 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_187 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_188 = tmp_qloop_185*2.0 + tmp_qloop_186*2.0 + tmp_qloop_187*2.0;
                const real_t tmp_qloop_189 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 3] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 3] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_190 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 3] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 3] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_191 = tmp_qloop_185 + tmp_qloop_186 + tmp_qloop_187;
                const real_t tmp_qloop_192 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_193 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_194 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_195 = tmp_qloop_192*2.0 + tmp_qloop_193*2.0 + tmp_qloop_194*2.0;
                const real_t tmp_qloop_196 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 4] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 4] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_197 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 4] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 4] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_198 = tmp_qloop_192 + tmp_qloop_193 + tmp_qloop_194;
                const real_t tmp_qloop_199 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_200 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_201 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_202 = tmp_qloop_199*2.0 + tmp_qloop_200*2.0 + tmp_qloop_201*2.0;
                const real_t tmp_qloop_203 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 5] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 5] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_204 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 5] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 5] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_205 = tmp_qloop_199 + tmp_qloop_200 + tmp_qloop_201;
                const real_t tmp_qloop_206 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_207 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_208 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_209 = tmp_qloop_206*2.0 + tmp_qloop_207*2.0 + tmp_qloop_208*2.0;
                const real_t tmp_qloop_210 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 6] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 6] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_211 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 6] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 6] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_212 = tmp_qloop_206 + tmp_qloop_207 + tmp_qloop_208;
                const real_t tmp_qloop_213 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_214 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_215 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_216 = tmp_qloop_213*2.0 + tmp_qloop_214*2.0 + tmp_qloop_215*2.0;
                const real_t tmp_qloop_217 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 7] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 7] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_218 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 7] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 7] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_219 = tmp_qloop_213 + tmp_qloop_214 + tmp_qloop_215;
                const real_t tmp_qloop_220 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_221 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_222 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_223 = tmp_qloop_220*2.0 + tmp_qloop_221*2.0 + tmp_qloop_222*2.0;
                const real_t tmp_qloop_224 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 8] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 8] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_225 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 8] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 8] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_226 = tmp_qloop_220 + tmp_qloop_221 + tmp_qloop_222;
                const real_t tmp_qloop_227 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 9];
                const real_t tmp_qloop_228 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 9];
                const real_t tmp_qloop_229 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 9];
                const real_t tmp_qloop_230 = tmp_qloop_227*2.0 + tmp_qloop_228*2.0 + tmp_qloop_229*2.0;
                const real_t tmp_qloop_231 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 9] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 9] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 9];
                const real_t tmp_qloop_232 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_BLUE_DOWN[10*q + 9] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_BLUE_DOWN[10*q + 9] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_BLUE_DOWN[10*q + 9];
                const real_t tmp_qloop_233 = tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229;
                const real_t tmp_qloop_234 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_235 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_236 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_237 = tmp_qloop_234*1.0 + tmp_qloop_235*1.0 + tmp_qloop_236*1.0;
                const real_t tmp_qloop_238 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 1] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 1] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_239 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 1] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 1] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_240 = tmp_qloop_234*0.66666666666666667 + tmp_qloop_235*0.66666666666666667 + tmp_qloop_236*0.66666666666666667;
                const real_t tmp_qloop_241 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_242 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_243 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_244 = tmp_qloop_241*1.0 + tmp_qloop_242*1.0 + tmp_qloop_243*1.0;
                const real_t tmp_qloop_245 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 2] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 2] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_246 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 2] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 2] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_247 = tmp_qloop_241*0.66666666666666667 + tmp_qloop_242*0.66666666666666667 + tmp_qloop_243*0.66666666666666667;
                const real_t tmp_qloop_248 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_249 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_250 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_251 = tmp_qloop_248*1.0 + tmp_qloop_249*1.0 + tmp_qloop_250*1.0;
                const real_t tmp_qloop_252 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 3] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 3] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_253 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 3] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 3] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_254 = tmp_qloop_248*0.66666666666666667 + tmp_qloop_249*0.66666666666666667 + tmp_qloop_250*0.66666666666666667;
                const real_t tmp_qloop_255 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_256 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_257 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_258 = tmp_qloop_255*1.0 + tmp_qloop_256*1.0 + tmp_qloop_257*1.0;
                const real_t tmp_qloop_259 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 4] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 4] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_260 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 4] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 4] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_261 = tmp_qloop_255*0.66666666666666667 + tmp_qloop_256*0.66666666666666667 + tmp_qloop_257*0.66666666666666667;
                const real_t tmp_qloop_262 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_263 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_264 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_265 = tmp_qloop_262*1.0 + tmp_qloop_263*1.0 + tmp_qloop_264*1.0;
                const real_t tmp_qloop_266 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 5] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 5] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_267 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 5] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 5] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_268 = tmp_qloop_262*0.66666666666666667 + tmp_qloop_263*0.66666666666666667 + tmp_qloop_264*0.66666666666666667;
                const real_t tmp_qloop_269 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_270 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_271 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_272 = tmp_qloop_269*1.0 + tmp_qloop_270*1.0 + tmp_qloop_271*1.0;
                const real_t tmp_qloop_273 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 6] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 6] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_274 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 6] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 6] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_275 = tmp_qloop_269*0.66666666666666667 + tmp_qloop_270*0.66666666666666667 + tmp_qloop_271*0.66666666666666667;
                const real_t tmp_qloop_276 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_277 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_278 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_279 = tmp_qloop_276*1.0 + tmp_qloop_277*1.0 + tmp_qloop_278*1.0;
                const real_t tmp_qloop_280 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 7] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 7] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_281 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 7] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 7] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_282 = tmp_qloop_276*0.66666666666666667 + tmp_qloop_277*0.66666666666666667 + tmp_qloop_278*0.66666666666666667;
                const real_t tmp_qloop_283 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_284 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_285 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_286 = tmp_qloop_283*1.0 + tmp_qloop_284*1.0 + tmp_qloop_285*1.0;
                const real_t tmp_qloop_287 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 8] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 8] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_288 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 8] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 8] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_289 = tmp_qloop_283*0.66666666666666667 + tmp_qloop_284*0.66666666666666667 + tmp_qloop_285*0.66666666666666667;
                const real_t tmp_qloop_290 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 9];
                const real_t tmp_qloop_291 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 9];
                const real_t tmp_qloop_292 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 9];
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_170*(tmp_qloop_132*(tmp_qloop_123*2.0 + tmp_qloop_125*2.0 + tmp_qloop_127*2.0) + tmp_qloop_152*(tmp_qloop_122*tmp_qloop_134 + tmp_qloop_136*tmp_qloop_137 + tmp_qloop_139*tmp_qloop_140 + tmp_qloop_141) + tmp_qloop_161*(tmp_qloop_122*tmp_qloop_155 + tmp_qloop_137*tmp_qloop_154 + tmp_qloop_140*tmp_qloop_153 + tmp_qloop_156) - tmp_qloop_162*(tmp_qloop_123 + tmp_qloop_125 + tmp_qloop_127) + tmp_qloop_169);
                const real_t q_tmp_0_1 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_174 + tmp_qloop_152*tmp_qloop_175 + tmp_qloop_161*tmp_qloop_176 - tmp_qloop_162*tmp_qloop_177 + tmp_qloop_169);
                const real_t q_tmp_0_2 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_181 + tmp_qloop_152*tmp_qloop_182 + tmp_qloop_161*tmp_qloop_183 - tmp_qloop_162*tmp_qloop_184 + tmp_qloop_169);
                const real_t q_tmp_0_3 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_188 + tmp_qloop_152*tmp_qloop_189 + tmp_qloop_161*tmp_qloop_190 - tmp_qloop_162*tmp_qloop_191 + tmp_qloop_169);
                const real_t q_tmp_0_4 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_195 + tmp_qloop_152*tmp_qloop_196 + tmp_qloop_161*tmp_qloop_197 - tmp_qloop_162*tmp_qloop_198 + tmp_qloop_169);
                const real_t q_tmp_0_5 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_202 + tmp_qloop_152*tmp_qloop_203 + tmp_qloop_161*tmp_qloop_204 - tmp_qloop_162*tmp_qloop_205 + tmp_qloop_169);
                const real_t q_tmp_0_6 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_209 + tmp_qloop_152*tmp_qloop_210 + tmp_qloop_161*tmp_qloop_211 - tmp_qloop_162*tmp_qloop_212 + tmp_qloop_169);
                const real_t q_tmp_0_7 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_216 + tmp_qloop_152*tmp_qloop_217 + tmp_qloop_161*tmp_qloop_218 - tmp_qloop_162*tmp_qloop_219 + tmp_qloop_169);
                const real_t q_tmp_0_8 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_223 + tmp_qloop_152*tmp_qloop_224 + tmp_qloop_161*tmp_qloop_225 - tmp_qloop_162*tmp_qloop_226 + tmp_qloop_169);
                const real_t q_tmp_0_9 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_230 + tmp_qloop_152*tmp_qloop_231 + tmp_qloop_161*tmp_qloop_232 - tmp_qloop_162*tmp_qloop_233 + tmp_qloop_169);
                const real_t q_tmp_1_1 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_174*tmp_qloop_237 + tmp_qloop_175*tmp_qloop_238 + tmp_qloop_176*tmp_qloop_239 - tmp_qloop_177*tmp_qloop_240);
                const real_t q_tmp_1_2 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_181*tmp_qloop_237 + tmp_qloop_182*tmp_qloop_238 + tmp_qloop_183*tmp_qloop_239 - tmp_qloop_184*tmp_qloop_240);
                const real_t q_tmp_1_3 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_188*tmp_qloop_237 + tmp_qloop_189*tmp_qloop_238 + tmp_qloop_190*tmp_qloop_239 - tmp_qloop_191*tmp_qloop_240);
                const real_t q_tmp_1_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_237 + tmp_qloop_196*tmp_qloop_238 + tmp_qloop_197*tmp_qloop_239 - tmp_qloop_198*tmp_qloop_240);
                const real_t q_tmp_1_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_237 + tmp_qloop_203*tmp_qloop_238 + tmp_qloop_204*tmp_qloop_239 - tmp_qloop_205*tmp_qloop_240);
                const real_t q_tmp_1_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_237 + tmp_qloop_210*tmp_qloop_238 + tmp_qloop_211*tmp_qloop_239 - tmp_qloop_212*tmp_qloop_240);
                const real_t q_tmp_1_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_237 + tmp_qloop_217*tmp_qloop_238 + tmp_qloop_218*tmp_qloop_239 - tmp_qloop_219*tmp_qloop_240);
                const real_t q_tmp_1_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_237 + tmp_qloop_224*tmp_qloop_238 + tmp_qloop_225*tmp_qloop_239 - tmp_qloop_226*tmp_qloop_240);
                const real_t q_tmp_1_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_237 + tmp_qloop_231*tmp_qloop_238 + tmp_qloop_232*tmp_qloop_239 - tmp_qloop_233*tmp_qloop_240);
                const real_t q_tmp_2_2 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_181*tmp_qloop_244 + tmp_qloop_182*tmp_qloop_245 + tmp_qloop_183*tmp_qloop_246 - tmp_qloop_184*tmp_qloop_247);
                const real_t q_tmp_2_3 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_188*tmp_qloop_244 + tmp_qloop_189*tmp_qloop_245 + tmp_qloop_190*tmp_qloop_246 - tmp_qloop_191*tmp_qloop_247);
                const real_t q_tmp_2_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_244 + tmp_qloop_196*tmp_qloop_245 + tmp_qloop_197*tmp_qloop_246 - tmp_qloop_198*tmp_qloop_247);
                const real_t q_tmp_2_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_244 + tmp_qloop_203*tmp_qloop_245 + tmp_qloop_204*tmp_qloop_246 - tmp_qloop_205*tmp_qloop_247);
                const real_t q_tmp_2_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_244 + tmp_qloop_210*tmp_qloop_245 + tmp_qloop_211*tmp_qloop_246 - tmp_qloop_212*tmp_qloop_247);
                const real_t q_tmp_2_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_244 + tmp_qloop_217*tmp_qloop_245 + tmp_qloop_218*tmp_qloop_246 - tmp_qloop_219*tmp_qloop_247);
                const real_t q_tmp_2_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_244 + tmp_qloop_224*tmp_qloop_245 + tmp_qloop_225*tmp_qloop_246 - tmp_qloop_226*tmp_qloop_247);
                const real_t q_tmp_2_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_244 + tmp_qloop_231*tmp_qloop_245 + tmp_qloop_232*tmp_qloop_246 - tmp_qloop_233*tmp_qloop_247);
                const real_t q_tmp_3_3 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_188*tmp_qloop_251 + tmp_qloop_189*tmp_qloop_252 + tmp_qloop_190*tmp_qloop_253 - tmp_qloop_191*tmp_qloop_254);
                const real_t q_tmp_3_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_251 + tmp_qloop_196*tmp_qloop_252 + tmp_qloop_197*tmp_qloop_253 - tmp_qloop_198*tmp_qloop_254);
                const real_t q_tmp_3_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_251 + tmp_qloop_203*tmp_qloop_252 + tmp_qloop_204*tmp_qloop_253 - tmp_qloop_205*tmp_qloop_254);
                const real_t q_tmp_3_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_251 + tmp_qloop_210*tmp_qloop_252 + tmp_qloop_211*tmp_qloop_253 - tmp_qloop_212*tmp_qloop_254);
                const real_t q_tmp_3_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_251 + tmp_qloop_217*tmp_qloop_252 + tmp_qloop_218*tmp_qloop_253 - tmp_qloop_219*tmp_qloop_254);
                const real_t q_tmp_3_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_251 + tmp_qloop_224*tmp_qloop_252 + tmp_qloop_225*tmp_qloop_253 - tmp_qloop_226*tmp_qloop_254);
                const real_t q_tmp_3_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_251 + tmp_qloop_231*tmp_qloop_252 + tmp_qloop_232*tmp_qloop_253 - tmp_qloop_233*tmp_qloop_254);
                const real_t q_tmp_4_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_258 + tmp_qloop_196*tmp_qloop_259 + tmp_qloop_197*tmp_qloop_260 - tmp_qloop_198*tmp_qloop_261);
                const real_t q_tmp_4_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_258 + tmp_qloop_203*tmp_qloop_259 + tmp_qloop_204*tmp_qloop_260 - tmp_qloop_205*tmp_qloop_261);
                const real_t q_tmp_4_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_258 + tmp_qloop_210*tmp_qloop_259 + tmp_qloop_211*tmp_qloop_260 - tmp_qloop_212*tmp_qloop_261);
                const real_t q_tmp_4_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_258 + tmp_qloop_217*tmp_qloop_259 + tmp_qloop_218*tmp_qloop_260 - tmp_qloop_219*tmp_qloop_261);
                const real_t q_tmp_4_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_258 + tmp_qloop_224*tmp_qloop_259 + tmp_qloop_225*tmp_qloop_260 - tmp_qloop_226*tmp_qloop_261);
                const real_t q_tmp_4_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_258 + tmp_qloop_231*tmp_qloop_259 + tmp_qloop_232*tmp_qloop_260 - tmp_qloop_233*tmp_qloop_261);
                const real_t q_tmp_5_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_265 + tmp_qloop_203*tmp_qloop_266 + tmp_qloop_204*tmp_qloop_267 - tmp_qloop_205*tmp_qloop_268);
                const real_t q_tmp_5_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_265 + tmp_qloop_210*tmp_qloop_266 + tmp_qloop_211*tmp_qloop_267 - tmp_qloop_212*tmp_qloop_268);
                const real_t q_tmp_5_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_265 + tmp_qloop_217*tmp_qloop_266 + tmp_qloop_218*tmp_qloop_267 - tmp_qloop_219*tmp_qloop_268);
                const real_t q_tmp_5_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_265 + tmp_qloop_224*tmp_qloop_266 + tmp_qloop_225*tmp_qloop_267 - tmp_qloop_226*tmp_qloop_268);
                const real_t q_tmp_5_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_265 + tmp_qloop_231*tmp_qloop_266 + tmp_qloop_232*tmp_qloop_267 - tmp_qloop_233*tmp_qloop_268);
                const real_t q_tmp_6_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_272 + tmp_qloop_210*tmp_qloop_273 + tmp_qloop_211*tmp_qloop_274 - tmp_qloop_212*tmp_qloop_275);
                const real_t q_tmp_6_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_272 + tmp_qloop_217*tmp_qloop_273 + tmp_qloop_218*tmp_qloop_274 - tmp_qloop_219*tmp_qloop_275);
                const real_t q_tmp_6_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_272 + tmp_qloop_224*tmp_qloop_273 + tmp_qloop_225*tmp_qloop_274 - tmp_qloop_226*tmp_qloop_275);
                const real_t q_tmp_6_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_272 + tmp_qloop_231*tmp_qloop_273 + tmp_qloop_232*tmp_qloop_274 - tmp_qloop_233*tmp_qloop_275);
                const real_t q_tmp_7_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_279 + tmp_qloop_217*tmp_qloop_280 + tmp_qloop_218*tmp_qloop_281 - tmp_qloop_219*tmp_qloop_282);
                const real_t q_tmp_7_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_279 + tmp_qloop_224*tmp_qloop_280 + tmp_qloop_225*tmp_qloop_281 - tmp_qloop_226*tmp_qloop_282);
                const real_t q_tmp_7_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_279 + tmp_qloop_231*tmp_qloop_280 + tmp_qloop_232*tmp_qloop_281 - tmp_qloop_233*tmp_qloop_282);
                const real_t q_tmp_8_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_286 + tmp_qloop_224*tmp_qloop_287 + tmp_qloop_225*tmp_qloop_288 - tmp_qloop_226*tmp_qloop_289);
                const real_t q_tmp_8_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_286 + tmp_qloop_231*tmp_qloop_287 + tmp_qloop_232*tmp_qloop_288 - tmp_qloop_233*tmp_qloop_289);
                const real_t q_tmp_9_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*(tmp_qloop_290*1.0 + tmp_qloop_291*1.0 + tmp_qloop_292*1.0) + tmp_qloop_231*(tmp_qloop_151 + tmp_qloop_165*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 9] + tmp_qloop_166*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 9] + tmp_qloop_167*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 9])*2.0 + tmp_qloop_232*(tmp_qloop_160 + tmp_qloop_163*_data_jac_affine_inv_T_grad_psi_1_0_BLUE_DOWN[10*q + 9] + tmp_qloop_164*_data_jac_affine_inv_T_grad_psi_0_0_BLUE_DOWN[10*q + 9] + tmp_qloop_168*_data_jac_affine_inv_T_grad_psi_2_0_BLUE_DOWN[10*q + 9])*2.0 + tmp_qloop_233*(tmp_qloop_290 + tmp_qloop_291 + tmp_qloop_292)*-0.66666666666666667);
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_9*src_dof_9;
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       {
          /* CellType.GREEN_UP */
          const real_t _data_phi_0_0_GREEN_UP [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_1_0_GREEN_UP)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), ((real_t)(-jac_affine_inv_1_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_0_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_1_1_GREEN_UP)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), ((real_t)(-jac_affine_inv_1_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_1_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_1_2_GREEN_UP)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), ((real_t)(-jac_affine_inv_1_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_2_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_1_0_GREEN_UP)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), ((real_t)(-jac_affine_inv_1_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_0_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_1_1_GREEN_UP)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), ((real_t)(-jac_affine_inv_1_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_1_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_1_2_GREEN_UP)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), ((real_t)(-jac_affine_inv_1_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_2_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_3 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_7 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 1.0 / (tmp_qloop_31*tmp_qloop_31*tmp_qloop_31);
                const real_t tmp_qloop_106 = tmp_qloop_59*1.0;
                const real_t tmp_qloop_107 = tmp_qloop_104*tmp_qloop_105;
                const real_t tmp_qloop_108 = tmp_qloop_107*tmp_qloop_52;
                const real_t tmp_qloop_109 = tmp_qloop_108*tmp_qloop_25;
                const real_t tmp_qloop_110 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_22*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0 - tmp_qloop_106*tmp_qloop_109;
                const real_t tmp_qloop_111 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_113 = tmp_qloop_56*1.0;
                const real_t tmp_qloop_114 = tmp_qloop_113*tmp_qloop_50;
                const real_t tmp_qloop_115 = tmp_qloop_111*tmp_qloop_112;
                const real_t tmp_qloop_116 = tmp_qloop_115*tmp_qloop_52;
                const real_t tmp_qloop_117 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_118 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_119 = tmp_qloop_117*tmp_qloop_118*1.0;
                const real_t tmp_qloop_120 = -tmp_qloop_106*tmp_qloop_116*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43 + tmp_qloop_111*tmp_qloop_112*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*2.0 + tmp_qloop_111*tmp_qloop_112*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59*1.0 - tmp_qloop_114*tmp_qloop_116*tmp_qloop_86 - tmp_qloop_115*tmp_qloop_119*tmp_qloop_36;
                const real_t tmp_qloop_121 = 1.0 / (tmp_qloop_120);
                const real_t tmp_qloop_122 = tmp_qloop_121*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q];
                const real_t tmp_qloop_123 = tmp_qloop_110*tmp_qloop_122;
                const real_t tmp_qloop_124 = tmp_qloop_121*(tmp_qloop_104*tmp_qloop_105*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_52*1.0 - tmp_qloop_108*tmp_qloop_113*tmp_qloop_22);
                const real_t tmp_qloop_125 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q];
                const real_t tmp_qloop_126 = tmp_qloop_121*(tmp_qloop_107*tmp_qloop_113*tmp_qloop_59 - tmp_qloop_107*tmp_qloop_119);
                const real_t tmp_qloop_127 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q];
                const real_t tmp_qloop_128 = tmp_qloop_110*tmp_qloop_121;
                const real_t tmp_qloop_129 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q];
                const real_t tmp_qloop_130 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q];
                const real_t tmp_qloop_131 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q];
                const real_t tmp_qloop_132 = tmp_qloop_129*1.0 + tmp_qloop_130*1.0 + tmp_qloop_131*1.0;
                const real_t tmp_qloop_133 = tmp_qloop_107*tmp_qloop_36;
                const real_t tmp_qloop_134 = tmp_qloop_106*tmp_qloop_133 - tmp_qloop_108*tmp_qloop_50*tmp_qloop_86;
                const real_t tmp_qloop_135 = tmp_qloop_107*tmp_qloop_18;
                const real_t tmp_qloop_136 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_50*1.0 - tmp_qloop_106*tmp_qloop_135*tmp_qloop_43;
                const real_t tmp_qloop_137 = tmp_qloop_121*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q];
                const real_t tmp_qloop_138 = tmp_qloop_133*1.0;
                const real_t tmp_qloop_139 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_52*1.0 - tmp_qloop_117*tmp_qloop_138;
                const real_t tmp_qloop_140 = tmp_qloop_121*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q];
                const real_t tmp_qloop_141 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP[q] + tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP[q] + tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP[q];
                const real_t tmp_qloop_142 = tmp_qloop_121*tmp_qloop_134;
                const real_t tmp_qloop_143 = 0.5*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q];
                const real_t tmp_qloop_144 = tmp_qloop_121*tmp_qloop_136;
                const real_t tmp_qloop_145 = 0.5*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q];
                const real_t tmp_qloop_146 = tmp_qloop_121*tmp_qloop_139;
                const real_t tmp_qloop_147 = 0.5*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q];
                const real_t tmp_qloop_148 = tmp_qloop_126*0.5;
                const real_t tmp_qloop_149 = tmp_qloop_124*0.5;
                const real_t tmp_qloop_150 = tmp_qloop_128*0.5;
                const real_t tmp_qloop_151 = tmp_qloop_148*_data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP[q] + tmp_qloop_149*_data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP[q] + tmp_qloop_150*_data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP[q];
                const real_t tmp_qloop_152 = tmp_qloop_142*tmp_qloop_143*2.0 + tmp_qloop_144*tmp_qloop_145*2.0 + tmp_qloop_146*tmp_qloop_147*2.0 + tmp_qloop_151*2.0;
                const real_t tmp_qloop_153 = -tmp_qloop_109*tmp_qloop_18*tmp_qloop_43 + tmp_qloop_113*tmp_qloop_133;
                const real_t tmp_qloop_154 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*1.0 - tmp_qloop_114*tmp_qloop_135;
                const real_t tmp_qloop_155 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0 - tmp_qloop_118*tmp_qloop_138;
                const real_t tmp_qloop_156 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[q] + tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[q] + tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[q];
                const real_t tmp_qloop_157 = tmp_qloop_121*tmp_qloop_153;
                const real_t tmp_qloop_158 = tmp_qloop_121*tmp_qloop_154;
                const real_t tmp_qloop_159 = tmp_qloop_121*tmp_qloop_155;
                const real_t tmp_qloop_160 = tmp_qloop_148*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[q] + tmp_qloop_149*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[q] + tmp_qloop_150*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[q];
                const real_t tmp_qloop_161 = tmp_qloop_143*tmp_qloop_159*2.0 + tmp_qloop_145*tmp_qloop_158*2.0 + tmp_qloop_147*tmp_qloop_157*2.0 + tmp_qloop_160*2.0;
                const real_t tmp_qloop_162 = tmp_qloop_129*0.66666666666666667 + tmp_qloop_130*0.66666666666666667 + tmp_qloop_131*0.66666666666666667;
                const real_t tmp_qloop_163 = tmp_qloop_159*0.5;
                const real_t tmp_qloop_164 = tmp_qloop_158*0.5;
                const real_t tmp_qloop_165 = tmp_qloop_144*0.5;
                const real_t tmp_qloop_166 = tmp_qloop_146*0.5;
                const real_t tmp_qloop_167 = tmp_qloop_142*0.5;
                const real_t tmp_qloop_168 = tmp_qloop_157*0.5;
                const real_t tmp_qloop_169 = (tmp_qloop_142*1.0*_data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP[q] + tmp_qloop_144*1.0*_data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP[q] + tmp_qloop_146*1.0*_data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP[q])*(tmp_qloop_142*2.0*_data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP[q] + tmp_qloop_144*2.0*_data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP[q] + tmp_qloop_146*2.0*_data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP[q]) + (tmp_qloop_157*1.0*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[q] + tmp_qloop_158*1.0*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[q] + tmp_qloop_159*1.0*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[q])*(tmp_qloop_157*2.0*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[q] + tmp_qloop_158*2.0*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[q] + tmp_qloop_159*2.0*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[q]) + (tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_UP[q] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_UP[q] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_UP[q] + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_1_GREEN_UP[q] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_1_GREEN_UP[q] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_1_GREEN_UP[q])*(tmp_qloop_163*_data_jac_affine_inv_T_grad_psi_1_1_GREEN_UP[q] + tmp_qloop_164*_data_jac_affine_inv_T_grad_psi_0_1_GREEN_UP[q] + tmp_qloop_165*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_UP[q] + tmp_qloop_166*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_UP[q] + tmp_qloop_167*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_UP[q] + tmp_qloop_168*_data_jac_affine_inv_T_grad_psi_2_1_GREEN_UP[q])*2.0;
                const real_t tmp_qloop_170 = abs_det_jac_affine_GREEN_UP*(mu_dof_0*_data_phi_0_0_GREEN_UP[10*q] + mu_dof_1*_data_phi_0_0_GREEN_UP[10*q + 1] + mu_dof_2*_data_phi_0_0_GREEN_UP[10*q + 2] + mu_dof_3*_data_phi_0_0_GREEN_UP[10*q + 3] + mu_dof_4*_data_phi_0_0_GREEN_UP[10*q + 4] + mu_dof_5*_data_phi_0_0_GREEN_UP[10*q + 5] + mu_dof_6*_data_phi_0_0_GREEN_UP[10*q + 6] + mu_dof_7*_data_phi_0_0_GREEN_UP[10*q + 7] + mu_dof_8*_data_phi_0_0_GREEN_UP[10*q + 8] + mu_dof_9*_data_phi_0_0_GREEN_UP[10*q + 9])*abs(tmp_qloop_120)*_data_q_w[q];
                const real_t tmp_qloop_171 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_172 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_173 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_174 = tmp_qloop_171*2.0 + tmp_qloop_172*2.0 + tmp_qloop_173*2.0;
                const real_t tmp_qloop_175 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 1] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 1] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_176 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 1] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 1] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_177 = tmp_qloop_171 + tmp_qloop_172 + tmp_qloop_173;
                const real_t tmp_qloop_178 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_179 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_180 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_181 = tmp_qloop_178*2.0 + tmp_qloop_179*2.0 + tmp_qloop_180*2.0;
                const real_t tmp_qloop_182 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 2] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 2] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_183 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 2] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 2] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_184 = tmp_qloop_178 + tmp_qloop_179 + tmp_qloop_180;
                const real_t tmp_qloop_185 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_186 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_187 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_188 = tmp_qloop_185*2.0 + tmp_qloop_186*2.0 + tmp_qloop_187*2.0;
                const real_t tmp_qloop_189 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 3] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 3] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_190 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 3] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 3] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_191 = tmp_qloop_185 + tmp_qloop_186 + tmp_qloop_187;
                const real_t tmp_qloop_192 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_193 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_194 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_195 = tmp_qloop_192*2.0 + tmp_qloop_193*2.0 + tmp_qloop_194*2.0;
                const real_t tmp_qloop_196 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 4] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 4] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_197 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 4] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 4] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_198 = tmp_qloop_192 + tmp_qloop_193 + tmp_qloop_194;
                const real_t tmp_qloop_199 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_200 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_201 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_202 = tmp_qloop_199*2.0 + tmp_qloop_200*2.0 + tmp_qloop_201*2.0;
                const real_t tmp_qloop_203 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 5] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 5] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_204 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 5] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 5] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_205 = tmp_qloop_199 + tmp_qloop_200 + tmp_qloop_201;
                const real_t tmp_qloop_206 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_207 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_208 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_209 = tmp_qloop_206*2.0 + tmp_qloop_207*2.0 + tmp_qloop_208*2.0;
                const real_t tmp_qloop_210 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 6] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 6] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_211 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 6] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 6] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_212 = tmp_qloop_206 + tmp_qloop_207 + tmp_qloop_208;
                const real_t tmp_qloop_213 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_214 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_215 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_216 = tmp_qloop_213*2.0 + tmp_qloop_214*2.0 + tmp_qloop_215*2.0;
                const real_t tmp_qloop_217 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 7] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 7] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_218 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 7] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 7] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_219 = tmp_qloop_213 + tmp_qloop_214 + tmp_qloop_215;
                const real_t tmp_qloop_220 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_221 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_222 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_223 = tmp_qloop_220*2.0 + tmp_qloop_221*2.0 + tmp_qloop_222*2.0;
                const real_t tmp_qloop_224 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 8] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 8] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_225 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 8] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 8] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_226 = tmp_qloop_220 + tmp_qloop_221 + tmp_qloop_222;
                const real_t tmp_qloop_227 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 9];
                const real_t tmp_qloop_228 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 9];
                const real_t tmp_qloop_229 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 9];
                const real_t tmp_qloop_230 = tmp_qloop_227*2.0 + tmp_qloop_228*2.0 + tmp_qloop_229*2.0;
                const real_t tmp_qloop_231 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 9] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 9] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 9];
                const real_t tmp_qloop_232 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_UP[10*q + 9] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_UP[10*q + 9] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_UP[10*q + 9];
                const real_t tmp_qloop_233 = tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229;
                const real_t tmp_qloop_234 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_235 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_236 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_237 = tmp_qloop_234*1.0 + tmp_qloop_235*1.0 + tmp_qloop_236*1.0;
                const real_t tmp_qloop_238 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 1] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 1] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_239 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 1] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 1] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_240 = tmp_qloop_234*0.66666666666666667 + tmp_qloop_235*0.66666666666666667 + tmp_qloop_236*0.66666666666666667;
                const real_t tmp_qloop_241 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_242 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_243 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_244 = tmp_qloop_241*1.0 + tmp_qloop_242*1.0 + tmp_qloop_243*1.0;
                const real_t tmp_qloop_245 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 2] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 2] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_246 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 2] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 2] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_247 = tmp_qloop_241*0.66666666666666667 + tmp_qloop_242*0.66666666666666667 + tmp_qloop_243*0.66666666666666667;
                const real_t tmp_qloop_248 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_249 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_250 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_251 = tmp_qloop_248*1.0 + tmp_qloop_249*1.0 + tmp_qloop_250*1.0;
                const real_t tmp_qloop_252 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 3] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 3] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_253 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 3] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 3] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_254 = tmp_qloop_248*0.66666666666666667 + tmp_qloop_249*0.66666666666666667 + tmp_qloop_250*0.66666666666666667;
                const real_t tmp_qloop_255 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_256 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_257 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_258 = tmp_qloop_255*1.0 + tmp_qloop_256*1.0 + tmp_qloop_257*1.0;
                const real_t tmp_qloop_259 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 4] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 4] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_260 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 4] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 4] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_261 = tmp_qloop_255*0.66666666666666667 + tmp_qloop_256*0.66666666666666667 + tmp_qloop_257*0.66666666666666667;
                const real_t tmp_qloop_262 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_263 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_264 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_265 = tmp_qloop_262*1.0 + tmp_qloop_263*1.0 + tmp_qloop_264*1.0;
                const real_t tmp_qloop_266 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 5] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 5] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_267 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 5] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 5] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_268 = tmp_qloop_262*0.66666666666666667 + tmp_qloop_263*0.66666666666666667 + tmp_qloop_264*0.66666666666666667;
                const real_t tmp_qloop_269 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_270 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_271 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_272 = tmp_qloop_269*1.0 + tmp_qloop_270*1.0 + tmp_qloop_271*1.0;
                const real_t tmp_qloop_273 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 6] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 6] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_274 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 6] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 6] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_275 = tmp_qloop_269*0.66666666666666667 + tmp_qloop_270*0.66666666666666667 + tmp_qloop_271*0.66666666666666667;
                const real_t tmp_qloop_276 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_277 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_278 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_279 = tmp_qloop_276*1.0 + tmp_qloop_277*1.0 + tmp_qloop_278*1.0;
                const real_t tmp_qloop_280 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 7] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 7] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_281 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 7] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 7] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_282 = tmp_qloop_276*0.66666666666666667 + tmp_qloop_277*0.66666666666666667 + tmp_qloop_278*0.66666666666666667;
                const real_t tmp_qloop_283 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_284 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_285 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_286 = tmp_qloop_283*1.0 + tmp_qloop_284*1.0 + tmp_qloop_285*1.0;
                const real_t tmp_qloop_287 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 8] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 8] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_288 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 8] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 8] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_289 = tmp_qloop_283*0.66666666666666667 + tmp_qloop_284*0.66666666666666667 + tmp_qloop_285*0.66666666666666667;
                const real_t tmp_qloop_290 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 9];
                const real_t tmp_qloop_291 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 9];
                const real_t tmp_qloop_292 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 9];
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_170*(tmp_qloop_132*(tmp_qloop_123*2.0 + tmp_qloop_125*2.0 + tmp_qloop_127*2.0) + tmp_qloop_152*(tmp_qloop_122*tmp_qloop_134 + tmp_qloop_136*tmp_qloop_137 + tmp_qloop_139*tmp_qloop_140 + tmp_qloop_141) + tmp_qloop_161*(tmp_qloop_122*tmp_qloop_155 + tmp_qloop_137*tmp_qloop_154 + tmp_qloop_140*tmp_qloop_153 + tmp_qloop_156) - tmp_qloop_162*(tmp_qloop_123 + tmp_qloop_125 + tmp_qloop_127) + tmp_qloop_169);
                const real_t q_tmp_0_1 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_174 + tmp_qloop_152*tmp_qloop_175 + tmp_qloop_161*tmp_qloop_176 - tmp_qloop_162*tmp_qloop_177 + tmp_qloop_169);
                const real_t q_tmp_0_2 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_181 + tmp_qloop_152*tmp_qloop_182 + tmp_qloop_161*tmp_qloop_183 - tmp_qloop_162*tmp_qloop_184 + tmp_qloop_169);
                const real_t q_tmp_0_3 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_188 + tmp_qloop_152*tmp_qloop_189 + tmp_qloop_161*tmp_qloop_190 - tmp_qloop_162*tmp_qloop_191 + tmp_qloop_169);
                const real_t q_tmp_0_4 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_195 + tmp_qloop_152*tmp_qloop_196 + tmp_qloop_161*tmp_qloop_197 - tmp_qloop_162*tmp_qloop_198 + tmp_qloop_169);
                const real_t q_tmp_0_5 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_202 + tmp_qloop_152*tmp_qloop_203 + tmp_qloop_161*tmp_qloop_204 - tmp_qloop_162*tmp_qloop_205 + tmp_qloop_169);
                const real_t q_tmp_0_6 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_209 + tmp_qloop_152*tmp_qloop_210 + tmp_qloop_161*tmp_qloop_211 - tmp_qloop_162*tmp_qloop_212 + tmp_qloop_169);
                const real_t q_tmp_0_7 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_216 + tmp_qloop_152*tmp_qloop_217 + tmp_qloop_161*tmp_qloop_218 - tmp_qloop_162*tmp_qloop_219 + tmp_qloop_169);
                const real_t q_tmp_0_8 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_223 + tmp_qloop_152*tmp_qloop_224 + tmp_qloop_161*tmp_qloop_225 - tmp_qloop_162*tmp_qloop_226 + tmp_qloop_169);
                const real_t q_tmp_0_9 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_230 + tmp_qloop_152*tmp_qloop_231 + tmp_qloop_161*tmp_qloop_232 - tmp_qloop_162*tmp_qloop_233 + tmp_qloop_169);
                const real_t q_tmp_1_1 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_174*tmp_qloop_237 + tmp_qloop_175*tmp_qloop_238 + tmp_qloop_176*tmp_qloop_239 - tmp_qloop_177*tmp_qloop_240);
                const real_t q_tmp_1_2 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_181*tmp_qloop_237 + tmp_qloop_182*tmp_qloop_238 + tmp_qloop_183*tmp_qloop_239 - tmp_qloop_184*tmp_qloop_240);
                const real_t q_tmp_1_3 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_188*tmp_qloop_237 + tmp_qloop_189*tmp_qloop_238 + tmp_qloop_190*tmp_qloop_239 - tmp_qloop_191*tmp_qloop_240);
                const real_t q_tmp_1_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_237 + tmp_qloop_196*tmp_qloop_238 + tmp_qloop_197*tmp_qloop_239 - tmp_qloop_198*tmp_qloop_240);
                const real_t q_tmp_1_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_237 + tmp_qloop_203*tmp_qloop_238 + tmp_qloop_204*tmp_qloop_239 - tmp_qloop_205*tmp_qloop_240);
                const real_t q_tmp_1_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_237 + tmp_qloop_210*tmp_qloop_238 + tmp_qloop_211*tmp_qloop_239 - tmp_qloop_212*tmp_qloop_240);
                const real_t q_tmp_1_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_237 + tmp_qloop_217*tmp_qloop_238 + tmp_qloop_218*tmp_qloop_239 - tmp_qloop_219*tmp_qloop_240);
                const real_t q_tmp_1_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_237 + tmp_qloop_224*tmp_qloop_238 + tmp_qloop_225*tmp_qloop_239 - tmp_qloop_226*tmp_qloop_240);
                const real_t q_tmp_1_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_237 + tmp_qloop_231*tmp_qloop_238 + tmp_qloop_232*tmp_qloop_239 - tmp_qloop_233*tmp_qloop_240);
                const real_t q_tmp_2_2 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_181*tmp_qloop_244 + tmp_qloop_182*tmp_qloop_245 + tmp_qloop_183*tmp_qloop_246 - tmp_qloop_184*tmp_qloop_247);
                const real_t q_tmp_2_3 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_188*tmp_qloop_244 + tmp_qloop_189*tmp_qloop_245 + tmp_qloop_190*tmp_qloop_246 - tmp_qloop_191*tmp_qloop_247);
                const real_t q_tmp_2_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_244 + tmp_qloop_196*tmp_qloop_245 + tmp_qloop_197*tmp_qloop_246 - tmp_qloop_198*tmp_qloop_247);
                const real_t q_tmp_2_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_244 + tmp_qloop_203*tmp_qloop_245 + tmp_qloop_204*tmp_qloop_246 - tmp_qloop_205*tmp_qloop_247);
                const real_t q_tmp_2_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_244 + tmp_qloop_210*tmp_qloop_245 + tmp_qloop_211*tmp_qloop_246 - tmp_qloop_212*tmp_qloop_247);
                const real_t q_tmp_2_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_244 + tmp_qloop_217*tmp_qloop_245 + tmp_qloop_218*tmp_qloop_246 - tmp_qloop_219*tmp_qloop_247);
                const real_t q_tmp_2_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_244 + tmp_qloop_224*tmp_qloop_245 + tmp_qloop_225*tmp_qloop_246 - tmp_qloop_226*tmp_qloop_247);
                const real_t q_tmp_2_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_244 + tmp_qloop_231*tmp_qloop_245 + tmp_qloop_232*tmp_qloop_246 - tmp_qloop_233*tmp_qloop_247);
                const real_t q_tmp_3_3 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_188*tmp_qloop_251 + tmp_qloop_189*tmp_qloop_252 + tmp_qloop_190*tmp_qloop_253 - tmp_qloop_191*tmp_qloop_254);
                const real_t q_tmp_3_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_251 + tmp_qloop_196*tmp_qloop_252 + tmp_qloop_197*tmp_qloop_253 - tmp_qloop_198*tmp_qloop_254);
                const real_t q_tmp_3_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_251 + tmp_qloop_203*tmp_qloop_252 + tmp_qloop_204*tmp_qloop_253 - tmp_qloop_205*tmp_qloop_254);
                const real_t q_tmp_3_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_251 + tmp_qloop_210*tmp_qloop_252 + tmp_qloop_211*tmp_qloop_253 - tmp_qloop_212*tmp_qloop_254);
                const real_t q_tmp_3_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_251 + tmp_qloop_217*tmp_qloop_252 + tmp_qloop_218*tmp_qloop_253 - tmp_qloop_219*tmp_qloop_254);
                const real_t q_tmp_3_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_251 + tmp_qloop_224*tmp_qloop_252 + tmp_qloop_225*tmp_qloop_253 - tmp_qloop_226*tmp_qloop_254);
                const real_t q_tmp_3_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_251 + tmp_qloop_231*tmp_qloop_252 + tmp_qloop_232*tmp_qloop_253 - tmp_qloop_233*tmp_qloop_254);
                const real_t q_tmp_4_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_258 + tmp_qloop_196*tmp_qloop_259 + tmp_qloop_197*tmp_qloop_260 - tmp_qloop_198*tmp_qloop_261);
                const real_t q_tmp_4_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_258 + tmp_qloop_203*tmp_qloop_259 + tmp_qloop_204*tmp_qloop_260 - tmp_qloop_205*tmp_qloop_261);
                const real_t q_tmp_4_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_258 + tmp_qloop_210*tmp_qloop_259 + tmp_qloop_211*tmp_qloop_260 - tmp_qloop_212*tmp_qloop_261);
                const real_t q_tmp_4_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_258 + tmp_qloop_217*tmp_qloop_259 + tmp_qloop_218*tmp_qloop_260 - tmp_qloop_219*tmp_qloop_261);
                const real_t q_tmp_4_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_258 + tmp_qloop_224*tmp_qloop_259 + tmp_qloop_225*tmp_qloop_260 - tmp_qloop_226*tmp_qloop_261);
                const real_t q_tmp_4_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_258 + tmp_qloop_231*tmp_qloop_259 + tmp_qloop_232*tmp_qloop_260 - tmp_qloop_233*tmp_qloop_261);
                const real_t q_tmp_5_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_265 + tmp_qloop_203*tmp_qloop_266 + tmp_qloop_204*tmp_qloop_267 - tmp_qloop_205*tmp_qloop_268);
                const real_t q_tmp_5_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_265 + tmp_qloop_210*tmp_qloop_266 + tmp_qloop_211*tmp_qloop_267 - tmp_qloop_212*tmp_qloop_268);
                const real_t q_tmp_5_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_265 + tmp_qloop_217*tmp_qloop_266 + tmp_qloop_218*tmp_qloop_267 - tmp_qloop_219*tmp_qloop_268);
                const real_t q_tmp_5_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_265 + tmp_qloop_224*tmp_qloop_266 + tmp_qloop_225*tmp_qloop_267 - tmp_qloop_226*tmp_qloop_268);
                const real_t q_tmp_5_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_265 + tmp_qloop_231*tmp_qloop_266 + tmp_qloop_232*tmp_qloop_267 - tmp_qloop_233*tmp_qloop_268);
                const real_t q_tmp_6_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_272 + tmp_qloop_210*tmp_qloop_273 + tmp_qloop_211*tmp_qloop_274 - tmp_qloop_212*tmp_qloop_275);
                const real_t q_tmp_6_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_272 + tmp_qloop_217*tmp_qloop_273 + tmp_qloop_218*tmp_qloop_274 - tmp_qloop_219*tmp_qloop_275);
                const real_t q_tmp_6_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_272 + tmp_qloop_224*tmp_qloop_273 + tmp_qloop_225*tmp_qloop_274 - tmp_qloop_226*tmp_qloop_275);
                const real_t q_tmp_6_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_272 + tmp_qloop_231*tmp_qloop_273 + tmp_qloop_232*tmp_qloop_274 - tmp_qloop_233*tmp_qloop_275);
                const real_t q_tmp_7_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_279 + tmp_qloop_217*tmp_qloop_280 + tmp_qloop_218*tmp_qloop_281 - tmp_qloop_219*tmp_qloop_282);
                const real_t q_tmp_7_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_279 + tmp_qloop_224*tmp_qloop_280 + tmp_qloop_225*tmp_qloop_281 - tmp_qloop_226*tmp_qloop_282);
                const real_t q_tmp_7_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_279 + tmp_qloop_231*tmp_qloop_280 + tmp_qloop_232*tmp_qloop_281 - tmp_qloop_233*tmp_qloop_282);
                const real_t q_tmp_8_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_286 + tmp_qloop_224*tmp_qloop_287 + tmp_qloop_225*tmp_qloop_288 - tmp_qloop_226*tmp_qloop_289);
                const real_t q_tmp_8_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_286 + tmp_qloop_231*tmp_qloop_287 + tmp_qloop_232*tmp_qloop_288 - tmp_qloop_233*tmp_qloop_289);
                const real_t q_tmp_9_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*(tmp_qloop_290*1.0 + tmp_qloop_291*1.0 + tmp_qloop_292*1.0) + tmp_qloop_231*(tmp_qloop_151 + tmp_qloop_165*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 9] + tmp_qloop_166*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 9] + tmp_qloop_167*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 9])*2.0 + tmp_qloop_232*(tmp_qloop_160 + tmp_qloop_163*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_UP[10*q + 9] + tmp_qloop_164*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_UP[10*q + 9] + tmp_qloop_168*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_UP[10*q + 9])*2.0 + tmp_qloop_233*(tmp_qloop_290 + tmp_qloop_291 + tmp_qloop_292)*-0.66666666666666667);
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_9*src_dof_9;
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       {
          /* CellType.GREEN_DOWN */
          const real_t _data_phi_0_0_GREEN_DOWN [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_1_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_1_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_1_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_1_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_1_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_1_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_3 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_7 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_9 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 1.0 / (tmp_qloop_31*tmp_qloop_31*tmp_qloop_31);
                const real_t tmp_qloop_106 = tmp_qloop_59*1.0;
                const real_t tmp_qloop_107 = tmp_qloop_104*tmp_qloop_105;
                const real_t tmp_qloop_108 = tmp_qloop_107*tmp_qloop_52;
                const real_t tmp_qloop_109 = tmp_qloop_108*tmp_qloop_25;
                const real_t tmp_qloop_110 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_22*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0 - tmp_qloop_106*tmp_qloop_109;
                const real_t tmp_qloop_111 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_113 = tmp_qloop_56*1.0;
                const real_t tmp_qloop_114 = tmp_qloop_113*tmp_qloop_50;
                const real_t tmp_qloop_115 = tmp_qloop_111*tmp_qloop_112;
                const real_t tmp_qloop_116 = tmp_qloop_115*tmp_qloop_52;
                const real_t tmp_qloop_117 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_118 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_119 = tmp_qloop_117*tmp_qloop_118*1.0;
                const real_t tmp_qloop_120 = -tmp_qloop_106*tmp_qloop_116*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43 + tmp_qloop_111*tmp_qloop_112*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*2.0 + tmp_qloop_111*tmp_qloop_112*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59*1.0 - tmp_qloop_114*tmp_qloop_116*tmp_qloop_86 - tmp_qloop_115*tmp_qloop_119*tmp_qloop_36;
                const real_t tmp_qloop_121 = 1.0 / (tmp_qloop_120);
                const real_t tmp_qloop_122 = tmp_qloop_121*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q];
                const real_t tmp_qloop_123 = tmp_qloop_110*tmp_qloop_122;
                const real_t tmp_qloop_124 = tmp_qloop_121*(tmp_qloop_104*tmp_qloop_105*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_52*1.0 - tmp_qloop_108*tmp_qloop_113*tmp_qloop_22);
                const real_t tmp_qloop_125 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q];
                const real_t tmp_qloop_126 = tmp_qloop_121*(tmp_qloop_107*tmp_qloop_113*tmp_qloop_59 - tmp_qloop_107*tmp_qloop_119);
                const real_t tmp_qloop_127 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q];
                const real_t tmp_qloop_128 = tmp_qloop_110*tmp_qloop_121;
                const real_t tmp_qloop_129 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q];
                const real_t tmp_qloop_130 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q];
                const real_t tmp_qloop_131 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q];
                const real_t tmp_qloop_132 = tmp_qloop_129*1.0 + tmp_qloop_130*1.0 + tmp_qloop_131*1.0;
                const real_t tmp_qloop_133 = tmp_qloop_107*tmp_qloop_36;
                const real_t tmp_qloop_134 = tmp_qloop_106*tmp_qloop_133 - tmp_qloop_108*tmp_qloop_50*tmp_qloop_86;
                const real_t tmp_qloop_135 = tmp_qloop_107*tmp_qloop_18;
                const real_t tmp_qloop_136 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_50*1.0 - tmp_qloop_106*tmp_qloop_135*tmp_qloop_43;
                const real_t tmp_qloop_137 = tmp_qloop_121*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q];
                const real_t tmp_qloop_138 = tmp_qloop_133*1.0;
                const real_t tmp_qloop_139 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_22*tmp_qloop_43*tmp_qloop_52*1.0 - tmp_qloop_117*tmp_qloop_138;
                const real_t tmp_qloop_140 = tmp_qloop_121*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q];
                const real_t tmp_qloop_141 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN[q] + tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN[q] + tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN[q];
                const real_t tmp_qloop_142 = tmp_qloop_121*tmp_qloop_134;
                const real_t tmp_qloop_143 = 0.5*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q];
                const real_t tmp_qloop_144 = tmp_qloop_121*tmp_qloop_136;
                const real_t tmp_qloop_145 = 0.5*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q];
                const real_t tmp_qloop_146 = tmp_qloop_121*tmp_qloop_139;
                const real_t tmp_qloop_147 = 0.5*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q];
                const real_t tmp_qloop_148 = tmp_qloop_126*0.5;
                const real_t tmp_qloop_149 = tmp_qloop_124*0.5;
                const real_t tmp_qloop_150 = tmp_qloop_128*0.5;
                const real_t tmp_qloop_151 = tmp_qloop_148*_data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN[q] + tmp_qloop_149*_data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN[q] + tmp_qloop_150*_data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN[q];
                const real_t tmp_qloop_152 = tmp_qloop_142*tmp_qloop_143*2.0 + tmp_qloop_144*tmp_qloop_145*2.0 + tmp_qloop_146*tmp_qloop_147*2.0 + tmp_qloop_151*2.0;
                const real_t tmp_qloop_153 = -tmp_qloop_109*tmp_qloop_18*tmp_qloop_43 + tmp_qloop_113*tmp_qloop_133;
                const real_t tmp_qloop_154 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*1.0 - tmp_qloop_114*tmp_qloop_135;
                const real_t tmp_qloop_155 = tmp_qloop_104*tmp_qloop_105*tmp_qloop_18*tmp_qloop_25*tmp_qloop_50*tmp_qloop_52*1.0 - tmp_qloop_118*tmp_qloop_138;
                const real_t tmp_qloop_156 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[q] + tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[q] + tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[q];
                const real_t tmp_qloop_157 = tmp_qloop_121*tmp_qloop_153;
                const real_t tmp_qloop_158 = tmp_qloop_121*tmp_qloop_154;
                const real_t tmp_qloop_159 = tmp_qloop_121*tmp_qloop_155;
                const real_t tmp_qloop_160 = tmp_qloop_148*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[q] + tmp_qloop_149*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[q] + tmp_qloop_150*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[q];
                const real_t tmp_qloop_161 = tmp_qloop_143*tmp_qloop_159*2.0 + tmp_qloop_145*tmp_qloop_158*2.0 + tmp_qloop_147*tmp_qloop_157*2.0 + tmp_qloop_160*2.0;
                const real_t tmp_qloop_162 = tmp_qloop_129*0.66666666666666667 + tmp_qloop_130*0.66666666666666667 + tmp_qloop_131*0.66666666666666667;
                const real_t tmp_qloop_163 = tmp_qloop_159*0.5;
                const real_t tmp_qloop_164 = tmp_qloop_158*0.5;
                const real_t tmp_qloop_165 = tmp_qloop_144*0.5;
                const real_t tmp_qloop_166 = tmp_qloop_146*0.5;
                const real_t tmp_qloop_167 = tmp_qloop_142*0.5;
                const real_t tmp_qloop_168 = tmp_qloop_157*0.5;
                const real_t tmp_qloop_169 = (tmp_qloop_142*1.0*_data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN[q] + tmp_qloop_144*1.0*_data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN[q] + tmp_qloop_146*1.0*_data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN[q])*(tmp_qloop_142*2.0*_data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN[q] + tmp_qloop_144*2.0*_data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN[q] + tmp_qloop_146*2.0*_data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN[q]) + (tmp_qloop_157*1.0*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[q] + tmp_qloop_158*1.0*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[q] + tmp_qloop_159*1.0*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[q])*(tmp_qloop_157*2.0*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[q] + tmp_qloop_158*2.0*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[q] + tmp_qloop_159*2.0*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[q]) + (tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_2_GREEN_DOWN[q] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_2_GREEN_DOWN[q] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_2_GREEN_DOWN[q] + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_1_GREEN_DOWN[q] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_1_GREEN_DOWN[q] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_1_GREEN_DOWN[q])*(tmp_qloop_163*_data_jac_affine_inv_T_grad_psi_1_1_GREEN_DOWN[q] + tmp_qloop_164*_data_jac_affine_inv_T_grad_psi_0_1_GREEN_DOWN[q] + tmp_qloop_165*_data_jac_affine_inv_T_grad_psi_0_2_GREEN_DOWN[q] + tmp_qloop_166*_data_jac_affine_inv_T_grad_psi_2_2_GREEN_DOWN[q] + tmp_qloop_167*_data_jac_affine_inv_T_grad_psi_1_2_GREEN_DOWN[q] + tmp_qloop_168*_data_jac_affine_inv_T_grad_psi_2_1_GREEN_DOWN[q])*2.0;
                const real_t tmp_qloop_170 = abs_det_jac_affine_GREEN_DOWN*(mu_dof_0*_data_phi_0_0_GREEN_DOWN[10*q] + mu_dof_1*_data_phi_0_0_GREEN_DOWN[10*q + 1] + mu_dof_2*_data_phi_0_0_GREEN_DOWN[10*q + 2] + mu_dof_3*_data_phi_0_0_GREEN_DOWN[10*q + 3] + mu_dof_4*_data_phi_0_0_GREEN_DOWN[10*q + 4] + mu_dof_5*_data_phi_0_0_GREEN_DOWN[10*q + 5] + mu_dof_6*_data_phi_0_0_GREEN_DOWN[10*q + 6] + mu_dof_7*_data_phi_0_0_GREEN_DOWN[10*q + 7] + mu_dof_8*_data_phi_0_0_GREEN_DOWN[10*q + 8] + mu_dof_9*_data_phi_0_0_GREEN_DOWN[10*q + 9])*abs(tmp_qloop_120)*_data_q_w[q];
                const real_t tmp_qloop_171 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_172 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_173 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_174 = tmp_qloop_171*2.0 + tmp_qloop_172*2.0 + tmp_qloop_173*2.0;
                const real_t tmp_qloop_175 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 1] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 1] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_176 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 1] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 1] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_177 = tmp_qloop_171 + tmp_qloop_172 + tmp_qloop_173;
                const real_t tmp_qloop_178 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_179 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_180 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_181 = tmp_qloop_178*2.0 + tmp_qloop_179*2.0 + tmp_qloop_180*2.0;
                const real_t tmp_qloop_182 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 2] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 2] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_183 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 2] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 2] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_184 = tmp_qloop_178 + tmp_qloop_179 + tmp_qloop_180;
                const real_t tmp_qloop_185 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_186 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_187 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_188 = tmp_qloop_185*2.0 + tmp_qloop_186*2.0 + tmp_qloop_187*2.0;
                const real_t tmp_qloop_189 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 3] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 3] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_190 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 3] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 3] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_191 = tmp_qloop_185 + tmp_qloop_186 + tmp_qloop_187;
                const real_t tmp_qloop_192 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_193 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_194 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_195 = tmp_qloop_192*2.0 + tmp_qloop_193*2.0 + tmp_qloop_194*2.0;
                const real_t tmp_qloop_196 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 4] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 4] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_197 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 4] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 4] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_198 = tmp_qloop_192 + tmp_qloop_193 + tmp_qloop_194;
                const real_t tmp_qloop_199 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_200 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_201 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_202 = tmp_qloop_199*2.0 + tmp_qloop_200*2.0 + tmp_qloop_201*2.0;
                const real_t tmp_qloop_203 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 5] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 5] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_204 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 5] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 5] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_205 = tmp_qloop_199 + tmp_qloop_200 + tmp_qloop_201;
                const real_t tmp_qloop_206 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_207 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_208 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_209 = tmp_qloop_206*2.0 + tmp_qloop_207*2.0 + tmp_qloop_208*2.0;
                const real_t tmp_qloop_210 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 6] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 6] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_211 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 6] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 6] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_212 = tmp_qloop_206 + tmp_qloop_207 + tmp_qloop_208;
                const real_t tmp_qloop_213 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_214 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_215 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_216 = tmp_qloop_213*2.0 + tmp_qloop_214*2.0 + tmp_qloop_215*2.0;
                const real_t tmp_qloop_217 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 7] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 7] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_218 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 7] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 7] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_219 = tmp_qloop_213 + tmp_qloop_214 + tmp_qloop_215;
                const real_t tmp_qloop_220 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_221 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_222 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_223 = tmp_qloop_220*2.0 + tmp_qloop_221*2.0 + tmp_qloop_222*2.0;
                const real_t tmp_qloop_224 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 8] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 8] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_225 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 8] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 8] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_226 = tmp_qloop_220 + tmp_qloop_221 + tmp_qloop_222;
                const real_t tmp_qloop_227 = tmp_qloop_128*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 9];
                const real_t tmp_qloop_228 = tmp_qloop_124*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 9];
                const real_t tmp_qloop_229 = tmp_qloop_126*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 9];
                const real_t tmp_qloop_230 = tmp_qloop_227*2.0 + tmp_qloop_228*2.0 + tmp_qloop_229*2.0;
                const real_t tmp_qloop_231 = tmp_qloop_141 + tmp_qloop_142*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 9] + tmp_qloop_144*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 9] + tmp_qloop_146*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 9];
                const real_t tmp_qloop_232 = tmp_qloop_156 + tmp_qloop_157*_data_jac_affine_inv_T_grad_phi_2_0_GREEN_DOWN[10*q + 9] + tmp_qloop_158*_data_jac_affine_inv_T_grad_phi_0_0_GREEN_DOWN[10*q + 9] + tmp_qloop_159*_data_jac_affine_inv_T_grad_phi_1_0_GREEN_DOWN[10*q + 9];
                const real_t tmp_qloop_233 = tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229;
                const real_t tmp_qloop_234 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_235 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_236 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_237 = tmp_qloop_234*1.0 + tmp_qloop_235*1.0 + tmp_qloop_236*1.0;
                const real_t tmp_qloop_238 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 1] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 1] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_239 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 1] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 1] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_240 = tmp_qloop_234*0.66666666666666667 + tmp_qloop_235*0.66666666666666667 + tmp_qloop_236*0.66666666666666667;
                const real_t tmp_qloop_241 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_242 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_243 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_244 = tmp_qloop_241*1.0 + tmp_qloop_242*1.0 + tmp_qloop_243*1.0;
                const real_t tmp_qloop_245 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 2] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 2] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_246 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 2] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 2] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_247 = tmp_qloop_241*0.66666666666666667 + tmp_qloop_242*0.66666666666666667 + tmp_qloop_243*0.66666666666666667;
                const real_t tmp_qloop_248 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_249 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_250 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_251 = tmp_qloop_248*1.0 + tmp_qloop_249*1.0 + tmp_qloop_250*1.0;
                const real_t tmp_qloop_252 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 3] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 3] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_253 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 3] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 3] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_254 = tmp_qloop_248*0.66666666666666667 + tmp_qloop_249*0.66666666666666667 + tmp_qloop_250*0.66666666666666667;
                const real_t tmp_qloop_255 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_256 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_257 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_258 = tmp_qloop_255*1.0 + tmp_qloop_256*1.0 + tmp_qloop_257*1.0;
                const real_t tmp_qloop_259 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 4] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 4] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_260 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 4] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 4] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_261 = tmp_qloop_255*0.66666666666666667 + tmp_qloop_256*0.66666666666666667 + tmp_qloop_257*0.66666666666666667;
                const real_t tmp_qloop_262 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_263 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_264 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_265 = tmp_qloop_262*1.0 + tmp_qloop_263*1.0 + tmp_qloop_264*1.0;
                const real_t tmp_qloop_266 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 5] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 5] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_267 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 5] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 5] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_268 = tmp_qloop_262*0.66666666666666667 + tmp_qloop_263*0.66666666666666667 + tmp_qloop_264*0.66666666666666667;
                const real_t tmp_qloop_269 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_270 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_271 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_272 = tmp_qloop_269*1.0 + tmp_qloop_270*1.0 + tmp_qloop_271*1.0;
                const real_t tmp_qloop_273 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 6] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 6] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_274 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 6] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 6] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_275 = tmp_qloop_269*0.66666666666666667 + tmp_qloop_270*0.66666666666666667 + tmp_qloop_271*0.66666666666666667;
                const real_t tmp_qloop_276 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_277 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_278 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_279 = tmp_qloop_276*1.0 + tmp_qloop_277*1.0 + tmp_qloop_278*1.0;
                const real_t tmp_qloop_280 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 7] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 7] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_281 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 7] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 7] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_282 = tmp_qloop_276*0.66666666666666667 + tmp_qloop_277*0.66666666666666667 + tmp_qloop_278*0.66666666666666667;
                const real_t tmp_qloop_283 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_284 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_285 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_286 = tmp_qloop_283*1.0 + tmp_qloop_284*1.0 + tmp_qloop_285*1.0;
                const real_t tmp_qloop_287 = tmp_qloop_151*2.0 + tmp_qloop_165*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 8] + tmp_qloop_166*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 8] + tmp_qloop_167*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_288 = tmp_qloop_160*2.0 + tmp_qloop_163*2.0*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 8] + tmp_qloop_164*2.0*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 8] + tmp_qloop_168*2.0*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_289 = tmp_qloop_283*0.66666666666666667 + tmp_qloop_284*0.66666666666666667 + tmp_qloop_285*0.66666666666666667;
                const real_t tmp_qloop_290 = tmp_qloop_128*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 9];
                const real_t tmp_qloop_291 = tmp_qloop_124*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 9];
                const real_t tmp_qloop_292 = tmp_qloop_126*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 9];
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_170*(tmp_qloop_132*(tmp_qloop_123*2.0 + tmp_qloop_125*2.0 + tmp_qloop_127*2.0) + tmp_qloop_152*(tmp_qloop_122*tmp_qloop_134 + tmp_qloop_136*tmp_qloop_137 + tmp_qloop_139*tmp_qloop_140 + tmp_qloop_141) + tmp_qloop_161*(tmp_qloop_122*tmp_qloop_155 + tmp_qloop_137*tmp_qloop_154 + tmp_qloop_140*tmp_qloop_153 + tmp_qloop_156) - tmp_qloop_162*(tmp_qloop_123 + tmp_qloop_125 + tmp_qloop_127) + tmp_qloop_169);
                const real_t q_tmp_0_1 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_174 + tmp_qloop_152*tmp_qloop_175 + tmp_qloop_161*tmp_qloop_176 - tmp_qloop_162*tmp_qloop_177 + tmp_qloop_169);
                const real_t q_tmp_0_2 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_181 + tmp_qloop_152*tmp_qloop_182 + tmp_qloop_161*tmp_qloop_183 - tmp_qloop_162*tmp_qloop_184 + tmp_qloop_169);
                const real_t q_tmp_0_3 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_188 + tmp_qloop_152*tmp_qloop_189 + tmp_qloop_161*tmp_qloop_190 - tmp_qloop_162*tmp_qloop_191 + tmp_qloop_169);
                const real_t q_tmp_0_4 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_195 + tmp_qloop_152*tmp_qloop_196 + tmp_qloop_161*tmp_qloop_197 - tmp_qloop_162*tmp_qloop_198 + tmp_qloop_169);
                const real_t q_tmp_0_5 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_202 + tmp_qloop_152*tmp_qloop_203 + tmp_qloop_161*tmp_qloop_204 - tmp_qloop_162*tmp_qloop_205 + tmp_qloop_169);
                const real_t q_tmp_0_6 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_209 + tmp_qloop_152*tmp_qloop_210 + tmp_qloop_161*tmp_qloop_211 - tmp_qloop_162*tmp_qloop_212 + tmp_qloop_169);
                const real_t q_tmp_0_7 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_216 + tmp_qloop_152*tmp_qloop_217 + tmp_qloop_161*tmp_qloop_218 - tmp_qloop_162*tmp_qloop_219 + tmp_qloop_169);
                const real_t q_tmp_0_8 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_223 + tmp_qloop_152*tmp_qloop_224 + tmp_qloop_161*tmp_qloop_225 - tmp_qloop_162*tmp_qloop_226 + tmp_qloop_169);
                const real_t q_tmp_0_9 = tmp_qloop_170*(tmp_qloop_132*tmp_qloop_230 + tmp_qloop_152*tmp_qloop_231 + tmp_qloop_161*tmp_qloop_232 - tmp_qloop_162*tmp_qloop_233 + tmp_qloop_169);
                const real_t q_tmp_1_1 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_174*tmp_qloop_237 + tmp_qloop_175*tmp_qloop_238 + tmp_qloop_176*tmp_qloop_239 - tmp_qloop_177*tmp_qloop_240);
                const real_t q_tmp_1_2 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_181*tmp_qloop_237 + tmp_qloop_182*tmp_qloop_238 + tmp_qloop_183*tmp_qloop_239 - tmp_qloop_184*tmp_qloop_240);
                const real_t q_tmp_1_3 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_188*tmp_qloop_237 + tmp_qloop_189*tmp_qloop_238 + tmp_qloop_190*tmp_qloop_239 - tmp_qloop_191*tmp_qloop_240);
                const real_t q_tmp_1_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_237 + tmp_qloop_196*tmp_qloop_238 + tmp_qloop_197*tmp_qloop_239 - tmp_qloop_198*tmp_qloop_240);
                const real_t q_tmp_1_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_237 + tmp_qloop_203*tmp_qloop_238 + tmp_qloop_204*tmp_qloop_239 - tmp_qloop_205*tmp_qloop_240);
                const real_t q_tmp_1_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_237 + tmp_qloop_210*tmp_qloop_238 + tmp_qloop_211*tmp_qloop_239 - tmp_qloop_212*tmp_qloop_240);
                const real_t q_tmp_1_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_237 + tmp_qloop_217*tmp_qloop_238 + tmp_qloop_218*tmp_qloop_239 - tmp_qloop_219*tmp_qloop_240);
                const real_t q_tmp_1_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_237 + tmp_qloop_224*tmp_qloop_238 + tmp_qloop_225*tmp_qloop_239 - tmp_qloop_226*tmp_qloop_240);
                const real_t q_tmp_1_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_237 + tmp_qloop_231*tmp_qloop_238 + tmp_qloop_232*tmp_qloop_239 - tmp_qloop_233*tmp_qloop_240);
                const real_t q_tmp_2_2 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_181*tmp_qloop_244 + tmp_qloop_182*tmp_qloop_245 + tmp_qloop_183*tmp_qloop_246 - tmp_qloop_184*tmp_qloop_247);
                const real_t q_tmp_2_3 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_188*tmp_qloop_244 + tmp_qloop_189*tmp_qloop_245 + tmp_qloop_190*tmp_qloop_246 - tmp_qloop_191*tmp_qloop_247);
                const real_t q_tmp_2_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_244 + tmp_qloop_196*tmp_qloop_245 + tmp_qloop_197*tmp_qloop_246 - tmp_qloop_198*tmp_qloop_247);
                const real_t q_tmp_2_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_244 + tmp_qloop_203*tmp_qloop_245 + tmp_qloop_204*tmp_qloop_246 - tmp_qloop_205*tmp_qloop_247);
                const real_t q_tmp_2_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_244 + tmp_qloop_210*tmp_qloop_245 + tmp_qloop_211*tmp_qloop_246 - tmp_qloop_212*tmp_qloop_247);
                const real_t q_tmp_2_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_244 + tmp_qloop_217*tmp_qloop_245 + tmp_qloop_218*tmp_qloop_246 - tmp_qloop_219*tmp_qloop_247);
                const real_t q_tmp_2_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_244 + tmp_qloop_224*tmp_qloop_245 + tmp_qloop_225*tmp_qloop_246 - tmp_qloop_226*tmp_qloop_247);
                const real_t q_tmp_2_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_244 + tmp_qloop_231*tmp_qloop_245 + tmp_qloop_232*tmp_qloop_246 - tmp_qloop_233*tmp_qloop_247);
                const real_t q_tmp_3_3 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_188*tmp_qloop_251 + tmp_qloop_189*tmp_qloop_252 + tmp_qloop_190*tmp_qloop_253 - tmp_qloop_191*tmp_qloop_254);
                const real_t q_tmp_3_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_251 + tmp_qloop_196*tmp_qloop_252 + tmp_qloop_197*tmp_qloop_253 - tmp_qloop_198*tmp_qloop_254);
                const real_t q_tmp_3_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_251 + tmp_qloop_203*tmp_qloop_252 + tmp_qloop_204*tmp_qloop_253 - tmp_qloop_205*tmp_qloop_254);
                const real_t q_tmp_3_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_251 + tmp_qloop_210*tmp_qloop_252 + tmp_qloop_211*tmp_qloop_253 - tmp_qloop_212*tmp_qloop_254);
                const real_t q_tmp_3_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_251 + tmp_qloop_217*tmp_qloop_252 + tmp_qloop_218*tmp_qloop_253 - tmp_qloop_219*tmp_qloop_254);
                const real_t q_tmp_3_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_251 + tmp_qloop_224*tmp_qloop_252 + tmp_qloop_225*tmp_qloop_253 - tmp_qloop_226*tmp_qloop_254);
                const real_t q_tmp_3_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_251 + tmp_qloop_231*tmp_qloop_252 + tmp_qloop_232*tmp_qloop_253 - tmp_qloop_233*tmp_qloop_254);
                const real_t q_tmp_4_4 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_195*tmp_qloop_258 + tmp_qloop_196*tmp_qloop_259 + tmp_qloop_197*tmp_qloop_260 - tmp_qloop_198*tmp_qloop_261);
                const real_t q_tmp_4_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_258 + tmp_qloop_203*tmp_qloop_259 + tmp_qloop_204*tmp_qloop_260 - tmp_qloop_205*tmp_qloop_261);
                const real_t q_tmp_4_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_258 + tmp_qloop_210*tmp_qloop_259 + tmp_qloop_211*tmp_qloop_260 - tmp_qloop_212*tmp_qloop_261);
                const real_t q_tmp_4_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_258 + tmp_qloop_217*tmp_qloop_259 + tmp_qloop_218*tmp_qloop_260 - tmp_qloop_219*tmp_qloop_261);
                const real_t q_tmp_4_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_258 + tmp_qloop_224*tmp_qloop_259 + tmp_qloop_225*tmp_qloop_260 - tmp_qloop_226*tmp_qloop_261);
                const real_t q_tmp_4_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_258 + tmp_qloop_231*tmp_qloop_259 + tmp_qloop_232*tmp_qloop_260 - tmp_qloop_233*tmp_qloop_261);
                const real_t q_tmp_5_5 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_202*tmp_qloop_265 + tmp_qloop_203*tmp_qloop_266 + tmp_qloop_204*tmp_qloop_267 - tmp_qloop_205*tmp_qloop_268);
                const real_t q_tmp_5_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_265 + tmp_qloop_210*tmp_qloop_266 + tmp_qloop_211*tmp_qloop_267 - tmp_qloop_212*tmp_qloop_268);
                const real_t q_tmp_5_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_265 + tmp_qloop_217*tmp_qloop_266 + tmp_qloop_218*tmp_qloop_267 - tmp_qloop_219*tmp_qloop_268);
                const real_t q_tmp_5_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_265 + tmp_qloop_224*tmp_qloop_266 + tmp_qloop_225*tmp_qloop_267 - tmp_qloop_226*tmp_qloop_268);
                const real_t q_tmp_5_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_265 + tmp_qloop_231*tmp_qloop_266 + tmp_qloop_232*tmp_qloop_267 - tmp_qloop_233*tmp_qloop_268);
                const real_t q_tmp_6_6 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_209*tmp_qloop_272 + tmp_qloop_210*tmp_qloop_273 + tmp_qloop_211*tmp_qloop_274 - tmp_qloop_212*tmp_qloop_275);
                const real_t q_tmp_6_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_272 + tmp_qloop_217*tmp_qloop_273 + tmp_qloop_218*tmp_qloop_274 - tmp_qloop_219*tmp_qloop_275);
                const real_t q_tmp_6_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_272 + tmp_qloop_224*tmp_qloop_273 + tmp_qloop_225*tmp_qloop_274 - tmp_qloop_226*tmp_qloop_275);
                const real_t q_tmp_6_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_272 + tmp_qloop_231*tmp_qloop_273 + tmp_qloop_232*tmp_qloop_274 - tmp_qloop_233*tmp_qloop_275);
                const real_t q_tmp_7_7 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_216*tmp_qloop_279 + tmp_qloop_217*tmp_qloop_280 + tmp_qloop_218*tmp_qloop_281 - tmp_qloop_219*tmp_qloop_282);
                const real_t q_tmp_7_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_279 + tmp_qloop_224*tmp_qloop_280 + tmp_qloop_225*tmp_qloop_281 - tmp_qloop_226*tmp_qloop_282);
                const real_t q_tmp_7_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_279 + tmp_qloop_231*tmp_qloop_280 + tmp_qloop_232*tmp_qloop_281 - tmp_qloop_233*tmp_qloop_282);
                const real_t q_tmp_8_8 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_223*tmp_qloop_286 + tmp_qloop_224*tmp_qloop_287 + tmp_qloop_225*tmp_qloop_288 - tmp_qloop_226*tmp_qloop_289);
                const real_t q_tmp_8_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*tmp_qloop_286 + tmp_qloop_231*tmp_qloop_287 + tmp_qloop_232*tmp_qloop_288 - tmp_qloop_233*tmp_qloop_289);
                const real_t q_tmp_9_9 = tmp_qloop_170*(tmp_qloop_169 + tmp_qloop_230*(tmp_qloop_290*1.0 + tmp_qloop_291*1.0 + tmp_qloop_292*1.0) + tmp_qloop_231*(tmp_qloop_151 + tmp_qloop_165*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 9] + tmp_qloop_166*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 9] + tmp_qloop_167*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 9])*2.0 + tmp_qloop_232*(tmp_qloop_160 + tmp_qloop_163*_data_jac_affine_inv_T_grad_psi_1_0_GREEN_DOWN[10*q + 9] + tmp_qloop_164*_data_jac_affine_inv_T_grad_psi_0_0_GREEN_DOWN[10*q + 9] + tmp_qloop_168*_data_jac_affine_inv_T_grad_psi_2_0_GREEN_DOWN[10*q + 9])*2.0 + tmp_qloop_233*(tmp_qloop_290 + tmp_qloop_291 + tmp_qloop_292)*-0.66666666666666667);
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_9*src_dof_9;
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
