/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/































#include "../P2ElementwiseKMassIcosahedralShellMap.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseKMassIcosahedralShellMap::computeInverseDiagonalOperatorValues_P2ElementwiseKMassIcosahedralShellMap_macro_3D( real_t * RESTRICT  _data_invDiag_Edge, real_t * RESTRICT  _data_invDiag_Vertex, real_t * RESTRICT  _data_kEdge, real_t * RESTRICT  _data_kVertex, real_t forVertex_0, real_t forVertex_1, real_t forVertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t rayVertex_2, real_t refVertex_0, real_t refVertex_1, real_t refVertex_2, real_t thrVertex_0, real_t thrVertex_1, real_t thrVertex_2 ) const
{
    {
       const real_t _data_q_w [] = {0.02364442875776411, 0.0041220137385117907, 0.025486503738822306, 0.0091363578885896128, 0.0052827872295400091, 0.02526054964096567, 0.01949470769240411, 0.0094909452962763929, 0.019522077110586403, 0.018549261128954084, 0.0066770344442521412};
   
       const real_t _data_q_p_0 [] = {0.4881393122183349, 0.028620108024415062, 0.12011493111997025, 0.19015055018870972, 0.81934505243836264, 0.33721826230431567, 0.086557484679865959, 0.079692524193577793, 0.061206893331017434, 0.43957887847117094, 0.085226802665704912};
   
       const real_t _data_q_p_1 [] = {0.31081202744417918, 0.1144811451032984, 0.33248812467264544, 0.58529107547132619, 0.026719351714152292, 0.11264913310739497, 0.079391877387070833, 0.063296594113889035, 0.44299746808745322, 0.057741550565775693, 0.77428400209089154};
   
       const real_t _data_q_p_2 [] = {0.082320586256909412, 0.85148303380032098, 0.10040383353811888, 0.21187112908079075, 0.11113976289693195, 0.45821473775386756, 0.49383422023194623, 0.10603293862052354, 0.35074787972985066, 0.10858823393329198, 0.0088057690417862045};
   
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t abs_det_jac_affine_WHITE_UP = abs(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
       const real_t tmp_qloop_1 = -rayVertex_0;
       const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
       const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
       const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
       const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
       const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
       const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
       const real_t tmp_qloop_8 = -rayVertex_1;
       const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
       const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
       const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
       const real_t tmp_qloop_12 = -rayVertex_2;
       const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
       const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
       const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
       const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
       const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
       const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
       const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
       const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
       const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
       const real_t tmp_qloop_40 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
       const real_t tmp_qloop_41 = tmp_qloop_21*tmp_qloop_40;
       const real_t tmp_qloop_46 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
       const real_t tmp_qloop_47 = -tmp_qloop_21*tmp_qloop_46;
       const real_t tmp_qloop_54 = -tmp_qloop_21*tmp_qloop_40;
       const real_t tmp_qloop_69 = tmp_qloop_21*tmp_qloop_32;
       const real_t tmp_qloop_73 = tmp_qloop_21*tmp_qloop_46;
       const real_t tmp_qloop_116 = 1.0 / (tmp_qloop_16*tmp_qloop_16*tmp_qloop_16);
       {
          /* CellType.WHITE_UP */
          const real_t _data_phi_psi_jac_affine_det_0_0_WHITE_UP [] = {((real_t)(abs_det_jac_affine_WHITE_UP*0.0081966519410136655)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0010483393829444135)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.010647302229434073)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.006225865982166446)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0092658338660815045)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.014552261081115014)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.054943945083223346)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0035394853240292199)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.013363784925403197)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.02098821218651729)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00013408102109754342)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0013617738473651977)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00079627884031291754)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0011850861336478869)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0018612121768751683)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0070272474541544115)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00045269481823022469)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0017092078745466989)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0026843605866225069)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.013830652512846866)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0080872870080513325)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.012036150161049137)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.018903123246819378)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.07137118828375684)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0045977272492218257)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.017359314272935491)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.027263307020171587)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0047289317036809308)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0070379760270885047)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.011053345668513806)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.041733337109024285)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0026884588282915065)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.010150624249852821)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.015941850064987575)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.01047448127011787)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.016450476917137476)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.062110904641547282)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0040011803868095627)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.015106974388071553)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.02372594184379705)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.025835951568628612)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.097546978867890252)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0062839699548933566)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.023725941843797053)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.037262280448408056)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.3683012433653402)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.02372594184379705)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.089580364071742774)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.14068856236299254)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0015284236111493253)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0057707611543522386)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0090631479226385408)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.021788255597241783)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.034219087945639513)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.053742071025623714)), ((real_t)(abs_det_jac_affine_WHITE_UP*2.8698018728458151e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00014454340268069696)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00047286322640212926)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0032065374623290576)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0020887954478770055)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00052219560963689146)), ((real_t)(abs_det_jac_affine_WHITE_UP*-7.0208740498716208e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*-9.881379856501532e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*-1.3285428320562817e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*-3.3213363942336231e-6)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00072802221840478313)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0023816717242211073)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.016150377488204762)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.01052064271045634)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00263014429658129)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00035362058773580443)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00049769577515219844)), ((real_t)(abs_det_jac_affine_WHITE_UP*-6.691475929731612e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*-1.6728585635554696e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0077914657802387113)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.052834785019937068)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.034417517255215337)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0086043257244467573)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0011568440270383941)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0016281755212658067)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00021890676702241725)), ((real_t)(abs_det_jac_affine_WHITE_UP*-5.4726350909608775e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.35827847889456316)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.23338896382133173)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.058346877560018065)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0078446863779075976)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.011040836996163679)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0014844308248613668)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00037110539490121838)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.15203371578906599)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.038008192225104848)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0051101680203961414)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0071921972935839896)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00096698460132961257)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00024174464470133657)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0095019888761043864)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0012775340483769759)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0017980381248767646)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00024174464470134023)), ((real_t)(abs_det_jac_affine_WHITE_UP*6.0435784769912737e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00017176332934538114)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00024174464470134207)), ((real_t)(abs_det_jac_affine_WHITE_UP*3.2502354890713518e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*8.1255381153003586e-6)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00034023835858622775)), ((real_t)(abs_det_jac_affine_WHITE_UP*4.5744748107514238e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*1.1436115800600717e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*6.150341155286279e-6)), ((real_t)(abs_det_jac_affine_WHITE_UP*1.53757571251115e-6)), ((real_t)(abs_det_jac_affine_WHITE_UP*3.8439153406509323e-7)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0022455683985789271)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0043245643162645366)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0052785529053041248)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0038024608195830192)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0063277537331678678)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0022859694750058082)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0075700068116924318)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0085069574365176301)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.028170859867257168)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0101770278137826)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0083283397367649708)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.010165551648410579)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0073228615012435371)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.012186125354224276)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0044023695853291234)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.014578483270623889)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.01638288310132377)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.05425205280655232)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.01959914084869013)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.012408048132369226)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0089382673087210242)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.014874355585605769)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0053735218314278996)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.017794461960864042)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.019996908096963657)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.066219926452175323)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.023922664643748495)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0064387743849681585)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.010714897689853333)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0038708726792615806)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.012818426872970318)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.014404981993284736)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.047702216938480875)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.017232941800483223)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.017830882966183025)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0064415993244871881)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.021331409407572027)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.023971628613445938)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.079382246296480372)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.028677695046817175)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0023270974261863082)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0077062023619792735)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.008660010105842008)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.028677695046817168)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.010360127504160913)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.025519152819096672)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.028677695046817164)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.094966424189672397)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.034307647864064747)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.03222717458640751)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.10672055502407191)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.038553954756796821)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.35340600008570494)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.12767173985378449)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.046122796877640655)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00015290096248775118)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0014570800801489527)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0012345554413094673)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0015097104585850083)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0061335058519928322)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0019926658054762107)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0055047118378142874)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00013295486007563399)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00036728596944954594)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00011932460974427863)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.013885343332204057)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.011764779711675321)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.014386888088902506)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.058449659524751035)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.018989243784426475)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.052457524369618494)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0012670023459840343)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0035000765272880604)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0011371119520837828)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0099680676489457051)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.012189728770328983)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.04952325283425088)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.016089214697121625)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.044446233965065328)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0010735062963914434)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0029655463557783954)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00096345270719750374)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.014906548864553707)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.060560887138220144)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.019675143688079481)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.054352313404898829)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0013127670323983137)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0036265008430796091)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0011781849398884157)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.24604092364326371)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.079934273663800182)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.22081732986784111)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0053333831197440425)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.014733397398686206)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0047866159914586818)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.025969208746035512)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.071739581424095769)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0017327203114618317)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0047866159914586584)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0015550854992705844)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.19817960544100707)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0047866159914586211)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.01322296073874602)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0042959022697749219)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00011561074914193237)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00031937310191765402)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00010375858028624978)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00088226379454805234)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0002866316487224664)), ((real_t)(abs_det_jac_affine_WHITE_UP*9.3121470649767956e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0015313812260033845)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.020478525470679236)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0009897290528383181)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0033824754838425301)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00046483308651242364)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.014254039308965735)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0034268445398502956)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00074451353959082409)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00017899011660411598)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0054887060151714157)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.27385082063970095)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.013235235794627626)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.045232440605657676)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0062160199172626362)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.19061335093582549)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.045825769574392869)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0099560705230576918)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0023935605319149542)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.07339818722089371)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00063966018480500107)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0021860880883392128)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00030042082443606778)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0092123610926072748)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0022147637329352362)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0004811778202920854)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0001156810045506071)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0035473412586367816)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.007471124893345448)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0010267113717402016)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.031483955588337449)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0075691261236329422)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0016444623665833173)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00039534876814677629)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.012123312744788284)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00014109471544232499)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0043266490242589092)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0010401790863102422)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00022598848717865071)), ((real_t)(abs_det_jac_affine_WHITE_UP*5.4330382888033369e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0016660333264303686)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.13267606600597784)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.031896941106050063)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0069299042453857072)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0016660333264303651)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.051088670781077684)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0076684128686554951)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.001666033326430367)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00040053468944030722)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.012282338270543791)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00036196108534037404)), ((real_t)(abs_det_jac_affine_WHITE_UP*8.7019850447357002e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.002668451117030794)), ((real_t)(abs_det_jac_affine_WHITE_UP*2.0920631190945677e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00064152812701327526)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.019672367147664311)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0056280121552861676)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0082361505285512976)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.006546963131509812)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0028727623124179887)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.015489393471375653)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.046367923183087689)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.011399254367437734)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.012638819023050307)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0031071720072274201)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0093014044232272736)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.01205295469471257)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0095809625793618486)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0042040603653636923)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.022667501900539677)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.067855787175853305)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.016681906913665712)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.018495911718880619)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.004547100408372284)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.013611869491908979)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0076159619174044459)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0033418316140852618)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.018018526824128522)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.053938953077637526)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.013260543156471259)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.01470250594466384)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0036145161050283661)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.010820152862131633)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0014663726864729064)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0079064054197158472)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.023668040961914667)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0058186349696638454)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0064513583057541025)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0015860247622562602)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0047478085232114465)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.042629849312913477)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.1276136203719424)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.031372984155995043)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.034784509247666975)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0085515468828518213)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.025599289584411971)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.38201486439458487)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.093915886510190727)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.10412838021952459)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.025599289584412016)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.07663217382818617)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.023088613980959145)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.025599289584412002)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0062934199672080244)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.018839524874726728)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.02838297819726298)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.006977771829428203)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.020888150899772109)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0017154401263027783)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0051352169565958509)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.015372412471279177)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.011820472404298839)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.007781569024383839)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0072610786275946687)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00066208934951621885)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.017050403495896919)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.018589307722076551)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0029885333557655271)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.07306575166941863)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.011746507147698459)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.012806701969292705)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0051227069790568064)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.004780061456051238)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00043586193490000903)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.011224499931886399)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.012237580378111014)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0019673899480620945)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.048100124131019932)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0077328767445869005)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0084308166323810284)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0044603346662302444)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00040670818059537962)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.010473720184896984)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.011419038121814993)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0018357959762683471)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.044882822759521109)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0072156432570344995)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0078668996279190398)), ((real_t)(abs_det_jac_affine_WHITE_UP*3.7085007413357473e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0009550287140370076)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0010412259541497195)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00016739399559079557)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0040925653679565032)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00065794640099822775)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00071733012745018546)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.024594301262203948)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.026814088856171956)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0043108006037235582)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.10539346525960519)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.016943712542559438)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.018472987251230831)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.029234225990864938)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0046998769835807442)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.11490587645496211)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.018472987251230838)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.020140288447822608)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00075558161408803245)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.018472987251230834)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0029698329494740154)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0032378787161382984)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.45164050000874939)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.072608551069807847)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.079161921265709395)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.011673004720247106)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.012726565493781048)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.013875216634373964)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.14209718214348346)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.025252677134971455)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.020839612993267732)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.03149368209432183)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.010119845073829774)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.012741222646677527)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0076059006651480118)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.1200661827724549)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.07167376983628268)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.090239667974007801)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0044877575534129259)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0037034936977522613)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0055968723216219887)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0017984394655152865)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0022642953009190934)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0013516760214407645)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.021337457243309044)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.012737441667874105)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.016036864107647247)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0030562848830502985)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0046187836850695154)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0014841508586531178)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0018685954570844729)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0011154621360955055)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.017608602400224702)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.010511493631509539)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.013234321250089203)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0069800962756367633)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0022429099493131632)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0028238984719785166)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0016857323556725265)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.026610845714704033)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.01588540242442097)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.020000251747433327)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00072071284436102596)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00090740152120223465)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0005416753183783425)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0085508463287925583)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0051044463771850934)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0064266683239972821)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00114244879513716)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00068198730151671568)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.010765800869265733)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.006426668323997283)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0080913898775143087)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00040711380799715558)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0064266683239972821)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0038364136814548937)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0048301728458850918)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.10145090865343141)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.060561341325294053)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.076248749657487444)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.036152224872110263)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.045516857511929326)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.057307242502786078)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.010602832052866737)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0055309670312750914)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0052003949426853487)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.010780936812590689)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.063998122143175837)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0088423219489586306)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.011167925629143633)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.020954485874738926)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.026465688672824863)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0036566407264651056)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0028852287906211633)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0027127858702454444)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0056238753739928293)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0333846185502596)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0046125969868953268)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0058257480788658431)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.010930906945674442)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.013805825724628665)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0019074865283589999)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0025506494326292106)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0052877503857517326)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.031389303261174069)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.004336913582680707)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0054775576631322688)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.010277593932094844)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.012980685994326498)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0017934808215683258)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.010962033348971875)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.065073152862351727)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0089908539277986903)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.011355522744789336)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.021306476140476493)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.026910255284697957)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0037180644210720384)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.3862892119229091)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.05337177815296397)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.067408996477181224)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.12648014603762484)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.15974546874283108)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.02207128611291664)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0073741295777570923)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.009313586542023437)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.017475171676349516)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.022071286112916647)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0030494866271447126)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.011763136701232706)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.022071286112916647)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.027876216594627978)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0038515267885072964)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.041412565632020393)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.052304412320668951)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0072266566205763131)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.066060904618168603)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0091273269794773342)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0012610801845935181)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0069681379285338333)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0044341865869643995)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0042633692251674987)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0070958595609978423)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0020935800564522147)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.015938151369117328)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0084750763491579645)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.014288874398795993)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0075980770083520213)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.057843167305739338)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0028217022811074114)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.002713002358363512)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0045154624680312757)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0013322532791783996)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.010142270108137568)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0053931294495547805)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0090927498639929594)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0048350494066994043)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.036808599262129503)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0026084898629338414)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0043415141302798731)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0012809311288964204)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0097515612851041059)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0051853709066214775)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.008742471518058556)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0046487896795516861)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.035390628300808115)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0072259222515130232)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0021319540762042076)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.016230287766559517)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0086304192252137108)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.014550780575597435)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0077373450321837718)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.058903396570852681)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0006290170340667614)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0047886244769155305)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0025463403571347391)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0042930984973720693)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0022828455256225003)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.017379004651649481)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.03645517233875218)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.019384956368986152)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.032682797814571146)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.017379004651649481)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.13230409122829059)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.010307907199989913)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.017379004651649481)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0092412468600652879)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.070352404648282713)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.02930078791186147)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.015580628448835175)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.11861328821804179)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0082849643358013647)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.063072350763365564)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.48016156371688662)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0094094610911181365)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0068580279611794945)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.041201510190226373)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00083913709311830018)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0026455132646613986)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00029119630051498147)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.025604650302191737)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00044992567302397189)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.039561592985156692)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0043546141588640059)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0049984315850686882)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.030029467808109854)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00061159991971275918)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0019281661048415227)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00021223663627333838)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.018661792211926504)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00032792556514883638)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.02883422421897347)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0031738338011543547)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.18041037903410936)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0036743566032432728)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.011583994096666503)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0012750706152926475)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.1121159065463094)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0019701040285335608)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.17322962077585116)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.01906768920170104)), ((real_t)(abs_det_jac_affine_WHITE_UP*7.4834366626129028e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0002359272533481587)), ((real_t)(abs_det_jac_affine_WHITE_UP*-2.5968927951845934e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0022834263957128066)), ((real_t)(abs_det_jac_affine_WHITE_UP*-4.012443621633234e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0035281085510869368)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00038834511684948268)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00074379822241953109)), ((real_t)(abs_det_jac_affine_WHITE_UP*8.1871179249561797e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0071988652012604706)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00012649867240751639)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.011122923831648516)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0012243197998481877)), ((real_t)(abs_det_jac_affine_WHITE_UP*9.0117047737890255e-6)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00079239176099213078)), ((real_t)(abs_det_jac_affine_WHITE_UP*1.3923931479451492e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0012243197998481881)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00013476303488074395)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.069674353371455625)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0012243197998481872)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.10765342924248253)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.011849602401133497)), ((real_t)(abs_det_jac_affine_WHITE_UP*2.1513783763573511e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0018916892452585615)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00020822156414845061)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.16633467361914708)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.018308750234696657)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0020152763573759057))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t k_dof_0 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_1 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_2 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_3 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_7 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 11; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_105 = tmp_qloop_104*_data_q_p_1[q];
                const real_t tmp_qloop_106 = tmp_qloop_104*_data_q_p_2[q];
                const real_t tmp_qloop_107 = 4.0*_data_q_p_1[q]*_data_q_p_2[q];
                const real_t tmp_qloop_108 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_109 = tmp_qloop_108*2.0;
                const real_t tmp_qloop_110 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_111 = tmp_qloop_110*2.0;
                const real_t tmp_qloop_112 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const real_t tmp_qloop_113 = tmp_qloop_112*2.0;
                const real_t tmp_qloop_114 = tmp_qloop_105 + tmp_qloop_106;
                const real_t tmp_qloop_115 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_117 = tmp_qloop_115*tmp_qloop_116;
                const real_t tmp_qloop_118 = tmp_qloop_117*tmp_qloop_25*tmp_qloop_43*1.0;
                const real_t tmp_qloop_119 = (k_dof_0*(tmp_qloop_107 + tmp_qloop_109 + tmp_qloop_111 + tmp_qloop_113 + tmp_qloop_114 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0) + k_dof_1*(tmp_qloop_109 - _data_q_p_0[q]) + k_dof_2*(tmp_qloop_111 - _data_q_p_1[q]) + k_dof_3*(tmp_qloop_113 - _data_q_p_2[q]) + k_dof_4*tmp_qloop_107 + k_dof_5*tmp_qloop_106 + k_dof_6*tmp_qloop_105 + k_dof_7*(-tmp_qloop_106 - tmp_qloop_107 + tmp_qloop_112*-4.0 + 4.0*_data_q_p_2[q]) + k_dof_8*(-tmp_qloop_105 - tmp_qloop_107 + tmp_qloop_110*-4.0 + 4.0*_data_q_p_1[q]) + k_dof_9*(tmp_qloop_108*-4.0 - tmp_qloop_114 + 4.0*_data_q_p_0[q]))*abs(tmp_qloop_115*tmp_qloop_116*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*-2.0 - tmp_qloop_115*tmp_qloop_116*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59 + tmp_qloop_117*tmp_qloop_50*tmp_qloop_52*tmp_qloop_56*tmp_qloop_86*1.0 + tmp_qloop_118*tmp_qloop_18*tmp_qloop_52*tmp_qloop_59 + tmp_qloop_118*tmp_qloop_22*tmp_qloop_36*tmp_qloop_50)*_data_q_w[q];
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_UP[55*q];
                const real_t q_tmp_1_1 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_UP[55*q + 10];
                const real_t q_tmp_2_2 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_UP[55*q + 19];
                const real_t q_tmp_3_3 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_UP[55*q + 27];
                const real_t q_tmp_4_4 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_UP[55*q + 34];
                const real_t q_tmp_5_5 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_UP[55*q + 40];
                const real_t q_tmp_6_6 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_UP[55*q + 45];
                const real_t q_tmp_7_7 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_UP[55*q + 49];
                const real_t q_tmp_8_8 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_UP[55*q + 52];
                const real_t q_tmp_9_9 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_UP[55*q + 54];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       {
          /* CellType.WHITE_DOWN */
          const real_t _data_phi_psi_jac_affine_det_0_0_WHITE_DOWN [] = {((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0081966519410136655)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0010483393829444135)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.010647302229434073)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.006225865982166446)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0092658338660815045)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.014552261081115014)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.054943945083223346)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0035394853240292199)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.013363784925403197)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.02098821218651729)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00013408102109754342)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0013617738473651977)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00079627884031291754)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0011850861336478869)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0018612121768751683)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0070272474541544115)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00045269481823022469)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0017092078745466989)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0026843605866225069)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.013830652512846866)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0080872870080513325)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.012036150161049137)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.018903123246819378)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.07137118828375684)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0045977272492218257)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.017359314272935491)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.027263307020171587)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0047289317036809308)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0070379760270885047)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.011053345668513806)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.041733337109024285)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0026884588282915065)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.010150624249852821)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.015941850064987575)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.01047448127011787)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.016450476917137476)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.062110904641547282)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0040011803868095627)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.015106974388071553)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.02372594184379705)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.025835951568628612)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.097546978867890252)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0062839699548933566)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.023725941843797053)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.037262280448408056)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.3683012433653402)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.02372594184379705)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.089580364071742774)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.14068856236299254)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0015284236111493253)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0057707611543522386)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0090631479226385408)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.021788255597241783)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.034219087945639513)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.053742071025623714)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*2.8698018728458151e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00014454340268069696)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00047286322640212926)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0032065374623290576)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0020887954478770055)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00052219560963689146)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-7.0208740498716208e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-9.881379856501532e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-1.3285428320562817e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-3.3213363942336231e-6)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00072802221840478313)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0023816717242211073)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.016150377488204762)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.01052064271045634)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00263014429658129)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00035362058773580443)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00049769577515219844)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-6.691475929731612e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-1.6728585635554696e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0077914657802387113)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.052834785019937068)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.034417517255215337)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0086043257244467573)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0011568440270383941)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0016281755212658067)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00021890676702241725)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-5.4726350909608775e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.35827847889456316)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.23338896382133173)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.058346877560018065)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0078446863779075976)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.011040836996163679)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0014844308248613668)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00037110539490121838)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.15203371578906599)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.038008192225104848)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0051101680203961414)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0071921972935839896)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00096698460132961257)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00024174464470133657)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0095019888761043864)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0012775340483769759)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0017980381248767646)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00024174464470134023)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*6.0435784769912737e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00017176332934538114)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00024174464470134207)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*3.2502354890713518e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*8.1255381153003586e-6)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00034023835858622775)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*4.5744748107514238e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*1.1436115800600717e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*6.150341155286279e-6)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*1.53757571251115e-6)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*3.8439153406509323e-7)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0022455683985789271)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0043245643162645366)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0052785529053041248)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0038024608195830192)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0063277537331678678)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0022859694750058082)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0075700068116924318)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0085069574365176301)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.028170859867257168)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0101770278137826)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0083283397367649708)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.010165551648410579)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0073228615012435371)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.012186125354224276)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0044023695853291234)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.014578483270623889)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.01638288310132377)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.05425205280655232)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.01959914084869013)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.012408048132369226)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0089382673087210242)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.014874355585605769)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0053735218314278996)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.017794461960864042)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.019996908096963657)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.066219926452175323)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.023922664643748495)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0064387743849681585)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.010714897689853333)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0038708726792615806)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.012818426872970318)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.014404981993284736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.047702216938480875)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.017232941800483223)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.017830882966183025)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0064415993244871881)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.021331409407572027)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.023971628613445938)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.079382246296480372)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.028677695046817175)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0023270974261863082)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0077062023619792735)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.008660010105842008)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.028677695046817168)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.010360127504160913)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.025519152819096672)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.028677695046817164)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.094966424189672397)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.034307647864064747)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.03222717458640751)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.10672055502407191)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.038553954756796821)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.35340600008570494)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.12767173985378449)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.046122796877640655)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00015290096248775118)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0014570800801489527)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0012345554413094673)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0015097104585850083)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0061335058519928322)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0019926658054762107)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0055047118378142874)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00013295486007563399)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00036728596944954594)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00011932460974427863)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.013885343332204057)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.011764779711675321)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.014386888088902506)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.058449659524751035)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.018989243784426475)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.052457524369618494)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0012670023459840343)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0035000765272880604)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0011371119520837828)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0099680676489457051)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.012189728770328983)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.04952325283425088)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.016089214697121625)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.044446233965065328)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0010735062963914434)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0029655463557783954)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00096345270719750374)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.014906548864553707)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.060560887138220144)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.019675143688079481)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.054352313404898829)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0013127670323983137)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0036265008430796091)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0011781849398884157)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.24604092364326371)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.079934273663800182)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.22081732986784111)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0053333831197440425)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.014733397398686206)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0047866159914586818)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.025969208746035512)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.071739581424095769)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0017327203114618317)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0047866159914586584)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0015550854992705844)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.19817960544100707)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0047866159914586211)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.01322296073874602)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0042959022697749219)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00011561074914193237)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00031937310191765402)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00010375858028624978)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00088226379454805234)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0002866316487224664)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*9.3121470649767956e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0015313812260033845)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.020478525470679236)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0009897290528383181)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0033824754838425301)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00046483308651242364)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.014254039308965735)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0034268445398502956)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00074451353959082409)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00017899011660411598)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0054887060151714157)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.27385082063970095)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.013235235794627626)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.045232440605657676)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0062160199172626362)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.19061335093582549)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.045825769574392869)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0099560705230576918)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0023935605319149542)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.07339818722089371)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00063966018480500107)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0021860880883392128)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00030042082443606778)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0092123610926072748)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0022147637329352362)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0004811778202920854)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0001156810045506071)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0035473412586367816)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.007471124893345448)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0010267113717402016)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.031483955588337449)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0075691261236329422)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0016444623665833173)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00039534876814677629)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.012123312744788284)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00014109471544232499)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0043266490242589092)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0010401790863102422)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00022598848717865071)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*5.4330382888033369e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0016660333264303686)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.13267606600597784)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.031896941106050063)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0069299042453857072)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0016660333264303651)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.051088670781077684)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0076684128686554951)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.001666033326430367)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00040053468944030722)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.012282338270543791)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00036196108534037404)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*8.7019850447357002e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.002668451117030794)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*2.0920631190945677e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00064152812701327526)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.019672367147664311)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0056280121552861676)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0082361505285512976)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.006546963131509812)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0028727623124179887)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.015489393471375653)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.046367923183087689)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.011399254367437734)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.012638819023050307)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0031071720072274201)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0093014044232272736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.01205295469471257)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0095809625793618486)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0042040603653636923)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.022667501900539677)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.067855787175853305)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.016681906913665712)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.018495911718880619)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.004547100408372284)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.013611869491908979)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0076159619174044459)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0033418316140852618)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.018018526824128522)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.053938953077637526)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.013260543156471259)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.01470250594466384)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0036145161050283661)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.010820152862131633)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0014663726864729064)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0079064054197158472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.023668040961914667)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0058186349696638454)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0064513583057541025)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0015860247622562602)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0047478085232114465)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.042629849312913477)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.1276136203719424)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.031372984155995043)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.034784509247666975)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0085515468828518213)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.025599289584411971)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.38201486439458487)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.093915886510190727)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.10412838021952459)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.025599289584412016)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.07663217382818617)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.023088613980959145)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.025599289584412002)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0062934199672080244)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.018839524874726728)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.02838297819726298)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.006977771829428203)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.020888150899772109)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0017154401263027783)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0051352169565958509)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.015372412471279177)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.011820472404298839)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.007781569024383839)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0072610786275946687)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00066208934951621885)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.017050403495896919)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.018589307722076551)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0029885333557655271)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.07306575166941863)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.011746507147698459)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.012806701969292705)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0051227069790568064)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.004780061456051238)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00043586193490000903)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.011224499931886399)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.012237580378111014)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0019673899480620945)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.048100124131019932)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0077328767445869005)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0084308166323810284)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0044603346662302444)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00040670818059537962)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.010473720184896984)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.011419038121814993)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0018357959762683471)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.044882822759521109)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0072156432570344995)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0078668996279190398)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*3.7085007413357473e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0009550287140370076)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0010412259541497195)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00016739399559079557)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0040925653679565032)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00065794640099822775)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00071733012745018546)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.024594301262203948)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.026814088856171956)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0043108006037235582)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.10539346525960519)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.016943712542559438)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.018472987251230831)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.029234225990864938)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0046998769835807442)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.11490587645496211)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.018472987251230838)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.020140288447822608)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00075558161408803245)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.018472987251230834)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0029698329494740154)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0032378787161382984)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.45164050000874939)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.072608551069807847)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.079161921265709395)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.011673004720247106)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.012726565493781048)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.013875216634373964)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.14209718214348346)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.025252677134971455)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.020839612993267732)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.03149368209432183)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.010119845073829774)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.012741222646677527)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0076059006651480118)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.1200661827724549)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.07167376983628268)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.090239667974007801)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0044877575534129259)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0037034936977522613)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0055968723216219887)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0017984394655152865)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0022642953009190934)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0013516760214407645)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.021337457243309044)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.012737441667874105)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.016036864107647247)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0030562848830502985)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0046187836850695154)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0014841508586531178)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0018685954570844729)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0011154621360955055)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.017608602400224702)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.010511493631509539)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.013234321250089203)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0069800962756367633)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0022429099493131632)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0028238984719785166)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0016857323556725265)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.026610845714704033)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.01588540242442097)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.020000251747433327)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00072071284436102596)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00090740152120223465)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0005416753183783425)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0085508463287925583)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0051044463771850934)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0064266683239972821)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00114244879513716)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00068198730151671568)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.010765800869265733)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.006426668323997283)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0080913898775143087)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00040711380799715558)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0064266683239972821)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0038364136814548937)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0048301728458850918)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.10145090865343141)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.060561341325294053)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.076248749657487444)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.036152224872110263)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.045516857511929326)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.057307242502786078)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.010602832052866737)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0055309670312750914)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0052003949426853487)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.010780936812590689)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.063998122143175837)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0088423219489586306)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.011167925629143633)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.020954485874738926)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.026465688672824863)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0036566407264651056)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0028852287906211633)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0027127858702454444)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0056238753739928293)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0333846185502596)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0046125969868953268)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0058257480788658431)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.010930906945674442)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.013805825724628665)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0019074865283589999)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0025506494326292106)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0052877503857517326)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.031389303261174069)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.004336913582680707)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0054775576631322688)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.010277593932094844)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.012980685994326498)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0017934808215683258)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.010962033348971875)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.065073152862351727)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0089908539277986903)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.011355522744789336)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.021306476140476493)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.026910255284697957)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0037180644210720384)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.3862892119229091)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.05337177815296397)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.067408996477181224)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.12648014603762484)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.15974546874283108)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.02207128611291664)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0073741295777570923)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.009313586542023437)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.017475171676349516)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.022071286112916647)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0030494866271447126)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.011763136701232706)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.022071286112916647)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.027876216594627978)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0038515267885072964)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.041412565632020393)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.052304412320668951)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0072266566205763131)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.066060904618168603)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0091273269794773342)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0012610801845935181)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0069681379285338333)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0044341865869643995)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0042633692251674987)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0070958595609978423)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0020935800564522147)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.015938151369117328)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0084750763491579645)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.014288874398795993)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0075980770083520213)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.057843167305739338)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0028217022811074114)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.002713002358363512)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0045154624680312757)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0013322532791783996)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.010142270108137568)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0053931294495547805)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0090927498639929594)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0048350494066994043)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.036808599262129503)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0026084898629338414)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0043415141302798731)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0012809311288964204)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0097515612851041059)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0051853709066214775)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.008742471518058556)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0046487896795516861)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.035390628300808115)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0072259222515130232)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0021319540762042076)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.016230287766559517)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0086304192252137108)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.014550780575597435)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0077373450321837718)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.058903396570852681)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0006290170340667614)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0047886244769155305)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0025463403571347391)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0042930984973720693)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0022828455256225003)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.017379004651649481)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.03645517233875218)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.019384956368986152)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.032682797814571146)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.017379004651649481)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.13230409122829059)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.010307907199989913)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.017379004651649481)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0092412468600652879)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.070352404648282713)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.02930078791186147)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.015580628448835175)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.11861328821804179)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0082849643358013647)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.063072350763365564)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.48016156371688662)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0094094610911181365)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0068580279611794945)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.041201510190226373)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00083913709311830018)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0026455132646613986)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00029119630051498147)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.025604650302191737)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00044992567302397189)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.039561592985156692)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0043546141588640059)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0049984315850686882)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.030029467808109854)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00061159991971275918)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0019281661048415227)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00021223663627333838)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.018661792211926504)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00032792556514883638)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.02883422421897347)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0031738338011543547)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.18041037903410936)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0036743566032432728)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.011583994096666503)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0012750706152926475)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.1121159065463094)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0019701040285335608)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.17322962077585116)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.01906768920170104)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*7.4834366626129028e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0002359272533481587)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-2.5968927951845934e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0022834263957128066)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-4.012443621633234e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0035281085510869368)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00038834511684948268)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00074379822241953109)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*8.1871179249561797e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0071988652012604706)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00012649867240751639)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.011122923831648516)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0012243197998481877)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*9.0117047737890255e-6)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00079239176099213078)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*1.3923931479451492e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0012243197998481881)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00013476303488074395)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.069674353371455625)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0012243197998481872)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.10765342924248253)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.011849602401133497)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*2.1513783763573511e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0018916892452585615)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00020822156414845061)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.16633467361914708)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.018308750234696657)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0020152763573759057))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t k_dof_0 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_1 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_2 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_3 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_4 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_7 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_8 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 11; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_105 = tmp_qloop_104*_data_q_p_1[q];
                const real_t tmp_qloop_106 = tmp_qloop_104*_data_q_p_2[q];
                const real_t tmp_qloop_107 = 4.0*_data_q_p_1[q]*_data_q_p_2[q];
                const real_t tmp_qloop_108 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_109 = tmp_qloop_108*2.0;
                const real_t tmp_qloop_110 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_111 = tmp_qloop_110*2.0;
                const real_t tmp_qloop_112 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const real_t tmp_qloop_113 = tmp_qloop_112*2.0;
                const real_t tmp_qloop_114 = tmp_qloop_105 + tmp_qloop_106;
                const real_t tmp_qloop_115 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_117 = tmp_qloop_115*tmp_qloop_116;
                const real_t tmp_qloop_118 = tmp_qloop_117*tmp_qloop_25*tmp_qloop_43*1.0;
                const real_t tmp_qloop_119 = (k_dof_0*(tmp_qloop_107 + tmp_qloop_109 + tmp_qloop_111 + tmp_qloop_113 + tmp_qloop_114 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0) + k_dof_1*(tmp_qloop_109 - _data_q_p_0[q]) + k_dof_2*(tmp_qloop_111 - _data_q_p_1[q]) + k_dof_3*(tmp_qloop_113 - _data_q_p_2[q]) + k_dof_4*tmp_qloop_107 + k_dof_5*tmp_qloop_106 + k_dof_6*tmp_qloop_105 + k_dof_7*(-tmp_qloop_106 - tmp_qloop_107 + tmp_qloop_112*-4.0 + 4.0*_data_q_p_2[q]) + k_dof_8*(-tmp_qloop_105 - tmp_qloop_107 + tmp_qloop_110*-4.0 + 4.0*_data_q_p_1[q]) + k_dof_9*(tmp_qloop_108*-4.0 - tmp_qloop_114 + 4.0*_data_q_p_0[q]))*abs(tmp_qloop_115*tmp_qloop_116*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*-2.0 - tmp_qloop_115*tmp_qloop_116*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59 + tmp_qloop_117*tmp_qloop_50*tmp_qloop_52*tmp_qloop_56*tmp_qloop_86*1.0 + tmp_qloop_118*tmp_qloop_18*tmp_qloop_52*tmp_qloop_59 + tmp_qloop_118*tmp_qloop_22*tmp_qloop_36*tmp_qloop_50)*_data_q_w[q];
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_DOWN[55*q];
                const real_t q_tmp_1_1 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_DOWN[55*q + 10];
                const real_t q_tmp_2_2 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_DOWN[55*q + 19];
                const real_t q_tmp_3_3 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_DOWN[55*q + 27];
                const real_t q_tmp_4_4 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_DOWN[55*q + 34];
                const real_t q_tmp_5_5 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_DOWN[55*q + 40];
                const real_t q_tmp_6_6 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_DOWN[55*q + 45];
                const real_t q_tmp_7_7 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_DOWN[55*q + 49];
                const real_t q_tmp_8_8 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_DOWN[55*q + 52];
                const real_t q_tmp_9_9 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_WHITE_DOWN[55*q + 54];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t abs_det_jac_affine_BLUE_UP = abs(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       {
          /* CellType.BLUE_UP */
          const real_t _data_phi_psi_jac_affine_det_0_0_BLUE_UP [] = {((real_t)(abs_det_jac_affine_BLUE_UP*0.0081966519410136655)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0010483393829444135)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.010647302229434073)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.006225865982166446)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0092658338660815045)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.014552261081115014)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.054943945083223346)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0035394853240292199)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.013363784925403197)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.02098821218651729)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00013408102109754342)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0013617738473651977)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00079627884031291754)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0011850861336478869)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0018612121768751683)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0070272474541544115)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00045269481823022469)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0017092078745466989)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0026843605866225069)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.013830652512846866)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0080872870080513325)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.012036150161049137)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.018903123246819378)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.07137118828375684)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0045977272492218257)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.017359314272935491)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.027263307020171587)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0047289317036809308)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0070379760270885047)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.011053345668513806)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.041733337109024285)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0026884588282915065)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.010150624249852821)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.015941850064987575)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.01047448127011787)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.016450476917137476)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.062110904641547282)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0040011803868095627)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.015106974388071553)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.02372594184379705)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.025835951568628612)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.097546978867890252)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0062839699548933566)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.023725941843797053)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.037262280448408056)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.3683012433653402)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.02372594184379705)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.089580364071742774)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.14068856236299254)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0015284236111493253)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0057707611543522386)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0090631479226385408)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.021788255597241783)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.034219087945639513)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.053742071025623714)), ((real_t)(abs_det_jac_affine_BLUE_UP*2.8698018728458151e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00014454340268069696)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00047286322640212926)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0032065374623290576)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0020887954478770055)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00052219560963689146)), ((real_t)(abs_det_jac_affine_BLUE_UP*-7.0208740498716208e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*-9.881379856501532e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*-1.3285428320562817e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*-3.3213363942336231e-6)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00072802221840478313)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0023816717242211073)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.016150377488204762)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.01052064271045634)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00263014429658129)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00035362058773580443)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00049769577515219844)), ((real_t)(abs_det_jac_affine_BLUE_UP*-6.691475929731612e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*-1.6728585635554696e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0077914657802387113)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.052834785019937068)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.034417517255215337)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0086043257244467573)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0011568440270383941)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0016281755212658067)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00021890676702241725)), ((real_t)(abs_det_jac_affine_BLUE_UP*-5.4726350909608775e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.35827847889456316)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.23338896382133173)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.058346877560018065)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0078446863779075976)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.011040836996163679)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0014844308248613668)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00037110539490121838)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.15203371578906599)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.038008192225104848)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0051101680203961414)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0071921972935839896)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00096698460132961257)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00024174464470133657)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0095019888761043864)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0012775340483769759)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0017980381248767646)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00024174464470134023)), ((real_t)(abs_det_jac_affine_BLUE_UP*6.0435784769912737e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00017176332934538114)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00024174464470134207)), ((real_t)(abs_det_jac_affine_BLUE_UP*3.2502354890713518e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*8.1255381153003586e-6)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00034023835858622775)), ((real_t)(abs_det_jac_affine_BLUE_UP*4.5744748107514238e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*1.1436115800600717e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*6.150341155286279e-6)), ((real_t)(abs_det_jac_affine_BLUE_UP*1.53757571251115e-6)), ((real_t)(abs_det_jac_affine_BLUE_UP*3.8439153406509323e-7)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0022455683985789271)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0043245643162645366)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0052785529053041248)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0038024608195830192)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0063277537331678678)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0022859694750058082)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0075700068116924318)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0085069574365176301)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.028170859867257168)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0101770278137826)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0083283397367649708)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.010165551648410579)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0073228615012435371)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.012186125354224276)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0044023695853291234)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.014578483270623889)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.01638288310132377)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.05425205280655232)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.01959914084869013)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.012408048132369226)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0089382673087210242)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.014874355585605769)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0053735218314278996)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.017794461960864042)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.019996908096963657)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.066219926452175323)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.023922664643748495)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0064387743849681585)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.010714897689853333)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0038708726792615806)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.012818426872970318)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.014404981993284736)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.047702216938480875)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.017232941800483223)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.017830882966183025)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0064415993244871881)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.021331409407572027)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.023971628613445938)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.079382246296480372)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.028677695046817175)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0023270974261863082)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0077062023619792735)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.008660010105842008)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.028677695046817168)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.010360127504160913)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.025519152819096672)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.028677695046817164)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.094966424189672397)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.034307647864064747)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.03222717458640751)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.10672055502407191)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.038553954756796821)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.35340600008570494)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.12767173985378449)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.046122796877640655)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00015290096248775118)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0014570800801489527)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0012345554413094673)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0015097104585850083)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0061335058519928322)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0019926658054762107)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0055047118378142874)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00013295486007563399)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00036728596944954594)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00011932460974427863)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.013885343332204057)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.011764779711675321)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.014386888088902506)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.058449659524751035)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.018989243784426475)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.052457524369618494)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0012670023459840343)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0035000765272880604)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0011371119520837828)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0099680676489457051)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.012189728770328983)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.04952325283425088)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.016089214697121625)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.044446233965065328)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0010735062963914434)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0029655463557783954)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00096345270719750374)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.014906548864553707)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.060560887138220144)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.019675143688079481)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.054352313404898829)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0013127670323983137)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0036265008430796091)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0011781849398884157)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.24604092364326371)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.079934273663800182)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.22081732986784111)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0053333831197440425)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.014733397398686206)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0047866159914586818)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.025969208746035512)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.071739581424095769)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0017327203114618317)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0047866159914586584)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0015550854992705844)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.19817960544100707)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0047866159914586211)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.01322296073874602)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0042959022697749219)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00011561074914193237)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00031937310191765402)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00010375858028624978)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00088226379454805234)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0002866316487224664)), ((real_t)(abs_det_jac_affine_BLUE_UP*9.3121470649767956e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0015313812260033845)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.020478525470679236)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0009897290528383181)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0033824754838425301)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00046483308651242364)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.014254039308965735)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0034268445398502956)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00074451353959082409)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00017899011660411598)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0054887060151714157)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.27385082063970095)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.013235235794627626)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.045232440605657676)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0062160199172626362)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.19061335093582549)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.045825769574392869)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0099560705230576918)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0023935605319149542)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.07339818722089371)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00063966018480500107)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0021860880883392128)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00030042082443606778)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0092123610926072748)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0022147637329352362)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0004811778202920854)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0001156810045506071)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0035473412586367816)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.007471124893345448)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0010267113717402016)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.031483955588337449)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0075691261236329422)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0016444623665833173)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00039534876814677629)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.012123312744788284)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00014109471544232499)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0043266490242589092)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0010401790863102422)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00022598848717865071)), ((real_t)(abs_det_jac_affine_BLUE_UP*5.4330382888033369e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0016660333264303686)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.13267606600597784)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.031896941106050063)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0069299042453857072)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0016660333264303651)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.051088670781077684)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0076684128686554951)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.001666033326430367)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00040053468944030722)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.012282338270543791)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00036196108534037404)), ((real_t)(abs_det_jac_affine_BLUE_UP*8.7019850447357002e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.002668451117030794)), ((real_t)(abs_det_jac_affine_BLUE_UP*2.0920631190945677e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00064152812701327526)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.019672367147664311)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0056280121552861676)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0082361505285512976)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.006546963131509812)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0028727623124179887)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.015489393471375653)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.046367923183087689)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.011399254367437734)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.012638819023050307)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0031071720072274201)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0093014044232272736)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.01205295469471257)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0095809625793618486)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0042040603653636923)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.022667501900539677)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.067855787175853305)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.016681906913665712)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.018495911718880619)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.004547100408372284)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.013611869491908979)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0076159619174044459)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0033418316140852618)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.018018526824128522)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.053938953077637526)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.013260543156471259)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.01470250594466384)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0036145161050283661)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.010820152862131633)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0014663726864729064)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0079064054197158472)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.023668040961914667)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0058186349696638454)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0064513583057541025)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0015860247622562602)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0047478085232114465)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.042629849312913477)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.1276136203719424)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.031372984155995043)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.034784509247666975)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0085515468828518213)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.025599289584411971)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.38201486439458487)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.093915886510190727)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.10412838021952459)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.025599289584412016)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.07663217382818617)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.023088613980959145)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.025599289584412002)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0062934199672080244)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.018839524874726728)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.02838297819726298)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.006977771829428203)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.020888150899772109)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0017154401263027783)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0051352169565958509)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.015372412471279177)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.011820472404298839)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.007781569024383839)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0072610786275946687)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00066208934951621885)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.017050403495896919)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.018589307722076551)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0029885333557655271)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.07306575166941863)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.011746507147698459)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.012806701969292705)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0051227069790568064)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.004780061456051238)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00043586193490000903)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.011224499931886399)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.012237580378111014)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0019673899480620945)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.048100124131019932)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0077328767445869005)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0084308166323810284)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0044603346662302444)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00040670818059537962)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.010473720184896984)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.011419038121814993)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0018357959762683471)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.044882822759521109)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0072156432570344995)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0078668996279190398)), ((real_t)(abs_det_jac_affine_BLUE_UP*3.7085007413357473e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0009550287140370076)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0010412259541497195)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00016739399559079557)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0040925653679565032)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00065794640099822775)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00071733012745018546)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.024594301262203948)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.026814088856171956)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0043108006037235582)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.10539346525960519)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.016943712542559438)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.018472987251230831)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.029234225990864938)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0046998769835807442)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.11490587645496211)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.018472987251230838)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.020140288447822608)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00075558161408803245)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.018472987251230834)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0029698329494740154)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0032378787161382984)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.45164050000874939)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.072608551069807847)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.079161921265709395)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.011673004720247106)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.012726565493781048)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.013875216634373964)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.14209718214348346)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.025252677134971455)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.020839612993267732)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.03149368209432183)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.010119845073829774)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.012741222646677527)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0076059006651480118)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.1200661827724549)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.07167376983628268)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.090239667974007801)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0044877575534129259)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0037034936977522613)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0055968723216219887)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0017984394655152865)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0022642953009190934)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0013516760214407645)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.021337457243309044)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.012737441667874105)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.016036864107647247)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0030562848830502985)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0046187836850695154)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0014841508586531178)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0018685954570844729)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0011154621360955055)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.017608602400224702)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.010511493631509539)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.013234321250089203)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0069800962756367633)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0022429099493131632)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0028238984719785166)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0016857323556725265)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.026610845714704033)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.01588540242442097)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.020000251747433327)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00072071284436102596)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00090740152120223465)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0005416753183783425)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0085508463287925583)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0051044463771850934)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0064266683239972821)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00114244879513716)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00068198730151671568)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.010765800869265733)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.006426668323997283)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0080913898775143087)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00040711380799715558)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0064266683239972821)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0038364136814548937)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0048301728458850918)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.10145090865343141)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.060561341325294053)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.076248749657487444)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.036152224872110263)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.045516857511929326)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.057307242502786078)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.010602832052866737)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0055309670312750914)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0052003949426853487)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.010780936812590689)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.063998122143175837)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0088423219489586306)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.011167925629143633)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.020954485874738926)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.026465688672824863)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0036566407264651056)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0028852287906211633)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0027127858702454444)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0056238753739928293)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0333846185502596)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0046125969868953268)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0058257480788658431)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.010930906945674442)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.013805825724628665)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0019074865283589999)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0025506494326292106)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0052877503857517326)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.031389303261174069)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.004336913582680707)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0054775576631322688)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.010277593932094844)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.012980685994326498)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0017934808215683258)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.010962033348971875)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.065073152862351727)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0089908539277986903)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.011355522744789336)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.021306476140476493)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.026910255284697957)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0037180644210720384)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.3862892119229091)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.05337177815296397)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.067408996477181224)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.12648014603762484)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.15974546874283108)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.02207128611291664)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0073741295777570923)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.009313586542023437)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.017475171676349516)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.022071286112916647)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0030494866271447126)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.011763136701232706)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.022071286112916647)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.027876216594627978)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0038515267885072964)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.041412565632020393)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.052304412320668951)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0072266566205763131)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.066060904618168603)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0091273269794773342)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0012610801845935181)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0069681379285338333)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0044341865869643995)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0042633692251674987)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0070958595609978423)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0020935800564522147)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.015938151369117328)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0084750763491579645)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.014288874398795993)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0075980770083520213)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.057843167305739338)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0028217022811074114)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.002713002358363512)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0045154624680312757)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0013322532791783996)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.010142270108137568)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0053931294495547805)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0090927498639929594)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0048350494066994043)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.036808599262129503)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0026084898629338414)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0043415141302798731)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0012809311288964204)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0097515612851041059)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0051853709066214775)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.008742471518058556)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0046487896795516861)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.035390628300808115)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0072259222515130232)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0021319540762042076)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.016230287766559517)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0086304192252137108)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.014550780575597435)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0077373450321837718)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.058903396570852681)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0006290170340667614)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0047886244769155305)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0025463403571347391)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0042930984973720693)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0022828455256225003)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.017379004651649481)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.03645517233875218)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.019384956368986152)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.032682797814571146)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.017379004651649481)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.13230409122829059)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.010307907199989913)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.017379004651649481)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0092412468600652879)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.070352404648282713)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.02930078791186147)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.015580628448835175)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.11861328821804179)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0082849643358013647)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.063072350763365564)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.48016156371688662)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0094094610911181365)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0068580279611794945)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.041201510190226373)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00083913709311830018)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0026455132646613986)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00029119630051498147)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.025604650302191737)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00044992567302397189)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.039561592985156692)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0043546141588640059)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0049984315850686882)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.030029467808109854)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00061159991971275918)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0019281661048415227)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00021223663627333838)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.018661792211926504)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00032792556514883638)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.02883422421897347)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0031738338011543547)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.18041037903410936)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0036743566032432728)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.011583994096666503)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0012750706152926475)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.1121159065463094)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0019701040285335608)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.17322962077585116)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.01906768920170104)), ((real_t)(abs_det_jac_affine_BLUE_UP*7.4834366626129028e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0002359272533481587)), ((real_t)(abs_det_jac_affine_BLUE_UP*-2.5968927951845934e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0022834263957128066)), ((real_t)(abs_det_jac_affine_BLUE_UP*-4.012443621633234e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0035281085510869368)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00038834511684948268)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00074379822241953109)), ((real_t)(abs_det_jac_affine_BLUE_UP*8.1871179249561797e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0071988652012604706)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00012649867240751639)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.011122923831648516)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0012243197998481877)), ((real_t)(abs_det_jac_affine_BLUE_UP*9.0117047737890255e-6)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00079239176099213078)), ((real_t)(abs_det_jac_affine_BLUE_UP*1.3923931479451492e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0012243197998481881)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00013476303488074395)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.069674353371455625)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0012243197998481872)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.10765342924248253)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.011849602401133497)), ((real_t)(abs_det_jac_affine_BLUE_UP*2.1513783763573511e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0018916892452585615)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00020822156414845061)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.16633467361914708)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.018308750234696657)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0020152763573759057))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t k_dof_0 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_1 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_2 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_3 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_6 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_7 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 11; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_105 = tmp_qloop_104*_data_q_p_1[q];
                const real_t tmp_qloop_106 = tmp_qloop_104*_data_q_p_2[q];
                const real_t tmp_qloop_107 = 4.0*_data_q_p_1[q]*_data_q_p_2[q];
                const real_t tmp_qloop_108 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_109 = tmp_qloop_108*2.0;
                const real_t tmp_qloop_110 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_111 = tmp_qloop_110*2.0;
                const real_t tmp_qloop_112 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const real_t tmp_qloop_113 = tmp_qloop_112*2.0;
                const real_t tmp_qloop_114 = tmp_qloop_105 + tmp_qloop_106;
                const real_t tmp_qloop_115 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_117 = tmp_qloop_115*tmp_qloop_116;
                const real_t tmp_qloop_118 = tmp_qloop_117*tmp_qloop_25*tmp_qloop_43*1.0;
                const real_t tmp_qloop_119 = (k_dof_0*(tmp_qloop_107 + tmp_qloop_109 + tmp_qloop_111 + tmp_qloop_113 + tmp_qloop_114 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0) + k_dof_1*(tmp_qloop_109 - _data_q_p_0[q]) + k_dof_2*(tmp_qloop_111 - _data_q_p_1[q]) + k_dof_3*(tmp_qloop_113 - _data_q_p_2[q]) + k_dof_4*tmp_qloop_107 + k_dof_5*tmp_qloop_106 + k_dof_6*tmp_qloop_105 + k_dof_7*(-tmp_qloop_106 - tmp_qloop_107 + tmp_qloop_112*-4.0 + 4.0*_data_q_p_2[q]) + k_dof_8*(-tmp_qloop_105 - tmp_qloop_107 + tmp_qloop_110*-4.0 + 4.0*_data_q_p_1[q]) + k_dof_9*(tmp_qloop_108*-4.0 - tmp_qloop_114 + 4.0*_data_q_p_0[q]))*abs(tmp_qloop_115*tmp_qloop_116*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*-2.0 - tmp_qloop_115*tmp_qloop_116*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59 + tmp_qloop_117*tmp_qloop_50*tmp_qloop_52*tmp_qloop_56*tmp_qloop_86*1.0 + tmp_qloop_118*tmp_qloop_18*tmp_qloop_52*tmp_qloop_59 + tmp_qloop_118*tmp_qloop_22*tmp_qloop_36*tmp_qloop_50)*_data_q_w[q];
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_UP[55*q];
                const real_t q_tmp_1_1 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_UP[55*q + 10];
                const real_t q_tmp_2_2 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_UP[55*q + 19];
                const real_t q_tmp_3_3 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_UP[55*q + 27];
                const real_t q_tmp_4_4 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_UP[55*q + 34];
                const real_t q_tmp_5_5 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_UP[55*q + 40];
                const real_t q_tmp_6_6 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_UP[55*q + 45];
                const real_t q_tmp_7_7 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_UP[55*q + 49];
                const real_t q_tmp_8_8 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_UP[55*q + 52];
                const real_t q_tmp_9_9 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_UP[55*q + 54];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       {
          /* CellType.BLUE_DOWN */
          const real_t _data_phi_psi_jac_affine_det_0_0_BLUE_DOWN [] = {((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0081966519410136655)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0010483393829444135)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.010647302229434073)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.006225865982166446)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0092658338660815045)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.014552261081115014)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.054943945083223346)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0035394853240292199)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.013363784925403197)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.02098821218651729)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00013408102109754342)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0013617738473651977)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00079627884031291754)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0011850861336478869)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0018612121768751683)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0070272474541544115)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00045269481823022469)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0017092078745466989)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0026843605866225069)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.013830652512846866)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0080872870080513325)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.012036150161049137)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.018903123246819378)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.07137118828375684)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0045977272492218257)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.017359314272935491)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.027263307020171587)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0047289317036809308)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0070379760270885047)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.011053345668513806)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.041733337109024285)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0026884588282915065)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.010150624249852821)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.015941850064987575)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.01047448127011787)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.016450476917137476)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.062110904641547282)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0040011803868095627)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.015106974388071553)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.02372594184379705)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.025835951568628612)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.097546978867890252)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0062839699548933566)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.023725941843797053)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.037262280448408056)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.3683012433653402)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.02372594184379705)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.089580364071742774)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.14068856236299254)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0015284236111493253)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0057707611543522386)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0090631479226385408)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.021788255597241783)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.034219087945639513)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.053742071025623714)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*2.8698018728458151e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00014454340268069696)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00047286322640212926)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0032065374623290576)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0020887954478770055)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00052219560963689146)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-7.0208740498716208e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-9.881379856501532e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-1.3285428320562817e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-3.3213363942336231e-6)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00072802221840478313)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0023816717242211073)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.016150377488204762)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.01052064271045634)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00263014429658129)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00035362058773580443)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00049769577515219844)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-6.691475929731612e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-1.6728585635554696e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0077914657802387113)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.052834785019937068)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.034417517255215337)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0086043257244467573)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0011568440270383941)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0016281755212658067)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00021890676702241725)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-5.4726350909608775e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.35827847889456316)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.23338896382133173)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.058346877560018065)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0078446863779075976)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.011040836996163679)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0014844308248613668)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00037110539490121838)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.15203371578906599)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.038008192225104848)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0051101680203961414)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0071921972935839896)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00096698460132961257)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00024174464470133657)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0095019888761043864)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0012775340483769759)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0017980381248767646)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00024174464470134023)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*6.0435784769912737e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00017176332934538114)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00024174464470134207)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*3.2502354890713518e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*8.1255381153003586e-6)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00034023835858622775)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*4.5744748107514238e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*1.1436115800600717e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*6.150341155286279e-6)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*1.53757571251115e-6)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*3.8439153406509323e-7)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0022455683985789271)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0043245643162645366)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0052785529053041248)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0038024608195830192)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0063277537331678678)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0022859694750058082)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0075700068116924318)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0085069574365176301)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.028170859867257168)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0101770278137826)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0083283397367649708)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.010165551648410579)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0073228615012435371)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.012186125354224276)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0044023695853291234)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.014578483270623889)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.01638288310132377)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.05425205280655232)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.01959914084869013)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.012408048132369226)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0089382673087210242)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.014874355585605769)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0053735218314278996)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.017794461960864042)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.019996908096963657)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.066219926452175323)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.023922664643748495)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0064387743849681585)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.010714897689853333)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0038708726792615806)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.012818426872970318)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.014404981993284736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.047702216938480875)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.017232941800483223)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.017830882966183025)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0064415993244871881)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.021331409407572027)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.023971628613445938)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.079382246296480372)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.028677695046817175)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0023270974261863082)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0077062023619792735)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.008660010105842008)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.028677695046817168)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.010360127504160913)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.025519152819096672)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.028677695046817164)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.094966424189672397)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.034307647864064747)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.03222717458640751)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.10672055502407191)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.038553954756796821)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.35340600008570494)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.12767173985378449)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.046122796877640655)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00015290096248775118)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0014570800801489527)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0012345554413094673)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0015097104585850083)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0061335058519928322)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0019926658054762107)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0055047118378142874)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00013295486007563399)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00036728596944954594)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00011932460974427863)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.013885343332204057)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.011764779711675321)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.014386888088902506)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.058449659524751035)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.018989243784426475)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.052457524369618494)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0012670023459840343)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0035000765272880604)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0011371119520837828)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0099680676489457051)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.012189728770328983)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.04952325283425088)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.016089214697121625)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.044446233965065328)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0010735062963914434)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0029655463557783954)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00096345270719750374)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.014906548864553707)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.060560887138220144)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.019675143688079481)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.054352313404898829)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0013127670323983137)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0036265008430796091)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0011781849398884157)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.24604092364326371)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.079934273663800182)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.22081732986784111)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0053333831197440425)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.014733397398686206)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0047866159914586818)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.025969208746035512)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.071739581424095769)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0017327203114618317)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0047866159914586584)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0015550854992705844)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.19817960544100707)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0047866159914586211)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.01322296073874602)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0042959022697749219)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00011561074914193237)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00031937310191765402)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00010375858028624978)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00088226379454805234)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0002866316487224664)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*9.3121470649767956e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0015313812260033845)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.020478525470679236)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0009897290528383181)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0033824754838425301)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00046483308651242364)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.014254039308965735)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0034268445398502956)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00074451353959082409)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00017899011660411598)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0054887060151714157)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.27385082063970095)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.013235235794627626)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.045232440605657676)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0062160199172626362)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.19061335093582549)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.045825769574392869)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0099560705230576918)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0023935605319149542)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.07339818722089371)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00063966018480500107)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0021860880883392128)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00030042082443606778)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0092123610926072748)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0022147637329352362)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0004811778202920854)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0001156810045506071)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0035473412586367816)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.007471124893345448)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0010267113717402016)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.031483955588337449)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0075691261236329422)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0016444623665833173)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00039534876814677629)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.012123312744788284)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00014109471544232499)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0043266490242589092)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0010401790863102422)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00022598848717865071)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*5.4330382888033369e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0016660333264303686)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.13267606600597784)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.031896941106050063)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0069299042453857072)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0016660333264303651)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.051088670781077684)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0076684128686554951)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.001666033326430367)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00040053468944030722)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.012282338270543791)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00036196108534037404)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*8.7019850447357002e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.002668451117030794)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*2.0920631190945677e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00064152812701327526)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.019672367147664311)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0056280121552861676)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0082361505285512976)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.006546963131509812)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0028727623124179887)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.015489393471375653)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.046367923183087689)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.011399254367437734)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.012638819023050307)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0031071720072274201)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0093014044232272736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.01205295469471257)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0095809625793618486)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0042040603653636923)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.022667501900539677)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.067855787175853305)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.016681906913665712)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.018495911718880619)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.004547100408372284)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.013611869491908979)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0076159619174044459)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0033418316140852618)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.018018526824128522)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.053938953077637526)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.013260543156471259)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.01470250594466384)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0036145161050283661)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.010820152862131633)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0014663726864729064)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0079064054197158472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.023668040961914667)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0058186349696638454)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0064513583057541025)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0015860247622562602)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0047478085232114465)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.042629849312913477)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.1276136203719424)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.031372984155995043)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.034784509247666975)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0085515468828518213)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.025599289584411971)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.38201486439458487)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.093915886510190727)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.10412838021952459)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.025599289584412016)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.07663217382818617)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.023088613980959145)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.025599289584412002)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0062934199672080244)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.018839524874726728)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.02838297819726298)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.006977771829428203)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.020888150899772109)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0017154401263027783)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0051352169565958509)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.015372412471279177)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.011820472404298839)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.007781569024383839)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0072610786275946687)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00066208934951621885)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.017050403495896919)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.018589307722076551)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0029885333557655271)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.07306575166941863)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.011746507147698459)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.012806701969292705)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0051227069790568064)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.004780061456051238)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00043586193490000903)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.011224499931886399)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.012237580378111014)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0019673899480620945)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.048100124131019932)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0077328767445869005)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0084308166323810284)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0044603346662302444)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00040670818059537962)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.010473720184896984)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.011419038121814993)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0018357959762683471)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.044882822759521109)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0072156432570344995)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0078668996279190398)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*3.7085007413357473e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0009550287140370076)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0010412259541497195)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00016739399559079557)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0040925653679565032)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00065794640099822775)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00071733012745018546)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.024594301262203948)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.026814088856171956)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0043108006037235582)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.10539346525960519)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.016943712542559438)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.018472987251230831)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.029234225990864938)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0046998769835807442)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.11490587645496211)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.018472987251230838)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.020140288447822608)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00075558161408803245)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.018472987251230834)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0029698329494740154)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0032378787161382984)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.45164050000874939)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.072608551069807847)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.079161921265709395)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.011673004720247106)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.012726565493781048)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.013875216634373964)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.14209718214348346)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.025252677134971455)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.020839612993267732)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.03149368209432183)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.010119845073829774)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.012741222646677527)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0076059006651480118)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.1200661827724549)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.07167376983628268)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.090239667974007801)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0044877575534129259)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0037034936977522613)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0055968723216219887)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0017984394655152865)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0022642953009190934)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0013516760214407645)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.021337457243309044)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.012737441667874105)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.016036864107647247)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0030562848830502985)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0046187836850695154)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0014841508586531178)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0018685954570844729)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0011154621360955055)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.017608602400224702)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.010511493631509539)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.013234321250089203)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0069800962756367633)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0022429099493131632)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0028238984719785166)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0016857323556725265)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.026610845714704033)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.01588540242442097)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.020000251747433327)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00072071284436102596)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00090740152120223465)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0005416753183783425)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0085508463287925583)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0051044463771850934)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0064266683239972821)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00114244879513716)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00068198730151671568)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.010765800869265733)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.006426668323997283)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0080913898775143087)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00040711380799715558)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0064266683239972821)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0038364136814548937)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0048301728458850918)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.10145090865343141)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.060561341325294053)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.076248749657487444)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.036152224872110263)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.045516857511929326)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.057307242502786078)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.010602832052866737)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0055309670312750914)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0052003949426853487)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.010780936812590689)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.063998122143175837)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0088423219489586306)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.011167925629143633)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.020954485874738926)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.026465688672824863)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0036566407264651056)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0028852287906211633)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0027127858702454444)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0056238753739928293)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0333846185502596)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0046125969868953268)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0058257480788658431)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.010930906945674442)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.013805825724628665)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0019074865283589999)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0025506494326292106)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0052877503857517326)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.031389303261174069)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.004336913582680707)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0054775576631322688)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.010277593932094844)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.012980685994326498)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0017934808215683258)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.010962033348971875)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.065073152862351727)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0089908539277986903)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.011355522744789336)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.021306476140476493)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.026910255284697957)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0037180644210720384)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.3862892119229091)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.05337177815296397)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.067408996477181224)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.12648014603762484)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.15974546874283108)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.02207128611291664)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0073741295777570923)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.009313586542023437)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.017475171676349516)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.022071286112916647)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0030494866271447126)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.011763136701232706)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.022071286112916647)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.027876216594627978)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0038515267885072964)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.041412565632020393)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.052304412320668951)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0072266566205763131)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.066060904618168603)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0091273269794773342)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0012610801845935181)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0069681379285338333)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0044341865869643995)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0042633692251674987)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0070958595609978423)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0020935800564522147)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.015938151369117328)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0084750763491579645)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.014288874398795993)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0075980770083520213)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.057843167305739338)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0028217022811074114)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.002713002358363512)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0045154624680312757)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0013322532791783996)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.010142270108137568)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0053931294495547805)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0090927498639929594)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0048350494066994043)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.036808599262129503)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0026084898629338414)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0043415141302798731)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0012809311288964204)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0097515612851041059)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0051853709066214775)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.008742471518058556)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0046487896795516861)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.035390628300808115)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0072259222515130232)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0021319540762042076)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.016230287766559517)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0086304192252137108)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.014550780575597435)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0077373450321837718)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.058903396570852681)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0006290170340667614)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0047886244769155305)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0025463403571347391)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0042930984973720693)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0022828455256225003)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.017379004651649481)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.03645517233875218)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.019384956368986152)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.032682797814571146)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.017379004651649481)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.13230409122829059)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.010307907199989913)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.017379004651649481)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0092412468600652879)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.070352404648282713)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.02930078791186147)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.015580628448835175)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.11861328821804179)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0082849643358013647)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.063072350763365564)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.48016156371688662)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0094094610911181365)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0068580279611794945)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.041201510190226373)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00083913709311830018)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0026455132646613986)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00029119630051498147)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.025604650302191737)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00044992567302397189)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.039561592985156692)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0043546141588640059)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0049984315850686882)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.030029467808109854)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00061159991971275918)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0019281661048415227)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00021223663627333838)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.018661792211926504)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00032792556514883638)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.02883422421897347)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0031738338011543547)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.18041037903410936)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0036743566032432728)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.011583994096666503)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0012750706152926475)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.1121159065463094)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0019701040285335608)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.17322962077585116)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.01906768920170104)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*7.4834366626129028e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0002359272533481587)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-2.5968927951845934e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0022834263957128066)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-4.012443621633234e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0035281085510869368)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00038834511684948268)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00074379822241953109)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*8.1871179249561797e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0071988652012604706)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00012649867240751639)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.011122923831648516)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0012243197998481877)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*9.0117047737890255e-6)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00079239176099213078)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*1.3923931479451492e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0012243197998481881)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00013476303488074395)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.069674353371455625)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0012243197998481872)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.10765342924248253)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.011849602401133497)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*2.1513783763573511e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0018916892452585615)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00020822156414845061)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.16633467361914708)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.018308750234696657)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0020152763573759057))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t k_dof_0 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_1 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_2 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_3 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_7 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 11; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_105 = tmp_qloop_104*_data_q_p_1[q];
                const real_t tmp_qloop_106 = tmp_qloop_104*_data_q_p_2[q];
                const real_t tmp_qloop_107 = 4.0*_data_q_p_1[q]*_data_q_p_2[q];
                const real_t tmp_qloop_108 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_109 = tmp_qloop_108*2.0;
                const real_t tmp_qloop_110 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_111 = tmp_qloop_110*2.0;
                const real_t tmp_qloop_112 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const real_t tmp_qloop_113 = tmp_qloop_112*2.0;
                const real_t tmp_qloop_114 = tmp_qloop_105 + tmp_qloop_106;
                const real_t tmp_qloop_115 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_117 = tmp_qloop_115*tmp_qloop_116;
                const real_t tmp_qloop_118 = tmp_qloop_117*tmp_qloop_25*tmp_qloop_43*1.0;
                const real_t tmp_qloop_119 = (k_dof_0*(tmp_qloop_107 + tmp_qloop_109 + tmp_qloop_111 + tmp_qloop_113 + tmp_qloop_114 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0) + k_dof_1*(tmp_qloop_109 - _data_q_p_0[q]) + k_dof_2*(tmp_qloop_111 - _data_q_p_1[q]) + k_dof_3*(tmp_qloop_113 - _data_q_p_2[q]) + k_dof_4*tmp_qloop_107 + k_dof_5*tmp_qloop_106 + k_dof_6*tmp_qloop_105 + k_dof_7*(-tmp_qloop_106 - tmp_qloop_107 + tmp_qloop_112*-4.0 + 4.0*_data_q_p_2[q]) + k_dof_8*(-tmp_qloop_105 - tmp_qloop_107 + tmp_qloop_110*-4.0 + 4.0*_data_q_p_1[q]) + k_dof_9*(tmp_qloop_108*-4.0 - tmp_qloop_114 + 4.0*_data_q_p_0[q]))*abs(tmp_qloop_115*tmp_qloop_116*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*-2.0 - tmp_qloop_115*tmp_qloop_116*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59 + tmp_qloop_117*tmp_qloop_50*tmp_qloop_52*tmp_qloop_56*tmp_qloop_86*1.0 + tmp_qloop_118*tmp_qloop_18*tmp_qloop_52*tmp_qloop_59 + tmp_qloop_118*tmp_qloop_22*tmp_qloop_36*tmp_qloop_50)*_data_q_w[q];
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_DOWN[55*q];
                const real_t q_tmp_1_1 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_DOWN[55*q + 10];
                const real_t q_tmp_2_2 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_DOWN[55*q + 19];
                const real_t q_tmp_3_3 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_DOWN[55*q + 27];
                const real_t q_tmp_4_4 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_DOWN[55*q + 34];
                const real_t q_tmp_5_5 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_DOWN[55*q + 40];
                const real_t q_tmp_6_6 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_DOWN[55*q + 45];
                const real_t q_tmp_7_7 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_DOWN[55*q + 49];
                const real_t q_tmp_8_8 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_DOWN[55*q + 52];
                const real_t q_tmp_9_9 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_BLUE_DOWN[55*q + 54];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t abs_det_jac_affine_GREEN_UP = abs(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       {
          /* CellType.GREEN_UP */
          const real_t _data_phi_psi_jac_affine_det_0_0_GREEN_UP [] = {((real_t)(abs_det_jac_affine_GREEN_UP*0.0081966519410136655)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0010483393829444135)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.010647302229434073)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.006225865982166446)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0092658338660815045)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.014552261081115014)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.054943945083223346)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0035394853240292199)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.013363784925403197)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.02098821218651729)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00013408102109754342)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0013617738473651977)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00079627884031291754)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0011850861336478869)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0018612121768751683)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0070272474541544115)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00045269481823022469)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0017092078745466989)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0026843605866225069)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.013830652512846866)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0080872870080513325)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.012036150161049137)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.018903123246819378)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.07137118828375684)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0045977272492218257)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.017359314272935491)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.027263307020171587)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0047289317036809308)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0070379760270885047)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.011053345668513806)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.041733337109024285)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0026884588282915065)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.010150624249852821)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.015941850064987575)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.01047448127011787)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.016450476917137476)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.062110904641547282)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0040011803868095627)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.015106974388071553)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.02372594184379705)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.025835951568628612)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.097546978867890252)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0062839699548933566)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.023725941843797053)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.037262280448408056)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.3683012433653402)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.02372594184379705)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.089580364071742774)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.14068856236299254)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0015284236111493253)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0057707611543522386)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0090631479226385408)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.021788255597241783)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.034219087945639513)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.053742071025623714)), ((real_t)(abs_det_jac_affine_GREEN_UP*2.8698018728458151e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00014454340268069696)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00047286322640212926)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0032065374623290576)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0020887954478770055)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00052219560963689146)), ((real_t)(abs_det_jac_affine_GREEN_UP*-7.0208740498716208e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*-9.881379856501532e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*-1.3285428320562817e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*-3.3213363942336231e-6)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00072802221840478313)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0023816717242211073)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.016150377488204762)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.01052064271045634)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00263014429658129)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00035362058773580443)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00049769577515219844)), ((real_t)(abs_det_jac_affine_GREEN_UP*-6.691475929731612e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*-1.6728585635554696e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0077914657802387113)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.052834785019937068)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.034417517255215337)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0086043257244467573)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0011568440270383941)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0016281755212658067)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00021890676702241725)), ((real_t)(abs_det_jac_affine_GREEN_UP*-5.4726350909608775e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.35827847889456316)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.23338896382133173)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.058346877560018065)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0078446863779075976)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.011040836996163679)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0014844308248613668)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00037110539490121838)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.15203371578906599)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.038008192225104848)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0051101680203961414)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0071921972935839896)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00096698460132961257)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00024174464470133657)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0095019888761043864)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0012775340483769759)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0017980381248767646)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00024174464470134023)), ((real_t)(abs_det_jac_affine_GREEN_UP*6.0435784769912737e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00017176332934538114)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00024174464470134207)), ((real_t)(abs_det_jac_affine_GREEN_UP*3.2502354890713518e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*8.1255381153003586e-6)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00034023835858622775)), ((real_t)(abs_det_jac_affine_GREEN_UP*4.5744748107514238e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*1.1436115800600717e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*6.150341155286279e-6)), ((real_t)(abs_det_jac_affine_GREEN_UP*1.53757571251115e-6)), ((real_t)(abs_det_jac_affine_GREEN_UP*3.8439153406509323e-7)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0022455683985789271)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0043245643162645366)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0052785529053041248)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0038024608195830192)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0063277537331678678)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0022859694750058082)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0075700068116924318)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0085069574365176301)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.028170859867257168)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0101770278137826)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0083283397367649708)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.010165551648410579)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0073228615012435371)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.012186125354224276)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0044023695853291234)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.014578483270623889)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.01638288310132377)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.05425205280655232)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.01959914084869013)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.012408048132369226)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0089382673087210242)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.014874355585605769)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0053735218314278996)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.017794461960864042)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.019996908096963657)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.066219926452175323)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.023922664643748495)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0064387743849681585)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.010714897689853333)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0038708726792615806)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.012818426872970318)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.014404981993284736)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.047702216938480875)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.017232941800483223)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.017830882966183025)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0064415993244871881)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.021331409407572027)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.023971628613445938)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.079382246296480372)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.028677695046817175)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0023270974261863082)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0077062023619792735)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.008660010105842008)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.028677695046817168)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.010360127504160913)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.025519152819096672)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.028677695046817164)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.094966424189672397)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.034307647864064747)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.03222717458640751)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.10672055502407191)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.038553954756796821)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.35340600008570494)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.12767173985378449)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.046122796877640655)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00015290096248775118)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0014570800801489527)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0012345554413094673)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0015097104585850083)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0061335058519928322)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0019926658054762107)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0055047118378142874)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00013295486007563399)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00036728596944954594)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00011932460974427863)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.013885343332204057)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.011764779711675321)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.014386888088902506)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.058449659524751035)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.018989243784426475)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.052457524369618494)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0012670023459840343)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0035000765272880604)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0011371119520837828)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0099680676489457051)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.012189728770328983)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.04952325283425088)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.016089214697121625)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.044446233965065328)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0010735062963914434)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0029655463557783954)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00096345270719750374)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.014906548864553707)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.060560887138220144)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.019675143688079481)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.054352313404898829)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0013127670323983137)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0036265008430796091)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0011781849398884157)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.24604092364326371)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.079934273663800182)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.22081732986784111)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0053333831197440425)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.014733397398686206)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0047866159914586818)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.025969208746035512)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.071739581424095769)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0017327203114618317)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0047866159914586584)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0015550854992705844)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.19817960544100707)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0047866159914586211)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.01322296073874602)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0042959022697749219)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00011561074914193237)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00031937310191765402)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00010375858028624978)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00088226379454805234)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0002866316487224664)), ((real_t)(abs_det_jac_affine_GREEN_UP*9.3121470649767956e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0015313812260033845)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.020478525470679236)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0009897290528383181)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0033824754838425301)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00046483308651242364)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.014254039308965735)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0034268445398502956)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00074451353959082409)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00017899011660411598)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0054887060151714157)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.27385082063970095)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.013235235794627626)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.045232440605657676)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0062160199172626362)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.19061335093582549)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.045825769574392869)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0099560705230576918)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0023935605319149542)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.07339818722089371)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00063966018480500107)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0021860880883392128)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00030042082443606778)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0092123610926072748)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0022147637329352362)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0004811778202920854)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0001156810045506071)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0035473412586367816)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.007471124893345448)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0010267113717402016)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.031483955588337449)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0075691261236329422)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0016444623665833173)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00039534876814677629)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.012123312744788284)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00014109471544232499)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0043266490242589092)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0010401790863102422)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00022598848717865071)), ((real_t)(abs_det_jac_affine_GREEN_UP*5.4330382888033369e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0016660333264303686)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.13267606600597784)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.031896941106050063)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0069299042453857072)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0016660333264303651)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.051088670781077684)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0076684128686554951)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.001666033326430367)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00040053468944030722)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.012282338270543791)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00036196108534037404)), ((real_t)(abs_det_jac_affine_GREEN_UP*8.7019850447357002e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.002668451117030794)), ((real_t)(abs_det_jac_affine_GREEN_UP*2.0920631190945677e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00064152812701327526)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.019672367147664311)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0056280121552861676)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0082361505285512976)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.006546963131509812)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0028727623124179887)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.015489393471375653)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.046367923183087689)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.011399254367437734)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.012638819023050307)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0031071720072274201)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0093014044232272736)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.01205295469471257)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0095809625793618486)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0042040603653636923)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.022667501900539677)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.067855787175853305)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.016681906913665712)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.018495911718880619)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.004547100408372284)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.013611869491908979)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0076159619174044459)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0033418316140852618)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.018018526824128522)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.053938953077637526)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.013260543156471259)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.01470250594466384)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0036145161050283661)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.010820152862131633)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0014663726864729064)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0079064054197158472)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.023668040961914667)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0058186349696638454)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0064513583057541025)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0015860247622562602)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0047478085232114465)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.042629849312913477)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.1276136203719424)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.031372984155995043)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.034784509247666975)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0085515468828518213)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.025599289584411971)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.38201486439458487)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.093915886510190727)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.10412838021952459)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.025599289584412016)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.07663217382818617)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.023088613980959145)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.025599289584412002)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0062934199672080244)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.018839524874726728)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.02838297819726298)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.006977771829428203)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.020888150899772109)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0017154401263027783)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0051352169565958509)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.015372412471279177)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.011820472404298839)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.007781569024383839)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0072610786275946687)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00066208934951621885)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.017050403495896919)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.018589307722076551)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0029885333557655271)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.07306575166941863)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.011746507147698459)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.012806701969292705)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0051227069790568064)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.004780061456051238)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00043586193490000903)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.011224499931886399)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.012237580378111014)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0019673899480620945)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.048100124131019932)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0077328767445869005)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0084308166323810284)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0044603346662302444)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00040670818059537962)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.010473720184896984)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.011419038121814993)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0018357959762683471)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.044882822759521109)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0072156432570344995)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0078668996279190398)), ((real_t)(abs_det_jac_affine_GREEN_UP*3.7085007413357473e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0009550287140370076)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0010412259541497195)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00016739399559079557)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0040925653679565032)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00065794640099822775)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00071733012745018546)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.024594301262203948)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.026814088856171956)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0043108006037235582)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.10539346525960519)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.016943712542559438)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.018472987251230831)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.029234225990864938)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0046998769835807442)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.11490587645496211)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.018472987251230838)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.020140288447822608)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00075558161408803245)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.018472987251230834)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0029698329494740154)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0032378787161382984)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.45164050000874939)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.072608551069807847)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.079161921265709395)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.011673004720247106)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.012726565493781048)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.013875216634373964)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.14209718214348346)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.025252677134971455)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.020839612993267732)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.03149368209432183)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.010119845073829774)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.012741222646677527)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0076059006651480118)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.1200661827724549)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.07167376983628268)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.090239667974007801)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0044877575534129259)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0037034936977522613)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0055968723216219887)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0017984394655152865)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0022642953009190934)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0013516760214407645)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.021337457243309044)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.012737441667874105)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.016036864107647247)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0030562848830502985)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0046187836850695154)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0014841508586531178)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0018685954570844729)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0011154621360955055)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.017608602400224702)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.010511493631509539)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.013234321250089203)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0069800962756367633)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0022429099493131632)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0028238984719785166)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0016857323556725265)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.026610845714704033)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.01588540242442097)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.020000251747433327)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00072071284436102596)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00090740152120223465)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0005416753183783425)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0085508463287925583)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0051044463771850934)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0064266683239972821)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00114244879513716)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00068198730151671568)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.010765800869265733)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.006426668323997283)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0080913898775143087)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00040711380799715558)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0064266683239972821)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0038364136814548937)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0048301728458850918)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.10145090865343141)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.060561341325294053)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.076248749657487444)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.036152224872110263)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.045516857511929326)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.057307242502786078)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.010602832052866737)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0055309670312750914)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0052003949426853487)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.010780936812590689)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.063998122143175837)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0088423219489586306)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.011167925629143633)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.020954485874738926)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.026465688672824863)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0036566407264651056)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0028852287906211633)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0027127858702454444)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0056238753739928293)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0333846185502596)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0046125969868953268)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0058257480788658431)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.010930906945674442)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.013805825724628665)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0019074865283589999)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0025506494326292106)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0052877503857517326)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.031389303261174069)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.004336913582680707)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0054775576631322688)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.010277593932094844)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.012980685994326498)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0017934808215683258)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.010962033348971875)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.065073152862351727)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0089908539277986903)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.011355522744789336)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.021306476140476493)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.026910255284697957)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0037180644210720384)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.3862892119229091)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.05337177815296397)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.067408996477181224)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.12648014603762484)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.15974546874283108)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.02207128611291664)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0073741295777570923)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.009313586542023437)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.017475171676349516)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.022071286112916647)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0030494866271447126)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.011763136701232706)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.022071286112916647)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.027876216594627978)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0038515267885072964)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.041412565632020393)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.052304412320668951)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0072266566205763131)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.066060904618168603)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0091273269794773342)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0012610801845935181)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0069681379285338333)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0044341865869643995)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0042633692251674987)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0070958595609978423)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0020935800564522147)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.015938151369117328)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0084750763491579645)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.014288874398795993)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0075980770083520213)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.057843167305739338)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0028217022811074114)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.002713002358363512)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0045154624680312757)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0013322532791783996)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.010142270108137568)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0053931294495547805)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0090927498639929594)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0048350494066994043)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.036808599262129503)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0026084898629338414)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0043415141302798731)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0012809311288964204)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0097515612851041059)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0051853709066214775)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.008742471518058556)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0046487896795516861)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.035390628300808115)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0072259222515130232)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0021319540762042076)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.016230287766559517)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0086304192252137108)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.014550780575597435)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0077373450321837718)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.058903396570852681)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0006290170340667614)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0047886244769155305)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0025463403571347391)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0042930984973720693)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0022828455256225003)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.017379004651649481)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.03645517233875218)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.019384956368986152)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.032682797814571146)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.017379004651649481)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.13230409122829059)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.010307907199989913)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.017379004651649481)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0092412468600652879)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.070352404648282713)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.02930078791186147)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.015580628448835175)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.11861328821804179)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0082849643358013647)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.063072350763365564)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.48016156371688662)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0094094610911181365)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0068580279611794945)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.041201510190226373)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00083913709311830018)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0026455132646613986)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00029119630051498147)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.025604650302191737)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00044992567302397189)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.039561592985156692)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0043546141588640059)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0049984315850686882)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.030029467808109854)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00061159991971275918)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0019281661048415227)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00021223663627333838)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.018661792211926504)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00032792556514883638)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.02883422421897347)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0031738338011543547)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.18041037903410936)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0036743566032432728)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.011583994096666503)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0012750706152926475)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.1121159065463094)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0019701040285335608)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.17322962077585116)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.01906768920170104)), ((real_t)(abs_det_jac_affine_GREEN_UP*7.4834366626129028e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0002359272533481587)), ((real_t)(abs_det_jac_affine_GREEN_UP*-2.5968927951845934e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0022834263957128066)), ((real_t)(abs_det_jac_affine_GREEN_UP*-4.012443621633234e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0035281085510869368)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00038834511684948268)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00074379822241953109)), ((real_t)(abs_det_jac_affine_GREEN_UP*8.1871179249561797e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0071988652012604706)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00012649867240751639)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.011122923831648516)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0012243197998481877)), ((real_t)(abs_det_jac_affine_GREEN_UP*9.0117047737890255e-6)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00079239176099213078)), ((real_t)(abs_det_jac_affine_GREEN_UP*1.3923931479451492e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0012243197998481881)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00013476303488074395)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.069674353371455625)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0012243197998481872)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.10765342924248253)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.011849602401133497)), ((real_t)(abs_det_jac_affine_GREEN_UP*2.1513783763573511e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0018916892452585615)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00020822156414845061)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.16633467361914708)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.018308750234696657)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0020152763573759057))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t k_dof_0 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_1 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_2 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_3 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_7 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 11; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_105 = tmp_qloop_104*_data_q_p_1[q];
                const real_t tmp_qloop_106 = tmp_qloop_104*_data_q_p_2[q];
                const real_t tmp_qloop_107 = 4.0*_data_q_p_1[q]*_data_q_p_2[q];
                const real_t tmp_qloop_108 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_109 = tmp_qloop_108*2.0;
                const real_t tmp_qloop_110 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_111 = tmp_qloop_110*2.0;
                const real_t tmp_qloop_112 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const real_t tmp_qloop_113 = tmp_qloop_112*2.0;
                const real_t tmp_qloop_114 = tmp_qloop_105 + tmp_qloop_106;
                const real_t tmp_qloop_115 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_117 = tmp_qloop_115*tmp_qloop_116;
                const real_t tmp_qloop_118 = tmp_qloop_117*tmp_qloop_25*tmp_qloop_43*1.0;
                const real_t tmp_qloop_119 = (k_dof_0*(tmp_qloop_107 + tmp_qloop_109 + tmp_qloop_111 + tmp_qloop_113 + tmp_qloop_114 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0) + k_dof_1*(tmp_qloop_109 - _data_q_p_0[q]) + k_dof_2*(tmp_qloop_111 - _data_q_p_1[q]) + k_dof_3*(tmp_qloop_113 - _data_q_p_2[q]) + k_dof_4*tmp_qloop_107 + k_dof_5*tmp_qloop_106 + k_dof_6*tmp_qloop_105 + k_dof_7*(-tmp_qloop_106 - tmp_qloop_107 + tmp_qloop_112*-4.0 + 4.0*_data_q_p_2[q]) + k_dof_8*(-tmp_qloop_105 - tmp_qloop_107 + tmp_qloop_110*-4.0 + 4.0*_data_q_p_1[q]) + k_dof_9*(tmp_qloop_108*-4.0 - tmp_qloop_114 + 4.0*_data_q_p_0[q]))*abs(tmp_qloop_115*tmp_qloop_116*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*-2.0 - tmp_qloop_115*tmp_qloop_116*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59 + tmp_qloop_117*tmp_qloop_50*tmp_qloop_52*tmp_qloop_56*tmp_qloop_86*1.0 + tmp_qloop_118*tmp_qloop_18*tmp_qloop_52*tmp_qloop_59 + tmp_qloop_118*tmp_qloop_22*tmp_qloop_36*tmp_qloop_50)*_data_q_w[q];
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_UP[55*q];
                const real_t q_tmp_1_1 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_UP[55*q + 10];
                const real_t q_tmp_2_2 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_UP[55*q + 19];
                const real_t q_tmp_3_3 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_UP[55*q + 27];
                const real_t q_tmp_4_4 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_UP[55*q + 34];
                const real_t q_tmp_5_5 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_UP[55*q + 40];
                const real_t q_tmp_6_6 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_UP[55*q + 45];
                const real_t q_tmp_7_7 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_UP[55*q + 49];
                const real_t q_tmp_8_8 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_UP[55*q + 52];
                const real_t q_tmp_9_9 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_UP[55*q + 54];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       {
          /* CellType.GREEN_DOWN */
          const real_t _data_phi_psi_jac_affine_det_0_0_GREEN_DOWN [] = {((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0081966519410136655)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0010483393829444135)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.010647302229434073)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.006225865982166446)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0092658338660815045)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.014552261081115014)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.054943945083223346)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0035394853240292199)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.013363784925403197)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.02098821218651729)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00013408102109754342)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0013617738473651977)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00079627884031291754)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0011850861336478869)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0018612121768751683)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0070272474541544115)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00045269481823022469)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0017092078745466989)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0026843605866225069)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.013830652512846866)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0080872870080513325)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.012036150161049137)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.018903123246819378)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.07137118828375684)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0045977272492218257)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.017359314272935491)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.027263307020171587)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0047289317036809308)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0070379760270885047)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.011053345668513806)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.041733337109024285)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0026884588282915065)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.010150624249852821)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.015941850064987575)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.01047448127011787)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.016450476917137476)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.062110904641547282)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0040011803868095627)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.015106974388071553)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.02372594184379705)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.025835951568628612)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.097546978867890252)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0062839699548933566)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.023725941843797053)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.037262280448408056)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.3683012433653402)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.02372594184379705)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.089580364071742774)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.14068856236299254)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0015284236111493253)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0057707611543522386)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0090631479226385408)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.021788255597241783)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.034219087945639513)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.053742071025623714)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*2.8698018728458151e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00014454340268069696)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00047286322640212926)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0032065374623290576)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0020887954478770055)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00052219560963689146)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-7.0208740498716208e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-9.881379856501532e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-1.3285428320562817e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-3.3213363942336231e-6)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00072802221840478313)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0023816717242211073)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.016150377488204762)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.01052064271045634)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00263014429658129)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00035362058773580443)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00049769577515219844)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-6.691475929731612e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-1.6728585635554696e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0077914657802387113)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.052834785019937068)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.034417517255215337)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0086043257244467573)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0011568440270383941)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0016281755212658067)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00021890676702241725)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-5.4726350909608775e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.35827847889456316)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.23338896382133173)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.058346877560018065)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0078446863779075976)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.011040836996163679)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0014844308248613668)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00037110539490121838)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.15203371578906599)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.038008192225104848)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0051101680203961414)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0071921972935839896)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00096698460132961257)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00024174464470133657)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0095019888761043864)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0012775340483769759)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0017980381248767646)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00024174464470134023)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*6.0435784769912737e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00017176332934538114)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00024174464470134207)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*3.2502354890713518e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*8.1255381153003586e-6)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00034023835858622775)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*4.5744748107514238e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*1.1436115800600717e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*6.150341155286279e-6)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*1.53757571251115e-6)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*3.8439153406509323e-7)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0022455683985789271)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0043245643162645366)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0052785529053041248)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0038024608195830192)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0063277537331678678)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0022859694750058082)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0075700068116924318)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0085069574365176301)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.028170859867257168)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0101770278137826)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0083283397367649708)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.010165551648410579)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0073228615012435371)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.012186125354224276)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0044023695853291234)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.014578483270623889)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.01638288310132377)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.05425205280655232)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.01959914084869013)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.012408048132369226)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0089382673087210242)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.014874355585605769)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0053735218314278996)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.017794461960864042)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.019996908096963657)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.066219926452175323)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.023922664643748495)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0064387743849681585)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.010714897689853333)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0038708726792615806)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.012818426872970318)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.014404981993284736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.047702216938480875)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.017232941800483223)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.017830882966183025)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0064415993244871881)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.021331409407572027)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.023971628613445938)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.079382246296480372)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.028677695046817175)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0023270974261863082)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0077062023619792735)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.008660010105842008)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.028677695046817168)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.010360127504160913)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.025519152819096672)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.028677695046817164)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.094966424189672397)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.034307647864064747)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.03222717458640751)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.10672055502407191)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.038553954756796821)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.35340600008570494)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.12767173985378449)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.046122796877640655)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00015290096248775118)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0014570800801489527)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0012345554413094673)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0015097104585850083)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0061335058519928322)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0019926658054762107)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0055047118378142874)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00013295486007563399)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00036728596944954594)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00011932460974427863)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.013885343332204057)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.011764779711675321)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.014386888088902506)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.058449659524751035)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.018989243784426475)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.052457524369618494)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0012670023459840343)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0035000765272880604)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0011371119520837828)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0099680676489457051)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.012189728770328983)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.04952325283425088)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.016089214697121625)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.044446233965065328)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0010735062963914434)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0029655463557783954)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00096345270719750374)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.014906548864553707)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.060560887138220144)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.019675143688079481)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.054352313404898829)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0013127670323983137)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0036265008430796091)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0011781849398884157)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.24604092364326371)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.079934273663800182)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.22081732986784111)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0053333831197440425)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.014733397398686206)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0047866159914586818)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.025969208746035512)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.071739581424095769)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0017327203114618317)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0047866159914586584)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0015550854992705844)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.19817960544100707)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0047866159914586211)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.01322296073874602)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0042959022697749219)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00011561074914193237)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00031937310191765402)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00010375858028624978)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00088226379454805234)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0002866316487224664)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*9.3121470649767956e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0015313812260033845)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.020478525470679236)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0009897290528383181)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0033824754838425301)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00046483308651242364)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.014254039308965735)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0034268445398502956)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00074451353959082409)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00017899011660411598)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0054887060151714157)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.27385082063970095)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.013235235794627626)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.045232440605657676)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0062160199172626362)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.19061335093582549)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.045825769574392869)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0099560705230576918)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0023935605319149542)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.07339818722089371)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00063966018480500107)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0021860880883392128)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00030042082443606778)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0092123610926072748)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0022147637329352362)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0004811778202920854)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0001156810045506071)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0035473412586367816)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.007471124893345448)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0010267113717402016)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.031483955588337449)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0075691261236329422)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0016444623665833173)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00039534876814677629)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.012123312744788284)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00014109471544232499)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0043266490242589092)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0010401790863102422)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00022598848717865071)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*5.4330382888033369e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0016660333264303686)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.13267606600597784)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.031896941106050063)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0069299042453857072)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0016660333264303651)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.051088670781077684)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0076684128686554951)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.001666033326430367)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00040053468944030722)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.012282338270543791)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00036196108534037404)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*8.7019850447357002e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.002668451117030794)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*2.0920631190945677e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00064152812701327526)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.019672367147664311)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0056280121552861676)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0082361505285512976)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.006546963131509812)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0028727623124179887)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.015489393471375653)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.046367923183087689)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.011399254367437734)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.012638819023050307)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0031071720072274201)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0093014044232272736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.01205295469471257)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0095809625793618486)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0042040603653636923)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.022667501900539677)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.067855787175853305)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.016681906913665712)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.018495911718880619)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.004547100408372284)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.013611869491908979)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0076159619174044459)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0033418316140852618)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.018018526824128522)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.053938953077637526)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.013260543156471259)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.01470250594466384)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0036145161050283661)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.010820152862131633)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0014663726864729064)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0079064054197158472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.023668040961914667)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0058186349696638454)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0064513583057541025)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0015860247622562602)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0047478085232114465)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.042629849312913477)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.1276136203719424)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.031372984155995043)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.034784509247666975)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0085515468828518213)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.025599289584411971)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.38201486439458487)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.093915886510190727)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.10412838021952459)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.025599289584412016)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.07663217382818617)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.023088613980959145)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.025599289584412002)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0062934199672080244)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.018839524874726728)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.02838297819726298)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.006977771829428203)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.020888150899772109)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0017154401263027783)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0051352169565958509)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.015372412471279177)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.011820472404298839)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.007781569024383839)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0072610786275946687)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00066208934951621885)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.017050403495896919)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.018589307722076551)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0029885333557655271)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.07306575166941863)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.011746507147698459)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.012806701969292705)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0051227069790568064)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.004780061456051238)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00043586193490000903)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.011224499931886399)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.012237580378111014)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0019673899480620945)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.048100124131019932)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0077328767445869005)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0084308166323810284)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0044603346662302444)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00040670818059537962)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.010473720184896984)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.011419038121814993)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0018357959762683471)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.044882822759521109)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0072156432570344995)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0078668996279190398)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*3.7085007413357473e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0009550287140370076)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0010412259541497195)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00016739399559079557)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0040925653679565032)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00065794640099822775)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00071733012745018546)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.024594301262203948)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.026814088856171956)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0043108006037235582)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.10539346525960519)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.016943712542559438)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.018472987251230831)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.029234225990864938)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0046998769835807442)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.11490587645496211)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.018472987251230838)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.020140288447822608)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00075558161408803245)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.018472987251230834)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0029698329494740154)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0032378787161382984)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.45164050000874939)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.072608551069807847)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.079161921265709395)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.011673004720247106)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.012726565493781048)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.013875216634373964)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.14209718214348346)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.025252677134971455)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.020839612993267732)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.03149368209432183)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.010119845073829774)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.012741222646677527)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0076059006651480118)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.1200661827724549)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.07167376983628268)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.090239667974007801)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0044877575534129259)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0037034936977522613)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0055968723216219887)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0017984394655152865)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0022642953009190934)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0013516760214407645)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.021337457243309044)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.012737441667874105)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.016036864107647247)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0030562848830502985)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0046187836850695154)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0014841508586531178)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0018685954570844729)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0011154621360955055)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.017608602400224702)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.010511493631509539)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.013234321250089203)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0069800962756367633)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0022429099493131632)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0028238984719785166)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0016857323556725265)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.026610845714704033)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.01588540242442097)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.020000251747433327)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00072071284436102596)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00090740152120223465)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0005416753183783425)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0085508463287925583)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0051044463771850934)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0064266683239972821)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00114244879513716)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00068198730151671568)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.010765800869265733)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.006426668323997283)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0080913898775143087)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00040711380799715558)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0064266683239972821)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0038364136814548937)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0048301728458850918)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.10145090865343141)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.060561341325294053)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.076248749657487444)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.036152224872110263)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.045516857511929326)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.057307242502786078)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.010602832052866737)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0055309670312750914)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0052003949426853487)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.010780936812590689)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.063998122143175837)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0088423219489586306)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.011167925629143633)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.020954485874738926)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.026465688672824863)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0036566407264651056)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0028852287906211633)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0027127858702454444)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0056238753739928293)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0333846185502596)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0046125969868953268)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0058257480788658431)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.010930906945674442)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.013805825724628665)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0019074865283589999)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0025506494326292106)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0052877503857517326)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.031389303261174069)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.004336913582680707)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0054775576631322688)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.010277593932094844)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.012980685994326498)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0017934808215683258)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.010962033348971875)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.065073152862351727)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0089908539277986903)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.011355522744789336)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.021306476140476493)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.026910255284697957)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0037180644210720384)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.3862892119229091)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.05337177815296397)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.067408996477181224)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.12648014603762484)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.15974546874283108)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.02207128611291664)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0073741295777570923)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.009313586542023437)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.017475171676349516)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.022071286112916647)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0030494866271447126)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.011763136701232706)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.022071286112916647)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.027876216594627978)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0038515267885072964)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.041412565632020393)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.052304412320668951)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0072266566205763131)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.066060904618168603)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0091273269794773342)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0012610801845935181)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0069681379285338333)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0044341865869643995)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0042633692251674987)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0070958595609978423)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0020935800564522147)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.015938151369117328)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0084750763491579645)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.014288874398795993)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0075980770083520213)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.057843167305739338)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0028217022811074114)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.002713002358363512)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0045154624680312757)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0013322532791783996)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.010142270108137568)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0053931294495547805)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0090927498639929594)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0048350494066994043)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.036808599262129503)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0026084898629338414)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0043415141302798731)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0012809311288964204)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0097515612851041059)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0051853709066214775)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.008742471518058556)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0046487896795516861)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.035390628300808115)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0072259222515130232)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0021319540762042076)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.016230287766559517)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0086304192252137108)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.014550780575597435)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0077373450321837718)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.058903396570852681)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0006290170340667614)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0047886244769155305)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0025463403571347391)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0042930984973720693)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0022828455256225003)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.017379004651649481)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.03645517233875218)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.019384956368986152)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.032682797814571146)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.017379004651649481)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.13230409122829059)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.010307907199989913)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.017379004651649481)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0092412468600652879)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.070352404648282713)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.02930078791186147)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.015580628448835175)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.11861328821804179)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0082849643358013647)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.063072350763365564)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.48016156371688662)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0094094610911181365)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0068580279611794945)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.041201510190226373)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00083913709311830018)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0026455132646613986)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00029119630051498147)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.025604650302191737)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00044992567302397189)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.039561592985156692)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0043546141588640059)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0049984315850686882)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.030029467808109854)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00061159991971275918)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0019281661048415227)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00021223663627333838)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.018661792211926504)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00032792556514883638)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.02883422421897347)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0031738338011543547)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.18041037903410936)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0036743566032432728)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.011583994096666503)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0012750706152926475)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.1121159065463094)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0019701040285335608)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.17322962077585116)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.01906768920170104)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*7.4834366626129028e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0002359272533481587)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-2.5968927951845934e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0022834263957128066)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-4.012443621633234e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0035281085510869368)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00038834511684948268)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00074379822241953109)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*8.1871179249561797e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0071988652012604706)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00012649867240751639)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.011122923831648516)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0012243197998481877)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*9.0117047737890255e-6)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00079239176099213078)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*1.3923931479451492e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0012243197998481881)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00013476303488074395)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.069674353371455625)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0012243197998481872)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.10765342924248253)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.011849602401133497)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*2.1513783763573511e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0018916892452585615)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00020822156414845061)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.16633467361914708)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.018308750234696657)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0020152763573759057))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t k_dof_0 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_1 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_2 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_3 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_5 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_7 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_9 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 11; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = -tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35;
                const real_t tmp_qloop_37 = tmp_qloop_17*tmp_qloop_36;
                const real_t tmp_qloop_38 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_39 = tmp_qloop_38*1.0;
                const real_t tmp_qloop_42 = tmp_qloop_31*tmp_qloop_41;
                const real_t tmp_qloop_43 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_42;
                const real_t tmp_qloop_44 = tmp_qloop_17*tmp_qloop_39;
                const real_t tmp_qloop_45 = tmp_qloop_43*tmp_qloop_44;
                const real_t tmp_qloop_48 = -tmp_qloop_28;
                const real_t tmp_qloop_49 = tmp_qloop_22*tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_31*tmp_qloop_47 + tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_44*tmp_qloop_50;
                const real_t tmp_qloop_52 = tmp_qloop_18*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_53 = tmp_qloop_44*tmp_qloop_52;
                const real_t tmp_qloop_55 = tmp_qloop_25*tmp_qloop_54 + tmp_qloop_28;
                const real_t tmp_qloop_56 = tmp_qloop_29*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_55;
                const real_t tmp_qloop_57 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_58 = tmp_qloop_28 + tmp_qloop_57;
                const real_t tmp_qloop_59 = tmp_qloop_30*tmp_qloop_48 + tmp_qloop_31*tmp_qloop_58;
                const real_t tmp_qloop_67 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_68 = tmp_qloop_37*tmp_qloop_67;
                const real_t tmp_qloop_70 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_71 = -tmp_qloop_42;
                const real_t tmp_qloop_72 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_74 = -tmp_qloop_31*tmp_qloop_73;
                const real_t tmp_qloop_75 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_76 = tmp_qloop_18*tmp_qloop_69 + tmp_qloop_34*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_77 = tmp_qloop_17*tmp_qloop_67;
                const real_t tmp_qloop_78 = tmp_qloop_52*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*tmp_qloop_78;
                const real_t tmp_qloop_80 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_81 = tmp_qloop_18*tmp_qloop_41 + tmp_qloop_33*tmp_qloop_80;
                const real_t tmp_qloop_82 = tmp_qloop_25*tmp_qloop_44;
                const real_t tmp_qloop_83 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_84 = tmp_qloop_18*tmp_qloop_73 + tmp_qloop_33*tmp_qloop_83;
                const real_t tmp_qloop_85 = -tmp_qloop_22*tmp_qloop_79;
                const real_t tmp_qloop_86 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_87 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_88 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_41*tmp_qloop_70;
                const real_t tmp_qloop_89 = tmp_qloop_18*tmp_qloop_44;
                const real_t tmp_qloop_90 = tmp_qloop_43*tmp_qloop_77;
                const real_t tmp_qloop_91 = -tmp_qloop_25*tmp_qloop_41 - tmp_qloop_28;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_90;
                const real_t tmp_qloop_93 = tmp_qloop_25*tmp_qloop_73 - tmp_qloop_41*tmp_qloop_83;
                const real_t tmp_qloop_94 = tmp_qloop_86*tmp_qloop_90;
                const real_t tmp_qloop_95 = -tmp_qloop_31*tmp_qloop_69;
                const real_t tmp_qloop_96 = tmp_qloop_56*tmp_qloop_77;
                const real_t tmp_qloop_97 = tmp_qloop_22*tmp_qloop_69 + tmp_qloop_47*tmp_qloop_70;
                const real_t tmp_qloop_98 = tmp_qloop_50*tmp_qloop_77;
                const real_t tmp_qloop_99 = tmp_qloop_22*tmp_qloop_41 + tmp_qloop_47*tmp_qloop_80;
                const real_t tmp_qloop_100 = tmp_qloop_25*tmp_qloop_98;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_18;
                const real_t tmp_qloop_102 = tmp_qloop_22*tmp_qloop_73 + tmp_qloop_57*2.0 + tmp_qloop_75;
                const real_t tmp_qloop_103 = tmp_qloop_59*tmp_qloop_77;
                const real_t tmp_qloop_104 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_105 = tmp_qloop_104*_data_q_p_1[q];
                const real_t tmp_qloop_106 = tmp_qloop_104*_data_q_p_2[q];
                const real_t tmp_qloop_107 = 4.0*_data_q_p_1[q]*_data_q_p_2[q];
                const real_t tmp_qloop_108 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_109 = tmp_qloop_108*2.0;
                const real_t tmp_qloop_110 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_111 = tmp_qloop_110*2.0;
                const real_t tmp_qloop_112 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const real_t tmp_qloop_113 = tmp_qloop_112*2.0;
                const real_t tmp_qloop_114 = tmp_qloop_105 + tmp_qloop_106;
                const real_t tmp_qloop_115 = pow(tmp_qloop_31, -4.5000000000000000);
                const real_t tmp_qloop_117 = tmp_qloop_115*tmp_qloop_116;
                const real_t tmp_qloop_118 = tmp_qloop_117*tmp_qloop_25*tmp_qloop_43*1.0;
                const real_t tmp_qloop_119 = (k_dof_0*(tmp_qloop_107 + tmp_qloop_109 + tmp_qloop_111 + tmp_qloop_113 + tmp_qloop_114 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0) + k_dof_1*(tmp_qloop_109 - _data_q_p_0[q]) + k_dof_2*(tmp_qloop_111 - _data_q_p_1[q]) + k_dof_3*(tmp_qloop_113 - _data_q_p_2[q]) + k_dof_4*tmp_qloop_107 + k_dof_5*tmp_qloop_106 + k_dof_6*tmp_qloop_105 + k_dof_7*(-tmp_qloop_106 - tmp_qloop_107 + tmp_qloop_112*-4.0 + 4.0*_data_q_p_2[q]) + k_dof_8*(-tmp_qloop_105 - tmp_qloop_107 + tmp_qloop_110*-4.0 + 4.0*_data_q_p_1[q]) + k_dof_9*(tmp_qloop_108*-4.0 - tmp_qloop_114 + 4.0*_data_q_p_0[q]))*abs(tmp_qloop_115*tmp_qloop_116*tmp_qloop_18*tmp_qloop_22*tmp_qloop_25*tmp_qloop_43*tmp_qloop_50*tmp_qloop_52*-2.0 - tmp_qloop_115*tmp_qloop_116*tmp_qloop_36*tmp_qloop_56*tmp_qloop_59 + tmp_qloop_117*tmp_qloop_50*tmp_qloop_52*tmp_qloop_56*tmp_qloop_86*1.0 + tmp_qloop_118*tmp_qloop_18*tmp_qloop_52*tmp_qloop_59 + tmp_qloop_118*tmp_qloop_22*tmp_qloop_36*tmp_qloop_50)*_data_q_w[q];
                const real_t jac_blending_0_0 = tmp_qloop_37*tmp_qloop_39;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_45;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_51;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_53;
                const real_t jac_blending_1_1 = tmp_qloop_44*tmp_qloop_56;
                const real_t tmp_qloop_64 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_51;
                const real_t tmp_qloop_61 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_53;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_45;
                const real_t tmp_qloop_62 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_44*tmp_qloop_59;
                const real_t tmp_qloop_60 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_63 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_65 = jac_blending_0_0*tmp_qloop_60 - jac_blending_0_0*tmp_qloop_62 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_63 + jac_blending_2_0*tmp_qloop_61 - jac_blending_2_0*tmp_qloop_64;
                const real_t tmp_qloop_66 = 1.0 / (tmp_qloop_65);
                const real_t abs_det_jac_blending = tmp_qloop_65;
                const real_t jac_blending_inv_0_0 = tmp_qloop_66*(tmp_qloop_60 - tmp_qloop_62);
                const real_t jac_blending_inv_0_1 = tmp_qloop_66*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_63);
                const real_t jac_blending_inv_0_2 = tmp_qloop_66*(tmp_qloop_61 - tmp_qloop_64);
                const real_t jac_blending_inv_1_0 = tmp_qloop_66*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_66*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_66*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_66*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_66*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_69 - tmp_qloop_28*tmp_qloop_70 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_69) + tmp_qloop_35*tmp_qloop_70)*1.0 - tmp_qloop_18*tmp_qloop_68;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_41 + tmp_qloop_25*tmp_qloop_72 + tmp_qloop_71)*1.0 - tmp_qloop_25*tmp_qloop_68;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_19*tmp_qloop_73 + tmp_qloop_22*tmp_qloop_72 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_68;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_18*tmp_qloop_79;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_81*tmp_qloop_82;
                const real_t hessian_blending_2_0_1 = tmp_qloop_82*tmp_qloop_84 + tmp_qloop_85;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_76*1.0 - tmp_qloop_78*tmp_qloop_86;
                const real_t hessian_blending_1_0_2 = tmp_qloop_81*tmp_qloop_87 + tmp_qloop_85;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_78 + tmp_qloop_53 + tmp_qloop_84*tmp_qloop_87;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_88*tmp_qloop_89;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_18*tmp_qloop_92;
                const real_t hessian_blending_2_1_0 = tmp_qloop_89*tmp_qloop_93 - tmp_qloop_94;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_69 + tmp_qloop_55*tmp_qloop_70 + tmp_qloop_95)*1.0 - tmp_qloop_18*tmp_qloop_96;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_41 + tmp_qloop_31*(-tmp_qloop_41 + tmp_qloop_54) + tmp_qloop_48*tmp_qloop_80 + tmp_qloop_55*tmp_qloop_80)*1.0 - tmp_qloop_25*tmp_qloop_96;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_38*(tmp_qloop_29*tmp_qloop_73 + tmp_qloop_55*tmp_qloop_83 + tmp_qloop_74)*1.0 - tmp_qloop_22*tmp_qloop_96;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_88*1.0 - tmp_qloop_94;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_38*tmp_qloop_91*1.0 - tmp_qloop_22*tmp_qloop_92;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_90 + tmp_qloop_45 + tmp_qloop_87*tmp_qloop_93;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_89*tmp_qloop_97;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*tmp_qloop_99*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_102*tmp_qloop_17*tmp_qloop_18*tmp_qloop_38*1.0 - tmp_qloop_86*tmp_qloop_98;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_101 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*tmp_qloop_97*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_98 + tmp_qloop_51 + tmp_qloop_82*tmp_qloop_99;
                const real_t hessian_blending_2_2_1 = -tmp_qloop_100*tmp_qloop_22 + tmp_qloop_102*tmp_qloop_17*tmp_qloop_25*tmp_qloop_38*1.0;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_103*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_69 + tmp_qloop_58*tmp_qloop_70 + tmp_qloop_95)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_103*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_41 + tmp_qloop_58*tmp_qloop_80 + tmp_qloop_71)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_103*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_38*(tmp_qloop_30*tmp_qloop_73 + tmp_qloop_31*(tmp_qloop_47 - tmp_qloop_73) + tmp_qloop_49*2.0 + tmp_qloop_58*tmp_qloop_83)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_DOWN[55*q];
                const real_t q_tmp_1_1 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_DOWN[55*q + 10];
                const real_t q_tmp_2_2 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_DOWN[55*q + 19];
                const real_t q_tmp_3_3 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_DOWN[55*q + 27];
                const real_t q_tmp_4_4 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_DOWN[55*q + 34];
                const real_t q_tmp_5_5 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_DOWN[55*q + 40];
                const real_t q_tmp_6_6 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_DOWN[55*q + 45];
                const real_t q_tmp_7_7 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_DOWN[55*q + 49];
                const real_t q_tmp_8_8 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_DOWN[55*q + 52];
                const real_t q_tmp_9_9 = tmp_qloop_119*_data_phi_psi_jac_affine_det_0_0_GREEN_DOWN[55*q + 54];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
